#
# This is the package for  Convert   Diagonistics


DifferentialGeometryConvertDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check, TF,BadProcedureList,P;



#~~~~~~  jet  ~~~~~~

Check[jet]:=proc()
local a,ans;
coord_init([x,y],[u,v],DGChk);

DifferentialGeometryTools:-Form(u[4,0]);
a:=convert( diff(u(x,y),x,y,y),jet,4);
ans:=u[1,2];
if a <> ans then RETURN(false) fi;

a:=convert( diff(u(x,y),x,y) -(x^2 +y^2)*v(x,y)*u(x,y),jet,2);
ans:=u[1,1]-(x^2+y^2)*v[0,0]*u[0,0];
if a <> ans then RETURN(false) fi;

true:
end:

#~~~~~  deriv  ~~~~~~

Check[deriv]:=proc()
local a, ans;
coord_init([x,y],[u,v],DGChk);
a:=convert(u[1,2],deriv);
ans:=diff(u(x,y),x,y,y);
if ans  <> a then RETURN(false) fi;
 
 a:=convert(u[1,1]*v[0,2] - x*y* u[0,0],deriv);
 ans:=diff(u(x,y),x,y)*diff(v(x,y),y,y)-x*y*u(x,y);
 if ans  <> a then RETURN(false) fi;
 
true;
end:

#~~~~~~ Lie_algebra_data ~~~~~~


Check[Lie_algebra_data]:=proc()
local L, A,phi,M,  Eq,ans;
L := [[Lie_alg,Max, [4]], [[[1, 4, 1], 1], [[2, 4, 1], 1], [[2, 4, 2], 1], 
	[[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);
ans:=convert(Max, Lie_algebra_data);
if L <> ans then RETURN(false) fi;

M:=[Matrix([[1,0],[0,-1]]), Matrix([[0,1],[0,0]]), Matrix([[0,0],[1,0]])];
L:=convert(M,Lie_algebra_data, Joe);
ans:=[[Lie_alg, Joe, [3]], [[[1, 2, 2], 2], [[1, 3, 3], -2], [[2, 3, 1], 1]]];
if L <> ans then RETURN(false) fi;


A:=array(1..3,1..3,1..3,sparse):
A[2,3,1]:=1;
A[3,2,1]:=-1;

L:=convert(eval(A),Lie_algebra_data,Hal);
ans:=[[Lie_alg, Hal, [3]], [[[2, 3, 1], 1]]];
if L <> ans then RETURN(false) fi;

Eq:=[[x1,x2]=x3,[x1,x3]=-x2, [x2,x3]=2*x1];
L:=convert(Eq,Lie_algebra_data,[x1,x2,x3],Sal);
ans:=[[Lie_alg, Sal, [3]], [[[1, 2, 3], 1], [[1, 3, 2], -1], [[2, 3, 1], 2]]];
if L <> ans then RETURN(false) fi;

change_Lie_algebra_to(Max);
L:=convert([e1,e2,e4],Lie_algebra_data,Bob):
ans:=[[Lie_alg, Bob, [3]], [[[1, 3, 1], 1], [[2, 3, 1], 1], [[2, 3, 2], 1]]];
if L <> ans then RETURN(false) fi;

L:=convert([e1,e2,e4],Lie_algebra_data,Bob):
ans:=[[Lie_alg, Bob, [3]], [[[1, 3, 1], 1], [[2, 3, 1], 1], [[2, 3, 2], 1]]];
if L <> ans then RETURN(false) fi;

L:=convert([e1,e2,e4],Lie_algebra_data,[[e1,e4]],Sue):
ans:=[[Lie_alg, Sue, [3]], [[[1, 3, 1], 1], [[2, 3, 1], 1], [[2, 3, 2], 1]]], [e1, e3];
if L <> ans then RETURN(false) fi;




true;
end:

#~~~~~~ Lie_algebra_transform ~~~~~~~~


Check[Lie_algebra_transform]:=proc()
local L, A,phi, ans;

L := [[Lie_alg,Max, [4]], [[[1, 4, 1], 1], [[2, 4, 1], 1],
[[2, 4, 2], 1], [[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);

A:=Ad(t*e3);
phi:=convert(A, Lie_algebra_transform,Max,Max);
ans:=transform(Max, Max,[z1 = z1, z2 = z2+t*z4, z3 = z3+t*z4, z4 = z4],A);
if not EqualTransform(phi,ans) then RETURN(false) fi;

true
end:



#~~~~~~ Vessiot_array ~~~~~~


Check[Vessiot_array]:=proc()

local a,b,c,i,j,k, ans;
 coord_init([x,y],[u,v],DGChk);


a:= evalV(dx &t D_x &t D_y -  dy &t D_y &t D_x);
b:=convert(a,Vessiot_array):
ans:=array(1..2,1..2,1..2,sparse);
ans[1,1,2]:=1;
ans[2,2,1]:=-1;

for  i from 1 to 2 do 
for  j from 1 to 2 do 
for  k from 1 to 2 do
	if b[i,j,k] <> ans[i,j,k] then  RETURN(false) fi;
od; od; od;


a:= evalV(dx &t du[0,0] -  dy &t dv[0,0]);
b:=convert(a,Vessiot_array);
ans:=array(1..2,1..2,sparse);
ans[1,1]:=1;
ans[2,2]:=-1;


for  i from 1 to 2  do for j from 1 to 2 do
	if b[i,j] <> ans[i,j] then  RETURN(false) fi;
od; od;



true

end:
#~~~~~~ Vessiot_biform ~~~~~~~
Check[Vessiot_biform]:=proc() 

local a,b, ans;
coord_init([x,y],[u]);

DifferentialGeometryTools:-Form(u[0,2]);
a:=du[0,1];
b:=convert(a,Vessiot_biform,[0,1]);
ans:=Cu[0,1]:
if ans <> b then RETURN(false) fi;

b:=convert(a,Vessiot_biform,[1,0]);
ans:=evalV(u[1,1]*Dx + u[0,2]*Dy);
if ans <> b then RETURN(false) fi;

a:=evalV(du[0,1] &w du[1,0] - dx &w du[1,1]);
b:=convert(a,Vessiot_biform);
ans:=evalV([-Cu[1,0] &w Cu[0,1], 
u[1,1]*Dx &w Cu[1,0] - u[2,0]*Dx &w Cu[0,1] - Dx&w Cu[1,1] + 
u[0,2]*Dy &w Cu[1,0] - u[1,1]*Dy &w Cu[0,1], (u[1,1]^2-u[2,0]*u[0,2]-u[1,2])*Dx &w Dy]);

if ans <> b then RETURN(false) fi;


true:
end;


#~~~~~ Vessiot_connection ~~~~~


Check[Vessiot_connection]:=proc()
 local a,b, ans;
 coord_init([x,y],[u,v],DGChk);
 a:=evalV( dx &t D_y  &t dy);
 b:=convert(a,Vessiot_connection);
 ans:=_VESSIOT([[connection, DGChk, [[cov_bas, con_bas, cov_bas], []]], [[[1, 2, 2], 1]]]);
 if ans <> b then RETURN(false) fi;
 

a:=evalV( du[0,0] &t D_v[0,0]  &t dx);
b:=convert(a,Vessiot_connection);
ans:=_VESSIOT([[connection, DGChk, [[cov_vrt, con_vrt, cov_bas], []]], [[[3, 4, 1], 1]]]);
if ans <> b then RETURN(false) fi;


true:
end:
true:





#~~~~~~ Vessiot_form ~~~~~


Check[Vessiot_form]:=proc()
 local a,b, ans;
 coord_init([x,y],[u,v],DGChk);
 a:=Cu[0,0];
 b:=convert(a,Vessiot_form);
ans:=evalV(-u[1,0]*dx -u[0,1]*dy+du[0, 0]);
 if ans <> b then RETURN(false) fi;
 
a:=Cu[0,0]&wedge DifferentialGeometryTools:-Biform(v[0,2]) &wedge Dx &wedge Dy;
 b:=convert(a,Vessiot_form);
 ans:=evalV( du[0,0] &w dv[0,2] &w dx &w dy);
 if ans <> b then RETURN(false)fi;

a:= evalV(dx&t dy - dy &t dx);
b:=convert(a,Vessiot_form);
ans:=evalV(2*dx &w dy);
if ans <> b then RETURN(false) fi;





true:
end:


#~~~~~~ Vessiot_tensor ~~~~~

Check[Vessiot_tensor]:=proc()
local a,b, ans;
 coord_init([x,y],[u,v],DGChk);
 
a:=evalV(dx &w dy):
b:=convert(a,Vessiot_tensor):
ans:=evalV(dx &t dy -dy &t  dx):
if  b <> ans then RETURN(false) fi;


a:=evalV(D_x -3*D_y):
b:=convert(a,Vessiot_tensor);
ans:=_VESSIOT([[tensor, DGChk, [[con_bas], []]], [[[1], 1], [[2], -3]]]);
if  b <> ans then RETURN(false) fi;

a:=Matrix([[1,2],[3,4]]);
b:=convert(a,Vessiot_tensor,[[con_bas,cov_bas],[]]);
ans:=evalV( D_x  &t dx +2*D_x &t dy +3*D_y  &t  dx +4*D_y &t dy);
if  b <> ans then RETURN(false) fi;

#  convert/Vessiot_tensor  doesn't work on Vectors.

a:=array(1..2,1..2,1..2,sparse);
a[1,2,2]:=4;
a[2,2,1]:=3;

b:=convert(a,Vessiot_tensor,[[cov_bas,con_bas,cov_bas],[]]);
ans:=evalV(4*dx &t  D_y &t dy +3*dy &t  D_y  &t  dx);
if  b <> ans then RETURN(false) fi;

b:=convert(a,Vessiot_tensor,[[cov_vrt,con_vrt,cov_vrt],[]]) ;          
ans:= evalV(4*du[0, 0] &t  D_v[0, 0] &t  dv[0, 0]+3*dv[0, 0] &t D_v[0, 0] &t du[0, 0]);
if  b <> ans then RETURN(false) fi;

b:=convert(a,Vessiot_tensor,[[cov_vrt,con_vrt,con_bas],[]]);
ans:=evalV(4*du[0, 0] &t D_v[0, 0] &t D_y +3*dv[0, 0] &t D_v[0, 0] &t D_x);
if  b <> ans then RETURN(false) fi;

true :
end:


#~~~~~~ Vessiot_transform ~~~~~

Check[Vessiot_transform]:=proc()
local a,b,c,ans:
coord_init([t],[x,y],DGChk);

a:=Diffeq([x[2]-y[0], y[2] +x[0]],[x[2],y[2]]);
c:=convert(a,Vessiot_transform);
ans:=transform(DGChk, DGChk,
[t = t, x[0] = x[0], y[0] = y[0], x[1] = x[1], 
y[1] = y[1], x[2] = y[0], y[2] = -x[0]]); 
if not DifferentialGeometryTools:-EqualTransform(c,ans) then RETURN(false) fi;

b:=pr_diffeq(a,1);
c:=convert(b,Vessiot_transform); 
ans:=transform(DGChk, DGChk,[t = t, x[0] = x[0], y[0] = y[0], x[1] = x[1], y[1] = y[1], 
x[2] = y[0], y[2] = -x[0], x[3] = y[1], y[3] = -x[1]]); 
if not DifferentialGeometryTools:-EqualTransform(c,ans) then RETURN(false) fi;

coord_init([t,x],[u],DGChk);
a:=Diffeq([u[0,2]-u[1,0]],[u[0,2]]);
b:=pr_diffeq(a,1);
c:=convert(b,Vessiot_transform);
ans:=transform(DGChk, DGChk,[t = t, x = x, u[0,0] = u[0,0], u[1,0] = u[1,0], 
u[0,1] = u[0,1], u[2,0] = u[2,0], u[1,1] = u[1,1], u[0,2] = u[1,0], 
u[3,0] = u[3,0], u[2,1] = u[2,1], u[1,2] = u[2,0], u[0,3] = u[1,1]]); 
if not DifferentialGeometryTools:-EqualTransform(c,ans) then RETURN(false) fi;

coord_init([t,x],[u],DGChk);
a:=Diffeq([u[0,2]-u[1,0]],[u[1,0]]);
b:=pr_diffeq(a,1);
c:=convert(b,Vessiot_transform);
ans:=transform(DGChk, DGChk,[t = t, x = x, u[0,0] = u[0,0], u[1,0] = u[0,2],
u[0,1] = u[0,1], u[2,0] = u[1,2], u[1,1] = u[0,3], u[0,2] = u[0,2]]); 
if not DifferentialGeometryTools:-EqualTransform(c,ans) then RETURN(false) fi;

true:
end:


#~~~~~~ Vessiot_vect ~~~~~~


Check[Vessiot_vect]:=proc()
local a,b,c, ans;
 coord_init([x,y],[u,v],DGChk);

a:= evalV(dx &t D_x &t D_y -  dy &t D_y &t D_x); 
b:=contract_indices(a,[[1,2]]);
c:=convert(b,Vessiot_vect);
ans:=evalV(-D_x +D_y);
if c <> ans then RETURN(false) fi;

true:
end:

#~~~~~    vector_field_system   ~~~~~~~

Check[vector_field_system]:=proc()
local L ,V, ans;

L:=[[Lie_alg,Sam, [4]], 
[[[1, 4, 1], 1], [[2, 4, 1], 1], [[2, 4, 2], 1], [[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L):

coord_init([x,y,z,w],Lie);
V:=convert(Sam, vector_field_system,Lie,adjoint);
ans:=evalV([w*D_x, w*D_x+w*D_y, w*D_y+w*D_z, (-x-y)*D_x+(-y-z)*D_y-z*D_z]);
if V  <> ans then RETURN(false) fi;

V:=convert(Sam, vector_field_system,Lie,coadjoint);
ans:=evalV([x*D_w, (x+y)*D_w, (y+z)*D_w, -x*D_x+(-x-y)*D_y+(-y-z)*D_z]);
if V  <> ans then RETURN(false) fi;

true: 
end:






#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`******  All convertProcedures Gave Correct Answers ******`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:

writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):
end:


#-------------------------






