#
# This is the package for  DifferentialGeometryTools Diagonistics


DifferentialGeometryToolsDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check, TF,BadProcedureList,P;


Check[DifferentialGeometryTools:-`&mplus`]:=proc()

local  A,B,C, ans;

coord_init([x,y,z,w], DGChk);

A:=Matrix( [[dx, dy], [dz,dw]]);
B:=Matrix( [evalV([dx-3*dz , dy+ 2*dx -dw]), evalV([dz-dx +dw,dy +dw])]);
C:=A &mplus B;
ans:=Matrix([evalV([2*dx-3*dz, 2*dx +2*dy -dw]),evalV([-dx +2*dz +dw, dy +2*dw])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;


A:=Matrix([evalV([D_x -D_y, D_w]),evalV([ D_x +D_y, D_z])]);
B:=Matrix([evalV([D_z + D_z, D_w -2*D_x]),evalV([ D_x +2*D_y -D_z, D_z-D_w])]);
C:= A &mplus  B;
ans:=Matrix([evalV([D_x-D_y+2*D_z,-2*D_x +2*D_w]), evalV([2*D_x +3*D_y -D_z,2*D_z-D_w])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;

A:=Matrix([evalV([dx &t dy, dy&t dy]), evalV([dz &t dw, dz &t  dy])]);
B:=Matrix([evalV([dx &t dz, dy&t dz]), evalV([dw &t dw, dz &t  dy])]);
C:= A &mplus B;
ans:= Matrix([evalV([dx &t dy +dx &t dz, dy &t dy + dy&t dz]), 
              evalV([dz&t dw +dw &t dw,dz&t dy + dz &t  dy])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;


true;
end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



Check[DifferentialGeometryTools:-`&mminus`]:=proc()

local  A,B,C, ans;

coord_init([x,y,z,w], DGChk);

A:=Matrix( [[dx, dy], [dz,dw]]);
B:=Matrix( [evalV([dx-3*dz , dy+ 2*dx -dw]), evalV([dz-dx +dw,dy +dw])]);
C:=A &mminus B;
ans:=Matrix([evalV([3*dz, -2*dx +dw]),evalV([dx -dw, -dy])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;


A:=Matrix([evalV([D_x -D_y, D_w]),evalV([ D_x +D_y, D_z])]);
B:=Matrix([evalV([D_z + D_z, D_w -2*D_x]),evalV([ D_x +2*D_y -D_z, D_z-D_w])]);
C:= A &mminus  B;
ans:=Matrix([evalV([D_x-D_y-2*D_z,2*D_x]), evalV([-D_y +D_z,D_w])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;

A:=Matrix([evalV([dx &t dy, dy&t dy]), evalV([dz &t dw, dz &t  dy])]);
B:=Matrix([evalV([dx &t dz, dy&t dz]), evalV([dw &t dw, dz &t  dy])]);
C:= A &mminus B;
ans:=Matrix([evalV([dx &t dy -dx &t dz, dy &t dy - dy&t dz]), 
             evalV([dz&t dw -dw &t dw,0 &mult dx &t dx])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;


A:=Matrix([evalV([dx &t dy, dy&t dy]), evalV([dz &t dw, dz &t  dy])]);


true;
end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-`&mwedge`]:=proc()

local  A,B,C, ans;

coord_init([x,y,z,w], DGChk);

A:=Matrix( [[dx, dy], [dz,dw]]);
B:=Matrix( [evalV([dx , dy+  dw]), evalV([dx +dw,dy +dw])]);
C:=A &mwedge B;
ans:=Matrix([evalV([-dx &w dy +dy&w dw, dx  &w dy +dx &w dw + dy&w dw]), 
		   evalV([-dx &w dz -dx &w dw, -dy&w dz +  dz &w dw -dy &w dw])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;

A:=Matrix( [[dx, dy], [dz,dw]]);
B:=Matrix( [evalV([dx &w dz , dy &w dw]), evalV([dx&w dw,dz&w dw])]);
C:=A &mwedge B;
ans:=Matrix([evalV([-dx &w dy &w dw , dx  &w dy &w dw +dy&w dz &w  dw]), 
		   evalV([zero_form(3), -dy&w dz &w dw])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;


true;
end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



Check[DifferentialGeometryTools:-`&mmult`]:=proc()

local  A,B,C, ans;

coord_init([x,y,z,w], DGChk);


A:=Matrix( [evalV([dx , dy+  dw]), evalV([dx +dw,dy +dw])]);
C:=3 &mmult A;
ans:=Matrix( [evalV([3*dx , 3*dy+  3*dw]), evalV([3*dx +3*dw,3*dy +3*dw])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;

A:=Matrix([evalV([D_x -D_y, D_w]),evalV([ D_x +D_y, D_z])]);
C:= (-1) &mmult A;
ans:=Matrix([evalV([-D_x + D_y, -D_w]),evalV([- D_x -D_y, -D_z])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;




A:=Matrix([evalV([dx &t dy, dy&t dy]), evalV([dz &t dw, dz &t  dy])]);
C:= x &mmult A;
ans:=Matrix([evalV([x*dx &t dy, x*dy&t dy]), evalV([x*dz &t dw, x*dz &t  dy])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;


A:=Matrix( [evalV([dx , dy+  dw]), evalV([dx +dw,dy +dw])]);
B:=Matrix( [[1,2],[3,4]]);
C:= A &mmult B;
ans:=Matrix([evalV([dx +3*dy +3*dw, 2*dx +4*dy +4*dw]),
	        evalV([dx +3*dy +4*dw, 2*dx  +4*dy +6*dw])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;




A:=Matrix( [evalV([dx , dy+  dw]), evalV([dx +dw,dy +dw])]);
B:=Matrix( [[1,2],[3,4]]);
C:= B &mmult A;
ans:=Matrix([evalV([3*dx + 2*dw, 3*dy +3*dw]), evalV([7*dx + 4*dw, 7*dy +7*dw])]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;


A:=Matrix( [evalV([dx &w dz , dy &w dw]), evalV([dx&w dw,dz&w dw])]);
B:=Matrix([[x],[y]]);
C:=A &mmult B;
ans:=Matrix([ [evalV(x*dx&w dz +  y*dy &w dw)],[evalV(x*dx &w dw + y* dz &w dw)]]);
if not LinearAlgebra[Equal](C,ans) then  RETURN(false) fi;





true;
end:

#~~~~~~ annihilator ~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-annihilator]:=proc() 
local A,B,C,ans;
coord_init([x,y,z,w],DGChk);

A:=[D_x, D_y];B:=[dx,dy, dz];
C:=annihilator(A,B);
ans:=[dz];
if not EqualSubspaces(C, ans) then RETURN(false) fi;

A:=[D_x, D_y]; B:=evalV([dx-dy,dy]);
C:=annihilator(A,B);
ans:=[];
if not EqualSubspaces(C, ans) then RETURN(false) fi;

A:=evalV([dx, dy, dx+ dy +dz]);
B:=evalV([D_x +D_y +D_z, D_y -2*D_w, -D_x +D_y +D_w, D_x +2*D_y +3*D_y +4*D_w]); C:=annihilator(A,B);
ans:=[D_w];
if not EqualSubspaces(C, ans) then RETURN(false) fi;

coord_init([x,y],[u],Jet):
A:=[Biform(u[0,0]), Biform(u[1,0]), Biform(u[0,1])];
A:=map(convert,A,Vessiot_form);
B:=frameJetVectors();
C:=annihilator(A,B);
ans:=[JetCalc:-total(D_x),JetCalc:-total(D_y)];
ans:=map(JetCalc:-pr_vect,ans,1):
if not EqualSubspaces(C, ans) then RETURN(false) fi;


true;
end:


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-Biform]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);

a:=Biform(x);
ans:=_VESSIOT([[biform, DGChk, [1,0]], [[[1], 1]]]);
if ans <> a then RETURN(false) fi; 

a:=Biform(3);
ans:=_VESSIOT([[biform, DGChk, [0,1]], [[[3], 1]]]);
if ans <> a then RETURN(false) fi; 


a:=Biform(v[0,2]);
ans:=_VESSIOT([[biform, DGChk, [0,1]], [[[14], 1]]]);
if ans <> a then RETURN(false) fi; 


true;
end;

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Check[DifferentialGeometryTools:-DiffGeom_basis]:= proc() 
local A, B, i,ans;
coord_init([x,y,z,u,v],DGChk);

A:= evalV([D_x, D_y,D_x +D_y]);
B:=DiffGeom_basis(A); 
ans:=[D_x,D_y];
if ans <>B then RETURN(false) fi;


A:=evalV( [dx &w dx, dx &w dy,  dx &w dy + dz&w du,  dz&w du,  du &w dv ]);
B:=DiffGeom_basis(A);
ans:=evalV( [ dx &w dy,  dx &w dy + dz&w du,  du &w dv ]);
if ans <>B then RETURN(false) fi;

A:=[Matrix([[1,0],[0,1]]), Matrix([[0,1],[0,0]]), Matrix([[2,3],[0,2]])];
B:= DiffGeom_basis(A);ans:=[Matrix([[1,0],[0,1]]), Matrix([[0,1],[0,0]])];
for i from 1 to nops(B) do 
	if  not LinearAlgebra[Equal](B[i],ans[i]) then 
		RETURN(false) 
	fi; 
od;


true;
end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Check[DifferentialGeometryTools:-complementary_basis]:=proc()
local A,B,C, ans;
coord_init([x,y,z,w],DGChk);

A:=[D_x, D_y];
B:=[D_x, D_y,D_z, D_w];
C:=complementary_basis(A,B);
ans:=[D_z,D_w];
if not EqualSubspaces(ans,C) then RETURN(false)fi;

A:=[D_x, D_y];
B:=[D_x, D_y];
C:=complementary_basis(A,B);
ans:=[];
if not EqualSubspaces(ans,C) then RETURN(false)fi;

A:=[D_x, D_y];
B:=evalV([D_x+D_y, D_z+D_y,D_z+D_w, D_w+D_x]);
C:=complementary_basis(A,B);
ans:=evalV([D_z+D_y,D_z+D_w]);
if not EqualSubspaces(ans,C) then RETURN(false)fi;

A:=evalV([dx+dz, dz+dw]);
B:=[dx,dz,dw];
C:=complementary_basis(A,B);
ans:=[dx];
if not EqualSubspaces(ans,C) then RETURN(false)fi;

A:=evalV([dx &w dy + dy &w dz,  dz &w dw, dy&w dz ]);
B:=generate_forms_in_degree(2,[dx,dy,dz,dw]);
C:=complementary_basis(A,B);
ans:=evalV([dx &w dz , dx &w dw, dy &w dw]);
if not EqualSubspaces(ans,C) then RETURN(false)fi;

A:=evalV([dx &t D_y, dz&t D_w]);
B:=TensorsTools:-generate_tensors([[dx,dz],[D_y,D_w]]);
C:=complementary_basis(A,B);
ans:=evalV([dx &t D_w, dz &t D_y]);
if not EqualSubspaces(ans,C) then RETURN(false)fi;

A:=[Matrix([[1,0],[0,0]]) ,Matrix([[0,1],[0,0]])];
B:=[Matrix([[1,0],[0,0]]) ,Matrix([[0,1],[0,0]]), Matrix([[0,0],[0,1]])];
C:=complementary_basis(A,B);
ans:=[Matrix([[0,0],[0,1]])];
if not EqualSubspaces(ans,C) then RETURN(false) fi;

true; 
end:


#~~~~~ canonical_subspace_basis ~~~~~~~

Check[DifferentialGeometryTools:-canonical_subspace_basis]:=proc()

local A,B,C,ans, check;
coord_init([x,y,z,w],DGChk);

check:=proc(X,Y) local i;for i from 1 to nops(X) do if X[i] <> Y[i] then RETURN(false) fi od; end;

A:=evalV([D_x+D_y, D_x -D_y]);
B:=evalV([D_x, D_y, D_z]);
C:=canonical_subspace_basis(A,B);
ans:=evalV([D_x, D_y]):
check(C,ans);


A:=evalV([D_x+D_y, D_x -D_y]);
B:=evalV([D_y, D_z, D_x]);
C:=canonical_subspace_basis(A,B);
ans:=evalV([D_y, D_x]):
check(C,ans);


A:=evalV([dx+dy, dx -dy +dz]);
B:=evalV([dx, dy, dz]);
C:=canonical_subspace_basis(A,B);
ans:=evalV([dx+1/2*dz, dy-1/2*dz]):
check(C,ans);

A:=evalV([dx &w dy,  dx&w dy  + dz&w dy]);
B:=evalV([dx &w dy,  dx&w dz , dx&w dw, dy &w dz, dy&w dw]);
C:=canonical_subspace_basis(A,B);
ans:= evalV([dx &w dy, dy &w dz]);
check(C,ans);

A:=evalV([dx &t dy,  dx&t dy  + dy &t dz]);
B:=evalV([dx &t dy,  dx&t dz , dx&t dw, dy &t dz, dy&t dw]);
C:=canonical_subspace_basis(A,B);
ans:= evalV([dx &t dy, dy &t dz]);
check(C,ans);


A:=[Matrix([[1,0],[0,0]]) ,Matrix([[3,0],[0,2]])];
B:=[Matrix([[1,0],[0,0]]) ,Matrix([[0,1],[0,0]]), Matrix([[0,0],[0,1]])];
C:=canonical_subspace_basis(A,B);
ans:=[Matrix([[1,0],[0,0]]) , Matrix([[0,0],[0,1]])];
if  not( LinearAlgebra[Equal](ans[1],C[1])   and   LinearAlgebra[Equal](ans[2],C[2]) )  then 
RETURN(false) fi; 

true:
end:






#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


Check[DifferentialGeometryTools:-Divergence ]:=proc() 
local X,a,ans;

coord_init([x,y],[u,v]);
X:=evalV(x*D_x + u[0,0]*D_u[0,0]);
a:=Divergence(X);
ans:=2; 
if  a <> ans then RETURN(false) fi;
 

X:=evalV(x*D_x + u[0,0]*D_u[0,0] +u[2,2]*Vect(u[2,2])); 
a:=Divergence(X);
ans:=3;
if  a <> ans then RETURN(false) fi;

true;
end:

#~~~~~ EqualSubspaces ~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-EqualSubspaces]:=proc()
local  A, B, TF;
coord_init([x,y,z],DGChk);

A:=[dx, dy];
B:=evalV([dx +dy, dx -3*dy]);
TF:=EqualSubspaces(A,B);
if TF <> true then RETURN(false) fi;

A:=evalV([dx &t dx , dx &t dy]);
B:=evalV([dx &t dx, dy &t dx]);
TF:=EqualSubspaces(A,B);
if TF <> false then RETURN(false) fi;

A:=[Matrix([[1,1],[0,1]])];
B:=[Matrix([[2,2],[0,2]])];
TF:=EqualSubspaces(A,B);
if TF <> true then RETURN(false) fi;

true;

end;



#~~~~~ EqualTransform ~~~~~~~~~~~~~~~~~~~~
Check[DifferentialGeometryTools:-EqualTransform]:=proc() 
local phi, psi, TF,ans;
coord_init([x,y],[u],DGChk);

phi:=transform(DGChk,DGChk,[x=x,y=y^2,u[0,0]=u[0,0]^3]);
TF:=EqualTransform(phi,phi);
if TF <> true then RETURN(false) fi;

psi:=transform(DGChk,DGChk,[x=x,y=y^3,u[0,0]=u[0,0]^2]);
TF:=EqualTransform(phi,psi);
if TF <> false  then RETURN(false) fi;

true;
end:


#~~~~~ Form ~~~~~~~~~~~~~~~~~~~~~~~~~~~~


Check[DifferentialGeometryTools:-Form]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);

a:=Form(x);
ans:=_VESSIOT([[form, DGChk, 1], [[[1], 1]]]);
if ans <> a then RETURN(false) fi; 

a:=Form(3);
ans:=_VESSIOT([[form, DGChk, 1], [[[3], 1]]]);
if ans <> a then RETURN(false) fi; 


a:=Form(v[0,2]);
ans:=_VESSIOT([[form, DGChk, 1], [[[14], 1]]]);
if ans <> a then RETURN(false) fi; 


true;
end;
#~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-identity_transform]:=proc()
local phi, ans;

coord_init([x,y,z],Pete);
phi:=identity_transform();
ans:=transform(Pete,Pete,[x=x,y=y,z=z]);
if not EqualTransform(phi,ans) then RETURN(false) fi;

coord_init([x,y],[u],Jake);
phi:=identity_transform(2,Jake);
ans:=transform(Jake,Jake,[x = x, y = y, u[0,0] = u[0,0], u[1,0] = u[1,0], u[0,1] = u[0,1], u[2,0] = u[2,0], u[1,1] = u[1,1], u[0,2] = u[0,2]]);
if not EqualTransform(phi,ans) then RETURN(false) fi;

coord_init([x,y],[u,v],Jake);
phi:=identity_transform(0,Jake);
ans:=transform(Jake,Jake,[x = x, y = y, u[0,0] = u[0,0], v[0,0]=v[0,0]]);
if not EqualTransform(phi,ans) then RETURN(false); fi;

true;

end:

#~~~~~ IntersectSubspaces ~~~~~~~~~~~~~~~


Check[DifferentialGeometryTools:-IntersectSubspaces]:=proc()
local A,B,C,E, ans;

coord_init([x,y,z,w,u],DGChk);

A:=evalV([D_x, D_y,D_z]);
B:=evalV([D_x+D_y, D_x+D_w, D_x+D_w]);
C:=IntersectSubspaces([A,B]);
ans:=evalV([D_x+D_y]);
if not EqualSubspaces(C,ans) then RETURN(false) fi;

A:=evalV([D_x, D_y,D_z]);
B:=evalV([D_x+D_w, D_x+D_w]);
C:=IntersectSubspaces([A,B]);
ans:=[];
if not EqualSubspaces(C,ans) then RETURN(false) fi;

A:=generate_forms_in_degree(2,[dx,dy,dz,du]);
B:=generate_forms_in_degree(2,[dx,dy,dz,dw]);
C:=generate_forms_in_degree(2,[dy,dz,dw,du]);
E:=IntersectSubspaces([A,B,C]);
ans:=[dy &wedge dz];
if not EqualSubspaces(E,ans) then RETURN(false) fi;


A:=evalV([D_x &t dx, D_y &t dy,  D_z&t dz]);
B:=evalV([D_x &t dx, D_y &t dy]);
C:=IntersectSubspaces([A,B]);
ans:=B;
if not EqualSubspaces(C,ans) then RETURN(false) fi;

# Add Matrix  compat 
#
#A:=[Matrix([[1,0],[0,1]]), Matrix([[0,1],[0,0]]), Matrix([[0,0],[0,1]])];
#B:=[Matrix([[1,0],[1,1]]), Matrix([[0,1],[1,0]])];
#C:=IntersectSubspaces([A,B]);
#ans:=[Matrix([[1,0],[-1,1]])];
#if not EqualSubspaces(C,ans) then RETURN(false) fi;


true;
end:






#~~~~~~~~~~~~~~~~~~~~~~~~~~~
Check[DifferentialGeometryTools:-generate_forms_in_degree]:= proc() 
local B, ans;

coord_init([x,y,z,w],DGChk);

B:=generate_forms_in_degree(2,[dx,dy,dw]);
ans:=evalV([dx &w dy , dx &w dw, dy &w dw]);
if B<> ans then RETURN(false) fi;

B:=generate_forms_in_degree(3,[dx,dy,dz,dw]);
ans:=evalV([dx &w dy &w dz , dx &w dy &w dw, dx &w dz &w dw , dy &w  dz &w dw]);
if B<> ans then RETURN(false) fi;

true;
end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~








#~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-tens]:=proc()


# 
#  This program may take a list of variables for the first arg??
#
local a,ans; 

coord_init([x,y],[u,v],DGChk);

a:=tens(x,cov_bas);
ans := _VESSIOT([[tensor, DGChk, [[cov_bas], []]], [[[1], 1]]]);
if ans <> a then RETURN(false) fi; 



a:=tens(y,con_bas);
ans := _VESSIOT([[tensor, DGChk, [[con_bas], []]], [[[2], 1]]]);
if ans <> a then RETURN(false) fi; 

a:= tens(u[0,0],cov_bas);
ans := _VESSIOT([[tensor, DGChk, [[cov_vrt], []]], [[[3], 1]]]);
if ans <> a then RETURN(false) fi; 

true:
end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-transform_pt]:=proc()
local phi, p,q, ans;
coord_init([x,y,z], Pete);

phi:=transform(Pete,Pete,[x=x^2, y=y^2, z=z^2]);
p:=[a,b,c];
q:=transform_pt(phi,p);
ans:=[a^2, b^2, c^2];
if ans <> q then RETURN(false) fi;

coord_init([u,v],Joe);
phi:=transform(Pete,Joe,[u=x*y, v=x^2-y^2]);
p:=[a,b,c];
q:=transform_pt(phi,p);
ans:=[a*b, a^2-b^2];
if ans <> q then RETURN(false) fi;

phi:=transform(Joe,Pete,[x=u, y=v, z= u^2+v^2]);
p:=[a,b];
q:=transform_pt(phi,p);
ans:=[a,b,a^2 +b^2];
if ans <> q then RETURN(false) fi;

true;
end:














#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-scalar_form]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);

a:=scalar_form(S);
ans:=_VESSIOT([[form, DGChk, 0], [[[], S]]]);
if ans <> a then RETURN(false) fi; 

true;
end;

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-vol_form]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);
a:=vol_form(S);
ans:=_VESSIOT([[form, DGChk, 2], [[[1, 2], S]]]);
if ans <> a then RETURN(false) fi; 

true;
 end;


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-zero_form]:=proc()
local a,ans;
 coord_init([x,y],[u,v],DGChk);
 
a:=zero_form(2);
ans:=_VESSIOT([[form, DGChk, 2], [[[1, 2], 0]]]); 
if ans <> a then RETURN(false) fi; 


a:=zero_form(4);
ans:=_VESSIOT([[form, DGChk, 4], [[[1, 2,3,4], 0]]]);
if ans <> a then RETURN(false) fi; 
true; 

end;


#~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-zero_vect]:=proc()
local a,ans;
 coord_init([x,y],[u,v],DGChk);
 
a:=zero_vect();
ans:=_VESSIOT([[vect, DGChk, []], [[[1], 0]]]); 
if ans <> a then RETURN(false) fi; 

true; 

end;


#~~~~~~~~~~~~~~~~~~~~~~~~~


Check[DifferentialGeometryTools:-scalar_tensor]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);

a:=scalar_tensor(1);
ans:=_VESSIOT([[tensor, DGChk, [[], []]], [[[], 1]]]);
if ans <> a then RETURN(false) fi; 

true;
end;




#~~~~~ Vessiot_map ~~~~~~~

Check[DifferentialGeometryTools:-Vessiot_map]:=proc()
local a,b, ans;

a:=(t^2) &mult dx;
b:=Vessiot_map(2,diff,a,t);
ans:=(2*t) &mult dx;
if ans <> b then RETURN(false) fi;

a:=(t^2) &mult dx;
b:=Vessiot_map(3,subs ,a ,{t=3});
ans:=9 &mult dx;
if ans <> b then RETURN(false) fi;

true;
end:


#~~~~~~~~~~~~~~~~~~~~~~~~~


Check[DifferentialGeometryTools:-Vect]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);

a:=Vect(x);
ans:=_VESSIOT([[vect, DGChk, []], [[[1], 1]]]);
if ans <> a then RETURN(false) fi; 

a:=Vect(3);
ans:=_VESSIOT([[vect, DGChk, []], [[[3], 1]]]);
if ans <> a then RETURN(false) fi; 


a:=Vect(v[0,2]);
ans:=_VESSIOT([[vect, DGChk, []], [[[14], 1]]]);
if ans <> a then RETURN(false) fi; 


true;
end;




#~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-zero_tens]:=proc()
local a,ans;
coord_init([x,y],[u,v],DGChk);
 
a:=zero_tens([[cov_bas,con_bas],[]]);
ans:=_VESSIOT([[tensor, DGChk, [[cov_bas, con_bas], []]], [[[1, 1], 0]]]); 
if ans <> a then RETURN(false) fi; 


a:=zero_tens([[cov_bas,con_vrt],[]]);
ans:=_VESSIOT([[tensor, DGChk, [[cov_bas, con_vrt], []]], [[[1, 3], 0]]]); 
if ans <> a then RETURN(false) fi; 




true; 

end;









#~~~~~~~~~~~~~~~~~~~~~~~~~~~~


Check[DifferentialGeometryTools:-scalar_biform]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);
a:=scalar_biform(S);
ans:=_VESSIOT([[biform, DGChk, [0,0]], [[[], S]]]);
if ans <> a then RETURN(false) fi; 

true;
 end;

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-vol_biform]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);
a:=vol_biform(S);
ans:=_VESSIOT([[biform, DGChk, [2,0]], [[[1, 2], S]]]);
if ans <> a then RETURN(false) fi; 

true;
 end;


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Check[DifferentialGeometryTools:-zero_biform]:=proc()
local a,ans; 

coord_init([x,y],[u,v],DGChk);
a:=zero_biform([1,0]);
ans:=_VESSIOT([[biform, DGChk, [1, 0]], [[[1], 0]]]);
if ans <> a then RETURN(false) fi; 


a:=zero_biform([1,1]);
ans:=_VESSIOT([[biform, DGChk, [1, 1]], [[[1, 3], 0]]]);
if ans <> a then RETURN(false) fi; 

a:=zero_biform([0,2]);
ans:=_VESSIOT([[biform, DGChk, [0, 2]], [[[3, 4], 0]]]);
if ans <> a then RETURN(false) fi; 


true;
 end;






















#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(` ****** All DifferentialGeometryTools  Procedures Gave Correct Answers *****`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:


writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):
end:


#-------------------------





