#
# This is the package for  Isometries  Diagonistics


IsometriesDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check, TF,BadProcedureList,P;

Check[Isometries:-Killing_data]:=proc()
local gm1,C1,ans1, ans2, ans3, i, omeg1, omeg2, omeg3,omeg4, H,C2,C3, cF, Cdata;
global  g1,basept1, R1,KD1, g2,basept2, R2, KD2,g3,basept3,R3, KD3;
 
coord_init([t, r ,theta, phi],Schw);
gm1:=Matrix([[-(1- 2*m/r), 0,0,0], [0, 1/(1-2*m/r),0,0], [0,0, r^2,0], [0,0,0,r^2*sin(theta)^2]]);
g1:=convert(gm1,Vessiot_tensor, [[cov_bas,cov_bas], [] ]):
C1:=offel2(g1):
R1:=curvature_tensor(C1):
basept1:=[0,3*m, Pi/2,0]:
KD1:=Killing_data(g1,C1,R1,basept1,4):
ans1:=[[convert(D_t,Vessiot_tensor), evalV((1/(3*m))*D_t &t dr+(1/(27*m))*D_r &t dt)], 
       [convert(D_theta,Vessiot_tensor),evalV( -m*D_r &t dtheta+(1/(3*m))*D_theta &t dr)], 
	  [convert(D_phi,Vessiot_tensor),evalV(-m*D_r &t dphi+(1/(3*m))*D_phi &t dr)], 
	  [convert(0 &mult D_t,Vessiot_tensor), evalV((1/(9*m^2))*D_theta &t dphi+(-1/(9*m^2))*D_phi &t dtheta)]];
if KD1 <> ans1 then  RETURN(false) fi;  

#
#

coord_init([t,chi,theta, phi]);
omeg1:= dt:
omeg2:= S(t) &mult dchi:
omeg3:=  (S(t)*sinh(chi)) &mult dtheta:
omeg4:=(S(t)*sinh(chi)*sin(theta)) &mult dphi :
cF:=[omeg1,omeg2,omeg3,omeg4];

Cdata:=coframe_data([t,chi,theta,phi],cF,RW):
frame_init(Cdata,[E],[omega]);
g2:=convert(LinearAlgebra[DiagonalMatrix]([-1,1,1,1]),Vessiot_tensor,[[cov_bas,cov_bas],[]]);
C2:=offel2(g2):
R2:=curvature_tensor(C2):
basept2:=[0,arcsinh(2),Pi/2,0];
KD2:=Killing_data(g2,C2,R2,basept2,10,[[t],[S]]);

ans2:=[[convert(E2,Vessiot_tensor), evalV((1/S[0]*S[1])* E1 &t omega2 +(1/S[0]*S[1])*E2 &t omega1)], 
	  [convert(E3,Vessiot_tensor), evalV( (1/S[0]*S[1])*E1 &t omega3 +(1/S[0]*S[1]) * E3 &t omega1)], 
	  [convert(E4,Vessiot_tensor), evalV((1/S[0]*S[1])* E1 &t omega4+(1/S[0]*S[1])*E4 &t omega1)],
	  [convert(0 &mult E1,Vessiot_tensor), evalV(E2 &t omega3-E3 &t omega2)], 
	  [convert(0 &mult E1,Vessiot_tensor) ,evalV(E2 &t omega4 -E4 &t omega2)], 
	  [ convert(0 &mult E1,Vessiot_tensor), evalV(E3 &t omega4-E4 &t omega3)]];

if KD2 <> ans2 then RETURN(false) fi; 

#
#

coord_init([y,z,u,v],[],spw):
H:=(y^2 -z^2)*cos(2*u) -2*y*z*sin(2*u);
g3:=evalV( du &t dv + dv &t du  + dy &t dy  + dz &t dz  +  H * du &t du);
C3:=offel2(g3):
R3:=curvature_tensor(C3):
basept3:=[0,0,0,0];

KD3:=Killing_data(g3,C3,R3, basept3):
ans3 := [[convert(D_y,Vessiot_tensor), 0  &mult D_y &tensor dy], 
	    [convert(D_z,Vessiot_tensor), 0 &mult D_y &tensor dy], 
         [convert(D_u,Vessiot_tensor), evalV(D_y &t dz - D_z &t  dy)],
         [convert(D_v,Vessiot_tensor), 0 &mult D_y &tensor dy], 
         [convert(0 &mult D_y,Vessiot_tensor), evalV(D_y &t du -D_v &t dy)], 
	    [convert(0  &mult D_y,Vessiot_tensor), evalV(D_z  &t du -D_v &t dz)]];
if KD3 <> ans3 then RETURN(false) fi; 
true;
 end:
 

#~~~~~~


Check[Isometries:-Killing_data_to_Lie_algebra]:=proc() local K, ans;

K:=Killing_data_to_Lie_algebra(KD1,R1,basept1,alg1);
Lie_algebra_init(K); 
ans:= [[Lie_alg, alg1, [4]], [[[2, 3, 4], 9*m^2], [[2, 4, 3], -1/(9*m^2)], [[3, 4, 2], 1/(9*m^2)]]];
if K <> ans then RETURN(false) fi;

K:=Killing_data_to_Lie_algebra(KD2,R2,basept2,alg2,[[t],[S]]);
Lie_algebra_init(K);
ans:=[[Lie_alg, alg2, [6]], [[[1, 2, 4], -1/(S[0]^2)], [[1, 3, 5], -1/(S[0]^2)], [[1, 4, 2], -1], 
      [[1, 5, 3], -1], [[2, 3, 6], -1/(S[0]^2)], [[2, 4, 1], 1], [[2, 6, 3], -1], [[3, 5, 1], 1], [[3, 6, 2], 1], 
      [[4, 5, 6], 1], [[4, 6, 5], -1], [[5, 6, 4], 1]]];
if K <> ans then RETURN(false) fi;

K:=Killing_data_to_Lie_algebra(KD3,R3,basept3,alg3);
Lie_algebra_init(K);
ans:=[[Lie_alg, alg3, [6]], [[[1, 3, 2], -1], [[1, 3, 5], -1], 
     [[1, 5, 4], -1], [[2, 3, 1], 1], [[2, 3, 6], 1], [[2, 6, 4], -1], [[3, 5, 1], 1], 
     [[3, 5, 6], 1], [[3, 6, 2], 1], [[3, 6, 5], -1]]];
if K <> ans then RETURN(false) fi;
true:
end:





#~~~~~~

Check[Isometries:-Killing_data_to_isotropy_subalgebra]:=proc() 
local iso, ans:

iso:=Killing_data_to_isotropy_subalgebra(KD1,alg1,R1,basept1);
ans:=[e4];
if iso <> ans then RETURN(false) fi;

iso:=Killing_data_to_isotropy_subalgebra(KD2,alg2,R2,basept2);
ans:=[e4,e5,e6];
if iso <> ans then RETURN(false) fi;

iso:=Killing_data_to_isotropy_subalgebra(KD3,alg3,R3,basept3);
ans:=[e5,e6]:
if iso <> ans then RETURN(false) fi;

true:
end:






#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`******  All  Isometries Procedures Gave Correct Answers ******`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:

writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):

end:


#-------------------------






