
# This is the package for  JetCalc  Diagonistics


JetCalcDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check, TF,BadProcedureList,P;

#-----------------------------



Check[JetCalc:-ext_dH]:=proc() 

local a,b, ans;
coord_init([x,y,z],[u,v],DGChk);

DifferentialGeometryTools:-Form(u[6,0,0]);
a:=y*Dx;
b:=ext_dH(a);
ans:= (-1) &mult evalV(Dx &w Dy);
if  ans  <> b then RETURN(false) fi;

a:=evalV(u[0,1,2]*(Dx &w Dz));
b:=ext_dH(a);
ans:= (-u[0,2,2]) &mult evalV(Dx &w Dy &w Dz);
if  ans  <> b then RETURN(false) fi;

a:=Cu[1,1,0];
b:=ext_dH(a);
ans:= evalV(Dx &w Cu[2,1,0] + Dy &w Cu[1,2,0] + Dz &w Cu[1,1,1]); 
if  ans  <> b then RETURN(false) fi;

a:=evalV(Dy &w Dz &w Cu[2,0,0] &w Cv[0,2,0]);
b:=ext_dH(a);
ans:=evalV(Dx &w Dy &w Dz &w (Cu[3,0,0] &w Cv[0,2,0] + Cu[2,0,0] &w Cv[1,2,0]));
if  ans  <> b then RETURN(false) fi;

true:
end:

#--------------------------


Check[JetCalc:-ext_dV]:=proc()

local a,b, ans;
coord_init([x,y,z],[u,v],DGChk);

DifferentialGeometryTools:-Form(u[6,0,0]);
a:=Dx;
b:=ext_dV(a);
ans:= 0 &mult evalV(Dx &w Cu[0,0,0]);
if  ans  <> b then RETURN(false) fi;

a:=evalV(y*u[0,1,2]*(Dx &w Dz));
b:=ext_dV(a);
ans:= ( y  &mult evalV(Dx &w Dz &w Cu[0,1,2]));
if  ans  <> b then RETURN(false) fi;

a:= evalV(y*Cu[1,1,0] &w Dx);
b:=ext_dV(a);
ans:= 0 &mult evalV(Cu[0,0,0] &w Cv[0,0,0] &w Dx); 
if  ans  <> b then RETURN(false) fi;

a:=evalV(Dy &w Dz &w Cu[2,0,0] &w Cv[0,2,0]);
b:=ext_dH(a);
ans:=evalV(Dx &w Dy &w Dz &w (Cu[3,0,0] &w Cv[0,2,0] + Cu[2,0,0] &w Cv[1,2,0]));
if  ans  <> b then RETURN(false) fi;

a:=evalV(u[0,2,0] * v[0,1,2] * Cu[0,0,0] &w Cu[1,1,1]  &w Dx &w Dy);
b:=ext_dH(a);
ans:=evalV((u[0,2,0]*v[0,1,3] + v[0,1,2]*u[0,2,1])*Dx &w Dy &w Dz &w Cu[0, 0, 0] &w Cu[1, 1, 1]+u[0,2,0]*v[0,1,2]*Dx &w Dy &w Dz &w Cu[0, 0, 0] &w Cu[1, 1, 2]
+u[0,2,0]*v[0,1,2]*Dx &w Dy &w Dz &w Cu[0, 0, 1] &w Cu[1, 1, 1]);
if  ans  <> b then RETURN(false) fi;

true:
end:



#--------------------------

#
Check[JetCalc:-Euler_Lagrange]:=proc()
local L, lambda,E, Omega,ans;
coord_init([x,y],[u],J1);

L:=1/2*(u[1,0]^2 +u[0,1]^2);
E:=Euler_Lagrange(L):
ans:=[-u[2,0] -u[0,2]];
if ans <> E then RETURN(false) fi;

lambda:= L &mult DifferentialGeometryTools:-vol_biform();
Omega:=Euler_Lagrange(lambda):
ans:= evalV((-u[2,0] -u[0,2]) *DifferentialGeometryTools:-vol_biform() &w Cu[0,0]); if  ans <> Omega then RETURN(false) fi;
L:=td( x*u[0,1]*cos(u[2,0]),x);
E:=Euler_Lagrange(L):
ans:=[0];
if ans <> E then RETURN(false) fi;

coord_init([t],[x,y],J2);
L:= 1/2*x[1]^2 +1/2*y[1]^2 - 1/(x[0]^2 +y[0]^2);
E:=Euler_Lagrange(L):
ans := [-x[2]+2/(x[0]^2+y[0]^2)^2*x[0], 2/(x[0]^2+y[0]^2)^2*y[0]-y[2]];
if ans <> E then RETURN(false) fi;

lambda:= L &mult DifferentialGeometryTools:-vol_biform();
Omega:=Euler_Lagrange(lambda):
ans :=evalV(E[1]* Cx[0] &w Dt + E[2] *Cy[0] &w Dt);
if ans <> Omega then RETURN(false) fi;

true:
end:

#-----------------------

Check[JetCalc:-Diffeq]:=proc()

local Delta, ans;
coord_init([x,y],[u],DGChk);

Delta:=Diffeq([ u[1,1]- exp(u[0,0])], [u[1,1]]); 
ans:=_VESSIOT([[diffeq, _diffeq, [evol, 0], {u[1,1]}, DGChk], [[[4], u[1,1]-exp(u[0,0])]]]);
if ans <> Delta then RETURN(false) fi;

Delta:=Diffeq([ u[1,1]- exp(u[0,0]),u[2,0]-(u[1,0]^2/2 + f(x))], [u[1,1],u[2,0]]);
ans:=_VESSIOT([[diffeq, _diffeq, [evol, 0], {u[1,1], u[2,0]}, DGChk], [[[4], u[1,1]-exp(u[0,0])], [[5], u[2,0]-1/2*u[1,0]^2-f(x)]]]);
if ans <> Delta then RETURN(false) fi;

coord_init([x],[u,v],DGChk); 
Delta:=Diffeq([u[3]=v[1], v[2]=u[0]],[u[3],v[2]]);
ans:=_VESSIOT([[diffeq, _diffeq, [evol, 0], {u[3], v[2]}, DGChk], [[[4], u[3] = v[1]], [[5], v[2] = u[0]]]]);
if ans <> Delta then RETURN(false) fi;

true;
end:










#------------------------
Check[JetCalc:-Evol]:=proc()

local a, b,ans0,ans;
coord_init([x,y],[u,v],DGChk);

a:=(D_x);
b:=Evol(a);
ans:=evalV(-u[1,0]*D_u[0, 0]-v[1,0]*D_v[0, 0]);
if ans <> b then RETURN(false) fi;

a:= r*D_x +s*D_y; 
b:=Evol(a);
ans:= evalV(-(u[0,1]*s+u[1,0]*r)*D_u[0, 0]-(v[0,1]*s+v[1,0]*r)*D_v[0, 0]); 
if ans <> b then RETURN(false) fi;

a:=evalV(r*D_u[0,0] + s*D_v[0,0]);
b:=Evol(a);
ans:= a; 
if ans <> b then RETURN(false) fi;

true;
end:


#-----------------------------


Check[JetCalc:-homotopy_dH]:=proc()
local a,b,c, ans;

coord_init([x,y],[u,v],DGChk);
DifferentialGeometryTools:-Form(u[2,2]);
a:=evalV(Cu[0,2] &w Dx &w Dy);
b:=homotopy_dH(a);
ans:=evalV(-Dx &w Cu[0, 1]);
if ans <> b then RETURN(false) fi;

a:= evalV( Cu[1,1] &w Dx +Cu[0,2] &w Dy);
b:=homotopy_dH(a);
ans:=evalV(-Cu[0,1]) ;
if ans <> b then RETURN(false) fi;

a:= ext_dH(x*v[1,1]^2 *Cv[1,1] &w Cu[0,0]);
b:=homotopy_dH(a);
ans:=evalV(x*v[1,1]^2 *Cv[1,1] &w Cu[0,0]) ;
if ans <> b then RETURN(false) fi;


a:=evalV(u[2,1]*Dx + u[1,2]*Dy);
b:=homotopy_dH(a);
ans:=DifferentialGeometryTools:-scalar_biform(u[1,1]) ;
if ans <> b then RETURN(false) fi;

a:=evalV(((u[2,2]* v[0,2] - u[1,3]*v[1,1])) * Dx &w Dy);
b:=homotopy_dH(a); c:= a &minus (ext_dH(b)); 
ans:=DifferentialGeometryTools:-zero_biform([2,0]);
if ans <> c then RETURN(false) fi;

true;
end:


#-----------------------------
Check[JetCalc:-homotopy_dV]:=proc()
local a,b, ans;
coord_init([x,y,z],[u,v],DGChk);

DifferentialGeometryTools:-Form(u[0,2,2]);
a:= Cu[0,2,0];
b:=homotopy_dV(a);
ans:=DifferentialGeometryTools:-scalar_biform(u[0,2,0]);
if ans <> b then RETURN(false) fi;

a:= evalV(Cu[0,2,0] &w  Dx &w Dy);
b:=homotopy_dV(a);
ans:=evalV(u[0,2,0]* Dx &w Dy) ;
if ans <> b then RETURN(false) fi;

a:= evalV(  x*v[1,1,0]^2 *Cv[1,1,0] &w Cu[0,0,0]);
b:=homotopy_dV(a);
ans:=evalV(x/4*v[1,1,0]^3*Cu[0, 0, 0]-x/4*v[1,1,0]^2*u[0,0,0]*Cv[1, 1, 0]) ;
if ans <> b then RETURN(false) fi;

true;
end:




#-----------------------------







#----------------------------








Check[JetCalc:-gen_Lie_bracket]:=proc()
local X,Y,Z, ans;
coord_init([x,y],[u],DGChk);

X:=evalV(u[1,1]^2 *D_u[0,0]);
Y:=evalV(u[2,1]*D_u[0,0]);
Z:=gen_Lie_bracket(X,Y);
ans:=evalV((4*u[2,2]*u[2,1]+2*u[1,2]*u[3,1])*D_u[0, 0]);
ans:=changeVectorType(ans,[generalized,0]);
if ans <> Z then RETURN(false) fi;

X:=evalV(u[1,1] *D_x);
Y:=evalV(u[0,1]*D_y);
Z:=gen_Lie_bracket(X,Y);
ans:=evalV((2*u[0,2]*u[1,1]+u[0,1]*u[1,2])*D_x-u[1,2]*u[1,0]*D_y);
ans:=changeVectorType(ans,[generalized,0]);
if ans <> Z then RETURN(false) fi;

true;
end:



#-----------------------------


Check[JetCalc:-I_parts]:=proc()
local a,b, c,nu, ans;

coord_init([x,y,z],[u,v],DGChk);
DifferentialGeometryTools:-Form(u[4,0,0]); 
nu:=evalV(Dx &w Dy &w Dz);

a:= Cu[0,1,0] &wedge nu;
b:=I_parts(a);
ans:= 0 &mult (Cu[0,0,0]) &wedge nu;
if ans <> b  then  RETURN(false) fi;

a:= Cu[0,1,0] &wedge Cv[1,0,1]&wedge nu;
b:=I_parts(a);
ans:= (1/2) &mult evalV( (Cu[1,1,1] &w Cv[0,0,0]  -Cu[0,0,0] &w Cv[1,1,1]) &w nu);
if ans <> b  then  RETURN(false) fi;

a:= ext_dH(u[0,1,2] *Cu[0,1,0] &w Cv[1,0,1]&w Dx &w Dy  + v[0,1,0]*Cu[1,0,1]&w Cu[1,2,0]&w Dx &w Dy);
b:=I_parts(a);
ans:=0 &mult evalV(Cu[0,1,0] &w Cv[1,0,1]&w nu);
if ans <> b  then  RETURN(false) fi;

a:= sin(x)* exp(v[0,0,0])*u[1,2,0]^2 *nu;
b:= Euler_Lagrange(a);
c:=I_parts(ext_dV(b));
ans:=DifferentialGeometryTools:-zero_biform([3,2]);
if c<> ans then RETURN(false) fi;


true;
end:
#----------------------------

Check[JetCalc:-pr_diffeq]:=proc()

local Delta, Delta1, ans;
coord_init([x,y],[u],DGChk);

Delta:=Diffeq([ u[1,1]- exp(u[0,0])], [u[1,1]]); 
Delta1:=pr_diffeq(Delta,1); 
ans:=_VESSIOT([[diffeq, _diffeq, [evol, 1], {u[1,1], u[1,2], u[2,1]}, DGChk], 
[[[4], u[1,1]-exp(u[0,0])], [[7], u[2,1]-exp(u[0,0])*u[1,0]], [[8], u[1,2]-exp(u[0,0])*u[0,1]]]]);
if ans <> Delta1 then RETURN(false) fi;

Delta:=Diffeq([ u[1,1]- exp(u[0,0]),u[2,0]-(u[1,0]^2/2 + f(x))], [u[1,1],u[2,0]]);
Delta1:=pr_diffeq(Delta,1);
ans:=_VESSIOT([[diffeq, _diffeq, [evol, 1], {u[1,1], u[2,0], u[3,0], u[1,2], u[2,1]}, DGChk], 
[[[4], u[1,1]-exp(u[0,0])], [[5], u[2,0]-1/2*u[1,0]^2-f(x)], [[8], u[2,1]-exp(u[0,0])*u[1,0]], 
[[9], u[1,2]-exp(u[0,0])*u[0,1]], [[10], -diff(f(x),x)+u[3,0]-u[1,0]*u[2,0]], 
[[11], u[2,1]-u[1,0]*u[1,1]]]]);

if ans <> Delta1 then RETURN(false) fi;

coord_init([x],[u,v],DGChk); 
Delta:=Diffeq([u[3]-v[1], v[2]-u[0]],[u[3],v[2]]);
Delta1:=pr_diffeq(Delta,2);
ans:=_VESSIOT([[diffeq, _diffeq, [evol, 2], {u[3], v[2], u[4], v[3], u[5], v[4]}, DGChk], 
[[[4], u[3]-v[1]], [[5], v[2]-u[0]], [[8], u[4]-v[2]], 
[[9], v[3]-u[1]], [[12], -v[3]+u[5]], 
[[13], -u[2]+v[4]]]]);

if ans <> Delta1 then RETURN(false) fi;

true;
end:

#----------------------------

 Check[JetCalc:-pr_transform]:=proc() 

local phi, phi1,phi2, EqualTransform,ans; 

EqualTransform:=proc(phi,psi) 
	LinearAlgebra:-Equal(JacobianMatrix(phi),JacobianMatrix(psi)) 
and 	op(phi)[2]=op(psi)[2] 
and 	op(phi)[1][1..3]=op(phi)[1][1..3]; 
end; 


coord_init([x,y],[u],J1);
coord_init([x,y],[v],J2);

phi:=transform(J1,J2,[x= x,y=y,v[0,0]=u[0,0]^2]);
phi1:=pr_transform(phi,2); 
ans:= op(transform(J1,J2, [x = x, y = y, v[0,0] = u[0,0]^2, v[1,0] = 2*u[0,0]*u[1,0], v[0,1] = 2*u[0,0]*u[0,1], v[2,0] = 2*u[1,0]^2+2*u[0,0]*u[2,0], v[1,1] = 2*u[1,0]*u[0,1]+2*u[0,0]*u[1,1], v[0,2] = 2*u[0,1]^2+2*u[0,0]*u[0,2]])); ans[1][3]:=[projectable,2]; ans:=_VESSIOT(ans); op(ans);
if not EqualTransform(ans, phi1) then RETURN(false) fi;

coord_init([x],[u],J1);
coord_init([y],[v],J2);
phi:=transform(J1,J2,[y=u[0] ,v[0]=x]);
phi1:=pr_transform(phi,2); 
ans:=op(transform(J1,J2,[y = u[0], v[0] = x, v[1] = 1/u[1], v[2] = -1/u[1]^3*u[2]]));
ans[1][3]:=[point,2]; 
ans:=_VESSIOT(ans); op(ans);
if not EqualTransform(ans, phi1) then RETURN(false) fi;
 
coord_init([x,y], [u],J1);
 coord_init([r,s], [v],J2);
 phi:=transform(J1,J2,[r=u[1,0], s =y, v[0,0]=1 ,v[1,0]=x ,v[0,1]=x]);

 
 true:
 
 
 
 end:












#----------------------------
Check[JetCalc:-pr_vect]:=proc()
local X,Y1,Y2,ans1,ans2,changeVectorType;
coord_init([x],[u]); 
changeVectorType:=proc(vec,newType)

#CLASS I PROGRAM
#03/01/05

local X;
      
X:=op(vec):

X[1][3]:=newType;

_VESSIOT(X):
end:


X:= evalV(u[0]*D_x -x*D_u[0]);
Y1:=pr_vect(X,1);
ans1:=evalV(u[0]*D_x-x*D_u[0]+(-u[1]^2-1)*D_u[1]);ans1:=changeVectorType(ans1,[point,1]);
if Y1 <> ans1 then RETURN(false) fi;

X:= evalV(u[0]*D_x -x*D_u[0]);
Y2:=pr_vect(X,2);
ans2:=evalV(u[0]*D_x-x*D_u[0]+(-u[1]^2-1)*D_u[1] -3*u[1]*u[2]*D_u[2]);ans2:=changeVectorType(ans2,[point,2]);
if Y2 <> ans2 then RETURN(false) fi;

X:= evalV(u[0]*D_x -x*D_u[0]);
Y1:=pr_vect(X,1);
Y2:=pr_vect(Y1,2);
ans2:=evalV(u[0]*D_x-x*D_u[0]+(-u[1]^2-1)*D_u[1] -3*u[1]*u[2]*D_u[2]);ans2:=changeVectorType(ans2,[point,2]);
if Y2 <> ans2 then RETURN(false) fi;


X:=evalV(u[1]*D_x);
Y1:=pr_vect(X,2);
ans1:=evalV(u[1]*D_x-u[1]*u[2]*D_u[1]+(-2*u[2]^2-u[1]*u[3])*D_u[2]);
ans1:=changeVectorType(ans1,[generalized,2]);
if Y1 <> ans1 then RETURN(false) fi;

X:=evalV(u[2]*D_u[0]);
Y1:=pr_vect(X,3);op(Y1);
ans1:=evalV(u[2]* D_u[0] +u[3]*D_u[1] + u[4]*D_u[2] + u[5]*D_u[3]);
ans1:=changeVectorType(ans1,[evol,3]);
if Y1 <> ans1 then RETURN(false) fi;

coord_init([x],[u,v],DGChk2);
X:= evalV(u[0]*D_v[0] - v[0]*D_u[0]);
Y1:=pr_vect(X,2);
ans1:=evalV(X + u[1]*D_v[1] - v[1]*D_u[1] +u[2]*D_v[2] - v[2]*D_u[2]);
ans1:=changeVectorType(ans1,[projectable,2]);
if Y1 <> ans1 then RETURN(false) fi;

coord_init([x,y],[u,v],DGChk2);
X:=evalV(v[0,0]*D_y-u[0,0]*D_v[0,0]);
Y1:=pr_vect(X,1);
ans1:=evalV(v[0,0]*D_y -u[0,0]*D_v[0, 0]-v[1,0]*u[0,1]*D_u[1, 0]-v[0,1]*u[0,1]*D_u[0, 1]+(-u[1,0]-v[1,0]*v[0,1])*D_v[1, 0]+(-u[0,1]-v[0,1]^2)*D_v[0, 1]);
ans1:=changeVectorType(ans1,[point,1]);
if Y1 <> ans1 then RETURN(false) fi;

X:=evalV(u[1,0]*D_v[0,0]);
Y1:=pr_vect(X,1);
Y2:=pr_vect(Y1,3);
ans2:=pr_vect(X,3);
if Y2 <> ans2 then RETURN(false) fi;


true;
end:

#----------------------------


Check[JetCalc:-projected_pullback]:=proc() 
local phi, phi1, a,b, ans;

coord_init([x,y],[u],J1);
coord_init([r,s],[v],J2);
phi:=transform(J1,J2,[r= x,s=y,v[0,0]=u[0,0]^2]);
phi1:=pr_transform(phi,2);
a:=Cv[0,1];
b:=projected_pullback(phi1,a);
ans:=evalV(2*u[0,1]*Cu[0, 0]+2*u[0,0]*Cu[0, 1]);
if ans <> b then RETURN(false)  fi;

phi:=transform(J1,J2,[r= u[0,0],s=y,v[0,0]=x]);
phi1:=pr_transform(phi,2); 
a:=evalV(r*Dr -s* Ds);
b:=projected_pullback(phi1,a); 
ans:=evalV(u[0,0]*u[1,0]*Dx +(u[0,0]*u[0,1]-y)*Dy);
if ans <> b then RETURN(false)  fi;

phi:=transform(J1,J2,[r= u[0,0],s=y,v[0,0]=x]);
phi1:=pr_transform(phi,2); 
a:=evalV(Cv[0,0] &w Cv[0,1]);
b:=projected_pullback(phi1,a); 
ans:=evalV(-1/u[1,0]^3*u[0,1]*Cu[0, 0] &w Cu[1, 0]+1/u[1,0]^2*Cu[0, 0] &w Cu[0, 1]);
if ans <> b then RETURN(false)  fi;



true
end:

#---------------------------

Check[JetCalc:-pushforward_total]:=proc() 

local phi, phi1, a,b, ans,Psi,Psi1;

coord_init([x,y],[u],J1);
coord_init([r,s],[v],J2);
phi:=transform(J1,J2,[r= x,s=y,v[0,0]=u[0,0]^2]);
phi1:=pr_transform(phi,2);
a:=total(D_x);
b:=pushforward_total(phi1,a);
ans:=evalV(total(D_r));
if ans <> b then RETURN(false)  fi;


phi:=transform(J1,J2,[r= u[0,0],s=y,v[0,0]=x]);
phi1:=pr_transform(phi,2); 
a:=total(u[1,2]*D_x);
b:=pushforward_total(phi1,a); 
ans:=total(u[1,0]*u[1,2]*D_r);
if ans <> b then RETURN(false)  fi;

phi:=transform(J1,J2,[r= u[0,0],s=y,v[0,0]=x]);
Psi:=inverse_transform(phi); 
Psi1:=pr_transform(Psi,1);
phi1:=pr_transform(phi,2); 
a:=total(u[1,0]*D_x);
b:=pushforward_total(phi1,Psi1,a); 
ans:=total(1/(v[1,0]^2)*D_r);
if ans <> b then RETURN(false)  fi;


true:


end:








#------------------------------
Check[JetCalc:-pullback_biform]:=proc() 
local phi, phi1, a,b, ans;
coord_init([x,y],[u],J1);
coord_init([r,s],[v],J2);

phi:=transform(J1,J2,[r= x,s=y,v[0,0]=u[0,0]^2]);
phi1:=pr_transform(phi,2);
a:=Cv[0,1];
b:=pullback_biform(phi1,a);
ans:=evalV(2*u[0,1]*Cu[0, 0]+2*u[0,0]*Cu[0, 1]);
if ans <> b then RETURN(false)  fi;

a:=evalV(Cv[0,1]&w Cv[2,0]);
b:=pullback_biform(phi1,a); 
ans:=evalV(8*u[1,0]*u[0,1]*Cu[0, 0] &w Cu[1, 0]-4*u[0,0]*u[2,0]*Cu[0, 0] &w Cu[0, 1]
+4*u[0,0]*u[0,1]*Cu[0, 0] &w Cu[2, 0]-8*u[0,0]*u[1,0]*Cu[1, 0] &w Cu[0, 1]
+4*u[0,0]^2*Cu[0, 1] &w Cu[2, 0]);
if ans <> b then RETURN(false)  fi;

phi:=transform(J1,J2,[r= x^2,s=y^2,v[0,0]=u[0,0]]);
phi1:=pr_transform(phi,2); 
a:=evalV(r*Dr -s* Ds);
b:=pullback_biform(phi1,a); 
ans:=evalV(2*x^3*Dx  -2*y^3*Dy);
if ans <> b then RETURN(false)  fi;

phi:=transform(J1,J2,[r= x^2,s=y^2,v[0,0]=u[0,0]]);
phi1:=pr_transform(phi,2); 
a:=evalV(r*Dr &w Cv[0,1]);
b:=pullback_biform(phi1,a); 
ans:=evalV(x^3/y*Dx &w Cu[0, 1]);
if ans <> b then RETURN(false)  fi;


true;
end:


#-----------------------------
Check[JetCalc:-td]:=proc()
local a,b, ans;
coord_init([x,y],[u]);
 
a:=u[0,1];
b:=td(a,x);
ans:=u[1,1];
if ans <> b then RETURN(false) fi;


a:=u[0,1];
b:=td(a,2);
ans:=u[0,2];
if ans <> b then RETURN(false) fi;


a:=u[1,1];
b:=td(a,[3,5]);
ans:=u[4,6];
if ans <> b then RETURN(false) fi;

a:= x*u[0,1] + sin(u[1,0]);
b:=td(a,x);
ans:= u[0,1] + x*u[1,1] + cos(u[1,0])*u[2,0];
if ans <> b then RETURN(false) fi;

a:= x*u[0,1] + log(u[1,0]);
b:=td(a,y);
ans:= x*u[0,2] + 1/(u[1,0])*u[1,1];
if ans <> b then RETURN(false) fi;

Form(u[3,0]);

a:=du[1,0];
b:=td(a,x);
ans:=du[2,0];
if ans <> b then RETURN(false) fi;
 
a:=du[1,0];
b:=td(a,[2,5]);
ans:=du[3,5];
if ans <> b then RETURN(false) fi;


a:=evalV(du[1,0] &w du[0,2] &w dy);
b:=td(a,y);
ans:=evalV(du[1,1] &w du[0,2] + du[1,0] &w du[0,3]) &wedge dy;
if ans <> b then RETURN(false) fi;

a:= Cu[2,0];
b:=td(a,x);
ans:=Cu[3,0];
if ans <> b then RETURN(false) fi;

a:= evalV(x*Cu[2,0]);
b:=td(a,[1,1]);
ans:=evalV(x*Cu[3,1]+ Cu[2,1]);
if ans <> b then RETURN(false) fi;

true;end:

#-------------------------------

Check[JetCalc:-total]:=proc()
local a, b,ans0,ans;
coord_init([x,y],[u,v],DGChk);

a:=(D_x);
b:=total(a);
ans0:=op(evalV(D_x+u[1,0]*D_u[0, 0]+v[1,0]*D_v[0, 0])); 
ans0[1][3]:=[tot,0]; 
ans:=_VESSIOT(ans0); 
if ans <> b then RETURN(false) fi;

a:= total(r*D_x +s*D_y); 
b:=total(a);
ans0:= op(evalV(r*D_x+s*D_y+(u[0,1]*s+u[1,0]*r)*D_u[0, 0]+
	                       (v[0,1]*s+v[1,0]*r)*D_v[0, 0]));
ans0[1][3]:=[tot,0]; 
ans:=_VESSIOT(ans0); 
if ans <> b then RETURN(false) fi;



true;
end:

#-------------------------------

Check[JetCalc:-total_hook]:=proc()

local X, a, b,ans;
coord_init([x,y,z],[u,v],DGChk);
DifferentialGeometryTools:-Form(u[4,0,0]);

X:=total(D_x);
a:=evalV( Dx &w Cu[2,0,0]);
b:=total_hook(X,a);
ans:=Cu[2,0,0];
if b <> ans  then RETURN(false) fi;


X:=total(2*D_x - 3*D_z);
a:=evalV( Dx &w Cu[2,0,0] &w Cv[1,0,0]  +  Dz &w Cu[2,0,0] &w Cv[1,1,2]);
b:=total_hook(X,a);
ans:=evalV(2*Cu[2,0,0] &w Cv[1,0,0]  -3* Cu[2,0,0] &w Cv[1,1,2]);
if b <> ans  then RETURN(false) fi;

X:=total(2*D_x - 3*D_z);
a:=evalV( Dx &w Dz&w Cu[2,0,0] &w Cv[1,0,0]);
b:=total_hook(X,a);
ans:=evalV(2* Dz &w  Cu[2,0,0] &w Cv[1,0,0] +3 *Dx &w Cu[2,0,0] &w Cv[1,0,0]);
if b <> ans  then RETURN(false) fi;

true;
end:



#-------------------------------

Check[JetCalc:-vert_hook]:=proc()
local X,b,c,ans;

coord_init([x,y,z],[u,v],DGChk);
DifferentialGeometryTools:-Form(u[3,0,0]);
X:=evalV(z* D_u[0,0,1]);
b:= evalV(Cu[0,0,1] &w Dx);
c:=vert_hook(X,b);
ans:=evalV(z*Dx);
if ans <> c then RETURN(false) fi;

X:=evalV(z* D_u[0,0,1]  - y*D_v[2,0,0]);
b:= evalV(Cu[0,0,1] &w Cv[1,0,1] &w  Dx  + Cv[2,0,0] &w Cu[0,1,0] &w Dy);
c:=vert_hook(X,b);
ans:=evalV(z*Cv[1,0,1] &w Dx  - y*Cu[0,1,0] &w Dy);
if ans <> c then RETURN(false) fi;



X:=evalV(D_u[0,0,1]);
b:= evalV(Cu[0,0,1]);
c:=vert_hook(X,b);
ans:=DifferentialGeometryTools:-scalar_biform(1);
if ans <> c then RETURN(false) fi;





true:
end:




#-------------------------------


#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`All JetCalc Procedures Gave Correct Answers`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:

writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):

end: