#
# This is the package for LieAlgebraCohomology Diagonistics


LieAlgebraCohomologyDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check, Ch,TF, BadProcedureList,P;

Ch:=proc(a,b) 
local i, TF;
  
if nops(a) <> nops(b) then RETURN(false) fi; 
for i from 1 to nops(a) do 
	TF:=DifferentialGeometryTools[EqualSubspaces](a[i], b[i]); 
	if TF = false then RETURN(false) fi; 
od; 
end;

#~~~~~~ RelativeChains ~~~~~~~~~~~~~

Check[LieAlgebraCohomology:-RelativeChains]:=proc()
local L, C, ans;
L:=[[Lie_alg, Sam, [4]], [[[1, 4, 1], 2], [[2, 3, 1], 1], [[2, 4, 2], 1], 
[[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);
C:=RelativeChains([e1]);
ans:=map(evalV,[[DifferentialGeometryTools:-scalar_form(1)], [theta2, theta3, theta4], 
[theta2 &w theta3, theta2 &w theta4 , theta3 &w theta4], 
[theta2 &w theta3 &w theta4]]);
Ch(C,ans);

C:=RelativeChains([e3]);
ans:=map(evalV,[[DifferentialGeometryTools:-scalar_form(1)], [theta4], [theta2 &w theta4], 
[theta1 &w theta2 &w theta4]]):
if ans<> C then RETURN(false) fi;

C:=RelativeChains([e1,e2,e4]);
ans :=[[DifferentialGeometryTools:-scalar_form(1)], [0 &mult theta1]];
Ch(C,ans);

C:=RelativeChains([]);
ans := map(evalV,[[DifferentialGeometryTools:-scalar_form(1)], [theta1, theta2, theta3, theta4],
[theta1 &w theta2, theta1 &w theta3 , theta1 &w theta4 , theta2 &w theta3, theta2 &w theta4, theta3 &w theta4], 
[theta1 &w theta2 &w theta3 , theta1 &w theta2 &w theta4, theta1 &w theta3 &w theta4, theta2 &w theta3 &w theta4 ], 
[theta1 &w  theta2 &w theta3 &w theta4]]);
Ch(C,ans);


true:
end:








#~~~~~~  Cohomology  ~~~~~

Check[LieAlgebraCohomology:-Cohomology]:=proc() 
local L, C,H, Ch, ans; 
L:=[[Lie_alg, Sam, [4]], [[[1, 4, 1], 2], [[2, 3, 1], 1], [[2, 4, 2], 1], [[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);
C:=RelativeChains([e1]);
H:=Cohomology(C); 
ans:=[[theta4], [DifferentialGeometryTools:-zero_form(2)],[DifferentialGeometryTools:-zero_form(3)]];
Ch(H,ans);

L:=[[Lie_alg, sl2, [3]], [[[1, 2, 1], 1], [[1, 3, 2], -2], [[2, 3, 3], 1]]]; Lie_algebra_init(%);
C:=RelativeChains([]);
H:=Cohomology(C);
ans:=[[DifferentialGeometryTools:-zero_form(1)], [DifferentialGeometryTools:-zero_form(2)],
[DifferentialGeometryTools:-vol_form()]];
Ch(H,ans);

L := [[Lie_alg, sl3, [8]], [[[1, 2, 2], 1], [[1, 3, 3], 2], [[1, 4, 4], -1], [[1, 6, 6], 1], 
[[1, 7, 7], -2], [[1, 8, 8], -1], [[2, 4, 1], 1], [[2, 4, 5], -1], [[2, 5, 2], 1], [[2, 6, 3], 1], 
[[2, 7, 8], -1], [[3, 4, 6], -1], [[3, 5, 3], -1], [[3, 7, 1], 1], [[3, 8, 2], 1], [[4, 5, 4], -1], 
[[4, 8, 7], -1], [[5, 6, 6], 2], [[5, 7, 7], -1], [[5, 8, 8], -2], [[6, 7, 4], 1], [[6, 8, 5], 1]]];
Lie_algebra_init(L);
C:=RelativeChains([]):
H:=Cohomology(C);

use DifferentialGeometryTools in 
ans := map(evalV,[[zero_form(1)], [zero_form(2)], 
[-theta1&w theta2&w theta4-2*theta1&w theta3&w theta7-
theta1&w theta6&w theta8+theta2&w theta4&w theta5-theta2&w theta6&w theta7+
theta3&w theta4&w theta8+theta3&w theta5&w theta7-2*theta5&w theta6&w theta8], 
[zero_form(4)], [theta1&w theta2&w theta3&w theta4&w theta7-1/2*theta1&w theta2&w
 theta4&w theta6&w theta8-1/2*theta1&w theta2&w theta5&w theta6&w theta7+
1/2*theta1&w theta3&w theta4&w theta5&w theta8-1/2*theta1&w theta3&w theta6&w theta7&w theta8
+1/2*theta2&w theta3&w theta4&w theta5&w theta7+theta2&w theta4&w theta5&w theta6&w theta8+
1/2*theta3&w theta5&w theta6&w theta7&w theta8], 
[zero_form(6)], [zero_form(7)], [vol_form()]]); end;

Ch(H,ans);

C:=RelativeChains([e1,e5]);
H:=Cohomology(C);use DifferentialGeometryTools in 
ans:=map(evalV,[[zero_form(1)], [-theta3 &w theta7-theta6 &w theta8, -theta2 &w theta4-theta3 &w theta7]
, [zero_form(3)], 
[-theta2 &w theta3 &w theta4 &w theta7+theta2 &w theta4 &w theta6 &w theta8,
 -theta2 &w theta3 &w theta4 &w theta7+theta3 &w theta6 &w theta7 &w theta8], 
[zero_form(5)], 
[-theta2 &w theta3 &w theta4 &w theta6 &w theta7 &w theta8]]) end;

Ch(H,ans);

C:=RelativeChains([e5,e7,e8]);
H:=Cohomology(C);use DifferentialGeometryTools in 
ans:=[[zero_form(1)], [zero_form(2)], [zero_form(3)],[zero_form(4)],[zero_form(5)]] end:
Ch(ans,H);

true end:




#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`******  All LieAlgebraCohomology Procedures Gave Correct Answers ******`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:


writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):

end:


#-------------------------






