
# This is the package for  LieAlgebras  Diagonistics


LieAlgebrasDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local EqualTransform, EqualSubspaces,Check, TF,BadProcedureList,P;
#-----------------------------


EqualTransform:=proc(phi,psi) 
	LinearAlgebra:-Equal(JacobianMatrix(phi),JacobianMatrix(psi)) 
and 	op(phi)[2]=op(psi)[2] 
and 	op(phi)[1][1..3]=op(phi)[1][1..3]; 
end; 

#-----------------------------
EqualSubspaces:=proc(A,B)
  
local ans;
   
if A=[] and B=[] then 
	ans:=true;
     RETURN(ans);
fi; 

if (A=[] and B<>[]) or (A<> [] and B=[]) 
	then ans:=false;
     RETURN
fi; 
    
linear_combo(A,B,check) and linear_combo(B,A,check)
end:


Check[LieAlgebras:-ad]:=proc()
local L,i ,A,ans;
L:=[[Lie_alg, `USU2:490`, [4]], [[[1, 4, 1], 2*a], [[2, 3, 1], 1], [[2, 4, 2], a], [[3, 4, 2], 1], [[2, 4, 3], -1], [[3, 4, 3], a]]];
Lie_algebra_init(L);

A:=ad(e3);
ans:=Matrix([[0, -1, 0, 0], [0, 0, 0, 1], [0, 0, 0, a], [0, 0, 0, 0]]);
if not LinearAlgebra:-Equal(A,ans) then RETURN(false) end;
A:=ad(e1-2*e3+e4);
ans:=Matrix([[-2*a, 2, 0, 2*a], [0, -a, -1, -2], [0, 1, -a, -2*a], [0, 0, 0, 0]]);
if not LinearAlgebra:-Equal(A,ans) then RETURN(false) end;


A:=ad(e4,[e1,e2,e3],[e4]);
ans:=Matrix([[-2*a, 0, 0], [0, -a, -1], [0, 1, -a]]);
if not LinearAlgebra:-Equal(A,ans) then RETURN(false) end;

A:=ad(e2,[e1,e2,e3]);
ans:=Matrix([[0, 0, 1], [0, 0, 0], [0, 0, 0]]);
if not LinearAlgebra:-Equal(A,ans) then RETURN(false) end;

A:=ad();
ans:=map(Matrix,[[[0, 0, 0, -2*a], [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0]], [[0, 0, -1, 0], [0, 0, 0, -a], [0, 0, 0, 1], [0, 0, 0, 0]], [[0, 1, 0, 0], [0, 0, 0, -1], [0, 0, 0, -a], [0, 0, 0, 0]], [[2*a, 0, 0, 0], [0, a, 1, 0], [0, -1, a, 0], [0, 0, 0, 0]]]);
for i from 1 to 4 do if not LinearAlgebra:-Equal(A[i],ans[i]) then RETURN(false)fi; od;

true;
end:



Check[LieAlgebras:-Ad]:=proc()
local L,i ,A,ans;
L:=[[Lie_alg, `USU2:490`, [4]], [[[1, 4, 1], 2*a], [[2, 3, 1], 1], [[2, 4, 2], a], [[3, 4, 2], 1], [[2, 4, 3], -1], [[3, 4, 3], a]]];
Lie_algebra_init(L);



A:=Ad(t*e2);
ans:=Matrix([[1, 0, t, -1/2*t^2], [0, 1, 0, t*a], [0, 0, 1, -t], [0, 0, 0, 1]]);
if not LinearAlgebra:-Equal(A,ans) then RETURN(false) end;

A:=Ad(t*e2 +s*e3);
ans:=Matrix([[1, -s, t, -1/2*s^2-1/2*t^2], [0, 1, 0, t*a+s], [0, 0, 1, -t+s*a], [0, 0, 0, 1]]);
if not LinearAlgebra:-Equal(A,ans) then RETURN(false) end;

true;
end:

#-----------------------------------------
#-----------------------------------------
Check[LieAlgebras:-center]:=proc()
local L, a, ans;

L:=[[Lie_alg, `USU2:410`, [4]], [[[2, 4, 1], 1], [[3, 4, 2], 1]]];
Lie_algebra_init(L);
a:=center();
ans:=[e1];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;

L:=[[Lie_alg, `USU2:450`, [4]],
[[[1, 4, 1], 1], [[2, 4, 1], 1], [[2, 4, 2], 1], [[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);
a:=center();
ans:=[];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;


true; 
end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~




Check[LieAlgebras:-centralizer]:=proc()
local L, a, ans;

L:=[[Lie_alg, `USU2:5380`, [5]], [[[1, 4, 1], 1], [[2, 3, 1], 1], [[2, 4, 2], 1], [[2, 5, 2], -1], [[3, 5, 3], 1]]];
Lie_algebra_init(L);

a:=centralizer([e1,e4]);
ans:=[e3,e5];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;

a:=centralizer([e4,e5]);
ans:=[e4,e5];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;


a:=centralizer([e2,e3,e4]);
ans:=[];
if  not EqualSubspaces(a,ans) then RETURN(false) fi
;

true; 
end:
#----------------------------------------

Check[LieAlgebras:-change_Lie_algebra_basis]:=proc()
local A,L ,K, M ,ans;

L := [[Lie_alg, Sue, [4]], [[[1, 4, 1], 2], [[2, 3, 1], 1], [[2, 4, 2], 1],
[[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);

A:=Matrix([[1,0,0,1],[0,1,1,0],[1,0,0,-1],[0,0,1,1]]);
K:=change_Lie_algebra_basis(A,Bill);
ans:=[[Lie_alg, Bill, [4]], [[[1, 2, 1], 1/2], [[1, 2, 2], -1/2], [[1, 2, 3], 1/2], [[1, 3, 1], -1], [[1, 3, 3], -1], [[1, 4, 2], -1/2],
[[1, 4, 4], -1/2], [[2, 3, 1], 1/2], [[2, 3, 2], -1/2], [[2, 3, 3], 1/2],
[[2, 4, 1], 1], [[2, 4, 3], 1], [[3, 4, 2], 1/2], [[3, 4, 4], 1/2]]];
if ans <> K then RETURN(false) fi; change_Lie_algebra_to(Sue);

K:=change_Lie_algebra_basis([e1+e3,e2,e2 +e4,e1-e3+e4],Sid);
ans:=
[[Lie_alg, Sid, [4]], [[[1, 2, 1], -1/2], [[1, 2, 2], -1/2], [[1, 2, 3], 1/2], 
[[1, 2, 4], -1/2], [[1, 3, 1], 1], [[1, 3, 2], 1], [[1, 4, 1], 3/2], 
[[1, 4, 2], 3/2], [[1, 4, 3], -1/2], [[1, 4, 4], 1/2], [[2, 3, 2], 1], [[2, 4, 1], -1/2],
[[2, 4, 2], 1/2], [[2, 4, 3], 1/2], [[2, 4, 4], -1/2], [[3, 4, 1], -1], [[3, 4, 3], 2], 
[[3, 4, 4], -2]]];
if ans <> K then RETURN(false) fi; change_Lie_algebra_to(Sue);

change_Lie_algebra_to(Sue);
K:=change_Lie_algebra_basis([e1+e3,e2],Sam);
ans:=[[Lie_alg, Sam, [4]], [[[1, 2, 3], -1], [[1, 4, 1], 1], [[1, 4, 2], 1], 
[[1, 4, 3], 1], [[2, 4, 2], 1], [[3, 4, 3], 2]]],[e1,e2];
if ans <> K then RETURN(false) fi; 

true ; end:


#----------------------------------------

Check[LieAlgebras:-change_Lie_algebra_to]:=proc()
local L,K, M ;
L:=[[Lie_alg, Larry, [3]], [[[1, 3, 1], a], [[2, 3, 1], 1], [[1, 3, 2], -1], [[2, 3, 2], a]]];
Lie_algebra_init(L);

K:=[[Lie_alg, Curly, [5]], [[[3, 5, 1], 1], [[4, 5, 2], 1]]];
Lie_algebra_init(K);

M := [[Lie_alg, Moe, [5]], [[[1, 5, 1], 2], [[2, 3, 1], 1], [[2, 5, 2], 1], 
[[2, 5, 3], 1], [[3, 5, 3], 1], [[4, 5, 4], a]]];
Lie_algebra_init(M);

change_Lie_algebra_to(Larry); 

change_Lie_algebra_to(Curly);


true:
end:

#~~~~~~ DecomposeAlgebra ~~~~~~~

Check[LieAlgebras:-DecomposeLieAlgebra]:=proc()
local L1, L2,L3, L4, L5, L6,DA,ans;

L1 := [[Lie_alg, Curly, [3]], [[[1, 2, 1], 1], [[1, 3, 2], -2], [[2, 3, 3], 1]]];
L2 := [[Lie_alg, Larry, [3]], [[[2, 3, 1], 1]]];
Lie_algebra_init(L2):
DA:=DecomposeLieAlgebra()[1];
ans:=[[[Lie_alg, Larry0, [3]], [[[2, 3, 1], 1]]]];
if ans <> DA then RETURN(false) fi;

L3:=direct_sum_of_algebras([L1,L2]);
Lie_algebra_init(L3);
L4:=convert(evalV([e1,e2 +e5,e3-e5, e4 -e2, e5-e1, e6]),Lie_algebra_data); 
Lie_algebra_init(L4);
DA:=nops(DecomposeLieAlgebra()[1]);
if DA <> 2 then RETURN(false) fi;


L1:=[[Lie_alg, `USU2:210`, [2]], [[[1, 2, 1], 1]]];
L2:=direct_sum_of_algebras([L1,L1,L1],Sue); 
Lie_algebra_init(L2);L3:=convert(evalV([e1,e2 +e5,e3-e5, e4 -e2, e5-e1, e6]),Lie_algebra_data); Lie_algebra_init(L3);
DA:=DecomposeLieAlgebra();
if nops(DA[1]) <> 3 then RETURN(false) fi;

L1:=[[Lie_alg,Abe, [5]], []  ];
Lie_algebra_init(L1):
DA:=DecomposeLieAlgebra()[1]; ans:= [[[Lie_alg,Abe, [5]], []  ]]; 
if DA <>  ans then RETURN(false) fi;

true;
end:






#---------------------------------------

Check[LieAlgebras:-LieAlgCheck]:=proc()

#
# Need Checks for Reductive_pair1, Reductive_pair2, symmetric_pair2 homomorphism1
#


local L1,L2, L3, L4, L5,L6,L8, C, ans,S,M;

L1:=[[Lie_alg, `USU2:5210`, [5]], [[[1, 5, 1], 2], [[2, 3, 1], 1], [[2, 5, 2], 1], [[2, 5, 3], 1], [[3, 5, 3], 1], [[3, 5, 4], 1], [[4, 5, 4], 1]]];
Lie_algebra_init(L1);
C:=LieAlgCheck(solvable);
ans:=true;
if ans <> C then RETURN(false) fi;

L2:=[[Lie_alg, `USU2:350`, [3]], [[[1, 2, 1], 1], [[1, 3, 2], -2], [[2, 3, 3], 1]]];
Lie_algebra_init(L2);
C:=LieAlgCheck(solvable);
ans:=false;
if ans <> C then RETURN(false) fi;

L3:= [[Lie_alg, `USU2:410`, [4]], [[[2, 4, 1], 1], [[3, 4, 2], 1]]];
Lie_algebra_init(L3);


C:=LieAlgCheck(nilpotent);
ans:=true;
if ans <> C then RETURN(false) fi;
C:=LieAlgCheck(solvable);
ans:=true;
if ans <> C then RETURN(false) fi;
change_Lie_algebra_to(`USU2:5210`);
C:=LieAlgCheck(nilpotent);
ans:=false;
if ans <> C then RETURN(false) fi;

change_Lie_algebra_to(`USU2:350`);
C:=LieAlgCheck(semisimple);
ans:=true;
if ans <> C then RETURN(false) fi;

change_Lie_algebra_to(`USU2:410`);
C:=LieAlgCheck(semisimple);
ans:=false;
if ans <> C then RETURN(false) fi;

L5:= [[Lie_alg,Abe, [3]], [] ];
Lie_algebra_init(L5);
C:=LieAlgCheck(abelian);
ans:=true;
if ans <> C then RETURN(false) fi;

C:=LieAlgCheck(semisimple);
ans:=false;
if ans <> C then RETURN(false) fi;


change_Lie_algebra_to(`USU2:350`);
C:=LieAlgCheck(indecomposable);
ans:=true;
if ans <> C then RETURN(false) fi;



change_Lie_algebra_to(`USU2:410`);
C:=LieAlgCheck(absolutely_indecomposable);
ans:=true;
if ans <> C then RETURN(false) fi;

L4:=direct_sum_of_algebras([L1,L2],Pete);
Lie_algebra_init(L4);
C:=LieAlgCheck(indecomposable);
ans:=false;
if ans <> C then RETURN(false) fi;


C:=LieAlgCheck(absolutely_indecomposable);
ans:=false;
if ans <> C then RETURN(false) fi;




change_Lie_algebra_to(`USU2:410`);
C:=LieAlgCheck(L1,Jacobi1);
ans:=true;
if C<> ans then RETURN(false) fi;



C:=LieAlgCheck(Jacobi1);
ans:=true;
if C<> ans then RETURN(false) fi;

L6:=[[Lie_alg, Jake, [4]], [[[2, 4, 1], w], [[1, 3, 2], u], [[1, 2, 3], v]]];
Lie_algebra_init(L6);
C:=LieAlgCheck({u,v,w},Jacobi2);
ans:= {0, -u*w, u*w}, {w = 0, v = v, u = u}, {u = 0, v = v, w = w};
if C<> ans then RETURN(false) fi;

change_Lie_algebra_to(`USU2:5210`);
S:=[e1,e2];
C:=LieAlgCheck(S,subalgebra1); ans:=true:
if C<> ans then RETURN(false) fi;


change_Lie_algebra_to(`USU2:5210`);
S:=evalV([e1,e3, e2 + a*e1  +b*e5]);
C:=LieAlgCheck(S,{a,b},subalgebra2);
ans:=true, {b}, [{b = 0, a = a}], [evalV([e1, e3, a*e1+e2])];
if C<> ans then RETURN(false) fi;


change_Lie_algebra_to(`USU2:5210`);
S:=[e1,e2];
C:=LieAlgCheck(S, ideal1); ans:=false:
if C<> ans then RETURN(false) fi;

change_Lie_algebra_to(`USU2:5210`);
S:=[e1,e3,e4];
C:=LieAlgCheck(S, ideal1); ans:=true:
if C<> ans then RETURN(false) fi;

change_Lie_algebra_to(`USU2:5210`);
S:=evalV([e1,e4, e1 + a*e3 +b*e2 +c*e5]);
C:=LieAlgCheck(S,{a,b,c},ideal2);
ans:= true, {-c}, {b = b, c = 0, a = a}, evalV([e1, e4, e1+b*e2+a*e3]);
if C<> ans then RETURN(false) fi;

S:=table();
S[3]:=[e1];
S[2]:=[e1,e2,e3];
S[1]:=[e1,e2,e3,e4,e5];
C:=LieAlgCheck(S,graded_Lie_algebra); ans:=false; if C<> ans then RETURN(false) fi;
change_Lie_algebra_to(`USU2:410`);
S:=table();
S[1]:=[e1,e2,e3,e4]; S[2]:=[e1,e2,e3]; S[3]:=[e1,e2]; S[4]:=[e1];
C:=LieAlgCheck(S,graded_Lie_algebra); ans:=true:
if C<> ans then RETURN(false) fi;

change_Lie_algebra_to(`USU2:350`);
S:=[e2];
M:=[e1,e3];
C:=LieAlgCheck(S,M,reductive_pair1);
ans:=true;
if C<> ans then RETURN(false) fi;

L8 := [[Lie_alg, `USU2:440`, [4]], [[[2, 4, 1], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L8);
M:=evalV([e1,e2 +a*e3 +b*e4]);
S:=[e3,e4];
C:=LieAlgCheck(S,M,{a,b},reductive_pair2);
ans:=true, {0, a, -b}, {a = 0, b = 0}, [e1, e2];
if C<> ans then RETURN(false) fi;

M:=evalV([e2,e1]);
S:=[e3,e4];
C:=LieAlgCheck(S,M,symmetric_pair1);
ans:=true;
if C<> ans then RETURN(false) fi;





true:
end:




#----------------------------------------
Check[LieAlgebras:-complexify_Lie_algebra]:=proc()
local L,K, M, ans;

L:=[[Lie_alg, alg, [2]], [[[1, 2, 1], 1]]];
M:=complexify_Lie_algebra(L);
ans:=[[Lie_alg, algC, [4]], [[[1, 2, 1], 1], [[1, 4, 3], 1], [[3, 2, 3], 1], [[3, 4, 1], -1]]]; 
if M<> ans then RETURN(false) fi;

Lie_algebra_init(L);
M:=complexify_Lie_algebra(alg,Bob);
ans:=[[Lie_alg, Bob, [4]], [[[1, 2, 1], 1], [[1, 4, 3], 1], [[3, 2, 3], 1], [[3, 4, 1], -1]]];
if M<> ans then RETURN(false) fi;

true 
end:


#----------------------------------------
Check[LieAlgebras:-derived_algebra]:=proc()
local L, a, ans;

L:=[[Lie_alg, `USU2:5290`, [5]], [[[1, 5, 1], 1], [[2, 3, 1], 1], [[2, 5, 2], 1], [[3, 5, 4], 1]]];
Lie_algebra_init(L);
a:=derived_algebra();
ans:=[e1,e2,e4];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;

L:=[[Lie_alg, `USU2:540`, [5]], [[[2, 4, 1], 1], [[3, 5, 1], 1]]];
Lie_algebra_init(L);
a:=derived_algebra();
ans:=[e1];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;

true; 
end:
#----------------------------------------

Check[LieAlgebras:-direct_sum_of_algebras]:=proc()
local L,K, M, ans;
L:=[[Lie_alg, algx, [3]], [[[1, 3, 1], a], [[2, 3, 1], 1], [[1, 3, 2], -1], [[2, 3, 2], a]]];
K:=[[Lie_alg, algy, [2]], [[[1, 2, 1], 1]]];

M:=direct_sum_of_algebras([L,K],Bob);
ans:=[[Lie_alg, Bob, [5]], 
[[[1, 3, 1], a], [[2, 3, 1], 1], [[1, 3, 2], -1], [[2, 3, 2], a], [[4, 5, 4], 1]]]; 
if M<> ans then RETURN(false) fi;

Lie_algebra_init(L);
Lie_algebra_init(K);
M:=direct_sum_of_algebras([algx,algy, algy],Pete);
ans:=[[Lie_alg, Pete, [7]], 
[[[1, 3, 1], a], [[2, 3, 1], 1], [[1, 3, 2], -1], [[2, 3, 2], a], [[4, 5, 4], 1], [[6, 7, 6], 1]]];
if M<> ans then RETURN(false) fi;

true end:

#-------------------------------


Check[LieAlgebras:-infinitesimal_automorphisms]:=proc()
local L,A, ans;
L:=[[Lie_alg, `USU2:480`, [4]], [[[1, 4, 1], 2], [[2, 3, 1], 1], [[2, 4, 2], 1], [[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);

A:=infinitesimal_automorphisms(inner);
ans:=map(Matrix,[[[1, 0, 0, 0], [0, 1/2, 1/2, 0], [0, 0, 1/2, 0], [0, 0, 0, 0]], 
[[0, 1, 0, 0], [0, 0, 0, -1], [0, 0, 0, -1], [0, 0, 0, 0]], 
[[0, 0, 1, 0], [0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0]], [[0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0]]]); 
if not EqualSubspaces(A,ans) then RETURN(false) fi;

A:=infinitesimal_automorphisms(full);
ans:=map(Matrix,[[[2, 0, 0, 0], [0, 1, 0, 0], [0, 0, 1, 0], [0, 0, 0, 0]], 
[[0, 1, 0, 0], [0, 0, 0, -1], [0, 0, 0, -1], [0, 0, 0, 0]], [[0, 0, 1, 0], [0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0]], 
[[0, 0, 0, 0], [0, 0, 1, 0], [0, 0, 0, 0], [0, 0, 0, 0]], [[0, 0, 0, 1], [0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0]]]);
if not EqualSubspaces(A,ans) then RETURN(false) fi;

A:=infinitesimal_automorphisms(outer);
ans:=map(Matrix,[[[1, 0, 0, 0], [0, 1/2, -3, 0], [0, 0, 1/2, 0], [0, 0, 0, 0]]]);
if not EqualSubspaces(A,ans) then RETURN(false) fi;
true; 
end:



#-------------------------------

Check[LieAlgebras:-Killing]:=proc()
local L, a, ans;

L:=[[Lie_alg, `USU2:5400`, [5]], [[[1, 3, 2], -1], [[1, 4, 1], -1], [[2, 4, 2], 1], [[2, 5, 1], -1], [[3, 4, 3], 2], [[3, 5, 4], -1], [[4, 5, 5], 2]]];
Lie_algebra_init(L);
a:=Killing();
ans:=Matrix([[0, 0, 0, 0, 0], [0, 0, 0, 0, 0], [0, 0, 0, 0, 5], [0, 0, 0, 10, 0], [0, 0, 5, 0, 0]]);
if not LinearAlgebra:-Equal(a,ans) then RETURN(false) end;

a:=Killing(e3,e5);
ans:=5;
if a <> ans then RETURN(false) end;


true; 
end;


#~~~~~~ LeviDecomposition ~~~~~~

Check[LieAlgebras:-LeviDecomposition]:=proc()
local L, LD,ans, S;

L:= [[Lie_alg, sl3, [8]], [[[1, 2, 2], 1], [[1, 3, 3], 2], [[1, 4, 4], -1], [[1, 6, 6], 1], [[1, 7, 7], -2], [[1, 8, 8], -1], [[2, 4, 1], 1], [[2, 4, 5], -1], [[2, 5, 2], 1], [[2, 6, 3], 1], [[2, 7, 8], -1], [[3, 4, 6], -1], [[3, 5, 3], -1], [[3, 7, 1], 1], [[3, 8, 2], 1], [[4, 5, 4], -1], [[4, 8, 7], -1], [[5, 6, 6], 2], [[5, 7, 7], -1], [[5, 8, 8], -2], [[6, 7, 4], 1], [[6, 8, 5], 1]]];
Lie_algebra_init(L):
LD:=LeviDecomposition();
ans:=[[],[e1,e2,e3,e4,e5,e6,e7,e8]]; 
if not(DifferentialGeometryTools:-EqualSubspaces(LD[1],ans[1]) and 
       DifferentialGeometryTools:-EqualSubspaces(LD[2],ans[2])) then RETURN(false)  fi; 

L:=[[Lie_alg, upper_gl3, [6]], [[[1, 2, 2], 1], [[1, 3, 3], 1], [[2, 4, 2], 1], [[2, 5, 3], 1], [[3, 6, 3], 1], [[4, 5, 5], 1], [[5, 6, 5], 1]]];

Lie_algebra_init(L):
LD:=LeviDecomposition();
ans:=[[e1,e2,e3,e4,e5,e6],[]]; 
if not(DifferentialGeometryTools:-EqualSubspaces(LD[1],ans[1]) and 
       DifferentialGeometryTools:-EqualSubspaces(LD[2],ans[2])) then RETURN(false)  fi; 

L := [[Lie_alg, Joe, [7]], [[[1, 2, 2], 2], [[1, 3, 3], -2], [[2, 3, 1], 1], [[1, 4, 4], 3], [[1, 5, 5], 1], [[1, 6, 6], -1], [[1, 7, 7], -3], [[2, 5, 4], 3], [[2, 6, 5], 2], [[2, 7, 6], 1], [[3, 4, 5], 1], [[3, 5, 6], 2], [[3, 6, 7], 3]]];
Lie_algebra_init(L):

S:=convert(evalV([e1,e1+e2, e2+e3, e3+e4, e4+e5, e5 +e6, e7 +e1]),Lie_algebra_data,[[e4,e5,e6,e7],[e1,e2,e3]],Moe);
Lie_algebra_init(S[1]);

LD:=LeviDecomposition();ans:=[S[2],S[3]];
if not(DifferentialGeometryTools:-EqualSubspaces(LD[1],ans[1]) and 
       DifferentialGeometryTools:-EqualSubspaces(LD[2],ans[2])) then RETURN(false)  fi; 
unassign('W','K1','K2','L3','M','Q','N');

L:=convert([[W,M]=1/2*M, [W,N]=N, [W,Q]=1/2*Q,[K1,K2]=-L3,[K1,L3]=-K2, [K1,M]=-1/2*M,[K1,Q]=1/2*Q ,[K2,L3]=K1, [K2,M]=1/2*Q, [K2,Q]=1/2*M, [L3,M]=-1/2*Q,[L3,Q]=1/2*M,[M,Q]=-N],Lie_algebra_data,[W,K1,K2,L3,M,Q,N], opt21):
Lie_algebra_init(L,[W,K1,K2,L3,M,Q,N],['alpha']):
LD:=LeviDecomposition();
ans:=[[W, M, Q, N], [K1, K2, L3]]:
if not(DifferentialGeometryTools:-EqualSubspaces(LD[1],ans[1]) and 
       DifferentialGeometryTools:-EqualSubspaces(LD[2],ans[2])) then RETURN(false)  fi; 


true;
end;


#-------------------------------

Check[LieAlgebras:-mult_table]:=proc()
local L ,A, ans;

L:=[[Lie_alg, `USU2:210`, [2]], [[[1, 2, 1], 1]]];
Lie_algebra_init(L);

print(mult_table(bracket)):
mult_table(ext_d):

true;
end:

#-------------------------------

Check[LieAlgebras:-Lie_algebra_init]:=proc() 
local L, X,Y,Z,alpha, sigma,ans;

L:=DifferentialGeometryLibrary:-DiffGeom_library(Winternitz,1,[5,3]);
Lie_algebra_init(L,[X], [beta]); 

X:=evalV(X1+X4);
Y:=evalV(X2 + X3 -X5);
Z:=Lie_bracket(X,Y);
ans:=evalV(-X2-X3);
if Z <> ans then RETURN(false) fi;

alpha:=evalV(beta2 - beta3 + 3*beta4);
sigma:=ext_d(alpha);
ans:=evalV(-beta3 &w beta4+beta4 &w beta5);
if sigma <> ans then RETURN(false) fi;

alpha:=evalV(beta2&wedge beta3 + 3*beta4 &wedge beta1);
sigma:=ext_d(alpha);
ans:=evalV(beta2 &w beta4 &w beta5-3*beta3 &w beta4 &w beta5);
if sigma <> ans then RETURN(false) fi;

X:=evalV(X1+ 3*X2- 4*X4 + X5);
alpha:=evalV(beta2 &w beta3 + 3*beta4 &w beta1);
sigma:=Lie_derivative(X,alpha);
ans:=evalV(beta2 &w beta4+4*beta2 &w beta5 -3*beta3 &w beta4);
if sigma <> ans then RETURN(false) fi;

X:=evalV(X1+ 3*X2- 4*X4 + X5);
alpha:=evalV(beta2 &t X4 + 3*beta4 &t X5);
sigma:=Lie_derivative(X,alpha);
ans:=evalV(-beta2 &t X3 -4*beta3 &t X4-12*beta4 &t X3 );

if sigma <> ans then RETURN(false) fi;

true: 
end:





#-------------------------------
Check[LieAlgebras:-Lie_algebra_transform]:=proc()
local L,K,Q,A, phi ,ans0,ans;

 L := [[Lie_alg, Sid, [5]],[[[1, 5, 1], 2], 
[[2, 3, 1], 1], [[2, 5, 2], 1], [[2, 5, 3], 1], [[3, 5, 3], 1], [[4, 5, 4], 2]] ];
 Lie_algebra_init(L);
 A:=Ad(e4+e3);
 phi:=convert(A,Lie_algebra_transform,Sid,Sid);
 ans0:=[[helm_map, [[Sid, 0], [Sid, 0]], [], [A]], [[z1-z2, z1], [z2, z2], [z3+z5, z3], [z4+2*z5, z4], [z5, z5]]];
  ans:=_VESSIOT(ans0):
 if not EqualTransform(phi,ans) then RETURN(false) fi;
 
K:=[[Lie_alg,Joe, [3]], [[[2, 3, 1], 1]]];
Lie_algebra_init(K);
A:=Matrix([[1,0,0],[0,1,0],[0,0,1],[0,0,0],[0,0,0]]);
phi:=convert(A,Lie_algebra_transform,Joe,Sid); 
ans0:=[[helm_map, [[Joe, 0], [Sid, 0]], [], [A]], [[z1, z1], [z2, z2], [z3, z3], [0, z4], [0, z5]]];
ans:=_VESSIOT(ans0):
if not EqualTransform(phi,ans) then RETURN(false) fi;
 
Q:=quotient_algebra([e1,e3],[e2,e4,e5],Bob);
Lie_algebra_init(Q);
A:=Matrix([[0,1,0,0,0],[0,0,0,1,0],[0,0,0,0,1]]);
phi:=convert(A,Lie_algebra_transform,Sid,Bob); 

ans0:=[[helm_map, [[Sid, 0], [Bob, 0]], [], [A]], [[z2, z1], [z4, z2], [z5, z3]]];
ans:=_VESSIOT(ans0):
if not EqualTransform(phi,ans) then RETURN(false) fi;

true; 
end:




#-------------------------------
Check[LieAlgebras:-LieAlg_series] := proc()
local i,n, L,  S, H, ans;

L:=[[Lie_alg, Jake, [5]], [[[2, 5, 1], 1], [[3, 5, 2], 1], [[4, 5, 4], 1]]];
Lie_algebra_init(L);
S:=LieAlg_series(derived);
ans:=[[e1,e2,e3,e4,e5],[e1,e2,e4],[]]; 
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;

S:=LieAlg_series(lower);
ans:=[[e1,e2,e3,e4,e5],[e1,e2,e4],[e1,e4], [e4],[e4]];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;

S:=LieAlg_series(upper);
ans:=[[e1],[e1,e2],[e1,e2,e3]];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;


S:=LieAlg_series(upper);
ans:=[[e1],[e1,e2],[e1,e2,e3]];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;

S:=LieAlg_series(upper);
ans:=[[e1],[e1,e2],[e1,e2,e3]];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;


L:=[[Lie_alg, Sam, [5]], [[[1, 5, 1], 2], 
[[2, 4, 1], 1], [[2, 5, 2], 1], [[3, 4, 2], 1], 
[[3, 5, 3], 0], [[4, 5, 4], 1]]];
Lie_algebra_init(L);

S:=LieAlg_series(derived);
ans:=[[e1,e2,e3,e4,e5],[e1,e2,e4],[e1],[]]; 
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;

S:=LieAlg_series(lower);
ans:=[[e1,e2,e3,e4,e5],[e1,e2,e4],[e1,e2,e4] ];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;

S:=LieAlg_series(upper);
ans:=[[]];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;



L:=[[Lie_alg,Joe, [5]], [[[2, 5, 1], 1], [[3, 5, 2], 1], [[4, 5, 3], 1]]];
Lie_algebra_init(L);

S:=LieAlg_series(derived);
ans:=[[e1,e2,e3,e4,e5],[e1,e2,e3],[]]; 
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;

S:=LieAlg_series(lower);
ans:=[[e1,e2,e3,e4,e5],[e1,e2,e3],[e1,e2],[e1],[] ];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;

S:=LieAlg_series(upper);
ans:=[[e1],[e1,e2],[e1,e2,e3],[e1,e2,e3,e4,e5]];
n:=nops(S); 
for i from 1 to n do 
	if not EqualSubspaces(S[i],ans[i]) then RETURN(false) fi 
od;


true;
end:
#--------------------------------


Check[LieAlgebras:-matrix_algebras]:=proc()
local L,T,K, ans; 
L:=matrix_algebras(full,2);
ans:=[[Lie_alg, gl2R, [4]], [[[1, 2, 2], 1], [[1, 3, 3], -1], 
[[2, 3, 1], 1], [[2, 3, 4], -1], [[2, 4, 2], 1], [[3, 4, 3], -1]]],
[e11, e12, e21, e22], 
[epsilon11, epsilon12, epsilon21, epsilon22];
if ans<> L then RETURN(false) fi;

L:=matrix_algebras(upper,3);
ans:=[[Lie_alg, upper_gl3, [6]], [[[1, 2, 2], 1], [[1, 3, 3], 1], 
[[2, 4, 2], 1], [[2, 5, 3], 1], [[3, 6, 3], 1], [[4, 5, 5], 1], [[5, 6, 5], 1]]], 
[e11, e12, e13, e22, e23, e33], 
[epsilon11, epsilon12, epsilon13, epsilon22, epsilon23, epsilon33];
if ans<> L then RETURN(false) fi;

L:=matrix_algebras(strictly_upper,3);
ans:=[[Lie_alg, strictly_upper_gl3, [3]], [[[1, 3, 2], 1]]], [e12, e13, e23], 
[epsilon12, epsilon13, epsilon23];
if ans<> L then RETURN(false) fi;

coord_init([x,y,z]);
L:=matrix_algebras(full,3);
Lie_algebra_init(L);
T:=[evalV(dx &t dx  + dy &t dy + dz &t dz)];
K:=matrix_algebras(sub_algebra,gl3R, T);
ans:=evalV([e12-e21, e13-e31, e23-e32]);
if ans<> K then RETURN(false) fi;

coord_init([x,y,z]);
L:=matrix_algebras(full,3);
Lie_algebra_init(L);
T:=[D_x,evalV(dx &t dx  + dy &t dy + dz &t dz)];
K:=matrix_algebras(sub_algebra,gl3R, T);
ans:=evalV([e23-e32]);
if ans<> K then RETURN(false) fi;

true:
end:


#--------------------------------

Check[LieAlgebras:-minimal_ideal]:=proc()

local L,  S, H, ans;
L:=[[Lie_alg, Jake, [5]], [[[2, 5, 1], 1], [[3, 5, 2], 1], [[4, 5, 4], 1]]];
Lie_algebra_init(L);

S:=[e3,e5];
H:=minimal_ideal(S); 
ans:=[e1,e2,e3,e4,e5];
if not EqualSubspaces(H,ans) then RETURN(false) fi;

S:=[e1,e2,e3];
H:=minimal_ideal(S); ans:=[e1,e2,e3];
if not EqualSubspaces(H,ans) then RETURN(false) fi;

S:=[e5];
H:=minimal_ideal(S); 
ans:=[e1,e2,e4,e5];
if not EqualSubspaces(H,ans) then RETURN(false) fi;

true;
end:




#--------------------------------
Check[LieAlgebras:-minimal_subalgebra] :=proc()
local L,  S, H, ans;

L:=[[Lie_alg, `USU2:5290`, [5]], [[[1, 5, 1], 1], [[2, 3, 1], 1], [[2, 5, 2], 1], [[3, 5, 4], 1]]];
Lie_algebra_init(L);
S:=[e3,e5];
H:=minimal_subalgebra(S); 
ans:=[e3,e4,e5];

if not EqualSubspaces(H,ans) then RETURN(false) fi;
S:=[e2,e3,e5];
H:=minimal_subalgebra(S); 
ans:=[e1,e2,e3,e4,e5];
if not EqualSubspaces(H,ans) then RETURN(false) fi;

S:=[e1,e4,e5];
H:=minimal_subalgebra(S); 
ans:=[e1,e4,e5];
if not EqualSubspaces(H,ans) then RETURN(false) fi;

true; end:

#--------------------------------

Check[LieAlgebras:-Nilradical]:=proc()
local L, N,S,V, ans;

L:=[[Lie_alg, `USU2:471`, [4]], [[[1, 4, 1], 2], [[2, 3, 1], 1], [[2, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);
N:=Nilradical();
ans:=[e1,e2,e3];
if not EqualSubspaces(N,ans) then  RETURN(false) fi;

L:=[[Lie_alg, `USU2:530`, [5]], [[[2, 5, 1], 1], [[4, 5, 2], 1], [[2, 4, 3], 1]]];
Lie_algebra_init(L);
N:=Nilradical();ans:=[e1,e2,e3,e4,e5];
if not EqualSubspaces(N,ans) then  RETURN(false) fi;

L:=[[Lie_alg, `USU2:5400`, [5]], [[[1, 3, 2], -1], [[1, 4, 1], -1], 
[[2, 4, 2], 1], [[2, 5, 1], -1], [[3, 4, 3], 2], [[3, 5, 4], -1], [[4, 5, 5], 2]]];
Lie_algebra_init(L);
N:=Nilradical();  ans:=[e1,e2];
if not EqualSubspaces(N,ans) then  RETURN(false) fi;

S:=[ [x1,x5]=x2, [x1,x6]=x3, [x1,x7]=x4, [x1,xb]=-2*x1, [x1,xc]=-x1,[x1,xd]=-x1, [x1,xx]=-x1,
[x2,x8]=x3,[x2,x9]=x4,[x2,xb]=-x2,[x2,xc]=-2*x2,[x2,xd]=-x2,[x2,xx]=-x2,
[x3,xa]=x4,[x3,xb]=-x3,[x3,xc]=-x3,[x3,xd]=-2*x3,[x3,xx]=-x3,                                                            
[x4,xb]=-x4,[x4,xc]=-x4,[x4,xd]=-x4,[x4,xx]=-2*x4,
[x5,x8]=x6,[x5,x9]=x7,[x5,xb]=x5,[x5,xc]=-x5,
[x6,xa]=x7,[x6,xb]=x6,[x6,xd]=-x6,
[x7,xb]=x7,[x7,xx]=-x7,
[x8,xa]=x9,[x8,xc]=x8,[x8,xd]=-x8,
[x9,xc]=x9,[x9,xx]=-x9,
[xa,xd]=xa,[xa,xx]=-xa]:


V:=[x1,x2,x3,x4,x5,x6,x7,x8,x9,xa,xb,xc,xd,xx];

L:=convert(S,Lie_algebra_data,V); 
Lie_algebra_init(L):
N:=Nilradical();
ans:=[e1,e2,e3,e4,e5,e6,e7,e8,e9,e10];
if not EqualSubspaces(N,ans) then  RETURN(false) fi;

true: end:


#--------------------------------
Check[LieAlgebras:-normalizer]:=proc()
local L, a, ans;
L:=[[Lie_alg, `USU2:5290`, [5]], [[[1, 5, 1], 1], [[2, 3, 1], 1], [[2, 5, 2], 1], [[3, 5, 4], 1]]];
Lie_algebra_init(L);

a:=normalizer([e1,e5]);
ans:=[e1,e4,e5];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;

a:=normalizer([e3,e4,e5]);
ans:=[e3,e4,e5];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;


true:
end:
#-----------------------------------

Check[LieAlgebras:-quotient_algebra]:=proc()
local L,Q, ans;

L:=[[Lie_alg,alg1, [5]], [[[2, 5, 1], 1], [[3, 4, 1], 1], [[3, 5, 2], 1], [[4, 5, 3], 1]]];
Lie_algebra_init(L);
Q:=quotient_algebra([e1,e2],[e3,e4,e5],Bob);
ans:=[[Lie_alg, Bob, [3]], [[[2, 3, 1], 1]]];
if Q<> ans then RETURN(false) fi;

L:=[[Lie_alg, alg2, [5]], 
[[[1, 5, 1], 2], 
[[2, 3, 1], 1], [[2, 5, 2], 1], [[2, 5, 3], 1], [[3, 5, 3], 1], [[3, 5, 4], 1], [[4, 5, 4], 1]]];
Lie_algebra_init(L);
Q:=quotient_algebra([e1,e2,e3,e4],[e5 ],Bob);
ans:=[[Lie_alg, Bob, [1]], []]; 
if Q<> ans then RETURN(false) fi;

L:=[[Lie_alg, alg3, [5]], [[[1, 3, 2], -1], [[1, 4, 1], -1],
[[2, 4, 2], 1], [[2, 5, 1], -1], [[3, 4, 3], 2], [[3, 5, 4], -1], [[4, 5, 5], 2]]];
Lie_algebra_init(L);
Q:=quotient_algebra([e1,e2],[e3,e4,e5],Bob);
ans:=[[Lie_alg, Bob, [3]], [[[1, 2, 1], 2], [[1, 3, 2], -1], [[2, 3, 3], 2]]];
if Q<> ans then RETURN(false) 
fi;
true end:







#-----------------------------------
Check[LieAlgebras:-rad]:=proc()
local L, a, ans;

L:=[[Lie_alg, `USU2:5290`, [5]], 
[[[1, 5, 1], 1], [[2, 3, 1], 1], [[2, 5, 2], 1], [[3, 5, 4], 1]]];
Lie_algebra_init(L);
a:=rad();
ans:=[e1,e2,e3,e4,e5];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;

L:=[[Lie_alg, `USU2:5400`, [5]], 
[[[1, 3, 2], -1], [[1, 4, 1], -1], [[2, 4, 2], 1], [[2, 5, 1], -1], [[3, 4, 3], 2], [[3, 5, 4], -1], [[4, 5, 5], 2]]];
Lie_algebra_init(L);
a:=rad();
ans:=[e1,e2];
if  not EqualSubspaces(a,ans) then RETURN(false) fi;
true:
end:



Check[LieAlgebras:-transformation_subalgebra]:=proc()
local L,K,Q,A,N, J, InvJ ,phi ,ans0,ans;

L := [[Lie_alg, Sid, [5]],[[[1, 5, 1], 2], [[2, 3, 1], 1], 
[[2, 5, 2], 1], [[2, 5, 3], 1], [[3, 5, 3], 1], [[4, 5, 4], 2]] ];
 Lie_algebra_init(L);
 A:=Ad(e4+e3);
phi:=convert(A,Lie_algebra_transform,Sid,Sid);

 N:=transformation_subalgebra(phi,kernel);
 ans:=[];
if not  EqualSubspaces(N,ans) then RETURN(false) fi;

J:=transformation_subalgebra(phi,image);
ans:=[e1,e2,e3,e4,e5];
if not  EqualSubspaces(J,ans) then RETURN(false) fi;

InvJ:=transformation_subalgebra(phi,inverse_image,[e1,e2,e3]);
ans:=[e1,e2,e3];
if not  EqualSubspaces(InvJ,ans) then RETURN(false) fi;

 K:=[[Lie_alg,Joe, [3]], [[[2, 3, 1], 1]]];
 Lie_algebra_init(K);
 A:=Matrix([[1,0,0],[0,1,0],[0,0,1],[0,0,0],[0,0,0]]);
 phi:=convert(A,Lie_algebra_transform,Joe,Sid); 

N:=transformation_subalgebra(phi,kernel);
ans:=[];
if not  EqualSubspaces(N,ans) then RETURN(false) fi;

J:=transformation_subalgebra(phi,image);
ans:=[e1,e2,e3];
if not  EqualSubspaces(J,ans) then RETURN(false) fi;

InvJ:=transformation_subalgebra(phi,inverse_image,[e1,e2]);
ans:=[e1,e2];
if not  EqualSubspaces(InvJ,ans) then RETURN(false) fi;


change_Lie_algebra_to(Sid); 
Q:=quotient_algebra([e1,e3],[e2,e4,e5],Bob);
Lie_algebra_init(Q);
A:=Matrix([[0,1,0,0,0],[0,0,0,1,0],[0,0,0,0,1]]);
phi:=convert(A,Lie_algebra_transform,Sid,Bob); 

N:=transformation_subalgebra(phi,kernel);
ans:=[e1,e3];
if not  EqualSubspaces(N,ans) then RETURN(false) fi;
 
J:=transformation_subalgebra(phi,image);
ans:=[e1,e2,e3];
if not  EqualSubspaces(J,ans) then RETURN(false) fi;

InvJ:=transformation_subalgebra(phi,inverse_image,[e3]);
ans:=[e1,e3,e5];
if not  EqualSubspaces(InvJ,ans) then RETURN(false) fi;

true; 
end:












#---------------------------------

#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`***** All  LieAlgebras Procedures Gave Correct Answers *****`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:


writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):

end: