#
# This is the package for  LieEngelTheorems  Diagonistics
#

LieEngelTheoremsDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check,  CheckInvariantVector1 ,EqualRep, TF,BadProcedureList,P;

CheckInvariantVector1:=proc(rho,lambda,E) 
local fr,g,n,i,X;
fr:=rho[1][2][1][1];
g:=frameBaseVectors(fr);
n:=nops(lambda);

for i from 1 to n do  
for X in E do 
	if  not ApplyRepresentation(rho,g[i],X)= lambda[i] &mult X  then 
		RETURN(false) 
	fi 
od; 
od;

true
end:

#~~~~~ AscendingIdealsBasis ~~~~~

Check[LieEngelTheorems:-AscendingIdealsBasis]:=proc()
local B,TF,ans,L;

L:=[[Lie_alg, Sue, [5]], [[[2, 4, 1], 1], [[3, 5, 1], 1]]];

Lie_algebra_init(L):
B:=AscendingIdealsBasis();
TF:=CheckAscendingIdealsBasis(B); if TF =false then RETURN(false) fi;
ans := [e1, e2, e3, e4, e5];
if B <> ans then RETURN(false) fi;

L:=[[Lie_alg, Joe, [5]], [[[1, 2, 1], 3/2], [[1, 2, 3], 5/2], 
[[1, 2, 4], -3/2], [[1, 2, 5], -2], [[1, 3, 1], 3/2], [[1, 3, 2], -1], 
[[1, 3, 3], 3/2], [[1, 3, 4], -3/2], [[1, 3, 5], -1], [[1, 4, 1], -1/2], 
[[1, 4, 2], -1], [[1, 4, 3], -1/2], [[1, 4, 4], 1/2], [[1, 4, 5], 1], 
[[1, 5, 1], 2], [[1, 5, 3], 2], [[1, 5, 4], -2], [[1, 5, 5], -2], [[2, 3, 1], -1],
[[2, 3, 2], 1], [[2, 3, 3], -2], [[2, 3, 4], 1], [[2, 3, 5], 1], [[2, 4, 1], -3/2], 
[[2, 4, 2], -1], [[2, 4, 3], -7/2], [[2, 4, 4], 3/2], [[2, 4, 5], 3], [[2, 5, 1], -1], 
[[2, 5, 2], 2], [[2, 5, 3], -1], [[2, 5, 4], 1], [[3, 4, 1], -5/2], [[3, 4, 2], 1], 
[[3, 4, 3], -9/2], [[3, 4, 4], 5/2], [[3, 4, 5], 3], [[3, 5, 1], 1], 
[[3, 5, 3], 3], [[3, 5, 4], -1], [[3, 5, 5], -2], [[4, 5, 1], 3], [[4, 5, 3], 5], 
[[4, 5, 4], -3], [[4, 5, 5], -4]]];

Lie_algebra_init(L);
B:=AscendingIdealsBasis();

TF:=CheckAscendingIdealsBasis(B);
if TF =false then RETURN(false) fi;

ans:=evalV([e1+3*e3 -e4-2*e5, e2+e3-e5, e1, e2+(-1/2)*e5, e2]);
if B <> ans then RETURN(false) fi;


L:=[[Lie_alg, Jan, [10]], [[[1, 2, 2], -1], [[1, 4, 4], -1], [[1, 7, 7], -1], [[2, 3, 2], -1], 
[[2, 5, 4], -1], [[2, 8, 7], -1], [[3, 5, 5], -1], [[3, 8, 8], -1], [[4, 6, 4], -1], 
[[4, 9, 7], -1], [[5, 6, 5], -1], [[5, 9, 8], -1], [[6, 9, 9], -1], 
[[7, 10, 7], -1], [[8, 10, 8], -1], [[9, 10, 9], -1]]];
Lie_algebra_init(L);

B:=AscendingIdealsBasis();
TF:=CheckAscendingIdealsBasis(B);

if TF =false then RETURN(false) fi;
ans:=[e2, e4, e7, e1, e5, e8, e3, e9, e6, e10];
if B <> ans then RETURN(false) fi;

true;
end:


#~~~~~ RepresentationEigenvector ~~~~~


Check[LieEngelTheorems:-RepresentationEigenvector]:=proc()

local L ,R ,M,rho,rho1,A,Omega,T,ans;

L := [[Lie_alg,Bob, [5]], [[[1, 5, 1], 2], [[2, 3, 1], 1], [[2, 5, 2], 1], 
[[2, 5, 3], 1], [[3, 5, 3], 1], [[4, 5, 4], 2]]]; Lie_algebra_init(L);
M:=eval((-1) *ad()):
coord_init([x1,x2,x3,x4,x5],Sal);
rho:=MakeRepresentation(Bob,Sal,M):
R:=RepresentationEigenvector(rho);

CheckInvariantVector1(rho,R);
ans:=[0, 0, 0, 0, -2], [D_x1];
if not R=ans then RETURN(false) fi:



A:=Matrix([[1,0,1,1,0], [-1,2,2,1,0],[0,3,0,1,1],[1,1,1,0,-2],[-1,2,-1,0,1]]); 
coord_init([x1,x2,x3,x4,x5],Bob1);
rho1:=ChangeRepresentationRangeBasis(Bob1,A,rho);
R:=RepresentationEigenvector(rho1);
CheckInvariantVector1(rho1,R);
ans:=[0, 0, 0, 0, -2], 
evalV([D_x1+(1/2)*D_x3+(1/2)*D_x4+(-1/2)*D_x5, D_x2+(1/2)*D_x3+(-1/2)*D_x4+(1/2)*D_x5]);
if R <> ans then RETURN(false) fi;

Omega:=DifferentialGeometryTools:-generate_forms_in_degree(3, frameBaseForms(Sal));
coord_init([x1,x2,x3,x4,x5,x6,x7,x8,x9,x10],Pet);
rho1:=TensorProductRepresentation(rho,Omega,Pet);
R:=RepresentationEigenvector(rho1);CheckInvariantVector1(rho1,R);
ans:=[0, 0, 0, 0, 2], [D_x8];
if R <> ans then RETURN(false) fi;

L:=convert([e1+e3, e2+e4 +e5,e1-e4,e4 +2*e3 -e5,e2 +e5],Lie_algebra_data,Bob2);
Lie_algebra_init(L);
M:=eval((-1) *ad()):
coord_init([x1,x2,x3,x4,x5],Sal);
rho:=MakeRepresentation(Bob2,Sal,M):
R:=RepresentationEigenvector(rho);
CheckInvariantVector1(rho,R);
ans:=[0, -2, 0, 2, -2], evalV([D_x2-D_x5, D_x3]);
if not R=ans then RETURN(false) fi:

T:=TensorsTools:-generateSymmetricTensors(frameBaseForms(Sal),2);
coord_init([x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15],Joe);
rho1:=TensorProductRepresentation(rho,T,Joe);
R:=RepresentationEigenvector(rho1);CheckInvariantVector1(rho1,R);
ans:=[0, 0, 0, 0, 0], evalV([D_x6-D_x8+D_x9+D_x13-D_x14+D_x15]);
if R <> ans then RETURN(false) fi;




true: end:



#~~~~~ SolvableRepresentation ~~~~~

Check[LieEngelTheorems:-SolvableRepresentation]:=proc()  
local L ,R ,M,rho,rho1, rho2, A,Omega,T,ans,sigma;

L := [[Lie_alg,Bob, [5]], [[[1, 5, 1], 2], [[2, 3, 1], 1], [[2, 5, 2], 1], 
[[2, 5, 3], 1], [[3, 5, 3], 1], [[4, 5, 4], 2]]]; 
Lie_algebra_init(L);
M:=eval((-1) *ad()):
coord_init([x1,x2,x3,x4,x5],Sal);
rho:=MakeRepresentation(Bob,Sal,M):
sigma:=SolvableRepresentation(rho);
CheckSolvableRepresentation(rho,sigma[1]);
ans:= [D_x1, D_x4, D_x3, D_x2, D_x5], [1, 2, 3, 4, 5];
if sigma <> ans then RETURN(false) fi; 

A:=Matrix([[1,0,1,1,0], [-1,2,2,1,0],[0,3,0,1,1],[1,1,1,0,-2],[-1,2,-1,0,1]]);
 coord_init([x1,x2,x3,x4,x5],Bob1);
rho1:=ChangeRepresentationRangeBasis(Bob1,A,rho);
sigma:=SolvableRepresentation(rho1); 
CheckSolvableRepresentation(rho1,sigma[1]);
ans := evalV([D_x1+(1/2)*D_x3+(1/2)*D_x4+(-1/2)*D_x5, D_x1+D_x2+D_x3, D_x2, D_x1-3*D_x4, D_x1]), [1, 2, 3, 4, 5];
if sigma <> ans then RETURN(false) fi;

Omega:=DifferentialGeometryTools:-generate_forms_in_degree(3, frameBaseForms(Sal));
coord_init([x1,x2,x3,x4,x5,x6,x7,x8,x9,x10],Pet);
rho1:=TensorProductRepresentation(rho,Omega,Pet);
sigma:=SolvableRepresentation(rho1);
CheckSolvableRepresentation(rho1,sigma[1]);
ans:=[D_x8, D_x3, D_x5, D_x1, D_x9, D_x10, D_x6, D_x7, D_x2, D_x4], [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
if sigma<> ans then RETURN(false) fi;

change_frame_to(Bob):
L:=convert(evalV([e1+e3, e2+e4 +e5,e1-e4,e4 +2*e3 -e5,e2 +e5]),Lie_algebra_data,Bob2);
Lie_algebra_init(L);
M:=eval((-1) *ad()):
coord_init([x1,x2,x3,x4,x5],Sal);
rho2:=MakeRepresentation(Bob2,Sal,M):
sigma:=SolvableRepresentation(rho2); 
CheckSolvableRepresentation(rho2,sigma[1]);
change_frame_to(Sal):
ans:=evalV([D_x2-D_x5, D_x3, D_x1, D_x2+D_x4, D_x2]), [1, 2, 3, 4, 5]; 
if sigma <>ans then RETURN(false) fi:

T:=TensorsTools:-generateSymmetricTensors(frameBaseForms(Sal),2);
coord_init([x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15],Joe);
rho1:=TensorProductRepresentation(rho,T,Joe);
sigma:=SolvableRepresentation(rho1) ;
CheckSolvableRepresentation(rho1,sigma[1]);
ans:=[D_x15, D_x9, D_x12, D_x5, D_x6, D_x7, D_x10, D_x14, D_x2, D_x3, D_x1, D_x8, D_x11, D_x4, D_x13], [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
if sigma <> ans then RETURN(false) fi;

true: 
end:

#~~~~~

Check[LieEngelTheorems:-SolvableBasis]:=proc() local L,B,ans;

L:=[[Lie_alg, Sid, [5]], [[[1, 5, 1], 1], [[2, 5, 2], 1], [[3, 5, 3], 0], 
   [[4, 5, 3], 1], [[3, 5, 4], -1], [[4, 5, 4], 0]]];

Lie_algebra_init(L);


B:=SolvableBasis();
ans:=evalV([e1, e2, e3, e4, e5]), [1, 2, 4, 5];
if ans <> B then RETURN(false) fi;

L:=[[Lie_alg,Ali, [5]], [[[1, 3, 1], 1], [[1, 3, 2], -1], 
  [[2, 3, 1], 2], [[2, 3, 2], -1], [[2, 3, 4], -2], 
  [[2, 3, 5], 2], [[3, 4, 4], -1], [[3, 5, 5], -1]]];


Lie_algebra_init(L);


B:=SolvableBasis();
ans:=evalV([e4, e5, e1 -(1/2)*e2, 1/2*e2, e3]), [1, 2, 4, 5];
if ans <> B then RETURN(false) fi;


L :=[[Lie_alg, Mary, [5]], [[[1, 5, 1], 2], [[2, 3, 1], 1], 
    [[2, 5, 2], 1], [[2, 5, 3], 1], [[3, 5, 3], 1], 
    [[3, 5, 4], 1], [[4, 5, 4], 1]]];



Lie_algebra_init(L);

B:=SolvableBasis();
ans:=evalV( [e1, e4, e3, e2, e5]), [1, 2, 3, 4, 5];
if ans <> B then RETURN(false) fi;

true;


end:






#
#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`******  All  LieEngelTheorems   Procedures Gave Correct Answers ******`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:



writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):


end:


#-------------------------






