
#
# This is the package for  LieGroups  Diagonistics


LieGroupsDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check,CheckMC, TF,BadProcedureList,P;



CheckMC:=proc(Omega,alg_data) local B, VFS,ans;
B:=dual_basis(Omega):
 VFS:=vect_to_Lie_alg(B);
if VFS[2] =alg_data[2] then   ans:=true else ans:=false fi;
 ans;
 end:

#~~~~~ MatrixRepresentationToMultiplicationProcedure

Check[LieGroups:-MatrixRepresentationToMultiplicationProcedure]:=proc() 
local M,f, ans;

coord_init([x,y,z],Gp);
M:=Matrix([[x,y],[0,z]]);

f:=MatrixRepresentationToMultiplicationProcedure(M,[x,y,z]): 

ans:=[a*r, a*s+b*t, c*t];

if f([a,b,c],[r,s,t]) <> ans then 
	RETURN(false) 
fi;

true; 
end:

#~~~~~  LeftRightTransformations


Check[LieGroups:-LeftRightTransformations]:=proc() 

local L,R,M,f, ansR, ansL,TF;

coord_init([x,y,z],Gp);
M:=Matrix([[x,y],[0,z]]);
f:=MatrixRepresentationToMultiplicationProcedure(M,[x,y,z]): 
L,R:=LeftRightTransformations(f,Gp);

ansR:=transform(Gp, Gp, [x = x*b1, y = x*b2+y*b3, z = z*b3]);
ansL:=transform(Gp,Gp, [x = a1*x, y = a1*y+a2*z, z = a3*z]);

TF:= EqualTransform(L,ansL);
if  TF <> true then RETURN(false) fi; 

TF:= EqualTransform(R,ansR);
if  TF <> true then RETURN(false) fi; 

true ;
end:




#~~~~~ LieAlgebraToMaurerCartanForms

Check[LieGroups:-LieAlgebraToMaurerCartanForms]:=proc() 


local L, Omega,ans, ans0,Ch;

 L:=[[Lie_alg, Bob, [4]], [[[1, 4, 1], 1], [[2, 4, 1], 1], [[2, 4, 2], 1], 
	[[3, 4, 3], 1]]];
 Lie_algebra_init(L);

 coord_init([x1,x2,x3,x4],Gp);

 Omega:=LieAlgebraToMaurerCartanForms(Bob,Gp,Cartan);
 Ch:=CheckMC(Omega,L);
if Ch=false then RETURN(false) fi;
 ans0:=[[(-1+exp(x4))/x4, (1+x4*exp(x4)-exp(x4))/x4, 0, (-x2-x2*x4*exp(x4)+x1*x4+x1+exp(x4)*x2-exp(x4)*x1)/x4^2], 
[0, (-1+exp(x4))/x4, 0, x2*(x4+1-exp(x4))/x4^2], [0, 0, (-1+exp(x4))/x4, x3*(x4+1-exp(x4))/x4^2], [0, 0, 0, 1]];

 ans:=map(v_zip,ans0, frameBaseForms(Gp),plus);
 if ans <>Omega then RETURN(false) fi:
 
 L := [[Lie_alg, Mac, [4]], [[[1, 4, 1], 1], [[2, 4, 1], 1], [[2, 4, 2], 1], [[3, 4, 2], 1], [[3, 4, 3], 1]]];
 Lie_algebra_init(L);
 Omega:=LieAlgebraToMaurerCartanForms(Mac,Gp,Cartan);
Ch:=CheckMC(Omega,L);
if Ch=false then RETURN(false) fi;




ans0:=[[(-1+exp(x4))/x4, (1+x4*exp(x4)-exp(x4))/x4, 1/2*(-2+x4^2*exp(x4)-2*x4*exp(x4)+2*exp(x4))/x4, 
1/2*(2*x3-x3*x4^2*exp(x4)-2*x2+2*x3*x4*exp(x4)-2*x2*x4*exp(x4)+2*x1*x4+2*x1-2*exp(x4)*x3+2*exp(x4)*x2-2*exp(x4)*x1)/x4^2],
[0, (-1+exp(x4))/x4, (1+x4*exp(x4)-exp(x4))/x4, (-x3-x3*x4*exp(x4)+x4*x2+x2+exp(x4)*x3-exp(x4)*x2)/x4^2], 
[0, 0, (-1+exp(x4))/x4, x3*(x4+1-exp(x4))/x4^2], [0, 0, 0, 1]];

ans:=map(v_zip,ans0, frameBaseForms(Gp),plus);
 if ans <>Omega then RETURN(false) fi:



L := [[Lie_alg, Sue, [4]], [[[1, 4, 1], 1], [[2, 4, 2], 3], [[3, 4, 2], 1], [[2, 4, 3], -1], [[3, 4, 3], 3]]];
Lie_algebra_init(L);
Omega:=LieAlgebraToMaurerCartanForms(Sue,Gp,Cartan);

# vect_to_Lie_alg fails
#
 
ans0:=[[(-1+exp(x4))/x4, 0, 0, x1*(1+x4-exp(x4))/x4^2], 
[0, 1/10*(exp(3*x4)*sin(x4)+3*exp(3*x4)*cos(x4)-3)/x4, 1/10*(-exp(3*x4)*cos(x4)+3*exp(3*x4)*sin(x4)+1)/x4,
 -1/10*(exp(3*x4)*sin(x4)*x2+3*exp(3*x4)*sin(x4)*x3+3*exp(3*x4)*cos(x4)*x2-3*x2+x3-10*x4*x2-exp(3*x4)*cos(x4)*x3)/x4^2], 
[0, -1/10*(-exp(3*x4)*cos(x4)+3*exp(3*x4)*sin(x4)+1)/x4, 1/10*(exp(3*x4)*sin(x4)+3*exp(3*x4)*cos(x4)-3)/x4, 
1/10*(10*x3*x4-exp(3*x4)*cos(x4)*x2-3*exp(3*x4)*cos(x4)*x3+3*exp(3*x4)*sin(x4)*x2-exp(3*x4)*sin(x4)*x3+x2+3*x3)/x4^2],
[0,0,0,1]];
ans:=map(v_zip,ans0, frameBaseForms(Gp),plus);
 if ans <>Omega then RETURN(false) fi:


L:=[[Lie_alg, Bob, [4]], [[[1, 4, 1], 1], [[2, 4, 1], 1], [[2, 4, 2], 1], [[3, 4, 3], 1]]];

 Lie_algebra_init(L);
coord_init([x1,x2,x3,x4],Gp);
Omega:=LieAlgebraToMaurerCartanForms(Bob,Gp,solvable);
Ch:=CheckMC(Omega,L);
if Ch=false then RETURN(false) fi;
ans0:=[[1, -1, 0, -x1], [0, 1, 0, -x2], [0, 0, 1, -x3], [0, 0, 0, 1]];

ans:=map(v_zip,ans0, frameBaseForms(Gp),plus);
if ans <>Omega then RETURN(false) fi:


L := [[Lie_alg, Mac, [4]], [[[1, 4, 1], 1], [[2, 4, 1], 1], [[2, 4, 2], 1], [[3, 4, 2], 1], [[3, 4, 3], 1]]];
Lie_algebra_init(L);
Omega:=LieAlgebraToMaurerCartanForms(Mac,Gp,solvable);
Ch:=CheckMC(Omega,L);
if Ch=false then RETURN(false) fi;

ans0:=[[1, -1, 1, -x1], [0, 1, -1, -x2], [0, 0, 1, -x3], [0, 0, 0, 1]];
ans:=map(v_zip,ans0, frameBaseForms(Gp),plus);
if ans <>Omega then RETURN(false) fi:


true:
end:


#~~~~~~  MatrixAlgebraToMatrixGroup


Check[LieGroups:-MatrixAlgebraToMatrixGroup]:=proc() 
local L, M, G, ans0, ans;

L:=[[Lie_alg,Bob, [4]], [[[1, 3, 1], 1], [[2, 4, 1], 1], [[1, 4, 2], -1], [[2, 3, 2], 1]]];
Lie_algebra_init(L):
M:=ad():

G:=MatrixAlgebraToMatrixGroup(M,[x,y,z,w]);
ans0:=[[cos(z)*w, sin(z)*w, -x, -y], [-sin(z)*w, cos(z)*w, -y, x], [0, 0, 1, 0], [0, 0, 0, 1]];
ans:=Matrix(ans0):
if not LinearAlgebra:-Equal(G[1],ans) then RETURN(false) fi;
if G[2] <> [0,0,0,1] then RETURN(false) fi;


L:=[[Lie_alg,Pete, [5]], [[[1, 4, 1], 2], [[2, 3, 1], 1], [[2, 4, 2], 1], [[3, 5, 2], 1], 
[[2, 5, 3], -1], [[3, 4, 3], 1]]];
Lie_algebra_init(L):
M:=ad():

G:=MatrixAlgebraToMatrixGroup(M,[x,y,z,u,v]);
ans0:=[[v^2, (z*cos(u)+y*sin(u))*v, (z*sin(u)-y*cos(u))*v, y*z-2*x, -1/2*z^2-1/2*y^2], 
	 [0, cos(u)*v, sin(u)*v, -y, -z], [0, -sin(u)*v, cos(u)*v, -z, y], [0, 0, 0, 1, 0], 
	 [0, 0, 0, 0, 1]];
ans:=Matrix(ans0):

if not LinearAlgebra:-Equal(G[1],ans) then RETURN(false) fi;
if G[2] <> [0,0,0,0,1] then RETURN(false) fi;

M:=map(Matrix,[[[1,0],[0,0]],[[0,1],[0,0]],[[0,0],[0,1]],[[0,0],[1,0]] ]);
G:=MatrixAlgebraToMatrixGroup(M,[x,y,z,w]);
ans:=Matrix([[y*(z+w*x)/z, w], [x*y, z]]);
if not LinearAlgebra:-Equal(G[1],ans) then RETURN(false) fi;
if G[2] <> [0,1,1,0] then RETURN(false) fi;

true:
end:



#~~~~~~

Check[LieGroups:-MaurerCartanMatrixToMatrixGroup]:=proc() 

local L, M, MC, Omega, G, ans;

L:=[[Lie_alg,Bob, [4]], [[[1, 3, 1], 1], [[2, 4, 1], 1], [[1, 4, 2], -1], [[2, 3, 2], 1]]];
Lie_algebra_init(L):
M:=eval((-1)*ad()):

MC:=LieAlgebraToMaurerCartanForms(Bob,Gp,solvable);
Omega:=(M[1] &mmult MC[1]) &mplus (M[2] &mmult MC[2]) &mplus (M[3] &mmult MC[3]) 
                           &mplus (M[4] &mmult MC[4]);
G:=MaurerCartanMatrixToMatrixGroup(Omega,left,METHOD=pdsolve);
ans:=Matrix([[cos(w)*exp(-z), -sin(w)*exp(-z), (-sin(w)*y+x*cos(w))*exp(-z), (x*sin(w)+cos(w)*y)*exp(-z)], 
             [sin(w)*exp(-z), cos(w)*exp(-z), (x*sin(w)+cos(w)*y)*exp(-z), (sin(w)*y-x*cos(w))*exp(-z)], 
             [0, 0, 1, 0], [0, 0, 0, 1]]);

if not LinearAlgebra:-Equal(G,ans) then RETURN(false) fi;

true:

end:

#~~~~~

Check[LieGroups:-MaurerCartanMatrixToMatrixGroup]:=proc()

local L, M, MC, Omega, G, ans;

L:=[[Lie_alg,Bob, [4]], [[[1, 3, 1], 1], [[2, 4, 1], 1], [[1, 4, 2], -1], [[2, 3, 2], 1]]];
Lie_algebra_init(L):
M:=eval((-1)*ad()):
coord_init([x,y,z,w],Gp);
MC:=LieAlgebraToMaurerCartanForms(Bob,Gp,solvable); 

use DifferentialGeometryTools in 
	Omega:=(M[1] &mmult MC[1]) &mplus (M[2] &mmult MC[2]) &mplus (M[3] &mmult MC[3]) 
		   &mplus (M[4] &mmult MC[4]); 
end:

G:=MaurerCartanMatrixToMatrixGroup(Omega);
ans:=Matrix([[cos(w)*exp(-z), -sin(w)*exp(-z), (-sin(w)*y+x*cos(w))*exp(-z), (x*sin(w)+cos(w)*y)*exp(-z)], [sin(w)*exp(-z), cos(w)*exp(-z), (x*sin(w)+cos(w)*y)*exp(-z), (sin(w)*y-x*cos(w))*exp(-z)], 
	        [0, 0, 1, 0], [0, 0, 0, 1]]);

if not LinearAlgebra:-Equal(G,ans) then RETURN(false) fi;

true:
end:

#~~~~~~




#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`******  All LieGroup Procedures Gave Correct Answers ******`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:



writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):


end:


#-------------------------






