#
# This is the package for  Tensor  Diagonistics


TensorsDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check, TF,BadProcedureList,P;



#
#-----------------------------------------
#

Check[tensors:-contract_indices]:=proc() 

local R,S,T,ans;
coord_init([x,y,z,w],DGChk);

R:=evalV( dx &t D_x &t D_y);
T:=contract_indices(R,[[1,2]]);
ans:=evalV(convert(D_y,Vessiot_tensor));
if ans <> T then RETURN(false)fi;

R:=evalV( dx &t dw &t D_x &t D_y  &t dz + 
       3* dx &t dz &t D_x &t D_y &t dy +3* dx &t dx&t  D_z &t D_y &t dx );
T:=contract_indices(R,[[1,3],[4,5]]);
ans:=evalV(convert(3 &mult dz,Vessiot_tensor));
if ans <> T then RETURN(false)fi;

R:= evalV( dx &t D_x &t D_y);
S:= evalV( dx &t D_x &t D_y);
T:=contract_indices(R,S,[[1,2]]);
ans:=evalV(D_x &t D_y &t dx &t D_y);
if ans <> T then RETURN(false)fi;

R:=evalV( z*dx&t D_y + x* dy &t D_x  + y*dz &t  D_w   -w*dw &t D_z);
S:=evalV(  dx &t dy &t D_x  -z*dy &t dy &t D_y + y* dx&t dz &t D_w);
T:=contract_indices(R,S,[[2,2],[1,3]]); 
ans:=convert((-w*y+z) &mult dx,Vessiot_tensor);

true
end:
#---------------------------------


Check[tensors:-Cotton_tensor]:=proc()

local g,h, C,R,E, ans;
coord_init([x,y,z],DGChk);

g:=evalV(dx &t dx + z* dy&t dy + dz &t dz); h:=inverse_metric(g);
C:=offel2(g):
R:=curvature_tensor(C);
E:=Cotton_tensor(g,C,R); 
ans :=metric_density(g,-2) &tensor 
evalV( (-1/(2*z^2))*D_x &t D_y+(-1/(2*z^2))*D_y &t D_x); 
if  E <> ans then RETURN(false) fi;

g:=evalV(sin(z)*exp(y)*(dx &t dx - dy&t dy + dz &t dz)); h:=inverse_metric(g);
C:=offel2(g):
R:=curvature_tensor(C);
E:= Cotton_tensor(g,C,R); 
ans:=DifferentialGeometryTools:-zero_tens([[con_bas, con_bas], [[bas, -1]]]);
if  E <> ans then RETURN(false) fi;
true;
end:


#---------------------------------

Check[tensors:-covariant_derivative]:=proc()

local ans,C0, C, S,T;

coord_init([x,y,z],DGChk);

C0:= evalV(  dz &t D_y &t dz - dz&t D_x &t dy  + dx &t D_z &t dx);
C:=convert(C0,Vessiot_connection);
S:= convert(dx,Vessiot_tensor);
T:=covariant_derivative(S,C); ans:=dz &tensor dy;
if T <> ans then RETURN(false) fi;


C0:=evalV(  dz &t D_y &t dz - dz&t D_x &t dy  + dx &t D_z &t dx);
C:=convert(C0,Vessiot_connection);
S:=DifferentialGeometryTools:-scalar_tensor(x^2+y*z);
T:=covariant_derivative(S,C);
ans:=convert(2*x*dx +z*dy +y*dz,Vessiot_tensor);
if T <> ans then RETURN(false) fi;

C0:= evalV(  dz &t D_y &t dz - dz&t D_x &t dy  + dx &t D_z &t dx);
C:=convert(C0,Vessiot_connection);
S:= convert(z*dx&t D_y &t dz -y*dx&t D_x &t dx,Vessiot_tensor);
T:=covariant_derivative(S,C); 
ans:= evalV(-dx&t D_x&t dx&t dy-y*dx&t D_x&t dz&t dy -z*dx&t D_y&t dx&t dx +dx&t D_y&t dz&t dz-y*dx&t D_z&t dx&t dx-y*dz&t D_x&t dx&t dy+z*dz&t D_y&t dz&t dy);
if T <> ans then RETURN(false) fi;

true; end:



#---------------------------

Check[tensors:-curvature_tensor]:=proc() local g,C,R,ans; 
coord_init([x,y,z]);
C:=convert( evalV(x^2*dx &t D_y &t dz), Vessiot_connection);
R:=curvature_tensor(C);
ans:=evalV( -4*x*dx&t D_y&t dx&t dz +4*x*dx&t D_y&t dz&t dx);
if ans <> R then RETURN(false) fi;

C:=convert( evalV(y*dx &t D_y &t dz - y*dz &t D_x &t dy), Vessiot_connection);
R:=curvature_tensor(C);
ans:=evalV(-2*dx&t D_y&t dy&t dz +2*dx&t D_y&t dz&t dy -2*y^2*dz&t D_y&t dy&t dz +2*y^2*dz&t D_y&t dz&t dy); 
if ans <> R then RETURN(false) fi;

true; 
end:


#---------------------------


#---------------------------------


Check[tensors:-directional_covariant_derivative]:=proc() 

local ans,C0, C,X,S,T;

coord_init([x,y,z],DGChk);
C0:=evalV(dx &t D_x &t dy  +3*dx &t D_y &t dx -2*dy &t D_x &t dx);
C:=convert(C0,Vessiot_connection);
X:= D_x;
S:= convert(x^2*D_y,Vessiot_tensor);
T:=directional_covariant_derivative(X,S,C);
ans:=convert(evalV(-2*x^2*D_x +2*x *D_y),Vessiot_tensor);
if ans <>T then RETURN(false)fi;

C0:=evalV(dx &t D_x &t dy  +3*dx &t D_y &t dx -2*dy &t D_x &t dx);
C:=convert(C0,Vessiot_connection);
X:= D_x;
S:= convert(sin(x)*dx,Vessiot_tensor);
T:=directional_covariant_derivative(X,S,C);
ans:=convert( evalV(cos(x)*dx +2*sin(x)*dy), Vessiot_tensor);
if ans <>T then RETURN(false) fi;

C0:=evalV(dx &t D_x &t dy  +3*dx &t D_y &t dx -2*dy &t D_x &t dx);
C:=convert(C0,Vessiot_connection);
X:=evalV(D_x +4*D_y -D_z);
S:= evalV(dx &t dy);
T:=directional_covariant_derivative(X,S,C);
ans:=evalV(-3*dx &t dx -4*dx &t dy +2*dy &t dy);
if ans <>T then RETURN(false) fi;

C0:=evalV(y*dx &t D_x &t dy  +3*z*dx &t D_z &t dx -2*dy &t D_x &t dx);
C:=convert(C0,Vessiot_connection);
X:=evalV(D_x +4*D_y -D_z);
S:= evalV(z*dx &t D_y - x*dy &t D_z + y^2*dy &t D_y);
T:=directional_covariant_derivative(X,S,C);
ans:=evalV(-2*z*dx &t  D_x +(-4*y*z-1)*dx &t D_y -2*y^2*dy &t D_x+(2*z+8*y)*dy &t D_y -dy &t D_z);
if ans <>T then RETURN(false) fi;

true;
end:

#--------------------------------
Check[tensors:-Einstein_tensor]:=proc()
local g,h, C,R,E, ans;
coord_init([x,y,z,w],DGChk);

g:=evalV(dx &t dx - z* dy&t dy + dz &t dz - dw &t dw); 
h:=inverse_metric(g);
C:=offel2(g):
R:=curvature_tensor(C);
E:=Einstein_tensor(h,R); 

ans :=evalV( (-1/(2*z^2))*D_x &t D_x +(1/(2*z^2))*D_w &t D_w);
if  E <> ans then RETURN(false) fi;

true;

end:

#--------------------------------

Check[tensors:-GeodesicEquations]:=proc() 
local C, curve,G, ans;
coord_init([x,y],DGChk);

C:=convert(evalV(dx &t D_y  &t dy),Vessiot_connection);
curve:= [a(t),b(t)];
G:=GeodesicEquations(curve,C,t);
ans:=evalV(diff(a(t),`$`(t,2))*D_x+(diff(a(t),t)*diff(b(t),t)+diff(b(t),`$`(t,2)))*D_y);
if ans <>G then RETURN(false) fi;

true;
end:


#-------------------------------

Check[tensors:-Hodge_star]:=proc()
local g,a, ans;

coord_init([x1,x2,x3,x4,x5]);
g:=convert(LinearAlgebra[DiagonalMatrix]([1,1,1,1,1]),Vessiot_tensor,[[cov_bas, cov_bas], []]);

a:=Hodge_star(g,dx1);
ans:=evalV(dx2 &w dx3 &w dx4 &w dx5);
if a <> ans then RETURN(false) fi;

a:=Hodge_star(g,dx2 &wedge dx4 );
ans:=(-1) &mult evalV(dx1  &w dx3 &w dx5);
if a <> ans then RETURN(false) fi;

a:=Hodge_star(g,evalV(2*dx1 &w dx2  +3*dx2 &w dx4));
ans:=evalV(2* dx3 &w dx4 &w dx5 -3*dx1  &w dx3 &w dx5);
if a <> ans then RETURN(false) fi;

true;
end:



#---------------------------------

Check[tensors:-inverse_metric]:=proc() 
local g, h, ans;
coord_init([x,y,z]);

g:=evalV(dx &t dx  + dy &t dy + dz &t dz);
h:=inverse_metric(g);
ans:=evalV(D_x &t D_x+ D_y &t D_y + D_z &t D_z);
if h <> ans then RETURN(false) fi;

g:=evalV(y*(dx &t dy + dy &t dx)   +z*(dy &t dz +  dz&t  dy)  + y*dz &t dz);
h:=inverse_metric(g);
ans:=_VESSIOT([[tensor, euclid, [[con_bas, con_bas], []]], [[[1, 1], z^2/y^3], [[1, 2], 1/y], [[1, 3], -1/y^2*z], [[2, 1], 1/y], [[3, 1], -1/y^2*z], [[3, 3], 1/y]]]);
if h <> ans then RETURN(false) fi;

true;
end:
#

Check[tensors:-metric_density]:=proc()

local S,T, ans;
coord_init([x,y],DGChk);

S:=evalV(dx &t dx  + dy &t dy);
T:=metric_density(S,1);

ans:=_VESSIOT([[tensor, DGChk, [[], [[bas, 1/2]]]], [[[], 1]]]);
if T <> ans then RETURN(false) fi;

true
end:


#------------------------------------

Check[tensors:-multi_vector]:=proc()
local T, ans;
coord_init([x,y,z]);

T:=multi_vector([D_x,D_y]);
ans:= evalV(D_x &t D_y - D_y &t D_x);
if  ans <> T then RETURN(false) fi;

T:=multi_vector(evalV([D_x +3*D_y,2*D_x + D_y -D_z,D_z +D_x +D_y]));
ans:=(-7) &mult evalV(D_x&t D_y &t D_z + D_z&t D_x &t D_y + 
     D_y&t D_z  &t D_x -D_y &t D_x &t D_z - D_z &t D_y &t D_x - D_x &t D_z &t D_y );
if  ans <> T then RETURN(false) fi;

true;
end:

#------------------------------------

 Check[tensors:-offel1]:=proc() 
local g, C, ans;
coord_init([x,y,z],DGChk);

g:=evalV(dx&t dx + dy &t dy + dz &t dz);
C:=offel1(g);
ans:=0 &mult evalV( dx &t dx &t dx);

if ans<> C then RETURN(false) fi;
g:= evalV( x^2*dx&t dx + dy &t dy +4* y*z*dz &t dz);
C:=offel1(g);
ans:=evalV(x*dx&t dx&t dx +2*z*dy&t dz&t dz -2*z*dz&t dy&t dz
 +2*z*dz&t dz&t dy +2*y*dz&t dz&t dz);
if ans<> C then RETURN(false) fi;


true; end:
#----------------------------------

Check[tensors:-offel2]:=proc() 
local g, C, ans;
coord_init([x,y,z],DGChk);

g:=evalV(dx&t dx + dy &t dy + dz &t dz);
C:=offel2(g);
ans:=convert(0 &mult evalV( dx &t D_x &t dx),Vessiot_connection);
if ans<> C then RETURN(false) fi;

g:= evalV( x^2*dx&t dx + dy &t dy +4* y*z*dz &t dz);
C:=offel2(g);
ans:=evalV((1/x)* dx &t D_x&t dx +(1/(2*y)) * dy&t D_z&t dz 
-2*z*dz&t D_y&t dz +(1/(2*y))* dz&t D_z&t dy+(1/(2*z))* dz&t D_z&t dz); 
ans:=convert(ans,Vessiot_connection);
if ans<> C then RETURN(false) fi;

true;
end:

#-----------------------


Check[tensors:-ParallelTransportEquations]:=proc() 

local C, curve,Y,P, ans;
coord_init([x,y],DGChk);

C:=convert(evalV(dx &t D_y  &t dy),Vessiot_connection);
curve:= [a(t),b(t)];

Y:=evalV( A(t) *D_x +B(t) *D_y);
P:=ParallelTransportEquations(curve,Y,C,t);
ans:=evalV(diff(A(t),t)*D_x+(A(t)*diff(b(t),t)+diff(B(t),t))*D_y);

if ans <>P then RETURN(false) fi;

true;
end:

#-------------------------



#-----------------------------------
Check[tensors:-permutation_symbol]:=proc()
local g, k,T, ans;
coord_init([x,y],DGChk);

T:=permutation_symbol(con_bas);
g:=evalV(dx &t dx +dy &t dy);
k:=metric_density(g,-2);
ans:=k &tensor evalV(D_x &t D_y - D_y &t D_x);
if ans <>T then RETURN(false) fi;

T:=permutation_symbol(cov_bas);
g:=evalV(dx &t dx +dy &t dy);
k:=metric_density(g,2);
ans:=k &tensor evalV(dx &t dy - dy &t dx);;
if ans <>T then RETURN(false) fi;

true

end:

#--------------------------------

Check[tensors:-generalized_Kronecker_delta]:=proc()
local T, ans;
coord_init([x,y],DGChk);

T:=generalized_Kronecker_delta(bas,1);
ans:=evalV(D_x &t dx +D_y &t dy);
if ans <> T then RETURN(false) fi;

T:=generalized_Kronecker_delta(bas,2);
ans:=evalV(D_x &t D_y &t dx &t dy   -  D_y &t D_x &t dx &t dy  - 
D_x &t D_y &t dy &t dx + D_y &t D_x &t dy &t dx);
if ans <> T then RETURN(false) fi;

true;
end:

#-----------------------------------
Check[tensors:-push_pull_tensor]:=proc() 

local phi, inv_phi, S,T, ans;
coord_init([x,y,z],M1);
coord_init([u,v,w],M2);

S:= evalV(dx &t dx + dy &t dy +dz &t dz);
phi:=transform(M2,M1, [x= 2*u/(1+u^2+v^2),
 y=2*v/(1+u^2 +v^2), z= (1-u^2 -v^2)/(1+u^2 +v^2)]);
T:=push_pull_tensor(phi, S );
ans:= (4/(1+u^2+v^2)^2) &mult evalV((du &t du  + dv &t dv));
if  T <> ans then  RETURN(false) fi;

phi:=transform(M1,M2, [u=2*y  ,v =3*z, w=5*x]);
inv_phi:=inverse_transform(phi);
S:= evalV(dx &t D_x &t D_z &t dy);
T:=push_pull_tensor(phi, inv_phi,S);
ans:=evalV((3/2) * (dw &t D_w &t   D_v &t du));
if  T <> ans then  RETURN(false) fi;

phi:=transform(M1,M2, [u=2*y  ,v =3*z, w=5*x]);
inv_phi:=inverse_transform(phi);
S:= evalV(du &t D_v &t D_w &t dv);
T:=push_pull_tensor(inv_phi,phi,S);
ans:=evalV((2/5) * (dy &t D_z &t   D_x &t dz));
if  T <> ans then  RETURN(false) fi;

true:
end:

#--------------------------------

Check[tensors:-raise_lower_indices]:=proc() 
local g,h,S,T, ans;
coord_init([x,y,z],DGChk);

g:=evalV( dx &t dx + dy &t dy +dz&t dz);
S:=D_x;
T:= raise_lower_indices(g, S,[1]);
ans:=convert(dx,Vessiot_tensor);
if ans <>T then RETURN(false) fi;

g:=evalV( dx &t dx + dy &t dy +dz&t dz); h:=inverse_metric(g);
S:=dy;
T:= raise_lower_indices(h, S,[1]);
ans:=convert(D_y,Vessiot_tensor);
if ans <>T then RETURN(false) fi;

g:=evalV( dx &t dx + dy &t dy +dz&t dz);
S:=evalV(D_x&t D_y  - D_y &t D_z);
T:= raise_lower_indices(g, S,[2]);
ans:=evalV(D_x &t dy  - D_y &t dz);
if ans <>T then RETURN(false) fi;

g:=evalV( dx &t dx + dy &t dy +dz&t dz);
S:=evalV(D_x&t D_y  - D_y &t D_z);
T:= raise_lower_indices(g, S,[1,2]);
ans:=evalV(dx &t dy  - dy &t dz);
if ans <>T then RETURN(false) fi;

g:=evalV( dx &t dx + dy &t dy +dz&t dz);
h:=inverse_metric(g);
S:=evalV(dz&t dy  - dx &t dz);
T:= raise_lower_indices(h, S,[1,2]);
ans:=evalV(D_z&t D_y  - D_x &t D_z);
if ans <>T then RETURN(false) fi;

g:=evalV( dx &t dx +   3*(dx&t dy  + dy &t dx) -(dy&t dz + dz&t dy)  +dy &t dy +dz&t dz);
S:=evalV(D_x&t D_y  - D_y &t D_z);
T:= raise_lower_indices(g, S,[1,2]);
ans:=evalV(3*dx &t dx+ 4*dx &t dy-4*dx &t dz+9*dy &t dx+4*dy &t dy-4*dy&t dz-dz &t dy+dz &t dz);
if ans <>T then RETURN(false) fi;

true;
end:


#--------------------------------


Check[tensors:-Ricci_tensor]:=proc() 
local g,C,R,Ric,ans; 
coord_init([x,y,z]);

C:=convert( evalV(x^2*dx &t D_y &t dz), Vessiot_connection);
R:=curvature_tensor(C); 
Ric:=Ricci_tensor(R);
ans:=0 &mult (dx &tensor dx);
if ans <> Ric then RETURN(false) fi;

C:=convert( evalV(y*dx &t D_y &t dz - y*dz &t D_x &t dy), Vessiot_connection);
R:=curvature_tensor(C); 
Ric:=Ricci_tensor(R);
ans:=evalV(2*dx &t dz+2*y^2*dz &t dz); 
if ans <> Ric then RETURN(false) fi;

true; 
end:

Check[tensors:-Ricci_scalar]:=
proc()

local g,h,C,R,S, ans;
coord_init([x,y,z],DGChk);

g:=evalV(z*(dx &t dy + dy &t dx) + x*dz&t dz); 
h:=inverse_metric(g);
C:=offel2(g):
R:=curvature_tensor(C);
S:=Ricci_scalar(h,R);
ans:=DifferentialGeometryTools:-scalar_tensor(1/(z^2*x));
if ans <>S then  RETURN(false) fi:

g:=(1/(1+x^2+y^2+z^2)^2) &mult evalV(dx&t dx +dy &t dy + dz&t dz); 
h:=inverse_metric(g);
C:=offel2(g):
R:=curvature_tensor(C);
S:=Ricci_scalar(h,R);
ans:=DifferentialGeometryTools:-scalar_tensor(48);
if ans <>S then  RETURN(false) fi:


true:
end:



#--------------------------------
Check[tensors:-symm_skew_indices]:=proc()
local S,T,ans;
coord_init([x,y,z,w],DGChk);
S:=evalV(dx &t dy);
T:=symm_skew_indices(S,[1,2],symm);
ans:= (1/2) &mult evalV(dx &t dy  + dy &t  dx);
if  ans <> T then RETURN(false) fi;


S:=evalV(dx &t dy);
T:=symm_skew_indices(S,[1,2],skew);
ans:= (1/2) &mult evalV(dx &t dy  - dy &t  dx);
if  ans <> T then RETURN(false) fi;


S:=evalV(D_x &t dx &t dy);
T:=symm_skew_indices(S,[2,3],skew);
ans:= (1/2) &mult evalV(D_x &t (dx &t dy  - dy &t  dx));
if  ans <> T then RETURN(false) fi;


S:=evalV(D_x &t dx &t dy &t dz);
T:=symm_skew_indices(S,[2,3,4],skew);
ans:= (1/6) &mult evalV(D_x &t (dx &t dy &t dz   + dz &t dx &t dy + dy &t dz &t dx - dy &t dx &t dz - dz &t dy &t  dx - dx &t dz &t dy ));
if  ans <> T then RETURN(false) fi;



true:
end:



#--------------------------------


Check[tensors:-rearrange_indices]:=proc()
local S,T, ans; 
coord_init([x,y,z,w]);

S:=evalV( dx &t  D_x &t D_y);
T:=rearrange_indices(S,[1,3,2]);
ans:=evalV( dx &t  D_y &t D_x);
if ans <> T then  RETURN(false) fi;

S:=evalV( dx &t  D_x &t D_y);
T:=rearrange_indices(S,[3,1,2]);
ans:=evalV(D_y &t dx &t  D_x );
if ans <> T then RETURN(false) fi;

S:=evalV( x*dx &t  D_x &t D_y &t dw -  z* dy &t D_w &t D_z &t dy);
T:=rearrange_indices(S,[2,1,4,3]);
ans:=evalV(  x*D_x &t  dx &t dw &t D_y -  z* D_w &t dy &t dy &t D_z);
if ans <> T then RETURN(false) fi;


true;
end:



Check[tensors:-torsion_tensor]:=proc() 
local C0, C, T, ans;
coord_init([x,y,z],DGChk);

C0:=evalV(dx&t D_y &t dz - dy&t D_z &t dy);
C:=convert(C0, Vessiot_connection);
T:=torsion_tensor(C);
ans:=evalV(-dx &t D_y &t dz + dz &t D_y  &t dx);
if ans <>T then RETURN(false) fi;

true; 
end:

#-------------------------------------------

Check[tensors:-Weyl_tensor]:=proc()

local g,C,R,W, ans;
coord_init([x,y,z,w],DGChk);

g:=evalV(y*(dx &t dy + dy &t dx) + w*( dz &t dw + dw &t dz) + z*(dx&t dw + dw &t dx));
C:=offel2(g):
R:=curvature_tensor(C);
W:=Weyl_tensor(g,R); 

ans:=evalV((1/2*y/w^2) * dx&t dy&t dx&t dw +(-1/2*y/w^2)*dx&t dy&t dw&t dx +(1/2*y/w^2)* dx&t dw&t dx&t dy+(z/w^2) *dx&t dw&t dx&t dw +(-1/2*y/w^2)*dx&t dw&t dy&t dx +(-1/(2*w))* dx&t dw&t dz&t dw +(-z/w^2)* dx&t dw&t dw&t dx +(1/(2*w)) *dx&t dw&t dw&t dz+(-1/2*y/w^2) *dy&t dx&t dx&t dw 
+(1/2*y/w^2)* dy&t dx&t dw&t dx +(-1/(2*w)) * dz&t dw&t dx&t dw 
+(1/(2*w))* dz&t dw&t dw&t dx +(-1/2*y/w^2) *dw&t dx&t dx&t dy 
+(-z/w^2) * dw&t dx&t dx&t dw +(1/2*y/w^2) * dw&t dx&t dy&t dx 
+(1/(2*w))*  dw&t dx&t dz&t dw +(z/w^2)*  dw&t dx&t dw&t dx 
+(-1/(2*w))* dw&t dx&t dw&t dz+(1/(2*w))*  dw&t dz&t dx&t dw 
+(-1/(2*w))* dw&t dz&t dw&t dx );


if ans <>W then  RETURN(false) fi:

g:=(1/(1+x^2+y^2+z^2)^2) &mult evalV(dx&t dx +dy &t dy + dz&t dz + dw &t dw); 
C:=offel2(g):
R:=curvature_tensor(C);
W:=Weyl_tensor(g,R);
ans:=DifferentialGeometryTools:-zero_tens([[ cov_bas,cov_bas,cov_bas, cov_bas],[]]);
if ans <>W then  RETURN(false) fi:

true:
end:









#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`***** All Tensor Procedures Gave Correct Answers *****`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:


writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):

end:


#-------------------------






