#
# This is the package for  TensorsTools  Diagonistics


TensorsToolsDiagnostics:=proc(ProcedureList,{tracy:=off}) 

local Check, TF,BadProcedureList,P;



#
#-----------------------------------------
#

#~~~~~~canonical_flat_metric ~~~~~~~~~~~~~

Check[TensorsTools:-canonical_flat_metric]:=proc() 
local T, ans;
coord_init([x1,x2,x3,x4],DGChk);

T:=canonical_flat_metric(3,1,bas); op(T);
ans:=evalV(dx1 &t dx1 + dx2 &t dx2 + dx3 &t dx3 - dx4 &t dx4);
if  T <> ans then RETURN(false) fi;

coord_init([t], [u,v]);
T:=canonical_flat_metric(2,0,vrt);
ans:= evalV( du[0] &t du[0] + dv[0] &t dv[0]);
if  T <> ans then RETURN(false) fi;

true;
end:

#~~~~~~ canonical_symplectic_form ~~~~~

Check[TensorsTools:-canonical_symplectic_form]:=proc() 
local T, ans;
coord_init([x1,x2,x3,x4],DGChk);
T:=canonical_symplectic_form(bas); 
ans:=evalV(dx1 &w dx3 + dx2 &w dx4);
if  T <> ans then RETURN(false) fi;

coord_init([t], [u,v]);
T:=canonical_symplectic_form(vrt);
ans:= evalV( du[0] &w dv[0]);
if  T <> ans then RETURN(false) fi;

true;
end:

#~~~~~ canonical_complex_structure ~~~~~~

Check[canonical_complex_structure]:=proc() 
local T, ans;

coord_init([x1,x2,x3,x4],DGChk);
T:=canonical_complex_structure(bas); 
ans:=evalV(-dx1 &t D_x3 -dx2 &t D_x4 +dx3 &t D_x1+dx4 &t D_x2);
if  T <> ans then RETURN(false) fi;

coord_init([t], [u,v]);
T:=canonical_complex_structure(vrt);
ans:= evalV( -du[0] &t D_v[0]+ dv[0] &t D_u[0] );
if  T <> ans then RETURN(false) fi;

true;
end:


#~~~~~~ generate_tensors ~~~~~~

Check[TensorsTools:-generate_tensors]:=proc() 
local  A,B,C, ans;

coord_init([x,y],[u],DGChk);
A:=[dx, dy];
B:=[D_x];
C:=generate_tensors([A,B,A]);
ans:=evalV([dx &t D_x &t dx , dx &t D_x &t dy, dy &t D_x &t dx , dy &t D_x &t dy]);
if C <> ans then RETURN(false) fi;
 
 A:=[D_x ,D_y];
 B:=[du[0,0]];
 C:=generate_tensors([A,B]);
 ans:=evalV([D_x &t du[0, 0], D_y &t du[0, 0] ]);
 if C <> ans then RETURN(false) fi;
 
true;
end;




Check[TensorsTools:-generateSymmetricTensors]:=proc() 
local  A,B,C, ans;
 coord_init([x,y,z],DGChk);

A:=[dx, dy, dz];
C:=generateSymmetricTensors(A,2); 

ans:=evalV( [dx &t dx , (1/2)* dx &t dy +(1/2)*dy &t dx, (1/2)*dx &t dz+(1/2)*dz &t dx, dy &t dy, (1/2)*dy &t dz +(1/2)*dz &t dy, dz &t dz]);
if C <> ans then RETURN(false) fi;
 
true;
end:



#Main Procedure

 
BadProcedureList:=[];

for P in ProcedureList do 
	
	if tracy=on then 
		trace(Check[P]) 
	fi;

	TF:=Check[P]();

      if TF=true then print(cat(P,"  OK")) fi;

	untrace(Check[P]);

	if TF=true  then  else  
		BadProcedureList:=[op(BadProcedureList),P] 
	fi;

od;

if BadProcedureList=[] then 
	print(`******  All TensorTools Procedures Gave Correct Answers ******`) 
else  
	print(`The Following Procedures Failed To Give The Correct Answer`);
	print(BadProcedureList);
fi:


writeline(default,cat(StringTools:-FormatTime("%n%n%c"),"/IA")):

end:


#-------------------------






