# 
# derivate.vss
#
# Vessiot
#
# HOOK[form,deriv]; HOOK[form, anti]; HOOK[biform,deriv]; HOOK[biform,anti]
# derivation[formBiform];  mono_tensor_hook; derivation[tensor];
# homomorphism[vect]; homomorphism[formBiform]; homomorphism[tensor];
#
# 7/4/00

#--------------------------------------------

HOOK[form,deriv] := proc(X, omega)
#CLASS I PROGRAM
#12/13/02:IA

local degree, newform, term1, term2, vectr,f,forma;

vectr:=op(X);
forma:=op(omega);

newform := [];

for term1 in vectr[2] do
	for term2  in forma[2] do
            newform := [op(newform), mono_hook(term1, term2)]
	od;
od;

degree := forma[1][3] - 1;

newform := _VESSIOT([[op(1..2,forma[1]),degree], newform]);

newform;
end:

#---------------------------------------------------------

HOOK[form,anti] := proc(X, omega)
#CLASS I PROGRAM
#December 13,2002:IA

local degree, newform, term1, term2, vectr,f,forma;

vectr:=op(X);
forma:=op(omega);

newform := [];

for term1 in vectr[2] do
	for term2  in forma[2] do
            newform := [op(newform), anti_mono_hook(term1, term2)]
	od;
od;

degree := forma[1][3] - 1;

newform := _VESSIOT([[op(1..2,forma[1]),degree], newform]);

newform;
end:

#----------------------------------------------

HOOK[biform,deriv] := proc(X, omega)
#CLASS I PROGRAM
#12/13/02:IA

local degree, newform, term1, term2, vectr,f,forma;

vectr:=op(X);
forma:=op(omega);

if vectr[2][1][1][1]>frameBaseDimension() then
	degree:=forma[1][3] -[0,1]
else
      degree:=forma[1][3] -[1,0]  
fi;

newform := [];

for term1 in vectr[2] do
	for term2  in forma[2] do
            newform := [op(newform), mono_hook(term1, term2)]
	od;
od;

newform := _VESSIOT([[op(1..2,forma[1]),degree], newform]);

newform;
end:

#--------------------------------------------------------
HOOK[biform,anti] := proc(X, omega)
#CLASS I PROGRAM
#12/13/02:IA

local degree, newform, term1, term2, vectr,f,forma;

vectr:=op(X);
forma:=op(omega);

if vectr[2][1][1][1]>frameBaseDimension() then
	degree:=forma[1][3] -[0,1]
else
      degree:=forma[1][3] -[1,0]  
fi;

newform := [];

for term1 in vectr[2] do
	for term2  in forma[2] do
            newform := [op(newform), mono_hook(term1, term2)]
	od;
od;


newform := _VESSIOT([[op(1..2,forma[1]),degree], newform]);

newform;
end:

#-----------------------------------------------------------

derivation[formBiform]:=proc(phi,derivationType,geomObjField, output_type)
#CLASS I PROGRAM
#07/04/00:CM
#12/28/02:IA

local degree, i, iterm, newform, form_C, formAttr, term,
	newcoeff, X, term1, formType;

global _Vessiot_frame_data;
            
formAttr:=op(geomObjField)[1]:
formType:=formAttr[1]:
newform := output_type;

form_C:=objectGenerators(geomObjField);

for term in op(geomObjField)[2] do
      newcoeff:=phi(term[2],'coeff', args[5..nargs]);
      newform:= DiffGeomMain:-Plus(newform,DiffGeomMain:-Wedge(newcoeff, _VESSIOT([formAttr,[[term[1],1]]])) );
od;

for i in form_C do
      X:=_VESSIOT([[vect,_Vessiot_current_frame_name,[]], [[[i],1]]]);
      term1:= DiffGeomMain:-Wedge(phi(i,'bftv', args[5..nargs]),
		 (HOOK[formType,derivationType](X,geomObjField))   );
      newform:= DiffGeomMain:-Plus(newform, term1)
od;

helmsimp(newform);
end:

#----------------------------------------------

mono_tensor_hook:=proc(index,slot,kind,T)
#CLASS I PROGRAM
#07/04/00:CM
#12/28/02:IA
 
local ans1, ans2,val,val1,val2,part1,part2,attrib1,attrib2,
	comp1,comp2,degree,den,term,S,T1,T2,ans; 

VessiotFrameCheck(T):

S:=op(T);
val:=S[1][3][1]; 
den:=S[1][3][2];

degree:=nops(val);

val1:=[val[1..slot-1],    den];
val2:=[val[slot+1..degree], []] ;

ans:=[];

for  term in S[2] do 
	if  index=term[1][slot] and kind=val[slot] then
 		part1 := term[1][1..slot-1];
      	part2 := term[1][slot+1 ..degree];
            
		attrib1:=[ S[1][1], S[1][2], val1];
 		comp1:= [ [part1,       1]    ];
            
          	attrib2:=[ S[1][1], S[1][2], val2];
		comp2:= [ [part2,  term[2] ]    ];
 	 
 		ans1:= _VESSIOT([attrib1,comp1]) ; 
      	ans2:= _VESSIOT([attrib2,comp2]) ; 
      	ans:= [op(ans), [ans1,ans2]] ; 
	fi;
od;

ans;
 
end:

#----------------------------------------------

derivation[tensor]:=proc(phi,forma,  output_type)
#CLASS I PROGRAM
#07/04/00:CM
#12/28/02:IA

local degree, i, iterm, newform,  part1, part2, term,newcoeff,newform0,
      termform, wtype,S,C,A ,M,T,comp,s,B,P,valency,form_C,
	formAttr,term1,j,stuff;

T:=tensorType(forma);

s:=nops(T[1]);



newform:=output_type;

formAttr:=objectAttributes(newform);


for term in op(forma)[2] do 
	newcoeff:=phi(term[2],'coeff', args[4..nargs]);
      newform:= DiffGeomMain:-Plus(newform, DiffGeomMain:-Tensor(newcoeff, _VESSIOT([formAttr,[[term[1],1]]])));
od;

# This code is writen to minimize the calls to phi

form_C:=tensorGenerators(forma);


for i in form_C do 
	term1:=phi(i[2], i[1],args[4..nargs]); 
      for  j from 1 to s do
		stuff:=mono_tensor_hook(i[2],j, i[1],forma);
            for  P in stuff do
                   newform0:=DiffGeomMain:-Tensor(P[1],DiffGeomMain:-Tensor(term1,P[2]));
                    
            	newform:=DiffGeomMain:-Plus(newform,newform0)          od;
      od;
od;

helmsimp(newform)

end:

#--------------------------------------------------

homomorphism[vect] := proc(phi,geomObjField,  output_type)
#CLASS I PROGRAM
#07/04/00:CM
#12/28/02:IA

local newform,term,newterm,term2,T,S, i, forma, objType;


forma:=op(geomObjField):

objType:=op(geomObjField)[1][1]:

newform:=output_type;

for term in forma[2] do 
	newterm := phi(term[2],'coeff',args[4..nargs]);  
      newterm := DiffGeomMain:-Mult(newterm,  phi(term[1][1],'vect',args[4..nargs]));
      newform := DiffGeomMain:-Plus(newform, newterm)
od;

helmsimp(newform):

end:

#--------------------------------------------------

homomorphism[formBiform] := proc(phi,geomObjField,output_type)
#CLASS I PROGRAM
#07/04/00:CM
#12/28/02:IA
#01/12/03:IA             

local newform,term,newterm,term2,T,S,M, i, forma, form_C, objType;

forma:=op(geomObjField):

objType:=op(geomObjField)[1][1]:

newform:=output_type;

form_C:=objectGenerators(geomObjField);

M:=table();
for  i in form_C do 
	M[i]:=phi(i,objType,args[4..nargs])
od;

for term in forma[2] 
	do 
      newterm:= phi(term[2],'coeff',args[4..nargs]); 
      
	for term2 in term[1] do  
          	newterm :=DiffGeomMain:-Wedge(newterm ,M[term2])
      od;
     	
	newform :=DiffGeomMain:-Plus (newform ,newterm)
od;

helmsimp(newform):

end:

#----------------------------------------------------

homomorphism[tensor] := 
proc(phi::procedure,geomObjField::Vessiot_bftv,  output_type::Vessiot_bftv)

#CLASS I PROGRAM
#07/04/00:CM
#12/28/02:IA

# needs to be rewritten to elim multiple phi evaluations

local newform,term,newterm,term2,T,S, i,P, forma, objType;

VessiotFrameCheck(output_type):

forma:=op(geomObjField):

objType:=op(geomObjField)[1][1]:

newform:=output_type;


T:=tensorType(forma);
for term in forma[2] 
	do 
      newterm := phi(term[2],'coeff',args[4..nargs]); 
          # add   line for  density 
      for i from 1 to  nops(term[1]) 
		do
            P:= phi(term[1][i],T[1][i] ,args[4..nargs]);

          	newterm :=DiffGeomMain:-Tensor(newterm,P)
          	od;
      	newform :=DiffGeomMain:-Plus(newform, newterm)
      od;


helmsimp(newform):


end:

#************************************************
