#
# FrameUtilities.vss 
#
# Vessiot
#
# frameInformation; frameBaseDimension; frameProcotol; frameFiberDimension;
# frameJetDimension; frameJetOrder; listOfFrameNames; 

# frameIndependentVariables; frameDependentVariables;
# frameJetVariables; JetSpaceVariables; 
#
# frameLabels; coframeLabels; horizontalCoframeLabels;
# VerticalCOframeLabels; 
#
# change_labels
#
#
# frameBaseVectors; frameBaseForms; frameFiberVectors;frameFiberForms;
# frameJetVectors; frameJetForms; frameHorizontalBiforms; frameVerticalBiforms;
# 
# structureEquations_Ext_dFunctions; structureEquations_LieFunctions; structureEquations_Forms;
# structureEquations_Vectors; structure_constant; structureFunction; structure_constants_list;
# structureFunctionsList;
#
#

#  These are  simple commands for extracting information from
#  the global  table _Vessiot_frame_data.
#
# 



jet_space_dim:=proc(k::integer) 
#CLASS II PROGRAM
#06/16/92:CH
#12/13/02:IA 

local n,m;

if 1<nargs  then 
	change_frame_to(args[2]) 
fi;
 
n:=frameBaseDimension();
m:=frameFiberDimension();

n +m*binomial(n+k,k);

end;


#-----------------------------------------


change_labels:=proc(labels,label_type)

local fr, new_labels,i,temp, N;

global _Vessiot_frame_data;

N:=nops(labels);

for i from 1 to N do 
     if type(labels[i],name) =false then 
     		ERROR(`Vessiot Error: Label`, i,`an assigned name`);
     fi;
od;
     

fr:=_Vessiot_current_frame_name;


if label_type=jet then 
	_Vessiot_frame_data[fr][1][4][9]:=[op(labels),op(frameJetVariables()[N+1..-1]) ];
	RETURN()
fi;



new_labels:=constructFrameLabels(labels,"E",N);

if label_type = frame then 
         temp:=_Vessiot_frame_data[fr][1][4][5];	   	
         _Vessiot_frame_data[fr][1][4][5]:=[op(new_labels), op(temp[N+1..-1])];

for i to N 
do 
	assign(reconstructVariableName(new_labels[i]),  DifferentialGeometryTools:-Vect(i))
od;
RETURN()
fi;

if label_type= coframe then 
         temp:=_Vessiot_frame_data[fr][1][4][6];	   	
         _Vessiot_frame_data[fr][1][4][6]:=[op(new_labels), op(temp[N+1..-1])];

for i to N 
do 
	assign(reconstructVariableName(new_labels[i]),  DifferentialGeometryTools:-Form(i))
od;
RETURN()
fi;

if label_type= horizontal_coframe then 
         temp:=_Vessiot_frame_data[fr][1][4][7];
	   	
         _Vessiot_frame_data[fr][1][4][7]:=[op(new_labels), op(temp[N+1..-1])];

for i to N 
do 
	assign(reconstructVariableName(new_labels[i]),  Biform(i))
od;
RETURN()
fi;

if label_type= vertical_coframe then 
         temp:=_Vessiot_frame_data[fr][1][4][8];
	   	
         _Vessiot_frame_data[fr][1][4][8]:=[op(new_labels), op(temp[N+1..-1])];

for i to N 
do 
	assign(reconstructVariableName(new_labels[i]),  DifferentialGeometryTools:-Biform(frameBaseDimension()+i))
od;
RETURN()
fi;

ERROR(`Invalid  label type`);

end:


frameInformation:= proc()
#CLASS I PROGRAM
#12/16/02:IA

local a, b, c, d,e,f,g,fr, frlist, i, n ;


if   nargs=0 then 
	frlist:=[_Vessiot_current_frame_name] 
fi;

 

if nargs = 1 and  member(args[1],eval(listOfFrameNames())) 
	then
      frlist:= [args[1]] 
fi;

if nargs = 1 and   not member(args[1],eval(listOfFrameNames())) 
      then  
	if args[1]=`all`  
		then  
		frlist:=listOfFrameNames()
            else
		ERROR(`Vessiot Error:  Invalid  Frame Name`)  
	fi;
fi;

for fr in  frlist do 
      a:=cat(`frame name:   `,fr ):
      b:=cat(`library name:   `,frameProtocol(fr) ):
	c:=frameJetVariables(fr):
	d:=map(labelDataToLabel, frameLabels(fr));
      e:=map(labelDataToLabel, coframeLabels(fr));
	f:=map(labelDataToLabel, horizontalCoframeLabels(fr));
	g:=map(labelDataToLabel, verticalCoframeLabels(fr));

	print(a); 
	print(b);
      print(`Frame Jet Variables:`);
      print(c);
      print(`Frame Labels`);
      print(d);
      print(`CoFrame Labels`);
      print(e);
      print(`Horizontal Coframe Labels`);
      print(f);
      print(`Vertical Coframe Labels`);
      print(g);
      
if frameProtocol(fr)=`repere_mobile`  then
	   
          for  i from 1 to  nops(structureEquationsFunctions(fr)) do 
          	print( `ext_d:` , frameJetVariables()[i] , show(structureEquations_Ext_dFunctions(fr)[i]) );
          od;
		for  i from 1 to  nops(structureEquations_Forms(fr))
		do 
          	print(`ext_d:`, reconstructVariableName(coframeLabels(fr)[i]), 
                  show(structureEquations_Forms(fr)[i])  );
            od;
fi;



if frameProtocol(fr)=`Koszul_frame`  then
		for  i from 1 to  nops(structureEquations_Forms(fr))
		do 
          	print(`ext_d:`, reconstructVariableName(coframeLabels(fr)[i]), 
                  show(structureEquations_Forms(fr)[i])  );
            od;
fi;

print(`--------------`);

od;

VessiotPrompt():

NULL;

end:

#----------------------------------------------

frameBaseDimension:=proc(frame::VessiotFrameName)
#CLASS I PROGRAM
#12/16/02:IA

local fr ;

if nargs = 0 then fr:= _Vessiot_current_frame_name else fr:=frame fi;

nops(frameIndependentVariables(fr));

end:

#-----------------------------------------

frameProtocol:=proc(frame_name::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA

local fr;

if nargs = 0 then fr:= _Vessiot_current_frame_name else fr:=frame_name fi;

_Vessiot_frame_data[fr][1][2]

end:

#------------------------------------

frameFiberDimension:=proc(frame::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA
local fr ;

if nargs = 0 then fr:= _Vessiot_current_frame_name else fr:=frame fi;

nops(frameDependentVariables(fr));

end:

#------------------------------------

frameJetDimension:=proc(frame_name::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA
local fr ;

if nargs = 0 then fr:= _Vessiot_current_frame_name else fr:=frame_name fi;


nops(frameJetVariables(fr));

end:

#--------------------------------

frameJetOrder:=proc(frame_name::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA

local fr ;

if nargs = 0 then 
	fr:= _Vessiot_current_frame_name else fr:=frame_name 
fi;

_Vessiot_frame_data[fr][1][4][3];

end:

#-------------------------------

frameIndependentVariables:= proc(frame_name::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA
local fr;

if nargs = 0 then 
	fr:= _Vessiot_current_frame_name 
else  fr:=frame_name 
fi;

_Vessiot_frame_data[fr][1][4][1];

end:

#--------------------------------

frameDependentVariables:=proc(frame_name::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA

local fr;

if nargs = 0 then 
	fr:= _Vessiot_current_frame_name else fr:=frame_name 
fi;

_Vessiot_frame_data[fr][1][4][2];

end:

#---------------------------------

frameJetVariables:=proc(frame_name::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA

local fr;

if nargs = 0 then 
	fr:= _Vessiot_current_frame_name 
else fr:=frame_name 
fi;

_Vessiot_frame_data[fr][1][4][9];

end:

#---------------------------------------------


JetSpaceVariables:=proc(frame_name::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA

local fr;

if nargs = 0 then 
	fr:= _Vessiot_current_frame_name 
else fr:=frame_name 
fi;

_Vessiot_frame_data[fr][1][4][4];

end:

#--------------------------------------------
listOfFrameNames:=proc() 
#CLASS I PROGRAM
#12/16/02:IA

local ans;
ans:=[];

if type(_Vessiot_frame_data,table) then
	ans:=indices(_Vessiot_frame_data) 
fi
;

map(op, [ans]);

end:

#---------------------------------

frameLabels:= proc(frame::VessiotFrameName)
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][1][4][5];

end:

#---------------------------------

coframeLabels:=proc(frame::VessiotFrameName)
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][1][4][6];

end:

#---------------------------------

horizontalCoframeLabels:=proc(frame::VessiotFrameName)
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][1][4][7];

end:

#------------------------------------

verticalCoframeLabels:=proc(frame::VessiotFrameName)
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][1][4][8];

end:

#------------------------------------------

frameBaseVectors:=proc(frame::VessiotFrameName) 
#CLASS II PROGRAM
#12/16/02:IA
local n,i;

if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

n:=frameBaseDimension();

[seq(DifferentialGeometryTools:-Vect(i), i=1..n) ];

end:

#--------------------------------------------

frameBaseForms:=proc(frame::VessiotFrameName) 
#CLASS II PROGRAM
#12/16/02:IA

local n,i ;

if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

n:=frameBaseDimension();

[seq(DifferentialGeometryTools:-Form(i), i=1..n) ];

end:

#-----------------------------------------------

frameFiberVectors:=proc(frame::VessiotFrameName) 
#CLASS II PROGRAM
#12/16/02:IA
local n,m,i;

if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

n:=frameBaseDimension();
m:=frameFiberDimension();

[seq(DifferentialGeometryTools:-Vect(i), i=n+1..n+m) ];

end:

#----------------------------------------------

frameFiberForms:=proc(frame::VessiotFrameName) 
#CLASS II PROGRAM
#12/16/02:IA
local n,m,i;

if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

n:=frameBaseDimension();
m:=frameFiberDimension();

[seq(DifferentialGeometryTools:-Form(i), i=n+1..n+m) ];

end:



#-------------------------------------------------


frameJetVectors:=proc(F::VessiotFrameName) 
#CLASS II PROGRAM
#12/16/02:IA

local N,i;
if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

N:=frameJetDimension();

[seq(DifferentialGeometryTools:-Vect(i), i=1..N) ];

end:

#---------------------------------------

frameJetForms:=proc(frame::VessiotFrameName)
local N,i;
if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

N:=frameJetDimension();

[seq(DifferentialGeometryTools:-Form(i), i=1..N) ];



end:

#----------------------------------------

frameHorizontalBiforms:=proc(frame::VessiotFrameName) 
#CLASS II PROGRAM
#12/16/02:IA

local n,i ;

if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

n:=frameBaseDimension();

[seq(DifferentialGeometryTools:-Biform(i), i=1..n) ];

end:

#----------------------------------------

frameVerticalBiforms:=proc(frame::VessiotFrameName)
#CLASS II PROGRAM
#12/16/02:IA

local N, n, i;
if nargs=1  and args[1] <>_Vessiot_current_frame_name then 
	change_frame_to(args[1])
fi;

N:=frameJetDimension();
n:=frameBaseDimension();

[seq(DifferentialGeometryTools:-Biform(i), i=n+1..N) ];

end:

#-----------------------------------------

#
#   STRUCTURE FUNCTIONS AND  EQUATIONS 
#


structureEquations_Ext_dFunctions:=proc(frame::VessiotFrameName) 
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][2][1];

end:

# -------------------------------------------

structureEquations_LieFunctions:=proc(frame::VessiotFrameName) 
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][4];

end:

#----------------------------------------------

structureEquations_Forms:=proc(frame::VessiotFrameName) 
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][3][1];

end:

#------------------------------------------
structureEquations_Vectors:=proc(frame::VessiotFrameName) 
#CLASS I PROGRAM
#12/16/02:IA

local fr_name;

if nargs=1 then  fr_name:=args[1] else fr_name:=_Vessiot_current_frame_name fi;

_Vessiot_frame_data[fr_name][5];

end:


#-----------------------------------------
structure_constant:=proc() structureFunction(args) end;

#-----------------------------------------

structureFunction:=proc(i::nonnegint,j::nonnegint,k::nonnegint) 
#CLASS I PROGRAM
#12/16/02:IA

local ans,str_eq, Lie_data,term, fr;

if nargs=3 then 

	fr:=_Vessiot_current_frame_name;

	if  i=j  then   
	RETURN(0) 
	fi;

	if  i<j  then 
	RETURN(-coeff_list(_Vessiot_frame_data[fr][3][1][k],[[i,j]])) 
      fi;

	if  j<i  then 
	RETURN(coeff_list(_Vessiot_frame_data[fr][3][1][k],[[j,i]])) 
	
      fi;

fi;



if  (  nargs=4 and type(args[4],name)) then

	if args[4]<> _Vessiot_current_frame_name then 
	change_frame_to(args[4]) 
	fi;

	fr:=_Vessiot_current_frame_name;

	if  i=j  then   
	RETURN(0) 
	fi;

	if  i<j  then 
	RETURN(-coeff_list(_Vessiot_frame_data[fr][3][1][k],[[i,j]])) 
      fi;

	if  j<i  then 
	RETURN(coeff_list(_Vessiot_frame_data[fr][3][1][k],[[j,i]])) 
	
      fi;

fi;


if nargs=4 and type(args[4],Vessiot_Lie_alg) then
	 
	for term in args[4][2] do 
		if [i,j,k] =term[1] then 
		RETURN(term[2]) ; 
		fi; 
		
            if [j,i,k] =term[1] then 
		RETURN(term[2]) ;
            fi; 
	
  
od;
RETURN(0)
     fi;
end;

#---------------------------------------

structure_constants_list:=proc()  structureFunctionsList(args) end;

#--------------------------------------

structureFunctionsList := proc()
#CLASS I PROGRAM
#12/16/02:IA

local fr, n, i, st_con_list, form, term;
     

    if nargs = 1 then change_frame_to(args[1]) fi;

    fr := _Vessiot_current_frame_name;

    if frameProtocol(fr)=vst_euc then RETURN([ [[1,2,1],0]]) fi;

    n := frameBaseDimension();
    st_con_list := [];
    for i to n do
        form := _Vessiot_frame_data[fr][3][1][i];
        for term in op(form)[2] do
            if term[2] <> 0 then st_con_list := [
                op(st_con_list),
                [[term[1][1], term[1][2], i], -term[2]]]
            fi
        od
    od;
    st_con_list
end:


#************************************************