# 
# Internal.vss
#
# Vessiot
#
# index_to_tuple; tuple_to_index; ldiff; pr_Vessiot_frame_data;
# sgn_perm, 
#


#-------------------------------------------------------

assign_vect_type:=proc(vectr0)
# CLASS II PROGRAM
#08/26/91:CH
#12/13/02:IA       
      
        
local ans, vectr, frame;


vectr:=evalV(vectr0);

if type(vectr,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  assign_vect_type requires first arguement to be a vector:", 
		    "\n ",objectType(vectr) ))
fi;

VessiotFrameCheck(vectr);

frame:=frameProtocol();

ans:=frame[assign_vect_type](vectr);



ans:

end:







#------------------------------------------------

index_to_jet_variable := proc(index::nonnegint)

# CLASS II PROGRAM
# 08/26/91:CH
# 12/13/02:IA

local tuple;
       
while index > frameJetDimension() do
	pr_Vessiot_frame_data()
od;

tuple := JetSpaceVariables()[index];

tuple

end:


#------------------------------------------------------------

index_to_jet_label := proc(index::nonnegint)

# CLASS II PROGRAM
# 08/26/91:CH
# 12/13/02:IA

#index_to_tuple:: converts the index number to its respective variable.

local tuple;
       
while index > frameJetDimension() do
	pr_Vessiot_frame_data()
od;

tuple := frameJetVariables()[index];

tuple

end:

#---------------------------------------------------------

index_to_tuple := proc(index::nonnegint)

# CLASS II PROGRAM
# 08/26/91:CH
# 12/13/02:IA

#index_to_tuple:: converts the index number to its respective variable.

local tuple;
       
while index > frameJetDimension() do
	pr_Vessiot_frame_data()
od;

tuple := frameJetVariables()[index];

tuple

end:

#--------------------------------

tuple_to_index := proc(tuple::algebraic)

# CLASS II PROGRAM
# December 13,2002:IA
# 12/19/2003:IA

# tuple_to_index:: takes variable and converts to index number.

local index, k, jet_order, v;


if member(tuple, frameJetVariables(), index) then
      RETURN(index)
fi;



if  type(tuple,symbol) then 
	ERROR(cat("\n VESSIOT ERROR:", 
		    "\n tuple  not an independent variable",
                "\n ", tuple )):
fi;

if  nops(tuple)<> frameBaseDimension()then 
	ERROR(cat("\n VESSIOT ERROR:", 
		    "\n length of tuple different from number of  independent variables", 
                "\n", nops(tuple), frameBaseDimension() )):
fi;

v := op(0, tuple);

if not member(v, frameDependentVariables())  then
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  tuple not a dependent variable", 
		    "\n ", tuple, frameDependentVariables() ))
fi;
	

jet_order := convert(tuple, `+`);

while frameJetOrder()< jet_order do
      pr_Vessiot_frame_data()
od;



if member(tuple, frameJetVariables(), index) then
      RETURN(index)
fi;


NULL

end:

#----------------------------------------------

pr_Vessiot_frame_data := proc(frame::name)

# CLASS II PROGRAM
# December 13,2002:IA
        
local biglist, i, j, k, n,ans, fr, temp, tlist, varterm,new_jet_variables,L;
global _Vessiot_frame_data,_Vessiot_current_frame_name;

optionalFrameChange([args],0):

fr:=_Vessiot_current_frame_name;

#the following generates the possible combinations of derivitives.

       
j:=frameJetOrder(fr)+1;
n:=frameBaseDimension(fr);

tlist := [j, 0 $ i=2..n];
k := n - 1;

biglist := [tlist];

while k > 0 do
	k := n -1;
      while (k>0) and (tlist[k] <= 0) do
            k := k-1
     	od;
     	if k>0 then
            tlist := [op(1..k-1,tlist), tlist[k] - 1,
            op(k+1..n,tlist)];
            temp := 1 + tlist[n];
            tlist := [op(1..n-1,tlist), 0];
            tlist := [op(1..k,tlist), temp,
            op(k+2..n,tlist)];
            biglist := [op(biglist), tlist]
      fi;
od;


#after generating this list it attaches it to each of the variables
#and adds it to the master_var_list.
        
new_jet_variables:=[];    

for varterm in frameDependentVariables(fr) do
    	for tlist in biglist do 
      	new_jet_variables := [op(new_jet_variables), varterm[op(tlist)]]
      od;
od;

L:=createDefaultFrameLabels(frameJetDimension(), new_jet_variables);

_Vessiot_frame_data[fr][1][4][3]:=j;

_Vessiot_frame_data[fr][1][4][4]:= [op(_Vessiot_frame_data[fr][1][4][4]), op(new_jet_variables)];
_Vessiot_frame_data[fr][1][4][5]:= [op(_Vessiot_frame_data[fr][1][4][5]), op(L[1]) ];
_Vessiot_frame_data[fr][1][4][6]:= [op(_Vessiot_frame_data[fr][1][4][6]), op(L[2]) ];
_Vessiot_frame_data[fr][1][4][8]:= [op(_Vessiot_frame_data[fr][1][4][8]), op(L[3]) ];
_Vessiot_frame_data[fr][1][4][9]:= [op(_Vessiot_frame_data[fr][1][4][9]), op(new_jet_variables)];

j 

end:

#--------------------------------------------------

sgn_perm:=proc(sigma) 

#CLASS I PROGRAM
#December 13,2002:IA        

local i,e,A,n,m,n0;
e:=1;

A:=convert(sigma,set); 

if nops (A) <> nops(sigma) 
	then RETURN(0)
fi: 

while A <>{} do 
	n0:=A[1];
	n:=n0;  
	A:= A minus {n0};
	while n0 <> sigma[n] do 
		e:=e*(-1);
		m:=sigma[n];
		A:= A minus {m}; 
		n:=m 
	od; 
od;

e; 

end:


#-----------------------













#--------------------------------------------

vector_sort:=proc(v,w) 

#CLASS II PROGRAM
#December 13,2002:IA

local i, n; 

n:=nops(convert(v,list)):

for  i from 1 to n  
	do 
	if v[i] < w[i] 
		then RETURN(true) 
	fi; 
	if v[i]>w[i] 
		then RETURN(false) 
	fi; 
od; 
false
end:

#----------------------------------------------

ldiff := proc(v, indep_var)

#CLASS II PROGRAM
#December 13,2002:IA  

#ldiff::  primative differentiation         

local index, w,ind, newvar, jet_variables;


global _Vessiot_frame_data,_Vessiot_current_frame_name;

if nargs > 2 then
	change_frame_to(args[3])
fi;


jet_variables:=_Vessiot_frame_data[_Vessiot_current_frame_name][1][4][4];


#ERROR STATEMENTS.

if  type(v, indexed) then 
	w:=v
else  
	w:=jet_variables[tuple_to_index(v)]
fi;

if type(indep_var,integer)and(indep_var<=frameBaseDimension() ) then
	index := indep_var
elif member(indep_var, frameIndependentVariables()) then
  	index := tuple_to_index(indep_var)
else
      ERROR(cat("\n VESSIOT ERROR:",  
                "\n second argument must be an independent variable", frameIndependentVariables,
                "\n ", indep_var))
fi;

newvar := op(0,w)[op(1..index-1, w), op(index, w)+1,
                        op(index+1..-1, w)];

if member(newvar,jet_variables , ind)  then
	newvar:=frameJetVariables()[ind]              
fi;


newvar
end:

#******************************************





#--------------------------------------------


indet_helmlist := proc(expr::{algebraic,set(algebraic)})
#CLASS II PROGRAM
#06/16/92:CH
#12/13/02:IA  

# indet_helmlist:: returns list of indeterminants of a  given
# expresssion that are in the master_var_list.

local ans, tempset, term,n,var;
global _Vessiot_frame_data,_Vessiot_current_frame_name;

if nargs > 1 then
	change_frame_to(args[2])
fi;

tempset := indets(expr,name);
ans := [op(tempset intersect {op(frameJetVariables())})];


var:=frameDependentVariables();
n:= frameBaseDimension();

for term in tempset do
	if type(term,indexed) and member(op(0,term), var) and nops(term)=n
 	then
            ans := [op(ans),term]
      fi;
od;

ans:= convert(ans,set);



ans
end:




# END FILE Internal ************************************************
