#
# VessiotLinalg
#
# Vessiot
#
# 
# Vessiot_rref, Vessiot_nullspace; Vessiot_linsolve; newxlinsolve;
# 

Vessiot_rref:=proc(A::Matrix)

# Class II program
# 03/29/03:IA

local ans,w;
global _Vessiot_xlinalg_conditions,_Vessiot_matrices_rref;

if _Vessiot_linalg_flag = 1 or _Vessiot_linalg_flag =2 then
 	ans:=LinearAlgebra[ReducedRowEchelonForm](A);  
	RETURN(eval(ans)); 
fi;
 
if _Vessiot_linalg_flag=3  then  w:='w';
	ans:=xrref(A,w); 
      _Vessiot_xlinalg_conditions:=_Vessiot_xlinalg_conditions union w; 
     _Vessiot_matrices_rref:=[op(_Vessiot_matrices_rref),eval(A)];


      if _Vessiot_show_intermediate_steps_flag=true and w<>{}  then  print(w) fi;
	RETURN(eval(ans));
fi;

ERROR(cat("\n Vessiot Error:",  
          "\n The global variable _Vessiot_linalg_flag must be set to 1,2 or 3."));

end:
 
#-----------------------------------------------------

Vessiot_nullspace:=proc(A::Matrix) 
# 11/20/02:IA
local ans,w;
global _Vessiot_xlinalg_conditions, _Vessiot_matrices_null;

if _Vessiot_linalg_flag = 1 or _Vessiot_linalg_flag =2 then
 	ans:=LinearAlgebra[NullSpace] (A);  
	RETURN(ans); 
fi;
 
if _Vessiot_linalg_flag=3  then  w:='w';
	ans:=xkernel(A,w); 
      _Vessiot_xlinalg_conditions:=_Vessiot_xlinalg_conditions union w; 
      _Vessiot_matrices_null:=[op(_Vessiot_matrices_null),eval(A)]; 
      if _Vessiot_show_intermediate_steps_flag=true and w<>{}  then  print(w) fi;
	RETURN(ans);
fi;

ERROR(cat("\n Vessiot Error:",  
          "\n The global variable _Vessiot_linalg_flag must be set to 1,2 or 3:"));

end:

#-----------------------------------------------

Vessiot_linsolve:=proc(A,B) 
local ans;

if _Vessiot_linalg_flag = 1 or _Vessiot_linalg_flag=2 then
 	ans:=traperror(LinearAlgebra[LinearSolve](args));
 
	if ans="inconsistent system" then
			RETURN(NULL) 
		else    
			RETURN(eval(ans)) 
		fi; 
fi;
 
if _Vessiot_linalg_flag=3   
	then ans:= newxlinsolve(A,B); 
		if ans=NULL then 
			RETURN(ans) 
		else    
			RETURN(eval(ans)) 
		fi; 
fi;

ERROR(cat("\n Vessiot Error:",  
          "\n The global variable _Vessiot_linalg_flag must be set to 1,2 or 3:"));

end:

#-----------------------------------------------

newxlinsolve:=proc(A::Matrix,B::{vector,Matrix}) 
#11/20/02:IA

local w,ans,n, ans_list, constraints,i,b;
global _Vessiot_xlinalg_conditions;

if  type(B,vector) then   
	w:='w';
     	ans:=xlinsolve(A,B,w); 
	_Vessiot_xlinalg_conditions:=_Vessiot_xlinalg_conditions union w; 
	if _Vessiot_show_intermediate_steps_flag=true and w<>{} then 
		print(w) 
	fi;

	if ans=NULL then 
		if _Vessiot_show_intermediate_steps_flag=true and constraints<>{} then 
			print(constraints) 
		fi; 
		RETURN([]) 
	else 

 	RETURN(eval(ans)) 
	fi;
fi;

n:=LinearAlgebra[ColumnDimension](B);
ans_list:=[]; 
constraints:={};

for i from 1 to n do
 	b:=LinearAlgebra[Column](B,i);
 	w:='w';
 	ans:=xlinsolve(A,b,w);
	 _Vessiot_xlinalg_conditions:=_Vessiot_xlinalg_conditions union w; 
      constraints:=constraints union w;
 	if ans=NULL then 
		if _Vessiot_show_intermediate_steps_flag=true and constraints<>{} then 
			print(constraints) 
		fi; 
		RETURN([]) 
	else 
		ans_list:=[op(ans_list),eval(ans)] 
	fi; 
od;  

if _Vessiot_show_intermediate_steps_flag=true and constraints<>{} then 
	print(constraints) 
fi; 

ans:=LinearAlgebra[Transpose](Matrix(ans_list));

end:

#**********************************************************