#
# VessiotObject.vss 
#
# Vessiot
#
# makeVessiotObject; objectComponents; objectAttributes;
# vectorType; transformType; transformDomain; transformRange; transformJacobian;
# formDegree; biformDegree; objectFrame; objectType; tensorType;
# diffeqVariables; diffeqType; tensorLabels;
# functionOrder; objectOrder; objectOrder
#
# tensorIndexPart1, tensorIndexPart2

#

#---------------------

changeVectorType:=proc(vec,newType)

#CLASS I PROGRAM
#03/01/05

local X;
      
X:=op(vec):

X[1][3]:=newType;

_VESSIOT(X):
end:





#----------------------------
JacobianMatrix:=proc(a)

op(a)[1][4][1]

end:


tensorIndexPart1:=proc(a) 
#CLASS II Program
#01/04/03:IA
	
substring(op(1,a),1..3) 

end:
  
#---------------------------------------   

tensorIndexPart2:=proc(a)
#CLASS II Program
#01/04/03:IA

substring(op(1,a),5..7) 

end:



#-----------------------------------


makeVessiotObject:=proc(attributes, components);
_VESSIOT([attributes,components])
end:

#-------------------------------------------

objectComponents:=proc(a)
#CLASS I PROGRAM
#12/13/02:IA
#a::{Vessiot_bftv,Vessiot_connection,Vessiot_transformation,Vessiot_diffeq})   

op(a)[2]

end:

#------------------------------------------

objectGenerators:=proc(a) 
#CLASS I PROGRAM
#12/13/02:IA
#a::{Vessiot_bftv,Vessiot_connection

local ans,term;
ans:=[]; 

for term in op(a)[2] do 
	ans:= [op(ans),op(term[1])]
od;

convert(ans,set);
end;

#------------------------------------------

tensorGenerators:=proc(a)

local ans,i, term, n,indxType;

indxType:=op(a)[1][3][1];
n:=nops(indxType);
ans:=[];

for term in op(a)[2] do 
	ans:= [op(ans), seq([indxType[i],term[1][i] ], i=1..n)]
od;

convert(ans,set);
end:


#

objectAttributes:=proc(a)
#CLASS I PROGRAM
#12/13/02:IA
#a::{Vessiot_bftv,Vessiot_connection,Vessiot_transformation,Vessiot_diffeq})   
op(a)[1]
end:

#----------------------------------------

vectorType:=proc(a);
#CLASS I PROGRAM
#12/13/02:IA
#a::Vessiot_vect       

op(a)[1][3]
end:

#-------------------------

transformType:=proc(a);
#CLASS I PROGRAM
#12/13/02:IA
#a::Vessiot_transformation       

op(a)[1][3]
end:

#-------------------------

transformDomain:=proc(a)
#CLASS I PROGRAM
#12/13/02:IA
#a::Vessiot_transformation
       
op(a)[1][2][1]
end:

#------------------------

transformRange:=proc(a)
#CLASS I PROGRAM
#12/13/02:IA
#a::Vessiot_transformation      

op(a)[1][2][2]
end:

#--------------------------


transformJacobian:=proc(a)
op(a)[1][4][1]
end:


formDegree:= proc(a)  
#CLASS I PROGRAM
#12/13/02:IA
#a::Vessiot_form        

op(a)[1][3] 
end:

#-------------------------

biformDegree:=proc(a) 
#CLASS I PROGRAM
#12/13/02:IA
a::Vessiot_biform;
       
op(a)[1][3]  
end:

#-------------------------

objectFrame:=proc(a)   
#CLASS II PROGRAM
#12/13/02:IA
#a::{Vessiot_bftv,Vessiot_connection,Vessiot_transformation,Vessiot_diffeq}          

op(a)[1][2] 
end:

#------------------------

objectType:=proc(a) 
#CLASS I PROGRAM
#12/13/02:IA
#a::{Vessiot_bftv,Vessiot_connection,Vessiot_transformation,Vessiot_diffeq}        


if op(0,a)=_VESSIOT then RETURN(op(a)[1][1]) else RETURN(NULL) fi;
 
end:
#------------------------


tensorType:=proc(a)
#CLASS I PROGRAM
#01/05/03:IA

        
op(a)[1][3] 
end:

#------------------------

tensorIndexType:=proc(a)
#CLASS I PROGRAM
#01/05/03:IA

        
op(a)[1][3][1] 
end:

#------------------------

tensorDensityType:=proc(a)
#CLASS I PROGRAM
#01/05/03:IA
#a::Vessiot_tensor
        
op(a)[1][3][2] 
end:


#------------------------


diffeqVariables:=proc(a)
#CLASS I PROGRAM
#12/13/02:IA
#a::Vessiot_diffeq        
op(a)[1][4]
end:

#------------------------------------

diffeqType:=proc(a)
#CLASS I PROGRAM
#12/13/02:IA
#a::Vessiot_diffeq 
        
op(a)[1][3]
end:

#-------------------------------------

tensorLabels:=proc(tensor_type, index) 
#CLASS II PROGRAM
#12/13/02:IA
        
local label,n; 

n:=frameBaseDimension():

if tensor_type =`con_bas` then  
	label:=frameLabels()[index] 
fi;

if tensor_type =`cov_bas` then  
	label:=coframeLabels()[index] 
fi;

if tensor_type =`con_vrt` then  
	label:=frameLabels()[index] 
fi;
 
if tensor_type =`cov_vrt` then  
	label:= verticalCoframeLabels()[index-n] 
fi;

if tensor_type =`con_jet` then  
	label:=frameLabels()[index] 
fi;

if tensor_type =`cov_jet` then  
	label:=coframeLabels()[index] 
fi;

label;

end:

#--------------------------------

functionOrder := proc(expr::algebraic)
#CLASS II PROGRAM
#12/13/02:IA

#functionOrder:: returns the differential order of a function or expression.

local  maxorder, term, varset;

if nargs > 1 then
          change_frame_to(args[2])
fi;

varset := indet_helmlist(expr);

maxorder := 0;

for term in varset do
	if type(term, indexed) and member(op(0,term),frameDependentVariables()) then
            maxorder := max(convert(term, `+`), maxorder)
      fi;
od;

maxorder
end:


objectOrder:=proc(T) 
#Class II program
#01/06/03:IA
	  
local ans, A,a0,a,B,b;

#    This routine computes the differential order of a tensor



if op(0,T)= _VESSIOT then else 
	ans:=functionOrder(T);
      RETURN(ans);
fi;

VessiotFrameCheck(T);
 

A:=objectGenerators(T); 
a0:=max(op(A));

if a0<=frameBaseDimension() + frameFiberDimension()then
	a:=0
else
	a:=convert(index_to_jet_variable(a0),`+`);
fi;

B:=map(functionOrder,coeff_set(T));
b:=max(op(B));

ans:=max(a,b);

Vessiot_Prompt();

ans:

end:
#---------------------------------------------------
coeff_set :=  proc(geomObjField::{Vessiot_bftv,Vessiot_diffeq})
#CLASS I PROGRAM
#06/16/92:CH
#01/06/03:IA 
     
#coeff_set::returns a the set of coefficients from a given form or biform.

local ans, term,forma;
forma:=op(geomObjField);

VessiotFrameCheck(geomObjField);

ans :=[];

for term in forma[2] do
    ans := [op(ans),term[2]]
od;

ans:=convert(ans,set);

ans
end:

#-------------------------------

coeff_list:=proc(Vessiot_obj::{Vessiot_bftv,Vessiot_diffeq}, a_list::{name,list})
	 local ans, term, term1,a_v_object;
#CLASS I PROGRAM
#06/16/92:CH
#12/13/02:IA  

#coeff_list::  extracts specified coefficients from a Vessiot object,  
#              returning them as a list.
#
#a_v_object:: any Vessiot data structure
#a_list:: a list of indices in the component list of the object; if a_list =`all` then
#         all the components are returned in a list.
#optional args: coordinate frame - a defined coordinate frame.

a_v_object:=op(Vessiot_obj);

VessiotFrameCheck(Vessiot_obj);

if a_list <> `all` and nops(a_list)=1 
	then ans:=0;
      for term in a_v_object[2] do
	  	if term[1]=a_list[1] then
			ans:=term[2];
                 	break;
           	fi;
	od;	   
fi; 

if a_list <> `all` and nops(a_list)>1 then
   	ans:=[];
      for term in a_v_object[2] do
		for term1 in a_list do
	       	if term[1]=term1 then
		     		ans:=[op(ans),term[2]]
           		fi;
	     	od;
	od;
fi; 
        
if a_list = `all` then 
    	ans:=[];
	for term in a_v_object[2] do
		ans:=[op(ans),term[2]];
	od
fi;

ans
end:

