#
#
#

ode_to_vect:=proc(ode,indepVar,frame) 
local Vars, diffVars,Sub1, X1,X,odeNormal; 

Vars:=frameIndependentVariables(frame): 
Sub1:={seq(Vars[i](indepVar)=Vars[i], i=1..nops(Vars))};
diffVars:=[seq(diff(v(indepVar), indepVar),v=Vars)]: 

odeNormal:=solve(ode, {seq(diff(v(indepVar), indepVar),v=Vars)});

X:= v_zip(diffVars,frameBaseVectors(frame),plus):
X1:=subs(odeNormal,X);
subs(Sub1,X1);

end:


vect_to_ode:=proc(X,indepVar) 
local  fr, vars,Eq,Sub1,v,eq;

fr:=objectFrame(X):
vars:=frameIndependentVariables(fr);

Eq:=[]; 
Sub1:={seq(v=v(indepVar),v=vars)};

for v in vars do 
	eq:=diff(v(indepVar),indepVar)-subs(Sub1,Lie_derivative(X,v)); 
	Eq:=[op(Eq),eq]
od;

convert(Eq,set):

end: 

#~~~~~~~~


SolveLieEquation:=proc(C,Gamma,init_pt)

local  IC, ICsoln, soln3, diff_order,n, X, t, fr, vars, m, alg1, alg2,rho, S, CC, 
	 newGamma, newC, GpVars, Omega, Right, mu, Y, de, soln0, soln1, soln2;

n:=nops(Gamma): 
X:=v_zip(C,Gamma,plus): 

t:=indets(C)[1]:
fr:=objectFrame(X): 
vars:=frameIndependentVariables(fr):
m:=frameBaseDimension(fr);

alg1:=vect_to_Lie_alg(Gamma,LieEqAlg1);
Lie_algebra_init(alg1);

rho:=LieAlgebraRepresentations:-MakeRepresentation(LieEqAlg1,LieEqAlg1,ad());

S:=LieEngelTheorems:-SolvableBasis(rho)[1];

alg2:=convert(S,Lie_algebra_data,LieEqAlg2);
Lie_algebra_init(alg2);

CC:=linear_combo(S,frameBaseVectors(LieEqAlg1));  
newGamma:=map(v_zip,CC,Gamma,plus);     
newC:=LieEqLinearCombo(X,newGamma,init_pt):
GpVars:=[seq(cat(z,i),i=1..n)];

coord_init(GpVars,Gp1);
Omega:=LieGroups:-LieAlgebraToMaurerCartanForms(LieEqAlg2,Gp1,solvable);
Right:=dual_basis(Omega);

mu:=GroupActions:-SolvableAction(Right,newGamma,[seq(v=0,v=GpVars)]);

Y:=v_zip(newC,Right,plus);
de:=vect_to_ode(Y,t);

soln0:=dsolve(convert(de,set),explicit);
soln1:=subs(soln0, [seq(v(t),v=GpVars)]);
soln2:=mu(soln1,map(rhs,init_pt));

if nargs=4 then
	 	IC:={seq( subs(args[4],vars[i])=subs(t=0,soln2[i]),i=1..m)};
else
	IC:={seq(cat(_c,i)=subs(t=0,soln2[i]),i=1..m)};
fi;

ICsoln:=solve(IC,{seq(cat(_C,i),i=1..n)});
soln3:=simplify(subs(ICsoln,soln2));

[seq(vars[i](t)=soln3[i],i=1..m)];


end:



#~~~~~~~~~~~~~~~


multi_Wronskian := proc(eq, vars, diff_order)
#CLASS II PROGRAM
#03/08/03:IA
   
local ind, eq_table, v, w, k, _Vessiot_x;

ind := [seq(op(combinat[choose](
       [seq(seq(_Vessiot_x, i = 1 .. k), _Vessiot_x = vars)], k)),
        k = 1 .. diff_order)];
    
eq_table := table();
eq_table[[]] := eq;
    
for v in ind do
        w := v[2 .. -1];
        eq_table[v] := map(diff, eq_table[w], v[1])
od;

[op(eq), seq(op(eq_table[v]), v = ind)]

end:


#~~~~~~


LieEqLinearCombo:=proc(X,Gamma,points) 

local m ,fr,vars,unknowns,Z,linear_system,W_system,eq,temp,test,Comp,diff_order;


m:=nops(Gamma); 
fr:=objectFrame(X);
vars:=frameIndependentVariables(fr):
unknowns:=[seq(cat(a,i), i=1...m)];

Z:=X &minus v_zip(unknowns,Gamma,plus);
linear_system:= convert(coeff_set(Z),list);

diff_order:=1; 
            
while  nops(linear_system)*binomial(nops(vars) +diff_order,diff_order) < 2*m
do 
diff_order:=diff_order+1 
od;

W_system:=multi_Wronskian(linear_system,vars,diff_order+1);
            
eq:={seq( op(simplify(subs(pt,W_system))),pt=points)};
             
temp:=solve(eq ,convert(unknowns,set));
      	
test:= subs(temp,Z);
	     
Comp:=_Vessiot_simplify(coeff_set(test));
             
if Comp <> {0}  then
 	RETURN([]) 		
else 
	RETURN(subs(temp,unknowns));
fi;
end:


FindLieEquation:=proc(ode,indepVar,fr,init_pt,N) 

local X,C,Gamma0,Gamma, findLieEquation0,  findLieAlg; 

#
#
#

findLieEquation0:=proc(X,t,init_pt,N)

 
local  Gamma,Y,i,C;

Gamma:=[helmsimp(subs(t=0,X))];
Y:=X;

for  i from 1 to N do 
	Y:=DifferentialGeometryTools:-Vessiot_map(2,diff,Y,t);
	Gamma:=[op(Gamma),helmsimp(subs(t=0,Y))];
	C:=LieEqLinearCombo(DifferentialGeometryTools:-zero_vect(),Gamma,[init_pt]); 
	if C<>[0$nops(Gamma)] then RETURN([]) fi;
	C:=LieEqLinearCombo(X,Gamma,[init_pt]);
	if C<>[] then RETURN(C,Gamma) fi;
od;

[];

end:

#
#


findLieAlg:=proc(Gamma0,init_pt,N) 



local Gamma,n,closedList,i,j,Z,C; 

Gamma:=Gamma0;

while nops(Gamma) <N do
	n:=nops(Gamma); closedList:=[];
	for i from 1 to n 	
		do for j from i+1 to n do 
		if member([i,j],closedList)=false 
			then Z:=Lie_bracket(Gamma[i],Gamma[j]);
			C:=LieEqLinearCombo(Z, Gamma, init_pt);
			if C<>[] then 
				closedList:=[op(closedList),[i,j]] 
			else 
				Gamma:=[op(Gamma),Z]; 
			break fi; 
		fi;
		od; 
		if nops(Gamma) <> n then break fi; 
	od; 
	if nops(Gamma) =n then RETURN(Gamma) fi 
od;

[];

end:




#Main Routine


X:=ode_to_vect(ode,indepVar,fr):

C,Gamma0:=findLieEquation0(X,indepVar,init_pt,N):

Gamma:=findLieAlg(Gamma0,init_pt,N);

C:=LieEqLinearCombo(X,Gamma,[init_pt]);

C,Gamma;

end:
