#
# Arith.dg 
#
# DiffGeom
#
# &mult; &plus; &minus &tensor

`&mult` := proc(scalar, geomObjField)

# CLASS I PROGRAM
# 06/16/92 CH
# 07/07/97 CM
# 12/13/02 IA

#&mult:: performs scalar multiplication, acts as an operator.

local term, newform, new_attributes;


if type(scalar,Vessiot_scalar)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  &mult  requires first arguement to be a Maple expression", 
		    "\n ",objectType(scalar))); 
fi;


if type(geomObjField,Vessiot_bftv)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  &mult  requires second arguement to be a biform,form,tensor, vector:", 
		    "\n ",objectType(geomObjField))); 
fi;

VessiotFrameCheck(geomObjField):

newform := [];

for term in op(geomObjField)[2] do
    	newform := [op(newform), [term[1], scalar*term[2]] ]
od;
 
new_attributes:=op(geomObjField)[1]; 

if new_attributes[1]=cat(vect) then 
	new_attributes[3]:=[] 
fi;

newform :=  _VESSIOT([new_attributes,newform]);
newform := helmsimp(newform);


newform:

end:

#==========================================================

`&plus` := proc(geomObjField1,geomObjField2)

# CLASS I PROGRAM
# 06/16/92CH
# 07/07/97CM
# 12/13/02IA
# 12/28/03IA

# Procedure to add together two vectors, forms, or biforms

local form1, form2, newform, temp, new_attributes;

if type(geomObjField1,Vessiot_bftv)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  &plus  requires first arguement to be a biform, form, tensor, vector:", 
		    "\n ",objectType(geomObjField1))); 
fi;


if type(geomObjField2,Vessiot_bftv)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  &plus  requires second arguement to be a biform, form, tensor, vector:", 
		    "\n ",objectType(geomObjField2))); 
fi;

VessiotFrameCheck(geomObjField1):

form1:=op(geomObjField1):
form2:=op(geomObjField2):


if form1[1] <> form2[1] then
  
	if form1[1][1] <> form2[1][1] then
      	ERROR(cat("\n VESSIOT ERROR:",
                      "\n &plus requires input objects to be the same type:\n ",  
                       form1[1][1]," , ",  form2[1][1] ));
      
	elif form1[1][2]<> form2[1][2] then
          	ERROR(cat("\n VESSIOT ERROR:",  
                    "\n &plus requires input to be in the same frame:\n ", 
                     form1[1][2]," , ", form2[1][2] ));
    
	elif form1[1][3] <> form2[1][3] and form1[1][1]=form then
          	ERROR(cat("\n VESSIOT ERROR:",  
                    "\n &plus requires forms to be of the same degree:\n ",
                      form1[1][3]," , ", form2[1][3] ));

	elif form1[1][3] <> form2[1][3] and form1[1][1]=biform then
          	ERROR(cat("\n VESSIOT ERROR:",
			    "\n &plus requires biforms to be of the same bidegree:\n ",
                        convert(form1[1][3],string), " , " ,   convert(form2[1][3],string) ));

	elif form1[1][3] <> form2[1][3] and form1[1][1]=tensor then
          	ERROR(cat("\n VESSIOT ERROR:", 
                      "\n &plus requires tensors to be of the same index type:\n ",
                       convert(form1[1][3],string), " , " , convert(form2[1][3],string ) ));                                                   

      fi:
fi:
	
new_attributes:=form1[1]; 

if form1[1][1]=cat(vect) then 
	new_attributes[3]:=[] 
fi;

#Concats the two lists.

temp:=[op(form1[2]), op(form2[2])]:
      
temp:= _VESSIOT([new_attributes, temp]):

#Simplifies the new list.

newform:= helmsimp(temp):

newform

end:

#==================================================

`&minus` := proc(form1, form2)

# CLASS II PROGRAM
# 06/16/92 CH
# 07/07/97 CM
# 12/13/02 IA
        
#PROCEDURE &MINUS, performs subtraction, acts as an operator.

local temp:

temp:=(-1) &mult form2:
temp := form1 &plus temp:


temp:

end:

#===============================================


`&tensor`:=proc(tensor1::Vessiot_bftv, tensor2::Vessiot_bftv)
#Class I program
#06/01/97:CM
#01/04/03:IA
     

local ans, new_index_char, tensorProductWeight, new_density, new_comps, 
      tens1, tens2, term1, term2; 


tensorProductWeight:= proc (A1,A2) 
#Class II Program
#01/05/03:IA

local A, B,a, i, j;

if A1=[] then 
	RETURN(A2) 
fi;

if A2=[] then
	RETURN(A1);
fi;
 
A := [op(A1), op(A2)] ;

for i to nops(A) do 
	for j from i+1 to nops(A) do 
		if A[i][1] = A[j][1] then 
			A[i]:= [A[i][1], A[i][2]+A[j][2]];
                  A:=[op(1..j-1,A),op(j+1..-1,A)]; 
			break 
		fi 
	od 
od; 

B:=[];

for a in A do 
if a[2] <>0 then B:=[op(B), a] fi;
od;

B; 


end:

#-------------------------------------

# This routine multiplies Vessiot tensors.

if objectFrame(tensor1) <> objectFrame(tensor2) then
       ERROR(cat("VESSIOT ERROR: tensors must be in the same frame."))
fi;
     
VessiotFrameCheck(tensor1):


tens1:=tensor1;
tens2:=tensor2;

if objectType(tensor1)= form then 
	tens1:= convert(tensor1,Vessiot_tensor) 
fi;

if objectType(tensor1)= vect 
	then tens1:= convert(tensor1,Vessiot_tensor)
fi;
  
if objectType(tensor2)= form then 
	tens2:= convert(tensor2,Vessiot_tensor)
fi;

if objectType(tensor2)= vect 
	then tens2:= convert(tensor2,Vessiot_tensor) 
fi;

new_index_char:=[op(tensorIndexType(tens1)), op(tensorIndexType(tens2))];

new_density:=tensorProductWeight(tensorDensityType(tens1), tensorDensityType(tens2)); 
#construct the tensor:

new_comps:=[];
     
for term1 in op(tens1)[2] do
	for term2 in op(tens2)[2] do
      	new_comps:=[op(new_comps),[[op(term1[1]),op(term2[1])],term1[2]*term2[2]]];
      od;
od; 
 
ans:=_VESSIOT([[tensor,objectFrame(tensor1),[new_index_char,new_density]],new_comps]);

ans:=helmsimp(ans);


ans;

end: 



#**************************************************