#
# ext_d.dg
#
# ext_d
#
# 


ext_d := module()

local ExteriorDerivativeProcedureTable ;

export addProcedure, ModuleApply;


addProcedure:=proc(r,p) ExteriorDerivativeProcedureTable[op(r)]:= p end:

ModuleApply:=proc(omega0)
# CLASS II PROGRAM
# 08/26/91:CH
# 12/13/02:IA

local ans, frame,omega, PHI,newdegree;

omega:=evalV(omega0);

if type(omega,Vessiot_scalar) then
	omega:=DifferentialGeometryTools:-scalar_form(omega)	
fi;

if type(omega,Vessiot_form)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		      "\n  ext_d requires arguement to be a form:", 
		      "\n ",objectType(omega)  )); 
fi;

VessiotFrameCheck(omega):

frame := frameProtocol();
newdegree := formDegree(omega) + 1;

# d is an anti-derivation.  Pass to antiderv: w, calculation
# code location, and degree of output.
# explain why deriv is used.


PHI:=ExteriorDerivativeProcedureTable[frame];

ans := derivation[formBiform](PHI,deriv, omega, DifferentialGeometryTools:-zero_form(newdegree)):

ans;

end:

#--------------------


ExteriorDerivativeProcedureTable[vst_euc]:=proc(expr,flag)
#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

local d_ans, d_list, term, varlist;

#ERROR STATEMENTS

        d_list := [];

#If statement to determine if expr should be treated as a coefficient,
# independent variable or a dependent variable.

#coordinate[d] will be called repeatedly from antiderv as it works on each
# part of the biform called by Vessiot[d].

#Coefficent code:

        if flag = 'coeff' then
          varlist := indet_helmlist(expr);
          for term in varlist do
                d_list := [op(d_list), [[tuple_to_index(term)],
                                                diff(expr, term)]]
           od;
          if d_list <> [] then
          d_ans := _VESSIOT([[form, _Vessiot_current_frame_name, 1], d_list])
          else
          d_ans := DifferentialGeometryTools:-zero_form(1)
          fi;

elif flag='bftv' then


#Independent variable code:
#Dependent variable code:

           d_ans := DifferentialGeometryTools:-zero_form(2)

        else
          ERROR(`VESSIOT ERROR: insufficient input`)
        fi;

        d_ans
end:



#-------------------------------------------------------------

ExteriorDerivativeProcedureTable[repere_mobile]:= proc(expr,flag)
# Class I program
# 01/12/03       

local d_ans,fr, varlist,term;
global _Vessiot_current_frame_name;

fr:=_Vessiot_current_frame_name;

if  flag= 'coeff' then 
	varlist := indet_helmlist(expr);
      d_ans:=DifferentialGeometryTools:-zero_form(1);
      for term in varlist do
		d_ans :=  DiffGeomMain:-Plus(d_ans,
                      DiffGeomMain:-Mult( diff(expr, term), _Vessiot_frame_data[fr][2][1][tuple_to_index(term)]))
      od;
fi;

if flag='bftv' then 
	d_ans:= _Vessiot_frame_data[fr][3][1][expr]
fi;

d_ans:
end:


end module:

#****************************************************************  