#
# frame_Init.dg
#
# DiffGeom
#
# dual_frame; dual_coframe; coframe_data; 
# frame_init;
#



dual_basis:=proc(basis::{list(Vessiot_vect), list(Vessiot_form)})
 

local dual_frame, dual_coframe,ans,objType;

#
#  LOCAL SUBROUTINES
#

dual_frame:= proc(basis::list(Vessiot_form))

# CLASS II PROGRAM
# 12/17/02:IA
      
local N, i, j, A, B, vects, fr,ans;
 
N := nops(basis);
A := Matrix(N, N);

if  nargs=2 then 
	vects:=args[2]
     
else
	VessiotFrameCheck(basis[1]);
   
	vects := [seq(DifferentialGeometryTools:-Vect(i), i = 1 .. N)];
   
fi;

for i to N do for j to N do
            A[i, j] := op(hook(vects[j], basis[i]))[2][1][2]
        od
    od;
    if  simplify(LinearAlgebra[Determinant](A)) = 0  
    then  
    ERROR(cat("\n VESSIOT ERROR:", 
	        "\n Span of the  given list of forms does not coincide with the ", 
		  "\n span of the differentials of:", 
		  "\n ",[seq(frameJetVariables()[i], i=1..N)]) );
    fi;
       
    B := LinearAlgebra[MatrixInverse](A);
    
[seq(
        v_zip(convert(LinearAlgebra[Column](B, i), list), vects, plus),
        i = 1 .. N)]
end:

#=======================================

dual_coframe:= proc (basis::list(Vessiot_vect)) 

# CLASS II PROGRAM
# 12/17/02:IA      

local N, i, j, A, B, forms,fr;
global _Vessiot_current_frame_name; 
N := nops(basis);
A := Matrix(N, N);

if  nargs=2 then 
	forms:=args[2]     
else
	VessiotFrameCheck(basis[1]);
   
	forms := [seq(DifferentialGeometryTools:-Form(i), i = 1 .. N)];
   
fi;


for i to N do 
	for j to N do 
	A[j,i] := op(hook(basis[j],forms[i]))[2][1][2] 
	od 
od; 

if  simplify(LinearAlgebra[Determinant](A)) = 0  then  
    ERROR(cat("\n VESSIOT ERROR:", 
	        "\n Span of the  given list of vect does not coincide with the ", 
		  "\n span of the coordinate basis of:",
              "\n ",[seq(frameJetVariables()[i], i=1..N)]) );
   
fi;

B:= LinearAlgebra[MatrixInverse](A); 
[seq(v_zip(convert(LinearAlgebra[Column](B,i),list),forms,plus),i = 1 .. N)] 

end:


#
# MAIN PROGRAM
#

objType:=objectType(basis[1]);

if objType=`vect` then 
	ans:=dual_coframe(args);
fi;

if objType=`form` then 
	ans:=dual_frame(args)
fi;


ans

end:


#------------------------------------------------------



coframe_data:= proc (varsList, coframe) 
#CLASS II PROGRAM
#12/17/02:IA 
     
local N, frame, fr, structure_functions1, structure_functions2, beta,
structure_functions3, i, k, j, alpha, C, frameName, M; 

N := nops(coframe); 
M := nops(varsList); 
if N < M then 
	ERROR(`Vessiot Error: length of variable`,M,
	`greater than length of coframe list`,N) 
fi; 

fr:=objectFrame(coframe[1]);
change_frame_to(fr):

frame := dual_basis(coframe,map(DifferentialGeometryTools:-Vect,varsList)); 

if nargs > 2 
	then 
	frameName := args[3]; 
	else 
	frameName := `Cartan` 
fi; 

structure_functions1 := []; 

for k to N do
 	
	if  nargs=4 then  
		alpha := pullback(args[4], ext_d(coframe[k]))
	else
      	alpha := ext_d(coframe[k])
	fi;
 
	for i to N do 
		beta:=hook(frame[i],alpha);
		
		for j  from i +1 to N do 
			C := -simplify(coeff_list(hook(frame[j],beta),[[]])); 
		if C <> 0 then 
			structure_functions1 := [op(structure_functions1), [[i, j, k], C]] 
		fi 
		od 
	od 
od; 

structure_functions2 := []; 

for k to M do 
	for i to N do 
        
	if nargs=4 then 
		C:= pullback(args[4], Lie_derivative(frame[i],varsList[k])); 
	else
            C:= Lie_derivative(frame[i],varsList[k]);
	fi; 
	
	if C <> 0 then 
		structure_functions2 := [op(structure_functions2), [[i, k], C]] 
	fi 
	od 
od; 

[[moving_frame, frameName,[N], objectFrame(coframe[1]), varsList], 
  structure_functions2, structure_functions1] 

end:

#----------------------------------------------------------------------

frame_init := proc(frameData)

# CLASS II PROGRAM
# December 17,2002:IA      

local check, frame, fr, frame_name,term, ind, i, j, N, struct_eq,k, p, q, r, v, s,
f,  indep_var_list,dep_var_list,jet_order,jet_var_list,coord_frame, 
frame_labels, coframe_labels, temp_frame_labels, temp_coframe_labels
,frame_bracket_array,A,B, 
coframe_ext_d_list, coord_ext_d_list, coord_Lie_array,part1, part2, part3,part4,part5;

global _Vessiot_frame_data ,_VessiotWarningFlag; 
       
frame_name:=frameData[1][2];
coord_frame:= frameData[1][4];
N:=frameData[1][3][1];

if member(frame_name, listOfFrameNames()) 
	then 
	remove_frame(frame_name) 
fi:

indep_var_list:=frameIndependentVariables(coord_frame):
dep_var_list:=frameDependentVariables(coord_frame):
jet_order:=frameJetOrder(coord_frame):
jet_var_list:=frameData[1][5];


#jet_var_list:=frameJetVariables(coord_frame):


readlib(repere_mobile):


coord_init([seq(cat(_z,i), i = 1 .. N)], [_u],frame_name);


if nargs >=2 
	then
	temp_frame_labels:=args[2];      
	if nargs <>3 
		then 
		ERROR(`Vessiot Error: Missing third argument --- coframe_labels`);
	      else
		temp_coframe_labels:=args[3];
      fi;
	else 
	temp_frame_labels:=[]; 
	temp_coframe_labels:=[]
fi;
 
frame_labels:=constructFrameLabels(temp_frame_labels,"E",N);

if frame_labels=[] then 
	print(`frame_init terminated`);
      RETURN()
fi;



coframe_labels:=constructFrameLabels(temp_coframe_labels,"Theta",N);
  

if coframe_labels=[] then 
	print(`frame_init terminated`);
      RETURN()
fi;


for i to N 
do 
	assign(reconstructVariableName(frame_labels[i]),  DifferentialGeometryTools:-Vect(cat(_z,i) ) )
od;
 

for i to N 
do 
	assign(reconstructVariableName(coframe_labels[i]),DifferentialGeometryTools:-Form(cat(_z,i) ))
od;
    

coord_ext_d_list:=[seq(DifferentialGeometryTools:-zero_form(1), i=1..N)]:


for term in frameData[2] do
      coord_ext_d_list[term[1][2]] := 
      coord_ext_d_list[term[1][2]]  &plus 
	(term[2] &mult (DifferentialGeometryTools:-Form(frameJetVariables()[term[1][1]]) ))
od;



coframe_ext_d_list:= [seq(DifferentialGeometryTools:-zero_form(2), i = 1 .. N)];
 
for term in frameData[3] do
      coframe_ext_d_list[term[1][3]] := 
      coframe_ext_d_list[term[1][3]]&minus 
	(term[2] &mult (DifferentialGeometryTools:-Form(frameJetVariables()[term[1][1]])
        &wedge
        DifferentialGeometryTools:-Form(frameJetVariables()[term[1][2]])));    
 
od;
 
coord_Lie_array:=Matrix(N,N,0);

for term in frameData[2] do 
	coord_Lie_array[term[1][1],term[1][2]]:=
	coord_Lie_array[term[1][1],term[1][2]] + term[2]
od;

   
f:=(i,j)->DifferentialGeometryTools:-zero_vect();
                      
frame_bracket_array:=Matrix(N,N,f);

for term in frameData[3] do 
	frame_bracket_array[term[1][1], term[1][2]]:= 
	DiffGeomMain:-Plus(frame_bracket_array[term[1][1], term[1][2]],
	DiffGeomMain:-Mult(term[2],DifferentialGeometryTools:-Vect(frameJetVariables()[term[1][3]]) ))
od;
 

for i from 1 to N  do
	for j from i to N  do
		frame_bracket_array[j,i]:= DiffGeomMain:-Mult( (-1) , frame_bracket_array[i,j]);
	od;
od;


fr:=frame_name;

part1:= [`frame`, repere_mobile, frame_name,[indep_var_list,dep_var_list,jet_order,jet_var_list,
	frame_labels, coframe_labels,[],[], jet_var_list]];

part2:=[coord_ext_d_list];

part3:=[coframe_ext_d_list]:

part4:=[eval(coord_Lie_array)]:

part5:=[eval(frame_bracket_array)]:

_Vessiot_frame_data[fr]:=[part1,part2,part3, part4, part5];

cat(`frame: `, frame_name);

end:



#
#***************************************************
#
