#
# Helmsimp.vss
#
# Vessiot
#
# helmsimp;
#
#
# These are the basis programs for simplifying  vectors, forms or biforms. 
#


helmsimp := proc(geomObjField::Vessiot_bftv)
#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

local forma,formcomp, temp,listorder, collect_terms, zero_out, 
	zero_object; 


#
# LOCAL SUBROUTINES
#


listorder := proc(a,b)

#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

#listorder:: gives prescedence for sort function
#Listorder input are two components of a vector, form or biform
#ie, a=[[1,3], c1] and b=[[2,3], c2].

local i, n1, truthvalue;

if nargs>2 then
	change_frame_to(args[3])
fi;

n1:= nops(a[1]);
i:=1;
truthvalue := false;

while i <= n1 do
	if a[1][i] < b[1][i] then
  		truthvalue := true;
            i := n1+100
     	elif a[1][i] > b[1][i] then
            i := n1 +100
    	else i:=i+1 fi
od:

truthvalue

end:

#========================================================

collect_terms:= proc(comp)
#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

#collect_terms:: combines like terms in a vector, form or biform.
#Collect assumes that comp has been sorted.
#Comp is the second part of a vector, form or biform list,
#ie, comp = [ [[1,2],a] , [[2,3],b] ].

local a, comp1, i, j, n, newlist;

if nargs>1 then
	change_frame_to(args[2])
fi;

n:=nops(comp);
i:=1;

newlist := [];

while i <= n-1 do
	j:=i+1;
      a:=comp[i][2];
      while (j<=n) and (comp[i][1] = comp[j][1]) do
            a:=a + comp[j][2];
            j:=j+1
      od;
      comp1 := [comp[i][1], a];
      i := j;
      newlist := [op(newlist), comp1]
od;

if i = n then
	newlist :=  [op(newlist), comp[i]]
fi;

	
_Vessiot_simplify(newlist)

end:

#=========================================================


zero_out := proc(comp)
#CLASS I PROGRAM
#December 13,2002:IA

#zero_out::eliminates zeros from a vect, form or biform.

local newlist, term;

if nargs>1 then
	change_frame_to(args[2])
fi;

newlist := [];

for term in comp do
  	if term[2] <> 0 then
      	newlist := [ op(newlist), term]
      fi;
od;

newlist

end:


#==============================================================

zero_object := proc(formtype)
#CLASS II PROGRAM
#08/26/91:CH
#12/13/02:IA

#zero:: gives default zero vector, form or biform.

local zeroform:

if formtype[1] = `vect` then
	zeroform := DifferentialGeometryTools:-zero_vect(formtype[3],formtype[2])
elif formtype[1] = `form` then
      zeroform := DifferentialGeometryTools:-zero_form(formtype[3], formtype[2])
elif formtype[1] = `biform` then
      zeroform := DifferentialGeometryTools:-zero_biform(formtype[3], formtype[2])
elif formtype[1]=`tensor` then
      zeroform := DifferentialGeometryTools:-zero_tens(formtype[3])
elif formtype[1]=`connection` then
      zeroform := DifferentialGeometryTools:-zero_tens(formtype[3])
elif formtype[1]=`pre-connection` then
      zeroform := DifferentialGeometryTools:-zero_tens(formtype[3])

fi;

zeroform

end:

#========================================================

#
# MAIN PROGRAM
#

forma:=op(geomObjField);

formcomp := forma[2];
formcomp := sort(formcomp, listorder);
formcomp := collect_terms(formcomp);
formcomp := zero_out(formcomp);

if formcomp = [] then
	temp := zero_object(forma[1])
else  
	temp := _VESSIOT([forma[1], formcomp])
fi:

temp

end:

#******************************************************