
Lie_bracket:=module()


export  addRule, ModuleApply;

local LieBracketRuleTable;  



addRule:=proc(r,p) LieBracketRuleTable[op(r)]:= p end:


ModuleApply:=proc(v10, v20)

# CLASS II PROGRAM
# 08/26/1991:CH
# 12/17/2002:IA         
# 12/19/2003:IA        

local ans, v1,v2,frame;


v1:=evalV(v10):

v2:=evalV(v20):

if type(v1,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Lie_bracket requires first arguement to be a vector field:", 
		    "\n ",convert(objectType(v1),string) )); 
fi;


if type(v2,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Lie_bracket requires second arguement to be a vector field:", 
		    "\n ",convert(objectType(v2),string) )); 
fi;


if objectFrame(v1)<> objectFrame(v2) then  
    ERROR(cat("\n Vessiot Error:",  
		  "\n frame of vector 1 ",objectFrame(v1),
              "\n must equal frame of vector 2 ", objectFrame(v2) ))
fi;
   
VessiotFrameCheck(v1):

frame := frameProtocol();

ans:=LieBracketRuleTable[frame](v1,v2);

ans

end:



LieBracketRuleTable[vst_euc] := proc(vec1, vec2)
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA         
        
local ans, term;


ans := [];

for term in op(vec2)[2] do
	ans := [op(ans), [term[1], Lie_derivative(vec1, term[2])]]
od;

for term in op(vec1)[2] do
      ans := [op(ans), [term[1], -Lie_derivative(vec2, term[2])]]
od;

ans := _VESSIOT([[vect, _Vessiot_current_frame_name,[]], ans]);

helmsimp(ans)

end:



LieBracketRuleTable[repere_mobile]:=proc(v::Vessiot_vect, w::Vessiot_vect)
# Class II program
# 01/12/03       

local X,i, c,fr,n,term1, term2, Lv,Lw,v_comp, w_comp;

fr:=_Vessiot_current_frame_name;
n:=frameBaseDimension();

X:=DifferentialGeometryTools:-zero_vect();

v_comp:=objectComponents(v);
w_comp:=objectComponents(w);

Lv:= x->Lie_derivative(v,x);
Lw:= x->Lie_derivative(w,x);



X:=DiffGeomMain:-Plus(X,DiffGeomMain:-Minus(
DifferentialGeometryTools:-Vessiot_map(1,Lv,w), DifferentialGeometryTools:-Vessiot_map(1,Lw,v) ));

for term1 in v_comp do 
	for term2 in w_comp do
 
	X:=DiffGeomMain:-Plus(X, 
         DiffGeomMain:-Mult( term1[2]*term2[2], 
		                 _Vessiot_frame_data[fr][5][1][term1[1][1], term2[1][1] ]));
	od; 
od;

helmsimp(X);

end:


end module:


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


