 #
# pullback.dg
#
# DiffGeom
#
# pullback; 
#

pullback:=proc(a_map,forma0)


# CLASS II PROGRAM
# 12/19/02:IA 
# 12/28/03:IA

local ans, eqn_list, dom_fr, fr1,fr2,psi, pbtype, beta, index, alpha, phi,forma,pullback_form, 
pullback_biform, 	projected_pullback, pullback0, pullback_form0, pullback_biform0;


global _Vessiot_current_frame_name;


forma:=evalV(forma0);

#.

pullback_biform := proc(phi, forma)

if objectOrder(forma)>transformRange(phi)[2]  then
        ERROR(cat("\n VESSIOT ERROR:",
                  "\n differential order of the biform exceeds that of the map:", 
                  "\n ", objectOrder(forma),transformRange(phi)[2]))
fi;      
if transformType(phi)=[] then  
	ERROR(cat("\n VESSIOT ERROR:",
                "\n biforms may not be pullbacked ", 
                " under maps which are not fiber_preserving.", 
                "\n Use projected_pullback."))

elif transformType(phi)[1]<>`projectable` then
       ERROR(cat("\n VESSIOT ERROR:",
                "\n biforms may not be pullbacked ", 
                " under maps which are not fiber_preserving.",
                "\n Use projected_pullback."))

fi;


pullback_biform0 := proc(term,flag,a_map)
#CLASS I PROGRAM
#12/17/02:IA 

local ans,expr,ans_components,i,varlist, eqn_list,index,phi,n,m,v;

phi:=op(a_map);
eqn_list:=[]:

for index from 1 to nops(phi[2]) do
	eqn_list:=[op(eqn_list),phi[2][index][2]=phi[2][index][1]]
od;

# pullback applied to differentials.

if nargs > 1 and args[2] =`coeff` then
	ans_components := [ [], subs(eqn_list, term)];
      ans:=_VESSIOT([[biform,_Vessiot_current_frame_name,[0,0]] , [ans_components]]); 

        
# pullback applied to variables.

elif type(term,integer) then
      
      expr:=rhs(eqn_list[term]);
      n:=frameBaseDimension(transformRange(a_map)[1] );
      m:=frameBaseDimension(transformDomain(a_map)[1] );

    	if term <= n then
		ans_components:=[];
      	for i from 1 by 1 to m do
			ans_components := [op(ans_components), [[i], td(expr,i)]]
      	od;
	
            ans:= _VESSIOT([[biform, _Vessiot_current_frame_name, [1,0]], ans_components])

      else
    
      	ans_components:=[];
      	varlist := indet_helmlist(expr) minus {op(frameIndependentVariables() )};
          
		for v in varlist do
      		ans_components:= [op(ans_components), [[tuple_to_index(v)], diff(expr, v)]]
     		 od;
     		 ans := _VESSIOT([[biform, _Vessiot_current_frame_name, [0,1]], ans_components])
    	fi;

fi;

ans

end:



end:

# =========================================================

projected_pullback:= proc(phi, forma)
         
alpha:=biform_to_form(forma);

if objectOrder(forma)>transformRange(phi)[2]  then
        ERROR(cat("\n VESSIOT ERROR:",
                  "\n differential order of the biform exceeds that of the map:",
                  "\n ", objectOrder(forma),transformRange(phi)[2]));
fi;

if  transformRange(phi)[1] <> objectFrame(forma) then
        ERROR(cat("\n VESSIOT ERROR:",
			"\n  the domain of the map and form must be the same frame:",
                  "\n ",transformRange(phi)[1],objectFrame(forma) ))
fi;      
             
if transformType(phi)=[] then
	ERROR(cat("\n VESSIOT ERROR:",
                " projected_pullback  may not be used on generic transformations.")) 
fi;

end:

#........   ERROR MESSAGES ...................

if type(a_map,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Pullback requires first arguement to be a transformation:", 
		    "\n ", objectType(a_map))); 
fi;

if type(forma,{Vessiot_scalar, Vessiot_form,Vessiot_biform,Vessiot_tensor})=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Pullback requires second arguement to be a Maple expression, form or biform,", 
		    "\n ",objectType(forma))); 
fi;

if objectOrder(forma) > transformRange(a_map)[2]  then
		ERROR(cat("\n VESSIOT ERROR:",
		    "\n Differential order of second argument(scalar,form,biform) exceeds",
                "\n differential order of map", 
                "\n ", functionOrder(forma),"," ,transformRange(a_map)[2] )  )
fi;

#...........Pullback for Maple Expressions ...............................

if type(forma,Vessiot_scalar) then 
	
	phi:=op(a_map):
	_Vessiot_current_frame_name :=transformRange(a_map)[1];

		eqn_list:=[seq( phi[2][index][2]=phi[2][index][1] , index=1 ..nops(phi[2]))];

	ans := subs(eqn_list, forma);

	change_frame_to(transformDomain(a_map)[1]):

	ans:=_Vessiot_simplify(ans);

      RETURN(ans)
fi;

#........................................



if  transformRange(a_map)[1] <> objectFrame(forma) then
        ERROR(cat("\n VESSIOT ERROR:",
			"\n  the range of the map and form must be the same frame:",
                  "\n ",transformRange(a_map)[1],objectFrame(forma) ))
fi;      

#.......... Pullback for forms ..........


if type(forma,Vessiot_form) then
	dom_fr:=transformDomain(a_map)[1];

	if dom_fr <> _Vessiot_current_frame_name then
		change_frame_to(dom_fr)
	fi;
        
# Apply homomorphism to forma, using pullback on each component.


 pullback_form0:= proc(term,flag,a_map)
#CLASS I PROGRAM
#12/17/02:IA 
        
local  J,Cff,coFrame,ans,eqn_list,indx, expr,ans_components,varlist, v,index,phi;

phi:=op(a_map);

eqn_list:=[seq( phi[2][indx][2]=phi[2][indx][1],indx=1..nops(phi[2]) )];

# pullback applied to coefficients.

if nargs > 1 and args[2] =`coeff` then
	ans_components := [ [], subs(eqn_list,term)] ;
      ans:=_VESSIOT([[form,_Vessiot_current_frame_name,0] , [ans_components]]); 

        
# pullback applied to variables.

elif type(term,integer) then
      J:=phi[1][4][1]:
      
      Cff:=convert(LinearAlgebra[Row](J,term),list);
      coFrame:=frameJetVectors(_Vessiot_current_frame_name)[1..nops(Cff)]:
      ans:=v_zip(Cff,coFrame,plus): 
	#expr:=rhs(eqn_list[term]);
      #ans_components:=[];
      #varlist := indet_helmlist(expr);
          
	#for v in varlist do
      # 	ans_components:= [op(ans_components), [[tuple_to_index(v)], diff(expr,v)]]
      #od;
      #ans := _VESSIOT([[form, _Vessiot_current_frame_name, 1], ans_components])

fi;

ans

end:





#----------------------------------------------------------

	pbtype := cat(`pullback_`, objectType(forma));

	ans:= homomorphism[formBiform](pullback_form0,forma,
      	DifferentialGeometryTools:-zero_form(formDegree(forma)),a_map);
	
	RETURN(ans);

fi;

#...............................................................

if type(forma,Vessiot_tensor) then 

# insert check that each indxe type is cov.
# we  use the general push_pull _tensor procedure with fake map

	fr1:=transformDomain(a_map)[1]:
	fr2:=transformRange(a_map)[1]:

	psi:=transform(fr2,fr1, [seq(v=0,v=frameJetVariables(fr1))]):

	ans:=push_pull_tensor(psi, a_map,forma);

RETURN(ans);
fi;

#--------------------------------------------------------------

phi:=JetCalcTools:-assign_transform_type(a_map);


if  type(forma,Vessiot_biform) and transformType(phi)[1]=`projectable` then
      dom_fr:=transformDomain(phi)[1]:

	if dom_fr <> _Vessiot_current_frame_name then 
		change_frame_to(dom_fr):
	fi;

# Apply homomorphism to forma, using pullback on each component.

	pbtype := cat(`pullback_`, objectType(forma));

	ans:= homomorphism[formBiform](frameProtocol()[pbtype],forma,
            DifferentialGeometryTools:-zero_biform(biformDegree(forma)),phi);

      RETURN(ans)
fi;


#
# pullback by contact transformations???
#

if  type(forma,Vessiot_biform) and transformType(phi)[1]<>`generic` then
	beta:= pullback_form(phi,alpha); 

	ans:= convert(beta, Vessiot_biform,biformDegree(forma));
      RETURN(ans)
fi;


ERROR(cat("\n VESSIOT ERROR:",  
          "\n Invalid Arguments for pullback."))
end:

#*************************************************

