#
# push_fwd.dg
#
# DiffGeom
#
# pt_pushforward; pushforward; pullback_vect
# 
#



pushforward:=module()

export pt_pushforward, pushforward,ModuleApply;

ModuleApply:=proc() 

local ans;

if nargs=2 then 
ans:=pt_pushforward(args);
fi;

if nargs=3 then
ans:=pushforward(args);
fi;

ans;

end:




pt_pushforward:=proc(phi,X0)
  
# CLASS II PROGRAM
# 12/20/02:IA               
# 12/27/03:IA

local ans, frame, vars, n, m, eq,fr, i, X, domain_info,comp,J,frOrder,N,Basis,c,Cff,term; 

if type(X0,list) then 
 	fr:=transformDomain(phi)[1];
	n:=nops(X0);
	m:=nops(op(phi)[2]);
 
	vars:=frameJetVariables(fr);
	eq:={seq(vars[i]= X0[i],i=1...n)};
 
	ans:=([seq(subs(eq,op(phi)[2][i][1]),i=1..m)]);
      RETURN(ans)

fi;
 





X:=evalV(X0):

if type(phi,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pt_pushforward requires first arguement to be a transformation: ", 
		    "\n ", objectType(phi))); 
fi;

if type(X,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pt_pushforward requires second arguement to be a vector:", 
		    "\n ",objectType(X))); 
fi;


domain_info:=transformDomain(phi);

if objectFrame(X)<> domain_info[1] then  
    ERROR(cat("\n Vessiot Error:", 
              "\ frame of vector must equal  domain frame of transformation:",
              "\n ", objectFrame(X), domain_info[1]  ))
fi;

if objectOrder(X) > domain_info[2] then
	ERROR(cat("\n Vessiot Error:",
		    "\n jet order  of vector greater than ",
                " domain order  of transformation: ",
		    "\n ", objectOrder(X), domain_info[2] ))
fi;

comp:=objectComponents(X);
# 
# Need a command to get Jac,
#
J:=op(phi)[1][4][1];

fr:=transformRange(phi)[1];
frOrder:=transformRange(phi)[2];


N:=jet_space_dim(frOrder,fr);

Basis:=frameJetVectors(fr)[1..N];

ans:=DifferentialGeometryTools:-zero_vect(fr);

for c in comp do
	Cff:=LinearAlgebra[Column](J,c[1]);

	term:=v_zip(convert(Cff,list),Basis,plus);

	ans:= ans &plus ( c[2] &mult term)
od;


ans;
end:

#----------------------------------------

pushforward:=proc(a_map,an_inv_map,a_vect0 )

# CLASS II PROGRAM
# 12/20/02:IA
# 12/27/03:IA               

local term,new_vect, temp, p,ans, a_vect;


a_vect:=evalV(a_vect0):


if type(a_map,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Pushforward requires first arguement to be a transformation: ", 
		    "\n ", objectType(a_map) )); 
fi;

if type(an_inv_map,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Pushforward requires second arguement to be a transformation: ", 
		    "\n ", objectType(an_inv_map))); 
fi;


if type(a_vect,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Pushforward requires third arguement to be a vector:", 
		    "\n ",objectType(a_vect))); 
fi;

p:=objectOrder(a_vect):

if transformRange(an_inv_map)[2] <p then  
	ERROR(cat("\n VESSIOT ERROR:",   
                "\n Range order of inverse map less than jet order of vector field:",
                "\n ", transformDomain(an_inv_map)[2], p) ) 
fi;

new_vect:=pt_pushforward(a_map,a_vect);



ans:=DifferentialGeometryTools:-Vessiot_map(3,pullback,new_vect,an_inv_map);

ans:

end:

#---------------------------------------
end module:







pullback_vect:=proc(phi,vec0,Delta::list(Vessiot_vect) ) 

# CLASS II PROGRAM
# 12/27/03:IA               

local domain_frame,X, n,i,vars,eq0,eq1,ans,vec,domain_info;

vec:=evalV(vec0):

if type(phi,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Pullback_vect requires first arguement to be a transformation: ", 
		    "\n ", objectType(phi)  )); 
fi;

if type(vec,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Pullback_vect requires second arguement to be a vector:", 
		    "\n ",objectType(vec)    )); 
fi;


domain_info:=transformRange(phi);

if objectFrame(vec)<> domain_info[1] then  
    ERROR(cat("\n Vessiot Error:", 
              "\n Frame of vector must equal  range frame of transformation:",
              "\n ", objectFrame(vec), domain_info[1]  ))
fi;


domain_frame:=transformDomain(phi)[1]; 
change_frame_to(domain_frame);

if nargs =2 then
	n:=frameJetDimension();
	vars:=[seq(cat(_a,i),i=1..n)];
	X:=v_zip(vars,frameJetVectors(domain_frame),plus);
else
	n:=nops(Delta);
	vars:=[seq(cat(_a,i),i=1..n)];
	X:=v_zip(vars,Delta,plus);
fi;


eq0:=coeff_set(pushforward(phi,X) &minus vec); 
eq1:=map2(pullback,phi,eq0);

ans:=solve(eq1,convert(vars,set));

helmsimp(subs(ans,X));

end:


