
#
#  Transformations.vss 
#
#  DiffGeom
# 
#   transform; compose_transforms; 
#  inverse_transform; 
#
#  

transform:=proc(dom_frame::name, range_frame::name, eqlist::list)

#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

local ans, dom_order, eqn_list, eqn_list_length, index, index1,J,
      lhs_list, map_type, max_dom_index, max_range_index, new_eqn_list,
      range_order, rhs_list, temp_list, temp_list1, temp_list2, term;
                
global _Vessiot_frame_data,_Vessiot_current_frame_name;

if not(member(dom_frame, listOfFrameNames() )) then
	ERROR(cat("\n VESSIOT ERROR:",  
		    "\n Undefined domain frame", 
                "\n ",dom_frame ))
fi;

if not(member(range_frame,  listOfFrameNames() )) then
	ERROR(cat("\n VESSIOT ERROR:",  
		    "\n Undefined range frame", 
                "\n ",range_frame ))

fi;

eqn_list:=eqlist:
eqn_list_length:=nops(eqn_list):

change_frame_to(range_frame):

for index from 1 to eqn_list_length do
	temp_list1[index]:=functionOrder(lhs(eqn_list[index])):
      lhs_list[index]:=lhs(eqn_list[index])
od;

change_frame_to(dom_frame):

for index from 1 to eqn_list_length do
	temp_list2[index]:=functionOrder(rhs(eqn_list[index])):
      rhs_list[index]:=rhs(eqn_list[index])
od;

range_order:=max(op(convert(temp_list1,list))):
dom_order:=max(op(convert(temp_list2,list))):

change_frame_to(range_frame):

max_range_index:=jet_space_dim(range_order);

#  The  next line prolongs the   frameJetVariables to the  required order.
       
DifferentialGeometryTools:-Form(max_range_index):

if convert(lhs_list,set)<>convert([op(1..max_range_index,frameJetVariables()      )],set) 
then
        ERROR(cat("\n VESSIOT ERROR:",  
			"\n Insufficiently specified range variable equations."))
fi;

new_eqn_list:=[]:

for term in [op(1..max_range_index,frameJetVariables())] do
	new_eqn_list:=[op(new_eqn_list),[subs(eqn_list,term),term]]
od;
  

      
ans := _VESSIOT([[helm_map,[[dom_frame,dom_order],[range_frame,range_order]], 
                []],new_eqn_list]);

if nargs=4 then 
	J:=args[4] 
else 
	J:=MakeJacobianMatrix(ans);
fi;

ans := _VESSIOT([[helm_map,[[dom_frame,dom_order],[range_frame,range_order]],[], 
                [eval(J)]],new_eqn_list]);

        
change_frame_to(dom_frame):

ans;

end:

#------------------------------------------------


#----------------------------


compose_transforms:=
proc(phi::Vessiot_transformation,psi::Vessiot_transformation)

#CLASS I PROGRAM
#12/18/02:IA

local ans, eqn_list_a, eqn_list_b, index, map_list, new_type, v,
new_map_name,map_a,map_b;

map_a:=op(phi);
map_b:=op(psi);



if transformDomain(phi)[1]<> transformRange(psi)[1] then
 	ERROR(cat("\n VESSIOT ERROR:", 
	          "\n  Domain frame of first map must equal range frame of second map:", 
                "\n ", transformDomain(phi)[1], transformRange(psi)[1]) )
fi;

if transformDomain(phi)[2]<> transformRange(psi)[2] then
	ERROR(cat("\n VESSIOT ERROR:",  
	          "\n  Domain order of first map must equal range order frame of second map:",
                "\n ", transformDomain(phi)[2]<> transformRange(psi)[2] ))
fi;

eqn_list_a:=[]:
eqn_list_b:=[]:

for index from 1 to nops(map_a[2]) do
	eqn_list_a:=[op(eqn_list_a), map_a[2][index][2]=map_a[2][index][1]]:
od;

for index from 1 to nops(map_b[2]) do
	eqn_list_b:=[op(eqn_list_b), map_b[2][index][2]=map_b[2][index][1]]
od;

map_list:=[]:

for index from 1 to nops(map_a[2]) do
	map_list:=[op(map_list),[_Vessiot_simplify(subs(eqn_list_b,rhs(eqn_list_a
	[index]))),lhs(eqn_list_a[index])]]:
od;

new_type:=[];

ans := transform(transformDomain(psi)[1], transformRange(phi)[1], [seq(v[2] = v[1], v = map_list)]);


end:

#-----------------------------------

inverse_transform:=proc(phi::Vessiot_transformation)

#CLASS I PROGRAM
#12/18/02:IA
       
local choice, ans, eqn_list, index, last_dom_var, PT,psi,
        last_range_var_index, fr, dom_fr, range_fr, a_map,
        last_dom_var_index, new_vars_list,i, temp_index,vars,sub_vars;

a_map:=op(phi);


dom_fr:=transformDomain(phi);
range_fr:=transformRange(phi);

change_frame_to(dom_fr[1]);

last_dom_var_index:=jet_space_dim(dom_fr[2]);
vars:=[seq(cat(_r,i),i=1..last_dom_var_index)]; 
        
new_vars_list:=[];
for index from 1 to last_dom_var_index do
	new_vars_list:=[op(new_vars_list),index_to_jet_label(index)];
od;

eqn_list:=[];
        
for index from 1 to nops(a_map[2]) do
	eqn_list:=[op(eqn_list), cat(_r,index)=a_map[2][index][1]]
od;

new_vars_list:=convert(new_vars_list,set);
eqn_list:=convert(eqn_list,set);
ans:=[solve(eqn_list,new_vars_list)];

last_range_var_index:=jet_space_dim(range_fr[2],range_fr[1]);

sub_vars:={seq(cat(_r,i)=index_to_jet_label(i),i=1..last_range_var_index)};


ans:=subs(sub_vars,ans);


if nargs=1 then 
	RETURN(transform(range_fr[1],dom_fr[1], [ op(ans[1])  ] )  ) ;
fi;

PT:=args[2];

if DifferentialGeometryTools:-transform_pt(phi,PT[2])<>PT[1] then 
 
ERROR(cat("\n VESSIOT ERROR:",  
	          "\n  The transformation does not map the second  point to the first"
              ))

fi;


for index from 1 to nops(ans) do

	psi:=transform(range_fr[1],dom_fr[1],[op( ans[index])] );
      
      if _Vessiot_simplify( DifferentialGeometryTools:-transform_pt(psi,PT[1])) =PT[2] then  
	
		RETURN(psi) 
	fi;
od;

       
[]


end:



#***********************************************

#  

MakeJacobianMatrix:=proc(phi) 
#
# NOTE -- Doe not work in LieAlgFrame --add  code FIXED!
#


local fr1,fr2,order1, order2,dim1,dim2,p,B,C,VectBasis1,VectBasis2,n1,
n2,A,F,Eq,v,i,eq,soln,S,C0,Fr,J:

fr1:=transformDomain(phi)[1];
fr2:=transformRange(phi)[1];

order1:=transformDomain(phi)[2];
order2:=transformRange(phi)[2];

while frameJetOrder(fr1)< order1 do pr_Vessiot_frame_data(fr1) od;

while frameJetOrder(fr2)< order2 do pr_Vessiot_frame_data(fr2) od;


#dim1:=jet_space_dim(order1, fr1):
#dim2:=jet_space_dim(order2, fr2):

VectBasis1:=frameJetVectors(fr1):
VectBasis2:=frameJetVectors(fr2);

n1:=jet_space_dim(transformDomain(phi)[2],fr1);
n2:=jet_space_dim(transformDomain(phi)[2],fr2);

F:=objectComponents(phi): 
p:=nops(F):

S:={seq(v[2]=v[1],v=F)};

if frameProtocol() = LieAlg_frame then
       Fr:=frameIndependentVariables(fr1);
	J:=Matrix(p,n1,(i,j)->diff(F[i][1],Fr[j]));
      RETURN(eval(J)) ;
fi;

B:=Matrix(p ,n1, (i,j)->Lie_derivative(VectBasis1[j],F[i][1])):		
C0:=Matrix(p, p, (i,j)->Lie_derivative(VectBasis2[j],F[i][2])):	

C:=subs(S,C0);

LinearAlgebra[Multiply](C^(-1),B);end:





