
#
# VessiotPrint
#


`print/_VESSIOT`:=module() export ModuleApply;

global show, show_vect, show_biform, show_form, show_tensor, 
	show_helm_map, show_diffeq, tensorLabels, labelDataToLabel;

ModuleApply:=proc() show(args) end:




tensorLabels:=proc(tensor_type, index) 
#CLASS II PROGRAM
#12/13/02:IA
        
local label,n; 

n:=frameBaseDimension():

if tensor_type =`con_bas` then  
	label:=frameLabels()[index] 
fi;

if tensor_type =`cov_bas` then  
	label:=coframeLabels()[index] 
fi;

if tensor_type =`con_vrt` then  
	label:=frameLabels()[index] 
fi;
 
if tensor_type =`cov_vrt` then  
	label:= verticalCoframeLabels()[index-n] 
fi;

if tensor_type =`con_jet` then  
	label:=frameLabels()[index] 
fi;

if tensor_type =`cov_jet` then  
	label:=coframeLabels()[index] 
fi;

label;

end:





show:=proc(X)
#CLASS I PROGRAM
#12/13/02:IA

local Vessiot_object,objType;

Vessiot_object:=_VESSIOT(X);

objType:=objectType(Vessiot_object);

if objectFrame(Vessiot_object  ) <> _Vessiot_current_frame_name  
	and 
   		(objType  <> `helm_map` and objType <> `diffeq`)
	then
		change_frame_to(objectFrame(Vessiot_object))
fi;


if objType = `vect` then
      RETURN(show_vect(Vessiot_object))
fi;

if objType =`form` then
      RETURN(show_form(Vessiot_object))
fi;


if objType =`biform` then
      RETURN(show_biform(Vessiot_object))
fi;

if objType =`tensor` or objectType(Vessiot_object) =`connection`  then
      RETURN(show_tensor(Vessiot_object))
fi;

if objType =`helm_map`   then
      RETURN(show_helm_map(Vessiot_object))
fi;

if objType =`diffeq` then
      RETURN(show_diffeq(Vessiot_object))
fi;

ERROR(`Vessiot Error: invalid  input to  show `):

end:

#-----------------------------------------------------

labelDataToLabel:=proc (t) 
 
local s, v, ``; 

if nops(t)=1 then 
	RETURN(convert(t[1],name)[``]) 
fi; 
 
if nops(t) = 2  and t[2]=[] then  
 	RETURN(convert(t[1],name)[``])
fi ; 

if nops(t) = 2  and t[2]<>[] then  
 	RETURN(convert(t[1],name)[op(t[2])[``]]) 
fi ; 

end:

#-----------------------------

show_vect:=proc(vec)
#CLASS I PROGRAM
#12/13/02:IA

local X ,ans, term,e,c,newterm;  

if objectFrame(vec) <> _Vessiot_current_frame_name then 
	change_frame_to(objectFrame(vec)) 
fi;

X:=op(vec);

ans:=0;
for term in X[2] do  
	e:=term[2];
	c:=frameLabels()[term[1][1]];
	if e=0  then 
		newterm := convert("0 ",name)*labelDataToLabel(c)   	else 
		if denom(e)=1 then newterm := e*labelDataToLabel(c) else   
			newterm :=(e)[``]*labelDataToLabel(c ); 
		fi;
	fi;
	ans:=ans + newterm;
od;

ans;
end:

#----------------------------------------------------------------------
 
show_form:=proc(f::Vessiot_form) 
#CLASS I PROGRAM
#12/13/02:IA

local  omega, w,term, e,c,newterm, k ,q,i,ans, makewedge; 

omega:=op(f);

if objectFrame(f) <> _Vessiot_current_frame_name then 
	change_frame_to(objectFrame(f)) 
fi;

ans:= 0; 

if omega[1][3]=0 then RETURN( omega[2][1][2]) fi;


q:=convert(interface(version),string); 

if substring(q,1..5) ="Stand"  then
	makewedge:=proc()  local `&Wedge;`; `&Wedge;` end;  
else
	makewedge:=proc()  local `^ `; `^ ` end;  
fi:


for term in omega[2] do  
	e:=term[2];
	c:=coframeLabels()[term[1][1]];
 	if e=0  then newterm := 
		convert("0 ",name)*labelDataToLabel(c)   
		else 
		if denom(e)=1 then   
		newterm := e*labelDataToLabel(c) 
		else   newterm :=(e)*labelDataToLabel(c ); 
		fi;
	fi;
 
	k:=nops(term[1]); 

	for i  from 2 to k do 
		c:=coframeLabels()[term[1][i]];
 		newterm:=`newterm` * makewedge() * labelDataToLabel(c);
	od;

	ans:=ans + newterm;
od;

ans;
end:

#-----------------------------------------------------------------------

show_biform:=proc(f::Vessiot_biform) 
#CLASS I PROGRAM
#12/13/02:IA

local w, omega, term, e,c, newterm, k , n,i, ans, makewedge; 

omega:=op(f);

if objectFrame(f) < _Vessiot_current_frame_name then 
	change_frame_to(objectFrame(f)) 
fi;
 
if omega[1][3]=[0,0] then RETURN( omega[2][1][2]) fi;

makewedge:=proc()  local `^ `; `^ ` end;  

n:=frameBaseDimension():

ans:= 0; 

for term in omega[2] do  
 	e:=term[2];
      if  term[1][1] <=frameBaseDimension() then                	
		c:=horizontalCoframeLabels()[term[1][1]];
      else
 		c:=verticalCoframeLabels()[term[1][1]-n];
      fi;
 
      if e=0  then 
 		newterm := convert("0 ",name)*labelDataToLabel(c)  
 	else 
 		if denom(e)=1 then 
			newterm := e*labelDataToLabel(c)  
 		else   
 			newterm :=(e)*labelDataToLabel(c ) 
 		fi;
 	fi;
  	
 	k:=nops(term[1]); 
 	
 	for i  from 2 to k do
 		if  term[1][i] <=frameBaseDimension() then
                 	c:=horizontalCoframeLabels()[term[1][i]];
            else
 			c:=verticalCoframeLabels()[term[1][i]- n];
            fi;
   
 		newterm:=`newterm` * makewedge() *labelDataToLabel(c);
  	od;
 
ans:=ans + newterm;
od;

ans;
end:

#---------------------------------------------------------------------

show_tensor:=proc(tens::{Vessiot_tensor,Vessiot_connection}) 
#CLASS I PROGRAM
#12/13/02:IA

local w, T, term, e,c, newterm, k , n,i, ans,Ttype; 
 
if objectFrame(tens) <> _Vessiot_current_frame_name then 
 	change_frame_to(objectFrame(tens)) 
fi;

T:=op(tens):

Ttype:=tensorIndexType(tens); 

n:=frameBaseDimension():

if Ttype=[] then RETURN( T[2][1][2]) fi;

ans:= 0; 
for term in T[2] do  
  	e:=term[2];
      c:=tensorLabels( Ttype[1],term[1][1]) ;                
      if e=0  then 
  		newterm := convert("0 ",name)*labelDataToLabel(c)  
  	else 
  		if denom(e)=1 then 
			newterm := e*labelDataToLabel(c)  
  		else   
  			newterm :=(e)[``]*labelDataToLabel(c ); 
  		fi;
  	fi;
   	
  	k:=nops(term[1]); 
  	
  	for i  from 2 to k do  
 		c:=tensorLabels( Ttype[i],term[1][i]);
  		newterm:=`newterm` *labelDataToLabel(c);
   	od;
  
ans:=ans + newterm;
od;

ans;
  
end;

#----------------------------------------------

show_helm_map:=proc(trans::Vessiot_transformation)
#CLASS I PROGRAM
#12/13/02:IA

local phi, index;
phi:=op(trans):

[seq(phi[2][index][2]= phi[2][index][1],index=1..nops(phi[2]))];

end:

#------------------------------------------------

show_diffeq:=proc(Delta::Vessiot_diffeq)
#CLASS I PROGRAM
#12/13/02:IA

local de, index;
de:=op(Delta);

[de[1][4], [seq(de[2][index][2],index=1..nops(de[2]))]];

end:

#-------------------------------------------------

end module;



#*********************************

#-----------------------------------------------

VessiotPrompt:=proc()
#CLASS II PROGRAM
#December 13,2002:IA

local name;
if helm_show_frame_flag=`true` then 
	name:=substring(cat(_Vessiot_current_frame_name,"                       "),1.._VessiotPromptLength);
	interface(prompt=cat(name, `>`)) 
fi;
end:

#