# 
# Wedge.dg 
#
# DiffGeom
#
# &wedge;  
#


#----------------------------------------------

`&wedge` := proc(formA0::{Vessiot_form,Vessiot_biform},
			        formB0::{Vessiot_form, Vessiot_biform})
# CLASS I PROGRAM
# 08/26/91:CH
# 12/13/03:IA

# note: form1, form2  may be of type form or biform.  
# They must both be of the same type.

local degree, index1, newform, formA, formB, form1, form2, term1, term2, mono_wedge;

#
#  SUBROUTINES
#  mono_wedge

#===========================================================

mono_wedge:= proc(terma,termb)

# CLASS I PROGRAM
# 08/26/91:CH
# 12/13/02:IA

# mono_wedge:: wedges two monomial terms
# this could be re-worked using the sign programs and sort? Faster -- seems not!
 
local coeff,epsilon,  eta, index1, index2, newterm,start_index,
       temp;

eta := 0;
start_index := 1;
temp := {op(terma[1]),op(termb[1])};

if nops([op(terma[1]),op(termb[1])]) <> nops(temp) then
      epsilon := 0; 
      temp:=[op(terma[1]),op(termb[1])];
else
     	temp := terma[1];
      for index2 to nops(termb[1]) do
          	for index1 from start_index to nops(temp) do
            	if termb[1][index2] < temp[index1] then
              		temp:=[op(1 .. index1-1,temp),termb[1][index2],
              			op(index1 .. nops(temp),temp)];
              		eta := eta+nops(temp)-index1;
              		start_index := index1+1;
              		index1 := nops(temp)
            	fi;
          	od;
  	od;
	
	if nops(temp) < nops(terma[1])+nops(termb[1]) then
        	temp := [op(temp),op(nops(temp)-
          	nops(terma[1])+1 .. nops(termb[1]),termb[1])]
      fi;

	if type(eta,even) then epsilon := 1 elif type(eta,odd) then
          epsilon := -1
      fi;
fi;

coeff := epsilon*terma[2]*termb[2];
newterm := [temp,coeff];

newterm
end:

#=============================================================



formA:=evalV(formA0);
formB:=evalV(formB0);


VessiotFrameCheck(formA):

if type(formA,{Vessiot_form,Vessiot_biform})=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  wedge  requires each arguement to be a form or biform:", 
		    "\n ",objectType(formA))); 
fi;


if type(formB,{Vessiot_form,Vessiot_biform})=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  wedge  requires each arguement to be a form or biform:", 
		    "\n ",objectType(formB))); 
fi;

form1:=op(formA):
form2:=op(formB):


if form1[1][2] <> form2[1][2]  then
   	ERROR(cat("\n VESSIOT ERROR:",  
                "\n Wedging forms in  different frames:\n ",
                  form1[1][2], " , ", form2[1][2] ));
fi;

if  form1[1][1] <> form2[1][1]   then
   	ERROR(cat("\n VESSIOT ERROR:",  
                "\n Wedging form and biform:\n ",
                  form1[1][1], " , ", form2[1][1] ));
fi;


newform := [];

for term1 in  form1[2] do
	for term2 in form2[2] do
  		newform := [op(newform), mono_wedge(term1, term2)]
      od;
od;

if form1[1][1] = `form` then
	degree :=  form1[1][3] + form2[1][3]
else
     	degree := [form1[1][3][1] + form2[1][3][1],
                 form1[1][3][2] + form2[1][3][2]]
fi;

newform := _VESSIOT([[op(1..2,form1[1]), degree], newform]);
newform := helmsimp(newform);

newform
end:


#*************************************