#
# Lie.dg
#
# DiffGeom
#
# Lie_derivative; Lie_bracket;
#

Lie_derivative:=proc(vectr0, geomObjField0) 

# CLASS II PROGRAM
# 08/26/1991:CH
# 12/17/2002:IA         

local ans, vectr,geomObjField,frame, vec,objType,Lie_conn,indxType,
newdegree, term,vecType;

 
#===================================================================

Lie_conn:=proc(a_vector,a_connection)

#08/26/1991:CH
#01/15/2003:IA         

#  currently works only on  base space
#  coordinate frame only.


local ans, ans0, V, frV, frC, indexType,n,C,indx1,  diff_order, indx, index1, new_args, 
new_comps, sum_start, sum_end, pr_vector, temp, term; 

V:=objectComponents(a_vector);
frV:=objectFrame(a_vector);
indexType:=tensorIndexType(a_connection);

frC:=objectFrame(a_connection);

if  frV <> frC then
	ERROR(cat("\n VESSIOT ERROR:",
            "\n vector and connection must be in the same frame",
            frV,frC))   
fi;

VessiotFrameCheck(a_vector);
n:=frameBaseDimension();

C:=convert(a_connection,Vessiot_tensor):
ans0:=Lie_derivative(a_vector,C):

new_comps:=[];

if  indexType[1]=cov_bas then
	for term in V do
		if term[1][1] <= frameBaseDimension() then
      		for indx from 1 to n do
            		for indx1 from 1 to n do
	          			new_comps:=[op(new_comps),
                                         [ [indx,term[1][1],indx1],
					diff(diff(term[2],frameIndependentVariables()[indx]),
                                                frameIndependentVariables()[indx1])]];  
		    		od;
		  	od;
		fi;
	od;
	
fi;

# this is junk for other kinds of connections

if ans[1][3][1]=cov_vrt then
	diff_order:=tens_diff_order(a_vector,coeff);
	sum_start:=frameBaseDimension() + 1;
	sum_end:=frameBaseDimension()+frameFiberDimension();
	pr_vector:=pr_vect(a_vector,diff_order);
	for term in pr_vector[2] do;
		if term[1][1] > frameBaseDimension() and
				    term[1][1]<= frameFiberDimension()+frameBaseDimension() 
		then
		for indx from sum_start to sum_end do;
            	for index1 from 1 to sum_start -1 do;
	          	new_comps:=[op(new_comps),[[indx,term[1][1],index1],
		      	      td(diff(term[2],index_to_jet_label(indx)),index1)]];  
		    	od;
		od;
		fi;
	 od;
fi; 
	  
#end of junk

temp:=_VESSIOT([objectAttributes(C),new_comps]);
	
ans:= helmsimp(ans0 &plus temp);

ans
        
end:

#================================================

vectr:=evalV(vectr0):
geomObjField:=evalV(geomObjField0):

if type(vectr,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  Lie derivative requires first arguement to be a vector field,", 
		    "\n ",convert(objectType(vectr),string) )); 
fi;

if type(geomObjField,{Vessiot_scalar,Vessiot_bftv,Vessiot_connection})=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  Lie_derivative requires second arguement to be one of:",  
		    "\n  Maple expression, biform,form,tensor, vector:", 
		    "\n ",convert(objectType(geomObjField),string) )); 
fi;


if  type(geomObjField, Vessiot_scalar)=false and
	objectFrame(vectr)<> objectFrame(geomObjField) then  
    	ERROR(cat("\n VESSIOT  ERROR:",
              "\n frame of vector must equal frame of geometric object field",
		  "\n ", convert(objectFrame(vectr),string),  
			   convert(objectFrame(geomObjField),string) ))
fi;


VessiotFrameCheck(vectr):

frame := frameProtocol();

#..............................................................

if   type(geomObjField,Vessiot_scalar) then 
	ans:=frame[Lie0](vectr,geomObjField);
      RETURN(ans);
fi;


objType:=objectType(geomObjField):


#....................................

if objType= `vect` then  
    	ans:=Lie_bracket(vectr,geomObjField);
      RETURN(ans) 
fi;

#....................................

if objType = `form` then
	newdegree:=formDegree(geomObjField);
	ans:=derivation[formBiform]
	     (frame[Lie_form],deriv,geomObjField,DifferentialGeometryTools:-zero_form(newdegree),vectr);
      RETURN(ans)
fi;

#...................................

vec:=assign_vect_type(vectr);
vecType:=vectorType(vec)[1]:


if  vecType= `projectable` and objType= `biform`  then
	newdegree := biformDegree(geomObjField);
	ans:=derivation[formBiform]
		(frame[Lie_biform],deriv,geomObjField,DifferentialGeometryTools:-zero_biform(newdegree),vectr);
      RETURN(ans)
fi;  

#....................................

if  vecType =`evol`  and  objType=`biform` then

     	if vecType[2] <objectOrder(geomObjField) then 
		ERROR(cat("\n VESSIOT ERROR:", 
                	     "\n vector must be  prolonged to order at least that of  biform:",
                	     "\n ", convert(vecType[2],string),",",					
                              convert(objectOrder(geomObjField),string)  ))
     	fi;

   	newdegree := biformDegree(geomObjField);
	ans:=derivation[formBiform]
		(frame[Lie_vert],deriv,geomObjField, DifferentialGeometryTools:-zero_biform(newdegree),  vec);
     RETURN(ans)
fi;

#................................................

if  vecType = `tot`  and  objType=`biform` then 
	
	if vecType[2] <objectOrder(geomObjField) then 
		ERROR(cat("\n VESSIOT ERROR:", 
                "\n vector must be  prolonged to order at least that of  biform:",
                "\n ", vecType[2],objectOrder(geomObjField)  ))
	fi;

	newdegree:=biformDegree(bform);
	ans:=derivation[formBiform]
		(frame[Lie_total],deriv,geomObjField, DifferentialGeometryTools:-zero_biform(newdegree), vec);
     RETURN(ans)
fi;

#................................................

if  objType= `tensor` then
	indxType:=tensorType(geomObjField);
	ans:=derivation[tensor](frame[Lie_tens],geomObjField,DifferentialGeometryTools:-zero_tens(indxType),vectr);
    	RETURN(ans)
fi;


#................................................


if   objType = `connection` then 
     ans:=Lie_conn(vectr,geomObjField);
     RETURN(ans)
fi;

ERROR(cat("\n VESSIOT ERROR:",  
          "\n Invalid arguements.  Second arguement must be one of:", 
	    "\n, expression, vector, form, biform, tensor, connection.",
          "\n If  second arguement is  biform, then  first arguement must be a vector of type:",
          "\n projectable, evol, tot.") ); 
end:

#===========================================================================


Lie_bracket := proc(v10, v20)

# CLASS II PROGRAM
# 08/26/1991:CH
# 12/17/2002:IA         
# 12/19/2003:IA        

local ans, v1,v2,frame;


v1:=evalV(v10):

v2:=evalV(v20):

if type(v1,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Lie_bracket requires first arguement to be a vector field:", 
		    "\n ",convert(objectType(v1),string) )); 
fi;


if type(v2,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Lie_bracket requires second arguement to be a vector field:", 
		    "\n ",convert(objectType(v2),string) )); 
fi;


if objectFrame(v1)<> objectFrame(v2) then  
    ERROR(cat("\n Vessiot Error:",  
		  "\n frame of vector 1 ",objectFrame(v1),
              "\n must equal frame of vector 2 ", objectFrame(v2) ))
fi;
   
VessiotFrameCheck(v1):

frame := frameProtocol();

ans:=frame:-Lie_bracket(v1,v2);

ans

end:

#---------------------------------------