normalizer_distribution:=proc(Gamma,outer,vars)

local i ,v, vars0,Yvars, Avars,n,p,m,q,backsub, frontsub,eq,IsoV0, Iso,IsoM,IsoV,
GammaM,Y,Om,RHS0,RHS,LHS,NorEq, Eq1,M,Eq2,Eq3,M2, N1,N2,M1,ans ; 

n:=nops(vars); 
p:=nops(Gamma);
q:=nops(outer);

vars0:= [seq(cat(_,vars[i]), i=1..n)]; 
Yvars:=[seq(_y[i],i=1..n)]; 
Avars:=[seq(_a[i], i=1..nops(outer))];

frontsub:={seq(vars[i]=vars0[i], i=1..n)};
backsub:={seq(vars0[i]=vars[i], i=1..n)};
 
Iso:=isotropy_subalgebra(Gamma,[seq(vars[i]=vars0[i],i=1..n)]);
m:=nops(Iso);
IsoV0:=map(l->l[1],Iso); 
IsoV:=[seq(matrix(p,1,IsoV0[i]), i=1..nops(Iso))]; 
IsoM:=map(l->l[2],Iso);

GammaM:=matrix(n,p,(i,j)->Lie0(Gamma[j],vars[i]));
GammaM:=map2(subs,frontsub,GammaM); Y:=matrix(n,1,Yvars); 

Om:=evalm(add(_a[i]*outer[i],i=1..q));
RHS0:=evalm(GammaM&*Om);
RHS:=map2(linalg[multiply],RHS0,IsoV);
LHS:=map(linalg[multiply],IsoM,Y);

Eq1:={}; 
for eq in  map(convert,LHS,set) do 
	Eq1:= Eq1 union eq 
od;
M1:= linalg[genmatrix](Eq1,Yvars);
N1:= Vessiot_nullspace(M1);

Eq2:={seq(add(v[i]*Yvars[i],i=1..n) ,v=N1)};

NorEq:=[seq(evalm(LHS[i]-RHS[i]), i=1..m)];

Eq3:={}; 
for eq in  map(convert,NorEq,set) do 
	Eq3:= Eq3 union eq 
od;

M2:=linalg[genmatrix]( Eq2 union Eq3, [op(Yvars),op(Avars)]);
N2:=map(convert,Vessiot_nullspace(M2),list); 

ans:=[seq([v_zip(v[1..n],vars,plus,vect), evalm(add( v[n+i]*outer[i], i=1..q))],v = N2)]; 
subs(backsub,ans);

end:







#################################################################

normalizer_PDE := proc (N, InvVect, Gamma, indep_vars, dep_vars) 
local i, eq, p, E, m, n,v,ans, new_vars, fr, vec, new_eq, eq_vars, ans0; 

m:= nops(dep_vars);
n:= nops(indep_vars); 
p:= nops(Gamma); 

fr:= _Vessiot_current_frame_name; 

new_vars:=[seq(v(op(indep_vars)),v = dep_vars)]; 
vec:=v_zip(new_vars,[N[1], op(InvVect)],plus); 

eq := {}; 
for i to p do 
	E := Lie_bracket(vec,Gamma[i]) &minus v_zip([seq(N[2][j,i],j = 1 .. p)],Gamma,plus);
 	eq := `union`(eq,coeff_set(E)); 
      ans:=eq;
od; 

if nargs=6 and args[6]=`_ExpSolve` 
then
	coord_init(indep_vars,dep_vars,cat(fr,temp)); 
	new_eq := map(diff_to_jet,eq,1); 
	eq_vars := {frameJetVariables()[n+1], op(frameJetVariables()[m+n+1 .. n+m+m*n])};
 	ans0 := solve(new_eq,eq_vars); 
	ans:={seq(jet_to_diff(lhs(v)) = jet_to_diff(rhs(v)),v = ans0)} 
fi;
change_frame_to(fr);
ans;


end:



























#############################################

outer_restricting_to_inner:=proc(ad_matrices, outer,subspace)
local  n,p,q,alpha,beta,A,B,H,Eq1,Eq2,Eq3,M1,M2, N1,N2,i,v,ans;
 n:=nops(ad_matrices); alpha:=[seq(_a[i],i=1..n)];
 p:=nops(outer);beta:=[seq(_b[i],i=1..p)];
 A:=evalm(add(_a[i]*ad_matrices[i], i=1..n));
 B:=evalm(add(_b[i]*outer[i], i=1..p));
 H:=linalg[transpose](subspace);
 Eq1:=convert(evalm(A&*H),set);
 M1:= linalg[genmatrix](Eq1,alpha);
 N1:= Vessiot_nullspace(M1);
 Eq2:={seq(add(v[i]*alpha[i],i=1..p) ,v=N1)};
 Eq3:=convert(evalm((A-B)&*H),set);
 M2:=linalg[genmatrix]( Eq2 union Eq3, [op(alpha),op(beta)]);
 N2:=map(convert,Vessiot_nullspace(M2),list); 
 ans:=[seq([v[1..n], v[n+1..n+p]],v = N2)];
 end;

