total_dsolve:=proc(Eq::set, depVar::list, indepVar::list)

local v, f, de, w,ans, initPt, i,n,m, initVal,opt, INITC, curve,
newDepVar, subsNewVar, backSubOldVar,temp, newDE;


n:=nops(indepVar);
m:=nops(depVar);

initPt:=[seq(0,v=indepVar)];
initVal:=[seq(0,v=depVar)];
curve:=[seq(_t*indepVar[i] +(1-_t)*initPt[i] ,i=1..n)];


for opt in args[4..-1] do 
	if lhs(opt)=INIT_PT   
		then initPt:=rhs(opt);
		curve:=[seq(_t*indepVar[i] +(1-_t)*initPt[i] ,i=1..n)];
	fi;
      if lhs(opt)=INIT_VAL 
		then initVal:=rhs(opt) 
	fi;
      if lhs(opt)=PATH 
		then
     		
		if rhs(opt)=ZIG-ZAG 
			then {}  
		fi;
            
		if type(rhs(opt),list) 
			then 	curve:=rhs(opt);
                  initPt:=subs(_t=0,curve);
		fi;
	fi; 
od;





newDepVar:=  {seq(op(0,v)(_t), v=depVar)};

subsNewVar:= {seq(indepVar[i]=curve[i] ,i=1..n), 
		  seq(v=op(0,v)(_t), v=depVar) };

newDE:={}; 

for f in depVar do 
      temp:=0;
      for i from 1 to n do 
         temp:= temp+ subs(subsNewVar,subs(Eq, diff(f,indepVar[i])  ))* diff(curve[i],_t);
      od;
 	de:= diff(op(0,f)(_t),_t)=  temp;
	newDE:={op(newDE),de} 
od;

INITC:={seq(op(0,depVar[i])(0) =initVal[i], i=1..nops(depVar))};


ans:=dsolve(newDE union INITC,newDepVar);

backSubOldVar:={seq(op(0,v)(_t) =v, v=depVar)}; 

ans:=subs(_t=1,subs(backSubOldVar,ans));
ans:

end:

Frobenius[vect_to_total_de] := proc (vecList::list, indepVar::list, depVar::list, Unknowns::list)
local rho, Eq, deriv, i, j, n, m, subsVar, inverseSubsVar; 

m := nops(indepVar);
 n := nops(depVar); 

if nops(Unknowns) <> n then 
	ERROR(`VESSIOT ERROR: Number of dependent variables and unknowns must coincide`)
 fi; 

rho := [seq(depVar[i]-Unknowns[i](op(indepVar)),i = 1 .. n)];
deriv := {seq(seq(diff(Unknowns[i](op(indepVar)),indepVar[j]),j = 1 .. m),i = 1 .. n)}; 

subsVar := {seq(depVar[i] = Unknowns[i](op(indepVar)),i = 1 .. n)};
inverseSubsVar := {seq(Unknowns[i](op(indepVar)) = depVar[i],i = 1 .. n)}; 

Eq := {seq(seq(Lie_derivative(vecList[i],rho[j]),j = 1 .. n),i = 1 .. m)}; 
[subs(subsVar,solve(Eq,deriv)), [seq(Unknowns[i](op(indepVar)),i = 1 .. n)], indepVar , inverseSubsVar] 

end:



Frobenius_init:=proc(vec_formList, vars) 
local n,m,M;
 
n:=nops(vec_formList);
m:=nops(vars);
 
if objectType(vec_formList[1]) = vect then
	M:=Matrix(n,m, (i,j)->Lie_derivative(vec_formList[i],vars[j]));
fi;
 
if objectType(vec_formList[1]) = form then
 	M:=Matrix(n,m, (i,j)->coeff_list(hook(vect(vars[j]), vec_formList[i]) ,[[]]));
fi;
 
 
eval(M)
end:







Frobenius_dsolve:=proc (vec_formList, indepVar::list, depVar::list) 
local _U, i, unknowns, v, initPt, DE, soln, vecList, opt,vecBasis, 
IC,ans,M,delta,var,varSub,InitVal,fixU0 ; 


initPt:=[seq(0,i=1..nops(indepVar) +nops(depVar))];


for opt in args[4..-1] do 
	if lhs(opt)=INIT_PT then initPt:=rhs(opt) fi;
od;




unknowns := [seq(_U.i,i = 1 .. nops(depVar))]; 

var:=[op(indepVar),op(depVar)];
varSub:={seq(var[i]=initPt[i], i=1..nops(var))};
 

if objectType(vec_formList[1]) = vect then
	M:=Frobenius_init(vec_formList,indepVar);
	delta:= subs(varSub, LinearAlgebra[Determinant](M));
	if delta = 0 then  ERROR(`Vessiot Error: The coefficient Matrix of the vectors with respect to the dependent variables is singular at the initial point`)
      fi;
fi;



if objectType(vec_formList[1]) = form then
	M:=Frobenius_init(vec_formList,depVar);
	delta:= subs(varSub, LinearAlgebra[Determinant](M));
	if delta = 0 then  ERROR(`Vessiot Error: The coefficient Matrix of the forms with respect to the independent variables is singular at the initial point`)
      fi;
fi;



if objectType(vec_formList[1]) = vect
then 
	vecList:=vec_formList 
else 
	vecBasis:=[op(map(vect,indepVar)),op( map(vect,depVar))]; 
	vecList:= annihilator(vec_formList,vecBasis) 
fi; 



InitVal:=[seq(_U.i.0,i = 1 .. nops(depVar))]; 


DE := vect_to_total_de(vecList,indepVar,depVar,unknowns); 

soln := total_dsolve(DE[1],DE[2],DE[3],args[4..-1],INIT_VAL=InitVal); 


soln := subs(DE[4],soln); 
ans := solve(soln,{seq(_U.i.0,i = 1 .. nops(depVar))}); 


if ans=NULL then RETURN([]) fi;


#fixU0:=subs(varSub,ans);


#subs(fixU0,ans) 

map(rhs,ans);

end:



