EquivalenceOfVectorFieldAlgebras:=proc(VFA1, VFA2) 

local domainFrame, rangeFrame, domainVariables,rangeVariables, transformData,
Psi, PDE,i,Z1,Z2,g,soln;
              
domainFrame := objectFrame(VFA1[1]);
rangeFrame := objectFrame(VFA2[1]);

domainVariables := op(frameJetVariables(domainFrame));
rangeVariables := frameJetVariables(rangeFrame);
  
transformData:=[seq(rangeVariables[i] = cat(F, i)(domainVariables), i = 1 .. nops(rangeVariables))];
Psi := transform(domainFrame, rangeFrame, transformData): 

PDE := {};

for i from 1 to nops(VFA1) do  
	
	Z1 := pushforward(Psi, VFA1[i]); 
	g := x -> pullback(Psi, x);
	Z2 := DifferentialGeometryTools:-Vessiot_map(g, VFA2[i]);
          
	PDE := `union`(PDE, coeff_set(Z1 &minus Z2));
                             
od;
                      
soln := pdsolve(PDE);
                        
subs(soln, Psi);

end: