#------------------------------------

IsotropySubalgebra:= proc(vlist::list(Vessiot_vect),initPt)

#CLASS II PROGRAM
#12/13/02:IA 
	
local n,m,vcoord,base_pt,vars ,a,b,c,j,var,U,i,B,soln,X, A, Iso,vpoint;
      
if objectFrame(vlist[1]) <>_Vessiot_current_frame_name then 
	change_frame_to(objectFrame(vlist[1]))
fi;
 
n:=nops(vlist);
m:=nops(initPt);
vcoord:=map(lhs,initPt);
vpoint:=map(rhs,initPt);

vars:=[seq(a[i],i=1..n)];
      base_pt:={seq(vcoord[i]=vpoint[i],i=1..m)};
 
U:=v_zip(vars,vlist,plus);  	  
U:= map2(subs,base_pt, U);
C:=eval(coeff_set(U));

C:=collect(C,vars);

B:= LinearAlgebra[GenerateMatrix](C,vars)[1];
soln:=Vessiot_nullspace(B);
A:=Matrix(m,m);

Iso:=[];

Omega:=frameBaseForms();

for b in soln do 
	X:= v_zip(convert(b,list),vlist, plus);      
	for i from 1 to m do 
       	c:=  op(coeff_set(hook(X, Omega[i] )));      
		for j from 1 to m do temp:=diff(c,vcoord[j]);    
       		A[i,j]:= subs(base_pt, temp)    
       	od;
 	od;
       
Iso:=[op(Iso),[convert(b,list),eval(A)]]
od; 

Iso 

end:

#-----------------------------------------

IsotropyFiltration:=proc (vlist::list(Vessiot_vect), initPt, alg_name) 

#CLASS II PROGRAM
#07/31/03:IA 

local k, i, j, v, f, c, n, PtSet, vars, Gamma, old_alg_dim, 
delta, new_alg, new_alg_dim, filtration, Z, C, eq, varlist, 
difflist, diff_var, temp, A, N, alg, ans;

n := nops(vlist); 

PtSet := convert(initPt,set); 
vars := map(lhs,PtSet); 

Gamma := vlist; 
old_alg_dim := n+1; 

delta := proc (i, j) local ans; 
	if i = j then ans := 1 else ans := 0 fi; 
	ans 
end; 

new_alg := [seq([seq(delta(i,j),j = 1 .. n)],i = 1 .. n)]; 
new_alg_dim := nops(new_alg); 

filtration := [new_alg];  

while new_alg_dim < old_alg_dim and 0 < new_alg_dim do 
	k := nops(filtration)-1; 
	Gamma := [seq(v_zip(new_alg[i],Gamma,plus),i = 1 .. new_alg_dim)]; 
	Z := v_zip([seq(_a[i],i = 1 .. nops(Gamma))],Gamma,plus); 
	C := coeff_set(Z); 
	if k = 0 then 
		eq := subs(PtSet,C) 
	else 
		varlist := [seq(seq(v,j = 1 .. k),v = vars)]; 
		difflist := combinat[choose](varlist,k); 
		eq := {}; 
		for diff_var in difflist do
			 temp := diff(C,op(diff_var)); 
			eq := `union`(eq,subs(PtSet,temp)) 
		od 
	fi;
	
	A := LinearAlgebra[GenerateMatrix](eq,[seq(_a[i],i = 1 .. nops(Gamma))])[1]; 
	N := Vessiot_nullspace(A); 
	
	old_alg_dim := new_alg_dim; 
	new_alg := [seq(convert(v,list),v = N)]; 
	new_alg_dim := nops(new_alg); 
	filtration := [op(filtration), new_alg] 
od; 

alg := frameBaseVectors(alg_name); 
ans := []; 

for i to nops(filtration) do 
	alg := [seq(v_zip(c,alg,plus),c = filtration[i])]; 
	ans := [op(ans), alg] 

od; 

ans 
end:





