#------------------------------------

implicitJacobian:=proc(eqnsList,dependentVarsList,independentVarsList) 
local n,m,J,newEqns,functionList,X,S; 

n:=nops(independentVarsList): 
m:=nops(dependentVarsList):

J:=Matrix(m,n, (i,j)->D[j](dependentVarsList[i]));

newEqns:={seq(lhs(v) -rhs(v), v=eqnsList)};
functionList:={seq(v(op(independentVarsList)),v=dependentVarsList)};

for X in independentVarsList do
	S:=implicitdiff(newEqns,functionList,convert(dependentVarsList,set),X);
	J:=map2(subs,S,J)
od;

J
end:

#-----------------------------------------------------

reductionTd:=proc(exp,var,J,domain_frame,range_frame)
local ans1, ans2,k,m;

ans1:=diff(exp,var): 

change_frame_to(domain_frame);
k:=tuple_to_index(var);

change_frame_to(range_frame);
m:=frameBaseDimension();

ans2:= Vessiot_simplify(add( J[i,k]*td(exp,i),i=1..m));

ans1 +ans2;
end:

#-------------------------------------------------------------------
 
inverseTdIndex:=proc(k) 
local U,u,tuple,i,newtuple;

U:=index_to_tuple(k);
u:=op(0,U);
tuple:=[op(U)];

for i from  1 to nops(tuple) do
	if tuple[i]=0 then next fi:

newtuple:=[op(tuple[1..i-1]), tuple[i]-1, op(tuple[i+1..-1])];
break;
od;

tuple_to_index(u[op(newtuple)]),i 
end:

#-------------------------------------------------


reductionJetEquations:=proc(independentReductionEquations,dependentReductionEquations,prolongationOrder,domain_frame,range_frame)

local n1, m1,m2, n2,N1,J,Vars1, Vars2,i,k,j,transformComponents,neweq;

n1:=frameBaseDimension(domain_frame):
m1:=frameFiberDimension(domain_frame): 
n2:=frameBaseDimension(range_frame):
N1:=jet_space_dim(prolongationOrder,domain_frame); 
Vars1:=frameJetVariables(domain_frame):form(N1):  
Vars2:=frameJetVariables(range_frame): 
 
J:=implicitJacobian(independentReductionEquations,Vars2[1..n2], Vars1[1..n1],domain_frame,range_frame):
transformComponents:=dependentReductionEquations;

for i from n1+m1+1 to N1  do change_frame_to(domain_frame): 
	k,j:=inverseTdIndex(i);  
	neweq:=reductionTd(rhs(transformComponents[k-n1]),Vars1[j],J,domain_frame,range_frame);
	transformComponents:=[op(transformComponents),Vars1[i]=neweq];
od;

transformComponents;
end:

#-----------------------------------------------------------------
reduceDifferentialEquations:=
proc(independentReductionEquations,crossSection,dependentReductionEquations,domain_frame,range_frame, differentialEquations::list)
local Eq1, Eq2, ans,M,m;   
change_frame_to(domain_frame); 
M:=map(objectOrder,differentialEquations); 
m:=max(op(M));

Eq1:=reductionJetEquations(independentReductionEquations,dependentReductionEquations,2,domain_frame,range_frame);
Eq2:=crossSection;
ans:=subs(Eq1,differentialEquations);
ans:=_Vessiot_simplify(subs(Eq2,ans)):
end:





