#
# invariant_tensors.vss
#
# tensors 
#
# invariant_tensors, 
# isotropy_invariant_tensors,Lie_algebra_invariant_tensors
#
#  the  exact differences  between these  programs needs to be clarified # 01/17/03:IA


invariant_tensors:=proc(sub_alg::list(Vessiot_vect), inv_objects::list(Vessiot_bftv) )
#Class II Program
#01/17/03:IA

local v, inv_bftv,  inv_forms,c,inv_bftv_coeff, tau,ans,  eqs,C; 

inv_forms:=inv_objects;

for v in sub_alg do
      k:=nops(inv_forms);
   
	inv_bftv:=v_zip([seq(a[j], j=1..k)],inv_forms,plus); 
         
      eqs := coeff_list(Lie_derivative(v, inv_bftv),all);
         
      C := LinearAlgebra[GenerateMatrix](eqs, [seq(a[j], j=1..k)])[1];
    	
	inv_bftv_coeff := Vessiot_nullspace(C);
    	
	if nops(inv_bftv_coeff)=0 
		then 
			inv_bftv := [0 &mult inv_objects[1]]; break;
    		else 
        		inv_forms:=[];
        		for c in inv_bftv_coeff do
        			tau:=helmsimp(subs({seq(a[j]=c[j],j=1..k)},inv_bftv));
				inv_forms := [op(inv_forms), tau]
        		od;
    	fi;
od;

inv_forms

end:

#--------------------------------------------

isotropy_invariant_tensors := proc (g, T_list, pt0) 
local eqn, vars, n, X, A, Z, inv, s, z, i, t, base_pt, vcoord, T, a; 
eqn := {}; 
vcoord := frameIndependentVariables(); 
vars := {seq(a[i],i = 1 .. nops(T_list))}; 

T := v_zip([seq(a[i],i = 1 .. nops(T_list))],T_list,plus); 

n := nops(vars); 
for X in g do eqn := `union`(eqn,coeff_set(Lie_derivative(X,T))) od; 
base_pt := seq(vcoord[i] = pt0[i],i = 1 .. frameBaseDimension()); 
eqn := subs(base_pt,eqn); 
A:= LinearAlgebra[GenerateMatrix](eqn,vars)[1]; 
Z := Vessiot_nullspace(A); 
inv := []; 
for z in Z do 
s := {seq(vars[i] = z[i],i = 1 .. n)}; 
inv := [op(inv), helmsimp(subs(s,T))] od; 
inv 
end:

#---------------------------------------

invariant_tensors_distribution:=proc(Gamma,T_list,vars)

local n,p,q,i,vars0,Avars,       frontSub,backSub,Iso,IsoV0,IsoV,eqn,X,T,A,Z,inv; 

n:=nops(vars); 
p:=nops(Gamma);
q:=nops(T_list):

vars0:= [seq(cat(_,vars[i]), i=1..n)]; 
Avars:=[seq(_a[i], i=1..q)];
T := v_zip(Avars, T_list,plus); 

frontSub:={seq(vars[i]=vars0[i], i=1..n)};
backSub:={seq(vars0[i]=vars[i], i=1..n)};
 
Iso:=isotropy_subalgebra(Gamma,[seq(vars[i]=vars0[i],i=1..n)]  ); 
m:=nops(Iso);

IsoV0:=map(l->l[1],Iso); 

IsoV:=map(v_zip, IsoV0, Gamma, plus);
 
eqn := {}; 
 
for X in Gamma do eqn := `union`(eqn,coeff_set(Lie_derivative(X,T))) od; 

eqn := subs(frontSub,eqn); 

A := LinearAlgebra[GenerateMatrix](eqn,Avars); 
Z := Vessiot_nullspace(A[1]); 
Z:=map(convert,Z,list);


inv :=map(v_zip,Z,T_list,plus);
inv:=subs(backSub, inv);

end:

#---------------------------------------------------


Lie_algebra_invariant_tensors := proc (g, T_list) 

local eqn, vars, n, X, A, Z, inv, s, z, i, t, base_pt, vcoord, T, a; 

eqn := {};
vars := {seq(a[i],i = 1 .. nops(T_list))}; 
T := v_zip([seq(a[i],i = 1 .. nops(T_list))],T_list,plus); 

n := nops(vars); 

for X in g do 
	eqn := `union`(eqn,coeff_set(Lie_derivative(X,T))) 
od; 

A := LinearAlgebra[GenerateMatrix](eqn,vars); 
Z := Vessiot_nullspace(A[1]); 

inv := []; 
for z in Z do 
	s := {seq(vars[i] = z[i],i = 1 .. n)}; 
	inv := [op(inv), helmsimp(subs(s,T))] 
od; 
inv 
end:


#----------------------------------------


isotropy_invariant_connection:=proc(Iso,Iso_pt) 
local ans,p ,V,v,C2, i, j,k,n,vars,C, C1,Eq,X,L,L1,L2,soln; 
n:=frameBaseDimension();
vars:=[seq(seq(seq(cat(z,i,j,k), i=1..n),j=1..n),k=1..n)];

C:=zero_tens([[cov_bas,con_bas,cov_bas],[]]);

for i from 1 to n do 
for j from 1 to n do 
for k from 1 to n do
C:= C &plus  (cat(z,i,j,k) &mult  
evalV( frameBaseForms()[i] &tensor frameBaseVectors()[j] &tensor frameBaseForms()[k]) );
od; od; od; 

C:=tens_to_connection(C);
Eq:={};

for X in Iso do
L:=Lie_derivative(X,C);
L1:=coeff_set(L);
L2:=subs(convert(Iso_pt,set),L1);
Eq:={op(Eq),op(L2)}; 
od;  

A:=LinearAlgebra[GenerateMatrix](Eq,vars);
soln:=Vessiot_rref(A[1],A[2],'r',_p);

if soln<>NULL then     
	q:=n^3-r;  
	S:={seq(vars[i]=soln[i], i=1..n^3)}; 
	C1:=helmsimp(subs(S,convert(C,Vessiot_tensor)));    
	if q=0 then  
		ans:=[tens_to_connection(C1)]  
	else  
		ans:=[]; 
		for j from 1 to q do 
                  ans:=[op(ans),tens_to_connection(Vessiot_diff(C1,_p[j]))]; 
		od 
	fi;
						

	C2:=tens_to_connection(C1);
	RETURN([true,ans]) 
else 
	RETURN([false]) 
fi; 

 end:







