#
# isometries.ms
#
# isometries
#
# Killing_data, Killing_data_bracket,  Killing_data_to_isotropy_subalgebra,
# Killing_data_to_isotropy_subalgebra, Killing_data_to_Lie_algebra, eval_pt,diff_sub
#
#


Killing_data:=proc(metric,offel,curvature,base_pt) 
# Class II Program
# 06/06/01:IA

local n,frame,_X,_F,X_vars,F_vars,var_list, alpha,beta,i,t,j,j1,j2,delta, 
	Eq_a,Eq_b, q, Eq,vars,A,B, A_pt,B_pt,R, 	M0,r,N,X_coeff,F_coeff,k_data,kd, D_alpha 
     ,inverse_metric_pt ,k,M,N_temp,C, pt,eval_data;
 ;


if objectFrame(metric) <> _Vessiot_current_frame_name then 
	change_frame_to(objectFrame(metric)) 
fi;
     
  
frame:=_Vessiot_current_frame_name;


n:=frameBaseDimension();
var_list:=frameIndependentVariables();
      
pt:={seq(var_list[i] = base_pt[i], i =1..n)};
 


if nargs=6 
then 
	eval_data:=pt, diff_sub(n*(n+1)/2 +2, args[6][1],args[6][2]);
else
      eval_data:=pt 
fi;

	
X_vars:=[seq(_X[i], i=1..n)];
F_vars:=[seq(seq(_F[i,j],j=i+1..n),i=1..n)];

alpha:=convert(v_zip(X_vars,frameBaseVectors(),plus),Vessiot_tensor);
beta:=convert(v_zip(F_vars,[seq(seq(
      DifferentialGeometryTools:-Form(i)&wedge DifferentialGeometryTools:-Form(j), j=i+1..n), 	
i=1..n)],plus),Vessiot_tensor);

inverse_metric_pt:= Vessiot_map(2,eval_pt, inverse_metric(metric), eval_data);

beta:=raise_lower_indices(inverse_metric_pt ,beta,[1]);
      
vars:= [op(X_vars), op(F_vars)];
 	R:= raise_lower_indices(metric,curvature,[2]);
 
if  _Vessiot_show_intermediate_steps_flag =true then 
	print( `Computing  curvature derivative`, 1);
fi; 	

if nargs=5 and  args[5]= `symmetric` then 
A:= DifferentialGeometryTools:-
zero_tens([[cov_bas,cov_bas,cov_bas,cov_bas,cov_bas],[]])
else
A:=covariant_derivative(R,offel);
 
fi;

	
A_pt:=helmsimp(Vessiot_map(2,eval_pt,A,eval_data));
B_pt:=helmsimp(Vessiot_map(2,eval_pt,R,eval_data));

M:= Matrix(1,nops(vars),0);
r[0]:= 0;
 
for k from 1 to n*(n+1)/2 do
	Eq_a:= contract_indices(alpha , A_pt, [[1,k+4]]) ;
	Eq_b:= zero_tens([  [seq(tensorIndexType(B_pt)[i], i=1..k+3)],[] ]); 
 	
	for i from 1 to k+3 do 			
		q:=[seq(j1,j1=2..i),1,seq(j2,j2=i+1..k+3)]; 
		t:= contract_indices(beta, B_pt, [[1,i]]);
 		Eq_b:= Eq_b &plus  rearrange_indices(t,q) 
 	od;
 		
	Eq:= Eq_a &plus Eq_b;
 	M0:=LinearAlgebra[GenerateMatrix](expand(coeff_list(Eq,all)),vars); 
 	M:=Matrix([[M],[M0[1]]]); 
#
#     CHANGE TO VESSIOT RANK  BUG  in 9,5 LinearAlgebra[rank] on zero matrix         
#		
	r[k]:=linalg[rank](M); 
	
	if  _Vessiot_show_intermediate_steps_flag =true then 		
      	print(`Maximal  size of symmetry alg:`, n*(n+1)/2 -r[k]);  
      fi;
 		
	if r[k]= r[k-1] then 
		break 
	fi; 
            
	if  nargs>=5 and  args[5] = n*(n+1)/2 -r[k] then 
		break  
 	fi;

	if  _Vessiot_show_intermediate_steps_flag =true then 		
		print(`Computing curvature derivative`, k+1);
	fi;

	A:=covariant_derivative(A,offel); 	
      B_pt:=A_pt;
	A_pt:=helmsimp(Vessiot_map(2,eval_pt,A,eval_data));

od;
 

N_temp := Vessiot_nullspace(M); 
C:=LinearAlgebra[Transpose](Matrix([op(N_temp)]));
C:=Vessiot_rref(eval(C));
N:=[];

for i from 1 to nops(N_temp) do
	N:=[op(N),LinearAlgebra[Row](C,i)];
od;



k_data:=[];

for kd in N do
 	X_coeff:=[seq(kd[i],i=1..n)];
 	F_coeff:=[seq(kd[i],i=n+1..n*(n+1)/2)];
 	alpha:=convert(v_zip(X_coeff,frameBaseVectors(),plus),Vessiot_tensor);
 	
	beta:= convert(v_zip(F_coeff,
	[seq(seq( DifferentialGeometryTools:-Form(i)&wedge DifferentialGeometryTools:-Form(j), j=i+1..n), i=1..n)],plus),
      Vessiot_tensor);
 	D_alpha:=   raise_lower_indices(inverse_metric_pt,beta,[1]);
 		k_data:= [op(k_data), [alpha, D_alpha]]
od;
 
k_data;

end:

#--------------------------------------

Killing_data_bracket:=proc(kd1,kd2,Riem) 
# Class II Program
# 06/06/01:IA

local X, dX, Y, dY, ans1a, ans1b, ans2a, ans2b,ans2c,
ans2d,ans2e, ans1,ans2, pt,n,eval_pt,S,dS, i,S0,dS0;
	
X:=kd1[1];
dX:=kd1[2];
Y:=kd2[1];
dY:=kd2[2];
 
ans1:=contract_indices(X &tensor dY,[[1,3]])  &minus 	
	contract_indices(Y 	&tensor dX,[[1,3]]);

ans2a:=contract_indices(dX &tensor dY,[[1,4]])&minus 
	 contract_indices(dY 	&tensor dX,[[1,4]]); 
ans2b:=contract_indices((X &tensor Y) &tensor Riem,[[1,5],[2,6]]);

ans2:=rearrange_indices(ans2a &minus ans2b, [2,1]) ;

[ans1, ans2]

end:

#-------------------------------------------------------

Killing_data_to_isotropy_subalgebra:=proc(Killing_data,algname) 

local n, vars, i, X,Eq,M, N_temp, B, N, v,iso;

n:=nops(Killing_data);
vars:=[seq(cat(_a,i), i=1..n)];

X:=v_zip(vars, [seq(Killing_data[i][1], i=1..n)],plus);

Eq:=coeff_list(X,all);
M:=LinearAlgebra[GenerateMatrix](Eq,vars); 


N_temp := Vessiot_nullspace(M[1]); 
B:=LinearAlgebra[Transpose](Matrix([op(N_temp)]));
B:=Vessiot_rref(eval(B));
N:=[];

for i from 1 to nops(N_temp) do
	N:=[op(N),LinearAlgebra[Row](B,i)];
od;


change_frame_to(algname);
iso:=[];

for v in N do 
       X:=v_zip(convert(v,list),  frameBaseVectors() ,plus);
      iso:=[op(iso), X]
od;

iso

end:

#-----------------------------------------------

Killing_data_to_Lie_algebra:=proc(Killing_data,Riem,base_pt)
# Class II Program
# 06/06/01:IA

local n,frame,var_list,alg_name, vars, X, dX, i, j, k, kd, eq, p, soln, pt,
Riem_pt, tens_frame, struc_const,eval_data;
    
tens_frame:=objectFrame(Riem);

VessiotFrameCheck(Riem);

frame:=_Vessiot_current_frame_name;
var_list:=frameIndependentVariables();
      
if nargs>=4 then alg_name:=args[4] else  alg_name:=isometry_alg fi;

n := nops(Killing_data);


vars := seq(cat(_a,i), i = 1 ..n);
pt:={seq(var_list[i] = base_pt[i], i =1..frameBaseDimension() )};

if nargs=5
then 
	eval_data:=pt, diff_sub(n*(n+1)/2 +2, args[5][1],args[5][2]);
else
      eval_data:=pt 
fi;

    
X := v_zip([vars], [seq(Killing_data[i][1], i = 1 .. n)],
        plus);

dX := v_zip([vars], [seq(Killing_data[i][2], i = 1 .. n)],
        plus);
    
struc_const := []; 
Riem_pt:=Vessiot_map(2,eval_pt,Riem,eval_data);
    
for i to n - 1 do for j from i + 1 to n do
      kd := Killing_data_bracket(Killing_data[i],
            Killing_data[j], Riem_pt );
      eq := [op(coeff_list(kd[1] &minus X,  all)), 
             op(coeff_list(kd[2] &minus dX, all))];
      soln := solve(convert(eq,set), {vars});
      
	if  soln=NULL then   
	ERROR( `Vessiot Error :  Killing  Data does  not determine a Lie algebra`) 
	fi;   
      
	for k to n do
          p := subs(soln, vars[k]);
          if p <> 0 then struc_const :=
                    [op(struc_const), [[i, j, k], p]]
          fi
      od
      od
od;
    
[[Lie_alg,alg_name, [n]], struc_const ];

end:

#-------------------------------------------------------

eval_pt:=proc(exp,pt)
# Class II Program
# 06/06/01:IA

local ans, v;
ans:=exp;

if nargs=3 
then 
	for v in args[3] do 
	ans:=subs(v,ans);
	od;
fi;

ans:=eval(ans,pt)

end:


#-----------------------------------------------------------

diff_sub:=proc(order, vars,funs)

# Class II Program
# 06/06/01:IA
 
local n,m,p,jets, indep_vars, l,k,
 dep_var,diff_list, ans,diff_dep_var,fr,i,eval_data;
 
 fr:=_Vessiot_current_frame_name;
 coord_init(vars,funs,_isoTemp);
   n:=frameBaseDimension();
  m:=frameFiberDimension();
  p:=jet_space_dim(order);  
 
 # The next command insures that the  list of jet variables is extend to order. 
 DifferentialGeometryTools:-Form(p);
 
  jets:=_Vessiot_frame_data[_isoTemp][1][4][4];
  indep_vars:=_Vessiot_frame_data[_isoTemp][1][4][1];
  
 ans:=[];

 for k from p to n+1  by -1 do
  	dep_var:=op(0,jets[k])(op(indep_vars));
  	diff_list:=[op(jets[k])];
  	diff_dep_var:=dep_var;
  	for l from 1 to n  do  
 	if diff_list[l] <>0 then   
 		diff_dep_var:=diff(diff_dep_var,seq(indep_vars[l], i=1..diff_list[l])); 
 	fi;
  	od; 
 	ans:=[op(ans) , diff_dep_var=jets[k]]  
 od;
                                                                   
 remove_frame(_isoTemp);
 change_frame_to(fr);
 
 ans;
 
 end:
 
#---------------------------------


