#
# LieGroups
#

MatrixAlgebraToMatrixGroup:=proc(A,vars)  

local f, n, B, Diag, F, G, i, a, b, c, r, j, t,S,trans,Origin,Up,Dg,Other, 
      temp,B1,B2, EXP ,Ups;

f:=proc(i,j,h,k) 
	if i=h and j=k then 
		RETURN(1) 
	fi; 
	0 
end:
Origin:=[];
n:=LinearAlgebra[RowDimension](A[1]);
B1:=[seq(seq([[j,i],Matrix(n,n,(k,h)->f(i,j,h,k))] ,i=j+1..n), j=1..n)];
B2:=[seq(seq([[j,i],Matrix(n,n,(k,h)->f(i,j,h,k))] ,i=1..j-1), j=1..n)];
B:=[op(B1),op(B2)]:

Diag:=[seq(Matrix(n,n, (h,k)->f(i,i,h,k)), i=1..n)]; 

F:=LinearAlgebra[DiagonalMatrix]([1$n]); 

Up:=[];
Dg:=[];
Other:=[];
temp:=[];

for a in A do  
	for b in B1 do  
		c:=LinearAlgebra[Equal](eval(a),b[2]); 
		if c =true then 
			Up:=[op(Up),b];  
                  break;

            fi;
     od;
     if c=false then  temp:=[op(temp),eval(a)] fi;

od;

for a in temp do 
	t:=convert(a,set);

	if linear_combo(a,Diag) <> [] and indets(t)={} then
		Dg:=[op(Dg),eval(a)]
      else
 		Other:=[op(Other),eval(a)]
      fi;
od;

i:=0;

for a in Other do	
	i:=i+1;  
	EXP:=LinearAlgebra[MatrixExponential](vars[i]*a) ;
	F:=LinearAlgebra[MatrixMatrixMultiply](F,EXP);
      Origin:=[op(Origin),0];
od;



for a in Dg do 
      i:=i+1; 
      if nargs=2 then 
		r:=min(op(map(abs,convert(a,set) minus {0}))); 
            EXP:=LinearAlgebra[MatrixExponential](1/r*log(vars[i])*a);
		F:=LinearAlgebra[MatrixMatrixMultiply](F,EXP);
            Origin:=[op(Origin),1];
      fi;
      if nargs=3 then 
            EXP:=LinearAlgebra[MatrixExponential](vars[i]*a);
		F:=LinearAlgebra[MatrixMatrixMultiply](F,EXP);
		Origin:=[op(Origin),0];
      fi; 
  
	
od;


f:=(a,b) ->lexorder(convert(a[1],string),convert(b[1],string));

Ups:=sort(Up,f);


for a in Ups do
      i:=i+1;
      EXP:=LinearAlgebra[MatrixExponential](eval(_x*a[2])); 
	F:=LinearAlgebra[MatrixMatrixMultiply](EXP  , F);
      Origin:=[op(Origin),0];
      S:=solve({F[op(a[1])]=vars[i]},{_x});
      F:=map2(subs,S,F);
      F:=map(simplify,F);
od;



eval(F),Origin
end: 



#

#~~~~~~~~~~~~



MaurerCartanMatrixToMatrixGroup:=proc (Omega,{LR:=left,METHOD:=pdsolve,INIT_PT:=[]}) 
local n, init_pt, i, j, unknowns, vars, S, EQ, de, soln, Id, opt, 
method, ans1, C, ICSoln, fr_name, S0, S1, S2, init_pt2, init_pt1, 
init_val, first_der, ans, total_de, v, dep_vars;  

fr_name := objectFrame(Omega[1,1]); 
change_frame_to(fr_name); 

vars := frameIndependentVariables(fr_name):

if INIT_PT=[] then  
	init_pt1 := [seq(0,v = vars)]; 
	init_pt2 := [seq(v = 0,v = vars)]; 
else
	init_pt2 := INIT_PT;
	init_pt1 := map(rhs,init_pt2); 
fi; 
 

n := LinearAlgebra[RowDimension](Omega); 
Id := LinearAlgebra[IdentityMatrix](n); 

S0 := Matrix(n,n,(i, j) -> cat(f,i,j)(op(vars)));
dep_vars := convert(map(op,convert(S0,listlist)),list); 

S := map(scalar_form,S0); 

if LR = left then 
	EQ := `&mminus`(map(ext_d,S),`&mwedge`(S,Omega)) 
fi; 

if LR = right then 
	EQ := `&mplus`(map(ext_d,S),`&mwedge`(Omega,S)) 
fi; 

de := convert(map(op,map(coeff_set,EQ)),set); 

if METHOD = Frobenius then 
	first_der := {seq(op(diff(dep_vars,v)),v = vars)}; 
	total_de := solve(de,first_der); 
	init_pt := [seq(0,v = vars)]; 
	init_val := map(op,convert(Id,listlist)); 
	soln := total_dsolve(total_de,dep_vars,vars,INIT_PT = init_pt1,INIT_VAL = init_val); 
	ans := convert(soln,int); 
	ans1 := eval(map2(subs,ans,S0)); 
	RETURN(ans1) 
fi; 

if METHOD = pdsolve then 
	first_der := {seq(op(diff(dep_vars,v)),v = vars)}; 
	total_de := solve(de,first_der); 
	soln := pdsolve(total_de); 
	S1 := eval(map2(subs,soln,S0)); 
	S2 := convert(subs(init_pt2,S1)-Id,set); 
	C := indets(S2); ICSoln := solve(S2,C);
 	ans := subs(ICSoln,S1);
	RETURN(ans) 
fi 

end:

#~~~~~~


MaurerCartanFormsToMultiplicationProcedure:=proc()

end:














