
#
# GrpTransformations
#
#
MatrixRepresentationToMultiplicationProcedure:=proc(M,vars)

local n,A,B,C,E,eq,multiplication1, multiplication2,ans;

n:=nops(vars);

A:=map2(subs, {seq(vars[i]=X[i],i=1..n)},M);
B:=map2(subs, {seq(vars[i]=Y[i],i=1..n)},M);
C:=map2(subs, {seq(vars[i]= cat(_z,i),i=1..n)},M);

E:=eval(C- LinearAlgebra[MatrixMatrixMultiply](A,B));
eq:=convert(E,set);

eq:=map(combine,eq);


multiplication1:=solve(eq,{seq(cat(_z,i),i=1..n)});
multiplication2:=subs(multiplication1,[seq(cat(_z,i),i=1..n)]);

proc(A,B) 
	subs({seq(X[i]=A[i],i=1..nops(A)),seq(Y[i]=B[i],i=1..nops(B))}, multiplication2) 
end: 


end:



LeftRightTransformations:=proc(gr_mult,gr_frame)

local vars, n, a_vars, b_vars, rightM, leftM, muR, muL;

vars:=frameIndependentVariables(gr_frame); 
n:=frameBaseDimension(); 

if nargs> 2 then 
	a_vars:=args[3];
	b_vars:=args[4];
else
	a_vars:=[seq(cat(a,i), i=1..n)]; 
	b_vars:=[seq(cat(b,i), i=1..n)]; 
fi;



rightM:=gr_mult(vars,b_vars);
leftM:=gr_mult(a_vars,vars);

muR:=transform(gr_frame,gr_frame,[seq(vars[i]=rightM[i], i=1..n)]);
muL:=transform(gr_frame,gr_frame,[seq(vars[i]=leftM[i],i=1..n)]);

muL,muR
end: