#
#
#

form_tuple_to_index:=proc(n,tuple)
local i,j,kp,lp,q,index;
q:=nops(tuple);

index:=1;
kp:=1;
for i from 1 to q do 
lp:=tuple[i]; 
index:=index+sum(binomial(n-j,q-i),j=kp..(lp-1));
kp:=lp+1;
od;

index;
end:

#
#
#

index_to_form_tuple:=proc(n,q,index)
local lp,kp,i,j,te,le, ans, tuple;

tuple:=[];
lp:=index;

te:=0;
for i from 1 to q do 
	kp:=0;
	for j from 1 to n while kp < lp do
	le:=kp;
	kp:=le+binomial(n-te-j,q-i);
	od;
te:=te+j-1;
tuple:=[op(tuple),te];
lp:=lp - le;
od;

tuple
end:

#
#
#




tableau_and_index_to_form:=proc(tabx,p,index) 

local   n,m,d,i,j,tup,tableau,alpha,beta; 

tableau:=tabx[2];

n:=frameBaseDimension();
m:=frameFiberDimension();
d:=nops(tableau);
i:= iquo(index-1,d) +1; 
j:=irem(index-1,d)+1;
tup:=index_to_form_tuple(n,p,i);
alpha:=v_zip(tableau[j],frameFiberForms(), plus);
beta:=_VESSIOT([[form,_Vessiot_current_frame_name,p],[[tup,1]]]); 
 
beta &wedge alpha;

end:

#


#
#

TableauLinearCombo:=proc(s,tabx) 
local p,m,i,c,combo,eq,k,vars,b, A,tableau;
tableau:=tabx[2];
p:=nops(tableau);
m:=nops(s); 
vars:=[seq(c[k], k=1..p)];
combo:= [seq(s[i] - add (c[k]*tableau[k][i],k=1..p), i=1..m)];
eq:={};
for i from 1 to m do
	eq:= eq union {coeffs(expand(combo[i]),frameIndependentVariables())};
od;

A,b:=LinearAlgebra[GenerateMatrix](eq,vars);
Vessiot_linsolve(A,b);
end:

#
#

TableauLinearCombo2 := proc (vfb::list(Vessiot_bftv), a_basis::list(Vessiot_bftv)) 
local ans,a, c, b,i, j, varList1, varList2, linearCombo, linearComboSet, A, B, C, X, index; 

varList1 := [seq(_t[i],i = 1 .. nops(vfb))]; 
varList2 := [seq(_s[j],j = 1 .. nops(a_basis))]; 
linearCombo := `&plus`(v_zip(varList2,a_basis,plus),v_zip(varList1,vfb,plus)); 
linearComboSet := coeff_list(linearCombo,all); 
linearComboSet := map(coeffs,linearComboSet,frameIndependentVariables()); 
A,a:= LinearAlgebra[GenerateMatrix](linearComboSet,varList2); 
B,b:= LinearAlgebra[GenerateMatrix](linearComboSet,varList1); 
X := Vessiot_linsolve(A,B); 

if X <> NULL then 
ans := [seq([seq(X[i,j],i = 1 .. nops(a_basis))],j = 1 .. nops(vfb))] 
else ans := 
[] 
fi; 
ans 

end:



#


TableauChains:=proc(tabx,p) 
local C1,n,m,d1,p1,chains,h,alpha;


n:= frameBaseDimension(); 

m:=frameFiberDimension(); 
d1:=nops(tabx[2]);
p1:=binomial(n,p);

if p>n  or tabx[2]=[[0$m]] or tabx[2]=[] then RETURN([DifferentialGeometryTools:-zero_form(p+1)]) fi;


chains:=[];
for h from 1 to d1*p1 do
	alpha:=tableau_and_index_to_form(tabx,p,h);
	chains:=[op(chains),alpha]
od;
chains;
end:




Spencer_ext_d_Matrix:= proc(chain1, chain2) 
local m, A,ext_d_chain1; 
	m := nops(chain1);  
      if map(coeff_list,chain2,all)=[[0]]  then 
		A:=Matrix(m,1,0) 
	else
      ext_d_chain1:=map(ext_d,chain1);
	A:=TableauLinearCombo2(ext_d_chain1,chain2); 
	fi;
      if  A=[] then 
ERROR(`VESSIOT ERROR: The exterior derivative is not a linear transformation between the given spaces of chains`); 
      fi;
	LinearAlgebra[Transpose](Matrix(A))
end:


#
#
###
#
#


Spencer_cohomology_in_degree:=proc(d_mat_1, d_mat_2, p,TableauChains)
local i, j, N,A,fr,n,m,tup,alpha,h,r,B,C,Co,s,E,Cans,d1,ans,eta, eta1 ; 


n:=frameBaseDimension();
m:=frameFiberDimension(); 
d1:=nops(tableau);

E:= Matrix([d_mat_2],  [LinearAlgebra[Transpose](d_mat_1)]);
A:=convert(Vessiot_nullspace(E),list); 
r:=nops(A); 
if  r= 0 then 
      eta:=DifferentialGeometryTools:-zero_form(p+1);
      if p<n then 
      eta1:=op(eta); 
	eta1[2][1][1][p+1]:=n+1; 
	eta:=_VESSIOT(eta1); fi;  
      ans:= [eta]   
	else  
 	ans:=[];
 	for  N  in A  do  	
	ans:=[op(ans),v_zip(convert(N,list),TableauChains,plus)] 	
      od;
fi; 
ans;
end:

#
#
#

SpencerCohomology:=proc(tableau_list,init_degree, final_degree) 
local i, j,  k ,D1, D2,n,r,ans,p,C1,C2,C3,H; 
 
n:=frameBaseDimension();
r:=nops(tableau_list);


C1:=TableauChains(tableau_list[1],init_degree-1);
C2:=TableauChains(tableau_list[2],init_degree);


D1:=Spencer_ext_d_Matrix(C1,C2);
ans:=[];

for  p   from  init_degree to final_degree do
	C3:= TableauChains(tableau_list[p+3-init_degree],p+1);
	D2:=Spencer_ext_d_Matrix(C2,C3);
      H:=Spencer_cohomology_in_degree(evalM(D1),evalM(D2), p, C2); 
 	ans:=[op(ans),H ];
 	D1:=evalm(D2);
      C2:=   C3; 
od;
ans;
end:
#############################################################


