SymbolToSymbolMatrix:=proc(Delta,vars) 
local k ,p,m,n,j1,j2,j3,q,Sigma,i,j,l,A,Z,s,der; 


p:=max(op(map(functionOrder,Delta))); 
m:=frameFiberDimension();
n:=frameBaseDimension();
j1:=jet_space_dim(p-1)+1;
j2:=binomial(n+p-1,p);
j3:=j1 + j2-1;
q:=nops(Delta);

Sigma:=Matrix(q,m);

for i from 1  to m 
do  
	for j from 1 to q 
	do 
	s:=0;
	for l from j1 to  j3 
		do
		der:=op(index_to_tuple(l));
		Z:=1;
 		for k from 1 to n 
			do
 			Z:= Z*(vars[k])^der[k]
 			od;
		 s:= s+ diff(Delta[j],frameJetVariables()[l + (i-1)*j2])*Z;
		od;
	Sigma[j,i]:=s; 
 	od;
 	od;
 
evalm(Sigma);

end:



#
#
#


SymbolMatrixToSymbol:=proc(M,vars) 
local j,Delta,i, m,n, var_dep;

n:=frameBaseDimension();
m:=frameFiberDimension();
var_dep:= frameJetVariables()[n+1..n+m];
 
Delta:=[];
for i from 1 to LinearAlgebra[RowDimension](M) 
do 
	Delta:=[op(Delta), 
      add(polynomial_to_symbol(M[i,j],vars, var_dep[j]),j=1..m)]

od;

Delta;

end:



monomial_to_tuple:=proc(monomial,var) 
local ind,v;

ind:=[]; 
for v in var do  
	ind:=[op(ind),degree(monomial,v)] 
od;

ind;
end:


polynomial_to_symbol:=proc(poly,poly_var, dep_var) 
local e_poly,ans,mono;

if type(expand(poly), monomial) 
	then 
	e_poly:=[poly] 
else 
	e_poly:=convert(expand(poly),list) 
fi;

ans:=0;

for mono in e_poly 
do
 	ans:=  ans + coeffs(mono,poly_var)*
	multi_td(dep_var, monomial_to_tuple(mono,poly_var))
od;

ans;
end:


