#
#
#

generate_monomials := proc (q)
local  n, j1, j2, j3, p, i, der, j;


n :=  frameBaseDimension();
j1 := jet_space_dim(q-1)+1; 
j2 := binomial(n+q-1,q); 
j3 := j1+j2-1;
 p := []; 
for i from j1 to j3 
do 
	der := op(index_to_tuple(i));
 	p := [op(p), mul( frameIndependentVariables()[j]^der[j],j = 1 .. n)] 
od 
end:




#

FullTableau:=proc(k) 
local m, P, b,ans, i,p,j,fr;

fr:=_Vessiot_current_frame_name;

m:=frameFiberDimension();
P:=generate_monomials(k);

ans:=[];
for i from 1 to m 
	do for p in P do 
	ans:=[op(ans),[seq(0, j=1..i-1),p,seq(0,j=i+1..m)]];
	od; 
od;

[[tableau,fr,[] ],ans];

end:


#
#
#

SymbolToTableau:=proc(Delta) 

local b,  p,m,n,j1,j2,j3,q,poly_list,r,_vessiotX,s,i,j,phi,
pr_phi,B,N,X,T,eq,v,fr;

fr:=_Vessiot_current_frame_name;
p:=max(op(map(functionOrder,Delta))); 
m:=frameFiberDimension();
n:=frameBaseDimension();

j1:=jet_space_dim(p-1)+1;
j2:=binomial(n+p-1,p);
j3:=j1 + j2-1;

q:=nops(Delta);
poly_list:=generate_monomials(p): 
r:=nops(poly_list);
 
s:=[seq (add( cat(_vessiotX,i,j)*poly_list[j],j=1..r),i=1..m)];

phi:=transform(_Vessiot_current_frame_name,_Vessiot_current_frame_name ,
	[seq(frameIndependentVariables()[i]=frameIndependentVariables()[i], i=1..n),
	 seq(frameJetVariables()[i+n]= s[i], i =1..m)]);

pr_phi:=pr_transform(phi,p); 

eq:=[seq(pullback( pr_phi, Delta[i]),i=1..q)];

B,b:=LinearAlgebra[GenerateMatrix](eq,[seq(seq(cat(_vessiotX,i,j), j=1..r),i=1..m)]); 

N:=Vessiot_nullspace(B) ; 

if N={} then N:={[seq(0,i=1..r*m)]} fi;

T:=[];

for  v in N 
do 

           T:=[op(T), [seq(add(v[i+m*(j-1)]*poly_list[j],j=1..r),i=1..m) ]  ]
od;

[[tableau,fr,[]] , T];

end:


#
#
#

ProlongSymbol:=proc(Delta) 

local fr,pr_Delta,var,eq;


pr_Delta:=[];

for  var in frameIndependentVariables()
do 
	for eq in Delta 
	do
		pr_Delta:=[op(pr_Delta), td(eq,var)]
	od;
od;

pr_Delta

end:

#
#
#

TableauToSymbol:=proc(Tab)

local b, i,j,p,m,n,j1,j2,j3,q,Delta_list, 
tablx, Delta,phi,pr_phi,B,T,v,eq,s,N; 

tablx:=Tab[2];


p:=max(op(map(degree,tablx[1]))); 
m:=frameFiberDimension();
n:=frameBaseDimension();

if nops(tablx[1]) <> m then 
ERROR(`number of dependent  variables and  length of tableau elements inconsistent`) fi;

j1:=jet_space_dim(p-1)+1;
j2:=binomial(n+p-1,p);
j3:=j1 + m*j2-1;
q:=nops(tablx);

# Prolong the jet space if necc.
#
index_to_tuple(j3);

Delta_list:=frameJetVariables()[j1..j3];
Delta:= add(cat(_vessiotX,j)*Delta_list[j],j=1..nops(Delta_list)); 

eq:=[]; 

for s in tablx 
do
 	phi:=transform(_Vessiot_current_frame_name,_Vessiot_current_frame_name,
    		[seq(frameIndependentVariables()[i]=frameIndependentVariables()[i], i=1..n),
     		 seq(frameJetVariables()[i+n]= s[i], i =1..m)]);

	pr_phi:=pr_transform(phi,p); 
	eq:=[op(eq),pullback( pr_phi, Delta)];
od; 

B,b:=LinearAlgebra[GenerateMatrix](eq,[seq(cat(_vessiotX,j), j=1..nops(Delta_list))]);
N:=Vessiot_nullspace(B) ;
T:=[];

for  v in N 
do 
	T:=[op(T),add( v[j]*Delta_list[j],j=1..nops(Delta_list) )]
od;  

if T=[] then T:=[] fi;

T 

end:



RestrictTableau:=proc(Tab,X) 

local  b, v,T,m,q,eq,i,temp,j,N, tablx ,B,Z ,fr;

fr:=_Vessiot_current_frame_name;

tablx:=Tab[2];
  
m:=frameFiberDimension();
q:=nops(tablx);
eq:=[];

for i from 1 to m 
do  	
	temp:=expand(Lie_derivative(X,add(cat(_vessiotX,j)*tablx[j][i],j=1..q)));
	eq:=[op(eq),coeffs(temp, frameIndependentVariables()        )] 
od;

B,b:=LinearAlgebra[GenerateMatrix](eq,[seq(cat(_vessiotX,j), j=1..q)]);
N:=Vessiot_nullspace(B); 

if N={} then N:={[seq(0,i=1..q)]} fi;

T:=[];
for  v in N 
do 
	T:=[op(T),[seq(add(v[j]*tablx[j][i],j=1..q),i=1..m)]]
od; 

[[tableau,fr, []], T] ;

end: 
 
 


TableauSequence:=proc(Tab,basis) 

local  m,n,q,new_tableau,seq_of_tableau,tableau, i;


 
m:=frameFiberDimension();
n:=frameBaseDimension();
q:=nops(tableau);

new_tableau:=Tab;
seq_of_tableau:=[new_tableau];
for i from 1 to n 
	do 
 	new_tableau:=RestrictTableau(new_tableau, basis[i]);
 	seq_of_tableau:=[op(seq_of_tableau), new_tableau];
	
od;

seq_of_tableau;

end:

#
#

SymbolToProlongedTableau:=proc(Delta,k)

local S, ans, i; 

S:=Delta;
ans:=[SymbolToTableau(S)];

for i from 1 to k do 
	S:=ProlongSymbol(S);
	ans:=[op(ans), SymbolToTableau(S)]  
od;

ans;
end:




##

DifferentiateTableau:=proc(Tab,X) 
local i,fr ; 

fr:=_Vessiot_current_frame_name ;  

[[tableau,fr,[]], [seq(map2(Lie_derivative,X,Tab[2][i]), i=1..nops(Tab[2]))] ] 

end:


#
#
#

CartanCharacters:=proc(seq_of_tableau) 

local i,a,s,n,m,j,k;

m:=frameFiberDimension();
n:=frameBaseDimension(); 

for i from 1 to n +1 
	do 
	if seq_of_tableau[i][2]=[[seq(0, j=1..m)]] 
		then a[i]:=0 
		else a[i]:=nops(seq_of_tableau[i][2]) fi;
	od;

s:= [seq(a[i]- a[i+1], i=1.. n)]; s,add(k*s[k], k=1..n)

end:


#
#
#

MatrixAlgebraToSymbol:=proc(matrixAlg::list(Matrix))
local tablx, fr, tablxComp, M;
fr:=frameIndependentVariables();

tablxComp:=[seq(convert(evalm(M&*fr),list), M=MatrixAlg)];

tablx:=[[tableau,_Vessiot_current_frame_name,[]],tablxComp];

TableauToSymbol(tablx);

end:
