#
# MatrixArith.utl 
#
# DG_Utilities
#
#
# &mplus; &mminus; &mmult; &mwedge
#







#====================================================
    `&mplus`:=proc(A::Matrix ,B::Matrix)
#CLASS II PROGRAM
#December 13,2002:IA
 
local i,j,C;

if  LinearAlgebra[RowDimension](A) <> LinearAlgebra[RowDimension](B) or  LinearAlgebra[ColumnDimension](A) <> LinearAlgebra[ColumnDimension](B) then
       ERROR(cat("\n VESSIOT ERROR:", 
                 "\n matrices dimensions not compatible for Matrix addition:",
                 "\n ", "[",LinearAlgebra[RowDimension](A),LinearAlgebra[ColumnDimension](A),"]", 
				"[",LinearAlgebra[RowDimension](B),LinearAlgebra[ColumnDimension](B),"]" ))
fi;


C:=Matrix(LinearAlgebra[RowDimension](A), LinearAlgebra[ColumnDimension](B));

for i from 1 to   LinearAlgebra[RowDimension](A) do
     	for j from 1 to   LinearAlgebra[ColumnDimension](B) do
         	C[i,j]:=A[i,j] &plus B[i,j];
      od;
od;

eval(C)
end:

#=================================================

`&mminus`:=proc(A::Matrix ,B::Matrix)
#CLASS II PROGRAM
#December 13,2002:IA

local i,j,C;

if  LinearAlgebra[RowDimension](A) <> LinearAlgebra[RowDimension](B) or  LinearAlgebra[ColumnDimension](A) <> LinearAlgebra[ColumnDimension](B) then
      ERROR(cat("\n VESSIOT ERROR:", 
                 "\n matrices dimensions not compatible for Matrix subtraction:",
                 "\n ", "[",LinearAlgebra[RowDimension](A),LinearAlgebra[ColumnDimension](A),"]", 
				"[",LinearAlgebra[RowDimension](B),LinearAlgebra[ColumnDimension](B),"]" ))

fi;

C:=Matrix(LinearAlgebra[RowDimension](A), LinearAlgebra[ColumnDimension](A));

for i from 1 to   LinearAlgebra[RowDimension](A) do
    	for j from 1 to   LinearAlgebra[ColumnDimension](B) do
        	C[i,j]:=A[i,j] &minus B[i,j];
      od;
od;

eval(C)
end:

#--------------------------------------------------

`&mmult`:=proc(A0,B0)

local ans, `&mmult0`, `&mmult1`, `&mmult2`, `&mmult3`, `&mmult4`,flagB, flagA,A,B;

#
# SUBROUTINES
#



`&mmult0`:=proc(A::Matrix,alpha::Vessiot_bftv) 

#CLASS II PROGRAM
#December 13,2002:IA

local i,j,C;

C:=Matrix(LinearAlgebra[RowDimension](A),LinearAlgebra[ColumnDimension](A));
     	
for i from 1 to  LinearAlgebra[RowDimension](Omega) do
     	for j from 1 to  LinearAlgebra[ColumnDimension](Omega) do
         	C[i,j]:= A[i,j] &mult alpha;
       od;
od;


eval(C);
end:



`&mmult1`:=proc(r::algebraic,Omega::Matrix) 

#CLASS II PROGRAM
#December 13,2002:IA

local i,j,C;

C:=Matrix(LinearAlgebra[RowDimension](Omega),LinearAlgebra[ColumnDimension](Omega));
     	
for i from 1 to  LinearAlgebra[RowDimension](Omega) do
     	for j from 1 to  LinearAlgebra[ColumnDimension](Omega) do
         	C[i,j]:= r &mult Omega[i,j];
       od;
od;


eval(C);
end:

#========================================================

`&mmult2` := proc (A::Matrix,form::Vessiot_bftv) 
#CLASS II PROGRAM
#December 13,2002:IA

local C, i, j; 


C := Matrix(LinearAlgebra[RowDimension](A),LinearAlgebra[ColumnDimension](A)); 

for i to LinearAlgebra[RowDimension](A) do 
  	for j to LinearAlgebra[ColumnDimension](A) do 
       	C[i,j] := A[i,j] &mult  form;
      od 
od: 
       
eval(C);
end:

#=======================================================

`&mmult3`:=proc(A::Matrix,Omega::Matrix)
#CLASS II PROGRAM
#December 13,2002:IA

local i,j,k,C;


if LinearAlgebra[ColumnDimension](A) <> LinearAlgebra[RowDimension](Omega) then
ERROR(cat("\n VESSIOT ERROR:", 
                 "\n matrices dimensions not compatible for Matrix multiplication:",
                 "\n ", "[",LinearAlgebra[RowDimension](A),LinearAlgebra[ColumnDimension](A),"]", 
				"[",LinearAlgebra[RowDimension](Omega),LinearAlgebra[ColumnDimension](Omega),"]" ))
fi;



C:=Matrix(LinearAlgebra[RowDimension](A),LinearAlgebra[ColumnDimension](Omega));

for i from 1 to LinearAlgebra[RowDimension](A)     do
     	for j from 1 to LinearAlgebra[ColumnDimension](Omega) do
         	C[i,j]:=A[i,1] &mult Omega[1,j];
         	for k from 2 to LinearAlgebra[ColumnDimension](A) do
           		C[i,j]:= C[i,j] &plus (A[i,k] &mult Omega[k,j])
         	od;
     	od;
od;


eval(C);
end:

#====================================================

`&mmult4`:=proc(Omega::Matrix ,A::Matrix)

#CLASS II PROGRAM
#December 13,2002:IA
     
local i,j,k,C;


if LinearAlgebra[ColumnDimension](Omega) <> LinearAlgebra[RowDimension](A) then
ERROR(cat("\n VESSIOT ERROR:", 
                 "\n matrices dimensions not compatible for Matrix multiplication:",
                 "\n ", "[",LinearAlgebra[RowDimension](Omega),LinearAlgebra[ColumnDimension](Omega),"]", 
				"[",LinearAlgebra[RowDimension](A),LinearAlgebra[ColumnDimension](A),"]" ))
fi;



C:=Matrix(LinearAlgebra[RowDimension](Omega),LinearAlgebra[ColumnDimension](A));

for i from 1 to  LinearAlgebra[RowDimension](Omega) do
	for j from 1 to  LinearAlgebra[ColumnDimension](A) do
		C[i,j]:=A[1,j]&mult Omega[i,1];
       	for k from 2 to LinearAlgebra[RowDimension](A) do
           		C[i,j]:= C[i,j] &plus (A[k,j] &mult Omega[i,k])
         	od;
       od;
od;

eval(C);
end:

#=============================================================

#
# RETURN TO MAIN PROGRAM
#

flagB:=type(B0,Vector);
flagA:=type(A0,Vector):

if flagA=true  then A:= convert(A0,Matrix)  else A:=A0 fi;
if flagB=true  then B:= convert(B0,Matrix)  else B:=B0 fi;


if type(A,Matrix) and type(B,Vessiot_bftv) then 
	ans:=A &mmult2 B;
      
      RETURN(eval(ans)):
fi;

if type(A,Matrix) and type(A[1,1],algebraic) and 
   type(B,Matrix) and type(B[1,1],Vessiot_bftv) then 
  	ans:= A &mmult3 B;
      if flagB=true then ans:=convert(ans,Vector) fi:
      RETURN(eval(ans))
fi;


if type(A,Matrix) and type(A[1,1],Vessiot_bftv) and 
   type(B,Matrix) and type(B[1,1],algebraic) then 
  	ans:= A &mmult4 B;
	if flagB=true then ans:=convert(ans,Vector) fi:
      RETURN(eval(ans));
fi;




if type(A,Matrix) and type(B,Vessiot_bftv) then 
	ans:= A &mmult0 B;
      RETURN(eval(ans)):
fi;



if type(A,algebraic) and type(B,Matrix) then 
	ans:= A &mmult1 B;
      if flagB=true then ans:=convert(ans,Vector) fi:
      RETURN(eval(ans)):
fi;



end:


#=====================================================




`&mwedge`:=proc(Omega1::Matrix ,Omega2::Matrix) 

#CLASS II PROGRAM
#December 13,2002:IA

local i,j,k,C;

if LinearAlgebra[ColumnDimension](Omega1) <> LinearAlgebra[RowDimension](Omega2) then
ERROR(cat("\n VESSIOT ERROR:", 
                 "\n matrices dimensions not compatible for Matrix multiplication:",
                 "\n ", "[",LinearAlgebra[RowDimension](Omega1),LinearAlgebra[ColumnDimension](Omega1),"]", 
				"[",LinearAlgebra[RowDimension](Omega1),LinearAlgebra[ColumnDimension](Omega2),"]" ))
fi;


C:=Matrix(LinearAlgebra[RowDimension](Omega1),LinearAlgebra[ColumnDimension](Omega2));

for i from 1 to LinearAlgebra[RowDimension](Omega1) do
       for j from 1 to LinearAlgebra[ColumnDimension](Omega2) do
         	C[i,j]:=Omega1[i,1] &wedge Omega2[1,j];
         	for k from 2 to LinearAlgebra[ColumnDimension](Omega1) do
           		C[i,j]:= C[i,j] &plus (Omega1[i,k] &wedge Omega2[k,j])
         	od;
       od;
od;

eval(C):
end:


#**************************************************