#
# form_utilities.utl
#
# generate_form_basis_in_bidegree; generate_forms_in_degree
#
#
# 

#-----------------------------------------

Form := proc(tuple::{algebraic,list})
#CLASS II PROGRAM
#08/26/91:CH
#12/13/02:IA

local Form0,ans, frameP, term, tup_list;

if nargs > 1 then
          change_frame_to(args[2])
fi;

frameP := frameProtocol();


if not type(tuple,list) then
	tup_list:=[tuple]
else
	tup_list:=tuple
fi;


if not type(tup_list[1],integer) and not frameP=vst_euc then
      ERROR(cat("\n VESSIOT ERROR:",
		    "\n If frame procotol is not vst_euc then first argument must be an integer or list of integers", 
		    "\n ",tuple, " ", frameP )); 
fi;



Form0:= proc(tuple)
#CLASS I PROGRAM
#08/26/91:CH
#07/02/97:CM
#12/13/02:IA 
       
local forma, index, index1;

if type(tuple,integer) then
	index:=tuple; 
             
	while index > frameJetDimension() do
		pr_Vessiot_frame_data()
	od;


else
	index := tuple_to_index(tuple)
fi;

  _VESSIOT([[form, _Vessiot_current_frame_name, 1], [[[index],1]]]);

end:










ans:=Form0(tup_list[1]);

if nops(tup_list) > 1 then
	for term from 2 to nops(tup_list) do 
		ans := ans &wedge Form0(tup_list[term]);
	od;
fi;

ans:=helmsimp(ans):

ans

end:





#----------------------------------



Biform := proc(tuple::{algebraic,list})
#CLASS II PROGRAM
#08/26/91:CH
#12/13/02:IA

local biForm0,ans, frameP, term, tup_list;

if nargs > 1 then
          change_frame_to(args[2])
fi;

frameP := frameProtocol();


if not type(tuple,list) then
	tup_list:=[tuple]
else
	tup_list:=tuple
fi;


if not type(tup_list[1],integer) and  not frameP=vst_euc then
      ERROR(cat("\n VESSIOT ERROR:",
		    "\n If frame procotol is not vst_euc then first argument must be an integer or list of integers", 
		    "\n ",tuple, " ", frameP )); 
fi;



if not type(tuple,list) then
	tup_list:=[tuple]
else
	tup_list:=tuple
fi;




biForm0:= proc(tuple)
#CLASS I PROGRAM
#08/26/91:CH
#07/02/97:CM
#12/13/02:IA
        
local bform, index, r, s;

if type(tuple,integer) then
	index:=tuple; 

	while index > frameJetDimension() do
		pr_Vessiot_frame_data()
	od;

else
	index := tuple_to_index(tuple)
fi;


#
#  Change after  new  version of  Vessiot_frame_data is obtained
#

if index <= frameBaseDimension() then
	r := 1; 
	s := 0
else 
	r:=0; 
	s :=1  
fi;

bform := _VESSIOT([[biform, _Vessiot_current_frame_name, [r,s]], [[[index],1]]]);

bform
end:





ans:=biForm0(tup_list[1]);

if nops(tup_list) > 1 then
	for term from 2 to nops(tup_list) do 
		ans := ans &wedge Form0(tup_list[term]);
	od;
fi;

ans:=helmsimp(ans):

ans

end:






















scalar_form := proc()

#CLASS I PROGRAM
#06/16/92 CH
#07/07/97 CM
#12/13/02 IA

#scalar_form:: converts "1" into a form for use in programs.

local c, forma;

optionalFrameChange([args],1):

if  nargs>0 then  
	c:=args[1] 
else 	c:=1
fi;

forma := _VESSIOT([[form, _Vessiot_current_frame_name, 0], [[[],c]]]);


forma:

end:



zero_form := proc(p::nonnegint)

#CLASS I PROGRAM
#06/16/92 CH
#07/07/97 CM
#12/13/02 IA


#zero_form:: returns zero form of given degree for coordinate system.

local i, newform, zero_form_degree,k;

optionalFrameChange([args],1):      
                
zero_form_degree:=args[1];

newform := _VESSIOT([ [form, _Vessiot_current_frame_name, zero_form_degree], 
		[[[i $ i=1..zero_form_degree],0]] ]);
         

    
while  frameJetDimension() <p do pr_Vessiot_frame_data() od; 


newform:
end:


#-----------------------------------------------

vol_form := proc()

#CLASS I PROGRAM
#06/16/92 CH
#07/07/97 CM
#12/13/02 IA


#vol_form::  returns full degree form in the indedpendent
#            variables with coefficient 1.

local i, n, c, newform;

optionalFrameChange([args],1):      

if  nargs>0 then  
	c:=args[1] 
else 	c:=1
fi:

n := frameBaseDimension();

newform := _VESSIOT([ [form,_Vessiot_current_frame_name , n], [[[i $ i=1..n],c]] ]);

newform;
end:



#------------------

#
# Arith.jet 
#
# JetCalc
#
#  scalar_biform;  vol_biform , zero_biform


scalar_biform := proc()

#CLASS I PROGRAM
#06/16/92 CH
#07/07/97 CM
#12/13/02 IA

#scalar_biform:: converts "1" into a biform for use in programs.

local  c, forma;

optionalFrameChange([args],1):      

if  nargs>0 then  
	c:=args[1] 
else 	c:=1
fi:

forma := _VESSIOT([[biform, _Vessiot_current_frame_name, [0,0]], [[[],c]]]);

forma:
end:


zero_biform := proc(p::list(nonnegint))
#CLASS I PROGRAM
#06/16/92 CH
#07/07/97 CM
#12/13/02 IA


#zero_biform:: returns zero biform for given degrees and coordinate system

local degrees, i, j, n, newbiform,k, r, s,templist;

optionalFrameChange([args],1):

degrees:=args[1];

if not(type(degrees,list)) or nops(degrees)<>2 then
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Zero biform degree must be a list of two integers."))
fi;

r := degrees[1];
s := degrees[2];
n := frameBaseDimension();

if  r>n then 
	ERROR(cat("\n VESSIOT ERROR:",  
		    "\n Horizontal degree must be not exceeed base dimension:",
                "\n ", r))
fi;

templist := [i $ i=1..r, j $ j=n+1..n+s];

newbiform := _VESSIOT([ [biform, _Vessiot_current_frame_name, degrees], [ [templist, 0] ] ]);

    
while  frameJetDimension() < n+s  do 
	pr_Vessiot_frame_data() 
od; 

newbiform:

end:

#======================================================

vol_biform := proc()
#CLASS I PROGRAM
#06/16/92 CH
#07/07/97 CM
#12/13/02 IA

#vol_biform:: returns full degree biform in the independent
#variables with coefficient 1.

local n, i, newbiform,c;

optionalFrameChange([args],1):      

if  nargs>0 then  
	c:=args[1] 
else 	c:=1
fi:

n := frameBaseDimension();

newbiform := _VESSIOT([ [biform, _Vessiot_current_frame_name, [n,0]], [[[i $ i=1..n], c]] ]);


newbiform;

end:

#======================================================= 




generate_forms_in_degree:=proc(p,formList) 
#CLASS II PROGRAM
#10/29/05:IA

local C, ans,P,alpha,i,q;

q:=nops(formList);
C:=combinat[choose]([seq(i,i=1..q)],p);

ans:=[];

for P in C do
	alpha:=scalar_form();
	for i from 1 to p do
		alpha:=alpha &wedge formList[P[i]]
	od;
    ans:=[op(ans), alpha]; 
od;

ans;

end:

