#
#  TensorUtilities.utl
#
#

#
#  zero_tens,scalar_tens, tens
#





#---------------------------------------------------------







scalar_tensor:=proc()
# CLASS I PROGRAM
# 05/01/99:CH
# 01/04/03:IA     

# This routine creates a  rank zero  tensor i.e., a scalar. 
# optional args: a coefficient; a defined Vessiot frame name.

local ans,c,tens_attributes;

if nargs =0 then  
	c:=1 
else 
	c:=args[1] 
fi;

optionalFrameChange([args],1);

tens_attributes:=[tensor,_Vessiot_current_frame_name,[[],[]] ];
ans:=_VESSIOT([tens_attributes,[ [ [],c] ] ]);

VessiotPrompt();

ans;
end:


tens:=proc(a_variable::{algebraic,list[algebraic]},an_index)
#CLASS II Program
#06/01/97:CM
#01/04/03:IA

#    This routine creates a tensor  from  a variable in the
#    master list.
#
#    a_variable: a single variable in the master list or a list of such.
#    an_index: a single variable space or a list of such.
#    optional args: coordinate frame - a defined coordinate frame.


local ans, i,T, index_list, term, var_list;


if not type(a_variable,list) then 
	var_list:=[a_variable]
else
	var_list:=a_variable
fi;

if not type(an_index,list) then 
	index_list:=[an_index]
else
	index_list:=an_index
fi;

if nops(var_list) <> nops(index_list) then
	ERROR(cat("\n VESSIOT ERROR:",
                "\n the number of coordinate variables must equal the tensor types."))
fi;

for term in index_list do
	if not member(term,[con_bas,con_vrt,con_jet,con_usr,
	                    cov_bas,cov_vrt,cov_jet,cov_usr]) then
	ERROR(cat("\n VESSIOT ERROR:", 
		    "\n an unknown  tensor type", term,  "was specified."))
      fi;
od;

optionalFrameChange([args],2);

ans:=[];

for i from 1 to nops(var_list) do
	if  tensorIndexPart1(index_list)=`con` then
           	T:= convert(DifferentialGeometryTools:-Vect(var_list[i]),Vessiot_tensor,index_list[i]);
	     	ans:=[op(ans), T];
      
	elif tensorIndexPart1(index_list)=`cov` then
 		T:=convert(DifferentialGeometryTools:-Form(var_list[i]), Vessiot_tensor ,index_list[i]); 
		ans:=[op(ans), T]
	fi;
od;

if nops(ans)=1 then
       ans:=ans[1];
else
	ans:=v_zip(ans,tensor);
fi;

VessiotPrompt();

ans
        
end:

#------------------------------------------------

zero_tens := proc(tensor_type)

# CLASS I PROGRAM
# 07/07/97 CM
# 12/13/02 IA

#zero_tens:: returns zero tensor of specific type and coordinate system

local t_type, t_type_list, density_type ,comp, index_type;

density_type:=tensor_type[2];
index_type:= tensor_type[1];

optionalFrameChange([args],1):     

comp:= [];

for t_type in index_type do
	if t_type = con_bas or t_type = cov_bas or
        	t_type = con_jet or t_type = cov_jet 
	then
            comp := [op(comp), 1]
      else
            if t_type = con_vrt or t_type = cov_vrt then 
			comp:= [op(comp), frameBaseDimension() + 1]
     	else 
		if t_type=[] then 
		comp:=comp     
      else 
		ERROR(cat("\n VESSIOT ERROR:",
			    "\n Improper tensor index type specified"))
            fi; 
		fi;
        	fi;
od;

_VESSIOT([[tensor, _Vessiot_current_frame_name,tensor_type], [[comp, 0]]])
end:

