#
# LieAlg_frame_derivatives
#
# LieAlg_frame
#
# ext_d; Lie0; Lie_form; Lie_biform; Lie_bracket; vect; form; 
# assign_vect_type; pr_vect; pullback_form; biform_to_form
#
#
#

ext_d := proc(expr,flag)
#CLASS I PROGRAM
#12/29/02:IA    
       
local d_ans,fr;

fr:=_Vessiot_current_frame_name;

if flag = 'coeff' then
         d_ans := _VESSIOT([[form,_Vessiot_current_frame_name,1], [ [[1],0] ]] );

fi;



if flag='bftv' then 
d_ans:= _Vessiot_frame_data[fr][3][1][expr]
fi;


d_ans:
end:

#--------------------------------------------

Lie0:=proc(v,exp) 0 end;
#CLASS I PROGRAM
#12/29/02:IA    

#--------------------------------------------

Lie_form:=proc(expr, flag,v)
#CLASS I PROGRAM
#12/29/02:IA    

local d_ans,fr;

fr:=_Vessiot_current_frame_name;

if flag = 'coeff' then
         d_ans := _VESSIOT([[form,_Vessiot_current_frame_name,0], [ [[],0] ]]) ;
fi;

if flag='bftv' then 
d_ans:=  HOOK[form,deriv](v, _Vessiot_frame_data[fr][3][1][expr])
fi;

d_ans:

end:

#--------------------------------------------


Lie_biform:=proc(expr, flag,v)
#CLASS I PROGRAM
#12/29/02:IA    

local d_ans,fr;

fr:=_Vessiot_current_frame_name;

if flag = 'coeff' then
         d_ans := _VESSIOT([[form,_Vessiot_current_frame_name,[0,0]], [ [[],0] ]]) ;

fi;

if flag='bftv' then 
d_ans:=  form_to_biform(hook(v, _Vessiot_frame_data[fr][3][1][expr]),[0,1]);

fi;


d_ans:

end:

#--------------------------------------------

Lie_bracket:=proc(v, w)
#CLASS I PROGRAM
#12/29/02:IA    
local X,i, c,fr,n,term1, term2;

fr:=_Vessiot_current_frame_name;
n:=frameBaseDimension();

X:=DifferentialGeometryTools:-zero_vect();

for term1 in op(v)[2] do 
for term2 in op(w)[2] do

X:=DiffGeomMain:-Plus(X ,   
DiffGeomMain:-Mult( (term1[2]*term2[2]) , _Vessiot_frame_data[fr][5][term1[1][1], term2[1][1] ]))
od; 
od;

helmsimp(X);
end:

#-------------------------------------------

assign_vect_type:= proc(v)  
#CLASS I PROGRAM
#12/29/02:IA    
local w;  
w:=op(v); 
w[1][3]:=[projectable,0]; 
_VESSIOT(w); 

end:

#------------------------------------------


Lie_tens :=proc() vst_euc[Lie_tens](args) end:
#-----------------------------------------

indet_helmlist:=proc() vst_euc[indet_helmlist](args) end:

#------------------------------

vect:=proc() vst_euc[vect](args) end:

#-------------------------------------------

pr_vect:= proc(v)  v end;

#-----------------------------------------

form:=proc() vst_euc[form](args) end:

#-----------------------------------------

biform:=proc() vst_euc[biform](args) end:

#----------------------------------------

biform_to_form:=proc() vst_euc[biform_to_form](args) end:

#------------------------------------------

pt_pushforward:=proc () vst_euc[pt_pushforward](args) end:

#

pullback_form:=proc(term,flag,phi)
#CLASS I PROGRAM
#12/29/02:IA    
local ans,index,c,i,n;

n:=frameBaseDimension();

# pullback applied to coefficients.

if nargs > 1 and args[2] =`coeff` then
	ans :=  [[form,_Vessiot_current_frame_name,0], [ [[],term] ]] ;


# pullback applied to differentials.

elif type(term,integer) then
	ans := DifferentialGeometryTools:-zero_form(1);
      
	for i from 1 to n do 
       	c:=diff(op(phi)[2][term][1],cat(z,i));
       	ans:=DiffGeomMain:-Plus(ans, 
		     DiffGeomMain:-Mult(c ,DifferentialGeometryTools:-Form(cat(z,i))) )
      od;
      
	ans;
fi;

ans

end:

#--------------------------------------------

project:=proc() vst_euc[project](args) end:

#---------------------------------------------

show_helm_map:=proc() vst_euc[show_helm_map](args) end;

#---------------------------------------------

assign_transform_type:=proc() vst_euc[assign_transform_type](args) end;

#--------------------------------------------

show_vect:=proc(fm)
#CLASS I PROGRAM
#12/29/02:IA     
local i,j,l, q,dum,ans,fr;
 
fr:=_Vessiot_current_frame_name:
dum:= helmsimp(fm);
 
 
ans:=[seq(dum[2][i][2]*reconstructVariableName(frameLabels()[dum[2][i][1][1]]),
i=1..nops(dum[2]))];
 
(add(l,l=ans));

end:

#------------------------------------------- 

show_form:=proc(fm)
#CLASS I PROGRAM
#12/29/02:IA     
local i,j,l, q,dum,ans,fr;
 
fr:=_Vessiot_current_frame_name:
dum:= helmsimp(fm);


q:=dum[1][3];
 	
if q = 0 then 
 		ans:=dum[2,1,2];
 
       elif q=1 then 
 	ans:=[seq(dum[2][i][2]*
reconstructVariableName(coframeLabels()[dum[2][i][1][1]]),
i=1..nops(dum[2]))];
 
 	elif q > 1 then 
 		ans:=[seq(dum[2][i][2]*w(seq(
        reconstructVariableName(coframeLabels()[dum[2][i][1][1]]),j =1..dum[1][3])),	i=1..nops(dum[2]))];

fi;
 	RETURN(add(l,l=ans));
end;
#-------------------------------------



push_pull_tensor:=proc(term,flag,phi,psi)

local eqn_list, ans, index,C,T,S;
        

if flag= `coeff` 
then 
    C:=pullback(psi,term);
    ans:=scalar_tensor(C,transformDomain(psi)[1]);
    RETURN(ans);
fi;

if  tensorIndexPart1(flag) = con 
then 
      T:=frameJetVectors(transformDomain(phi)[1])[term];
      S:=pt_pushforward(phi,T);
      ans:=convert(S,Vessiot_tensor);
      RETURN(ans);
fi;


if tensorIndexPart1(flag) = cov 
then 
	T:=frameJetForms(transformDomain(phi)[1])[term];
      S:=pullback(psi,T);
      ans:=convert(S,Vessiot_tensor);
     RETURN(ans)
fi;




end:




#-------------------------------------------

show_tensor:=proc(fm)
#CLASS I PROGRAM
#12/29/02:IA    

local i,j,l, q,dum,ans,fr,v,cv;
 
fr:=_Vessiot_current_frame_name:
dum:= helmsimp(fm);

##
cv:=proc(t) local p;

if substring(t,1..3)= con then p:=5 fi;

if substring(t,1..3)= cov then p:=6 fi;

p;
end:
##

q:=dum[1][3];
 	
if nops(q) = 1 then 
 		ans:=dum[2,1,2];
 
       elif nops(q)=2 then 
 	ans:=[seq(dum[2][i][2]*
convert(_Vessiot_frame_data[fr][1][4][cv(dum[1][3][1])][dum[2][i][1][1]][1],name),
i=1..nops(dum[2]))];
 
 	elif nops(q) > 2 then 
 		ans:=[seq(dum[2][i][2]*t(seq
        (convert(_Vessiot_frame_data[fr][1][4][cv(dum[1][3][j])][dum[2][i][1][j]][1],name),
       j =1..nops(q)-1)),	i=1..nops(dum[2]))];

fi;
 	RETURN(add(l,l=ans));
end:

#************************************************