#  D.euc 
#
#  vst_euc
#
#  dV; dH; ext_d;
#
#  


dV := proc(expr,flag)
#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

local dV_form, term, varlist, new_varlist;

#ERROR STATEMENTS

dV_form := [];

#If statement to determine if expr should be treated as a coefficient,
# independent variable or a dependent variable.

#coordinate[dV] will be called repeatedly from antiderv as it works on each
# part of the biform called by Vessiot[dV].

if flag= 'coeff' then

# Coefficient code:

varlist := indet_helmlist(expr);
	if varlist = {} then
      	dV_form := DifferentialGeometryTools:-zero_biform([0,1], _Vessiot_current_frame_name)
      else
          	new_varlist := varlist minus {op(frameIndependentVariables())};
          		for term in new_varlist do
                		dV_form := [op(dV_form), [[tuple_to_index(term)],
                                                diff(expr, term)]]
           		od;
          	dV_form := _VESSIOT([[biform, _Vessiot_current_frame_name, [0,1]], dV_form]);
         fi;

elif flag='bftv' then
	if expr <= frameBaseDimension() then

#Independent variable code:
		dV_form := DifferentialGeometryTools:-zero_biform([1,1], _Vessiot_current_frame_name)
      else

# Dependent variable code:
		dV_form := DifferentialGeometryTools:-zero_biform([0,2], _Vessiot_current_frame_name)
      fi

else
          
ERROR(`VESSIOT ERROR: insufficient input`)
fi;

dV_form

end:

# ----------------------------------------

dH := proc(expr,flag)
#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

local dH_form, i, tuple;

dH_form := [];

#If statement to determine if expr should be treated as a coefficient,
# independent variable or a dependent variable.

#coordinate[dH] will be called repeatedly from antiderv as it works on each
# part of the biform called by Vessiot[dH].

#Coefficient code:

if flag = 'coeff' then
	for i from 1 by 1 to frameBaseDimension() do
		dH_form := [op(dH_form), [[i], td(expr,i)]]
      od;
	dH_form := _VESSIOT([[biform, _Vessiot_current_frame_name, [1,0]], dH_form])

elif flag='bftv' then

#Dependent variable code

if expr > frameBaseDimension() then
	tuple := index_to_jet_variable(expr);
		for i from 1 by 1 to frameBaseDimension() do
            	dH_form := [op(dH_form),
                             [[i,tuple_to_index(ldiff(tuple,i))],1]]
            od;
            dH_form :=_VESSIOT([[biform, _Vessiot_current_frame_name, [1,1]], dH_form])

#Independent variable code:

else
	dH_form := DifferentialGeometryTools:-zero_biform([2,0])
fi

else
ERROR(`VESSIOT ERROR: insufficient input`)
fi;

dH_form
end:

#------------------------------------------------------------

ext_d := proc(expr,flag)
#CLASS I PROGRAM
#08/26/91:CH
#12/13/02:IA

local d_ans, d_list, term, varlist;

#ERROR STATEMENTS

        d_list := [];

#If statement to determine if expr should be treated as a coefficient,
# independent variable or a dependent variable.

#coordinate[d] will be called repeatedly from antiderv as it works on each
# part of the biform called by Vessiot[d].

#Coefficent code:

        if flag = 'coeff' then
          varlist := indet_helmlist(expr);
          for term in varlist do
                d_list := [op(d_list), [[tuple_to_index(term)],
                                                diff(expr, term)]]
           od;
          if d_list <> [] then
          d_ans := _VESSIOT([[form, _Vessiot_current_frame_name, 1], d_list])
          else
          d_ans := DifferentialGeometryTools:-zero_form(1)
          fi;

elif flag='bftv' then


#Independent variable code:
#Dependent variable code:

           d_ans := DifferentialGeometryTools:-zero_form(2)

        else
          ERROR(`VESSIOT ERROR: insufficient input`)
        fi;

        d_ans
end:


#************************************************
