#
# Eulerlag.euc 
# 
# vst_euc
#
# EL0; EL_form
#


EL0 := proc(expr, component_list)
#CLASS II PROGRAM
#06/09/92:CH
#12/13/02:IA

local temp, term, ans, tlist, sum,
         L_v, L_var_set;

# Creats list of dependent variables found in expr.

L_var_set := indet_helmlist(expr) minus {op(frameIndependentVariables())};
ans := [];

for term in component_list do

# Find the subset of L_var_set that is dependent on term.
# and compute its Euler contribution.

	temp :=0;
      for L_v in L_var_set do
                   if op(0,L_v) = term then
 
                  jet_var:=index_to_jet_variable(tuple_to_index(L_v));
           		tlist := [op(jet_var)];
           		sum := convert(tlist,`+`);
           		temp:= temp+ (-1)^sum*td(diff(expr,L_v), tlist)
                  fi;
	od;

      ans := [op(ans), temp]
od;

ans
end:

#------------------------------------------------------------

EL_form := proc(bform)
#CLASS II PROGRAM
#06/09/92:CH
#12/13/02:IA

local expr,ans, ELequa, i, tlist, newform,n,m;

VessiotFrameCheck(bform):

if (objectAttributes(bform) <> 
   [biform, _Vessiot_current_frame_name, [frameBaseDimension(),0]]) 
   then 
 	ERROR(`VESSIOT ERROR: EL_form acts on biform of type (base dimension,0)`)
fi;

expr := objectComponents(bform)[1][2];

n:=frameBaseDimension();
m:=frameFiberDimension();

ELequa := Euler_Lagrange(expr);

ans:=v_zip(ELequa,[seq(DifferentialGeometryTools:-Biform(i),i=n+1..n+m)],plus):

DiffGeomMain:-Wedge(ans, DifferentialGeometryTools:-vol_biform());

end:


#*****************************
