#
#  Homotopy.euc 
#
#  vst_euc
#
#  hdV; homo_d; hdH0; hdH, total_interior_product0;
#  
#

























hdV := proc(bform,int_parameters)
#CLASS II PROGRAM
#06/16/99
#12/17/02:IA

local varset,bot_limit_int,top_limit_int,index,vars,
	init_pt,init_pt_array,init_value,i, term, 
	line_segment_pt_array,	tempform,  helm_t2, R, ans,M;

global helm_t;

if nargs=2 then
   	bot_limit_int:=int_parameters[1];
   	top_limit_int:=int_parameters[2];
   	init_pt:=int_parameters[3]  
else
	bot_limit_int:=0;
   	top_limit_int:=1;
   	init_pt:=[]; 

fi;

## Extend master_var_list to form order.


M:=objectOrder(bform):

while frameJetOrder() < M 
    	do pr_Vessiot_frame_data()
	od;

## Create master_list for initial point

init_pt_array:=array(1..frameJetDimension(),sparse);

for term in init_pt do
	index:=tuple_to_index(lhs(term));
	init_value:=rhs(term);
	init_pt_array[index]:=init_value;
od;


vars:=indet_helmlist(coeff_set(bform)) minus {op(frameIndependentVariables() )};

## Creates a newform = bform(x,t*u +(1-t)u_0)

tempform := bform;

for term  in vars do
  	tempform := subs(term=helm_t*term+(1-helm_t)*
	init_pt_array[tuple_to_index(term)], tempform)
od;


## Create vertical radial vector field centered at initial point

R:= DifferentialGeometryTools:-zero_vect([],_Vessiot_current_frame_name);

for term in frameJetVariables()  do
	if tuple_to_index(term) >frameBaseDimension() then
		R:=DiffGeomMain:-Plus(R, 
		   DiffGeomMain:-Mult(term - init_pt_array[tuple_to_index(term)], DifferentialGeometryTools:-Vect(term)));
	fi;
od;

R:=helmsimp(R);

tempform := vert_hook(R, tempform);


## integrates each new coefficient multiplied by helm_t^(s-1)
## with respect to the package variable helm_t.

ans := [];

helm_t2 := helm_t^(biformDegree(tempform)[2]);

for term in objectComponents(tempform) do
   	ans := [op(ans), [term[1], int(helm_t2*term[2], 
	helm_t=bot_limit_int..top_limit_int)]]
od;

ans := _VESSIOT([objectAttributes(tempform), ans]);

helmsimp(ans)

end:
## END hd




OLDCODEhomo_d := proc(forma,int_parameters)
#CLASS I PROGRAM
#06/16/99
#12/13/02:IA

local varset,bot_limit_int,top_limit_int,index,vars, varsR,Eq,solnR,formb,
  	init_pt,init_pt_array,init_value,i, term, 
	line_segment_pt_array,	tempform, helm_t2, R, ans,M;

global helm_t;

if nargs=2 then
   	bot_limit_int:=int_parameters[1];
   	top_limit_int:=int_parameters[2];
   	init_pt:=int_parameters[3]  
else
	bot_limit_int:=0;
   	top_limit_int:=1;
   	init_pt:=[]; 
fi;

## Extend master_var_list to form order.

M:=objectOrder(forma):

while frameJetOrder()< M
	do pr_Vessiot_frame_data()
od;

## Create master_list for initial point

init_pt_array:=array(1..frameJetDimension(),sparse);

for term in init_pt do
	index:=tuple_to_index(lhs(term));
	init_value:=rhs(term);
	init_pt_array[index]:=init_value;
od;



## Create radial vector field centered at initial point

varsR:=seq(cat(_a,i), i=1..nops(frameJetVariables() ) ) ;  

R:=v_zip([varsR],frameJetVectors(),plus);

Eq:=seq(Lie_derivative(R, frameJetVariables()[i]) = 
        frameJetVariables()[i] -init_pt_array[i], i=1..nops(frameJetVariables()) );
solnR:=solve({Eq},{varsR});

R:=helmsimp(subs(solnR,R));




formb := hook(R, forma);



vars:=indet_helmlist(coeff_set(formb));

## Creates a newform = forma(x,t*u +(1-t)u_0)

tempform := formb;

for term  in vars do
  	tempform := subs(term=helm_t*term+(1-helm_t)*
	init_pt_array[tuple_to_index(term)], tempform)
od;




## integrates each new coefficient multiplied by helm_t^(s-1)
## with respect to the package variable helm_t.

ans := [];

helm_t2 := helm_t^(formDegree(tempform)-1);

for term in objectComponents(tempform) do
   ans := [op(ans), [term[1], int(helm_t2*term[2], 
	helm_t=bot_limit_int..top_limit_int)]]
  od;


ans := _VESSIOT([objectAttributes(tempform), ans]);

helmsimp(ans)

end:


#--------------------------------------



hdH0 := proc(bform,int_parameters)
#CLASS II PROGRAM
#06/16/99
#12/13/02:

local temp;

temp:=ext_dV(bform);
temp:=vst_euc[hdH1](temp);

if nargs =2 then  
	temp:=vst_euc[hdV](temp, int_parameters) 
else
	temp:=vst_euc[hdV](temp)
fi;
 
(-1) &mult temp     

end:

#----------------------------------

total_interior_product0 := proc(vectr, bform)

#CLASS I PROGRAM
#December 13,2002:IA

local newform, H_EL, term, newvect, K1, K2, i,r, tuple, terma,
      depvar, alpha, tlist, k, inner_coeff, const, newterm;

#ERROR STATEMENTS ...

for term in objectComponents(vectr) do
   	if term[1][1] <= frameBaseDimension()
    	or term[1][1] > frameBaseDimension()+frameFiberDimension() then
    		ERROR(`VESSIOT ERROR: vector must be a vertical on space of`.
		`independent and dependent variables.`)
    	fi
od;

if biformDegree(bform)[1] < 1 then
    ERROR(`VESSIOT ERROR: form must have positive horizontal degree.`)
fi;
##

newform := DifferentialGeometryTools:-zero_biform([ biformDegree(bform)[1] -1, 0]);

for term in objectComponents(bform) do
	H_EL := higher_EL0(term[2]);
	for terma in vectr[2] do
    		newvect[terma[1][1]-frameBaseDimension()] := terma[2]
  	od;
	
	K1 := functionOrder(term[2])-1;

  	if K1 < 0 then
    		K2 := 0
  	else
    	K2 := tuple_to_index(frameDependentVariables()[frameFiberDimension()]
			[0$frameBaseDimension()-1,K1])
  	fi;

  	for i from frameBaseDimension() +1 to K2 do
    		tuple := index_to_jet_variable(i);
    		depvar := op(0, tuple);
    		member(depvar, frameDependentVariables(), 'alpha');
    		tlist := [op(tuple)];

    		for k from 1 to frameBaseDimension() do
      	inner_coeff := H_EL[tuple_to_index(ldiff(tuple,k))] * newvect[alpha];
      	inner_coeff := td(inner_coeff, tlist);
      	r:=biformDegree(bform)[1];
		const := (tlist[k]+1)/(frameBaseDimension()-r+convert(tlist,`+`)+1);
      	inner_coeff := const * inner_coeff;
      	newterm := mono_hook([[k],1], [term[1], inner_coeff]);
      	newform := DiffGeomMain:-Plus( newform ,   _VESSIOT([newform[1], [newterm]]));
	od

od

od;

helmsimp(newform)

end:

#-------------------------------------

hdH1 := proc(bform)
#CLASS II PROGRAM
#06/16/99
#12/13/02:IA


local newform, H_EL, K1, K2, i, tuple, depvar, alpha, tlist, k,
    	temp_vect, newterm, const, r,s,temp_form;

newform := DifferentialGeometryTools:-zero_biform(biformDegree(bform)-[1,0]);

H_EL := JetCalc:-higher_hook_EL(bform);

K1 := objectOrder(bform) - 1;

if K1 < 0 then 
	K2 := 0
else
  	K2 := tuple_to_index(frameDependentVariables()
		[frameFiberDimension()][0$frameBaseDimension()-1,K1])
fi;

for i from frameBaseDimension()+1 to K2 do
  	tuple := index_to_jet_variable(i);
  	depvar := op(0, tuple);
  	member(depvar, frameDependentVariables(), 'alpha');
  	tlist := [op(tuple)];

  	for k from 1 to frameBaseDimension() do
    		temp_form := H_EL[tuple_to_index(ldiff(tuple,k))];
    		if objectComponents(temp_form)[1][2] <> 0 then
      		temp_vect := total(DifferentialGeometryTools:-Vect(frameIndependentVariables()[k]));
      		newterm := total_hook(temp_vect, temp_form);
			r:=biformDegree(bform)[1]; 
			s:=biformDegree(bform)[2];
      		const := -(tlist[k]+1)/s/(frameBaseDimension()-r+convert(tlist,`+`)+1);
      		temp_form := DifferentialGeometryTools:-Biform(frameBaseDimension()+alpha);
      		newterm := DiffGeomMain:-Mult(const,  DiffGeomMain:-Wedge(temp_form ,newterm)   );
      		newterm := td(newterm, tlist);
      		newform :=DiffGeomMain:-Plus(newform , newterm);
    		fi
  	od
 od;

 helmsimp(newform)

 end:

#************************************************
