# 
# Lie.euc 
#
# vst_euc
#
# Lie0,Lie_bracket; gen_Lie_bracket
#
# Lie_form; Lie_biform; Lie_vert; Lie_total
#
#


Lie0 := proc(vectr, expr)        
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA         

local ans, term;

ans := 0;

for term in op(vectr)[2] do
	ans := ans + term[2]*diff(expr, index_to_jet_label(term[1][1]))
od;

_Vessiot_simplify(ans)
end:

#----------------------------------

Lie_bracket := proc(vec1, vec2)
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA         
        
local ans, term;

ans := [];

for term in op(vec2)[2] do
	ans := [op(ans), [term[1], Lie0(vec1, term[2])]]
od;

for term in op(vec1)[2] do
      ans := [op(ans), [term[1], -Lie0(vec2, term[2])]]
od;

ans := _VESSIOT([[vect, _Vessiot_current_frame_name,[]], ans]);

helmsimp(ans)

end:

#-----------------------------------------------

gen_Lie_bracket := proc(vec1, vec2)
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA 
        
local ans, term, v1, v2;

v1 := pr_vect(vec1, objectOrder(vec2));
v2 := pr_vect(vec2, objectOrder(vec1));

ans:=[];

for term in op(vec2)[2]do
	ans := [op(ans), [term[1], Lie0(v1, term[2])]]
od;

for term in op(vec1)[2] do
	ans := [op(ans), [term[1], -Lie0(v2, term[2])]]
        od;

ans := _VESSIOT([[vect, _Vessiot_current_frame_name,[generalized,0]], ans]);
        
helmsimp(ans)
end:

#---------------------------------------------

Lie_form := proc(expr,flag,vec)
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA         

local vectr, i, ans, vars, v,Lie_f;

vectr:=op(vec)[2]; 

if flag='bftv' then
	i:=1;
	while (i<nops(vectr)) and (vectr[i][1][1] < expr) do i:=i+1  
		od;

      if vectr[i][1][1] = expr then
           	ans := [];
    	    	vars := indet_helmlist(vectr[i][2]);
    		
		for v in vars do
        		ans := [op(ans), [[tuple_to_index(v)], diff(vectr[i][2], v)]]
    		od;
    		
		Lie_f:=_VESSIOT([[form, _Vessiot_current_frame_name, 1], ans])
      else
           	Lie_f := DifferentialGeometryTools:-zero_form(1)
      fi;

elif  flag='coeff'  then
       ans:= [[[], Lie0(vec, expr)] ];
       Lie_f:=_VESSIOT([[biform, _Vessiot_current_frame_name,0], ans])

else
	ERROR(`VESSIOT ERROR: insufficient input`)
fi;

Lie_f
end:

#----------------------------------------

Lie_biform := proc(expr,flag,vec)
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA 

local   i, formlist, ans, v,vars, dtype, temp_form, Lie_form,vectr,
        biform_attributes, biform_component;
        
vectr:=op(vec)[2]:

if flag = `coeff` then
       ans:= [ [[], Lie0(vec, expr)] ];
       Lie_form:=_VESSIOT([[biform, _Vessiot_current_frame_name,[0,0]], ans])

elif flag='bftv' then
	i := 1;

      while  (i < nops(vectr)) and(vectr[i][1][1] < expr) do
      	i := i+1 
	od;      
			
      if vectr[i][1][1] = expr  then 
		if expr <= frameBaseDimension()  then
            	ans:=[];
    	    		vars := indet_helmlist(vectr[i][2]);
    		
			for v in vars do
        			ans := [op(ans), [[tuple_to_index(v)], diff(vectr[i][2], v)]]
    			od; 

			Lie_form:=_VESSIOT([[biform, _Vessiot_current_frame_name,[1,0]], ans])

            else   
			ans:=[];
    	    		vars := indet_helmlist(vectr[i][2]) minus {op(frameIndependentVariables())};
    		
			for v in vars do
        			ans := [op(ans), [[tuple_to_index(v)], diff(vectr[i][2], v)]]
    			od; 

			Lie_form:=_VESSIOT([[biform, _Vessiot_current_frame_name,[0,1]], ans])
            fi;


      elif  expr <= frameBaseDimension()  then 
                  Lie_form:=DifferentialGeometryTools:-zero_biform([1,0]);
            else 
			Lie_form:=DifferentialGeometryTools:-zero_biform([0,1]);
      fi;
      
else      
ERROR(`VESSIOT ERROR: input not of correct type`)
fi;

Lie_form
end:

#---------------------------------

Lie_vert := proc(expr,flag,vec)
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA 

local  ans,v,vars, Lie_form, i, temp, vectr, biform_attributes, biform_component;

vectr:=op(vec)[2];

if flag = `coeff`  then
       ans:= [ [[],Lie0(vec, expr)] ];
       Lie_form:= _VESSIOT([[biform, _Vessiot_current_frame_name,[0,0]], ans])
fi;

if flag='bftv' then
      if expr <= frameBaseDimension() then
            Lie_form := DifferentialGeometryTools:-zero_biform([1,0], _Vessiot_current_frame_name)
      else
            i := 1;
            while (i < nops(vectr)) and (vectr[i][1][1] < expr) do
            	i := i+1 
		od;
		
		if vectr[i][1][1] = expr then

            	ans:=[];
    	    		vars := indet_helmlist(vectr[i][2]) minus {op(frameIndependentVariables())};
    		
			for v in vars do
        			ans := [op(ans), [[tuple_to_index(v)], diff(vectr[i][2], v)]]
    			od; 

			Lie_form:=_VESSIOT([[biform, _Vessiot_current_frame_name,[0,1]], ans])
            else
              	Lie_form := DifferentialGeometryTools:-zero_biform([0,1], _Vessiot_current_frame_name)
            fi
      fi
fi;

Lie_form
end:

#-------------------------------------------

Lie_total:=proc(expr,flag,vec)
#CLASS I PROGRAM
#08/26/1991:CH
#12/17/2002:IA     

local   Lie_form, i,j, v, input_form,  term, ans,  newvar, vectr;

vectr:=op(vec)[2]:

if  flag = `coeff` then
       ans:= [[[],Lie0(vec, expr)]];
       Lie_form:= _VESSIOT([[biform, _Vessiot_current_frame_name,[0,0]], ans])
fi;

if flag= 'bftv' then
	if expr<=frameBaseDimension() then
      	i:=1;
            while  (vectr[i][1][1] <expr) do 
			i:=i+1 
		od;
            ans:=[];
            for j from 1 by 1 to frameBaseDimension() do
			ans := [op(ans), [[j], td(vectr[i][2], j)]]
      	od;
		Lie_form := _VESSIOT([[biform, _Vessiot_current_frame_name, [1,0]], ans])

      else
            v:=index_to_jet_variable(expr);    
            
            Lie_form:=
		_VESSIOT([[biform,_Vessiot_current_frame_name,[0,1]],[[[frameBaseDimension() +1],0]]]);
            for term in vectr do
            	if term[1][1] <=frameBaseDimension() then
                  	j:=term[1][1];
                        newvar := op(0,v)[op(1 .. j-1,v),
                              op(j,v)+1,op(j+1 .. frameBaseDimension(),v)] ;
                  	Lie_form:=DiffGeomMain:-Plus(Lie_form, 
                                  DiffGeomMain:-Mult(term[2], biform(newvar)))
                  fi
            od
      fi
fi;

Lie_form
end:

#------------------------------------------


Lie_tens:=proc(term,flag,X)

local ans,Y,Z, alpha,t,comp,termX,termN;

if flag = `coeff` 
	then 
      comp:=[ [ [], Lie_derivative(X,term)] ];
      ans:=_VESSIOT([[tensor,_Vessiot_current_frame_name,[[],[] ]],  comp ]);   
	RETURN(ans) 
fi;


if tensorIndexPart1(flag)= 'con'  
	then
#     code this from scratch for eff. 

      Y:=DifferentialGeometryTools:-Vect(term);
      ans:=Lie_bracket(X,Y);
      ans:=convert(ans,Vessiot_tensor);
	RETURN(ans);
fi;

if tensorIndexPart1(flag)= 'cov'  then
#     code this from scratch for eff.
	
      alpha:=DifferentialGeometryTools:-Form(term);
      ans:=Lie_derivative(X,alpha);
	ans:=convert(ans,Vessiot_tensor);
      RETURN(ans)

fi;

end:


#***************************
