# 
# pr_transform.euc
#
# Vessiot 
#
# assign_transform_type; pr_transform;
# 
#

assign_transform_type:= proc(a_map) 
#CLASS I PROGRAM
#12/17/2002:IA   

local i,domain_name, domain_order,  domain_base_dim, domain_fiber_dim,
      range_name,range_order ,range_base_dim, range_fiber_dim, 
      new_attributes,theta,new_theta, phi, Id, indep_var_set, var_set,Z_matrix; 



if transformType(a_map) <>[] then  RETURN(a_map) fi;

domain_name:= transformDomain(a_map)[1];
domain_order:=transformDomain(a_map)[2];

domain_base_dim:=frameBaseDimension(domain_name);
domain_fiber_dim:=frameFiberDimension(domain_name);

range_name:= transformRange(a_map)[1];
range_order:=transformRange(a_map)[2];

range_base_dim:=frameBaseDimension(range_name);
range_fiber_dim:=frameFiberDimension(range_name);

new_attributes:=objectAttributes(a_map);
new_attributes[3]:=[generic, NA];

Id:=LinearAlgebra[IdentityMatrix](domain_base_dim);
Z_matrix:=Matrix(domain_base_dim,domain_base_dim,0);
# test contact

if  domain_order =1 and range_order=1  then
	if domain_fiber_dim =1 and  range_fiber_dim =1 then   
		if domain_base_dim= range_base_dim  then
            	change_frame_to(range_name);
			theta:= convert(DifferentialGeometryTools:-Biform(range_base_dim+1),Vessiot_form );
                  new_theta:=convert(pullback_form(a_map,theta),Vessiot_biform,[1,0]);
			if coeff_set(new_theta) ={0} then 
                  	new_attributes[3]:=[contact,1]; 
                  fi;
            fi;
      fi;
fi;

# test for differential substitution

if range_order=0 then 
	new_attributes[3]:=[gen_diff_subs,0];
	if domain_base_dim = range_base_dim 
	and  LinearAlgebra[Equal](eval(total_Jacobian(a_map) -Id),Z_matrix) then
		new_attributes[3]:=[diff_subs,0]
	fi;   
fi;

# test for point and  projectable

if domain_order=0 and range_order=0  then 
	new_attributes[3]:=[point,0]; 
	indep_var_set:=convert(frameIndependentVariables(domain_name),set); 
	var_set:={seq(op(indet_helmlist(objectComponents(a_map)[i][1],domain_name)),
	          i=1..range_base_dim)}; 
	if var_set minus indep_var_set= {} then 
		new_attributes[3]:=[projectable,0]   
	fi ;
fi;    

phi_temp:=_VESSIOT([new_attributes, objectComponents(a_map)]);

J:=JacobianMatrix(phi_temp);

_VESSIOT([[op(new_attributes), [eval(J)]], objectComponents(a_map)]);


end: 

#----------------------------------------------------

pr_transform := proc(phi,pr_order)
#CLASS II PROGRAM
#12/17/2002:IA   

local i, domain_name, domain_order, domain_index, range_name,range_order ,
	range_index, d_var, diff_var_index, eqn_list, first_index,  index, 
	inv_jacob, last_index , new_map, new_var, order_index,
      prev_var, temp, var,st,a_map;

a_map:=op(phi):

change_frame_to(a_map[1][2][2][1]);

if nargs=3 then 
	inv_jacob:=args[3]
elif nargs=2 
	then inv_jacob:=LinearAlgebra[MatrixInverse](JetCalcTools:-
total_Jacobian(phi));
      change_frame_to(a_map[1][2][2][1]);
fi;

        
domain_name:=a_map[1][2][1][1];
domain_order:=a_map[1][2][1][2];

range_name:=a_map[1][2][2][1];
range_order:=a_map[1][2][2][2];

eqn_list:=[seq(a_map[2][i][2]=a_map[2][i][1],i=1..nops(a_map[2]))];

first_index:=jet_space_dim(range_order,range_name) +1;
last_index:=jet_space_dim(range_order + pr_order,range_name);

for order_index from first_index to last_index do
	var:=index_to_jet_variable(order_index);
      for index from 1 to frameBaseDimension() do
      	if op(index,var)>0 then
            	prev_var:=op(0,var)[op(1..index-1,var),op(index,var)-1,
              	op(index+1..frameBaseDimension(),var)];
              	diff_var_index:=index;
              	index:=frameBaseDimension()
            fi;
      od;

      prev_var:=subs(eqn_list,prev_var);
      change_frame_to(a_map[1][2][1][1]);
      new_var:=[];
       
	for index from 1 to frameBaseDimension() do
            
            new_var:=[op(new_var), td(prev_var,index)]
      od;
          
	temp:=[];
      for index from 1 to nops(frameIndependentVariables())do
            temp:=[op(temp),inv_jacob[index,diff_var_index]]
      od;
      
	new_var:=sum(temp['k']*new_var['k'],'k'=1..nops(frameIndependentVariables()));
      eqn_list:=[op(eqn_list),var=new_var];
      change_frame_to(a_map[1][2][2][1]);

od;

new_map:=op(transform(a_map[1][2][1][1],a_map[1][2][2][1],eqn_list));

new_map:=_VESSIOT([[op(1..2,new_map[1]),[a_map[1][3][1], pr_order],new_map[1][4] ],op(2,new_map)]);

new_map:=_Vessiot_simplify(new_map);



new_map

end:

