# 
# pr_vect.euc
#
# vst_euc
#
# assign_vect_type; pr_vect; 
#
#


assign_vect_type:=proc(vectr) 
# CLASS I PROGRAM
# 12/13/02:IA       

local first_component_index,last_component_index, 
new_attributes,temp,var, order_v,indep_var_set,term,contact_form;

if vectorType(vectr) <> [] then RETURN(vectr) fi;


new_attributes:=op(vectr)[1];

new_attributes[3]:=[generic,objectOrder(vectr)];

first_component_index:=op(vectr)[2][1][1][1];
last_component_index :=op(vectr)[2][-1][1][1];
order_v:=objectOrder(vectr);

# test contact 	

if   frameFiberDimension()=1 
and  
	last_component_index <= 2*frameBaseDimension() +1  
then 
	var:= frameJetVariables()[frameBaseDimension()+1]:
	contact_form:=convert(DifferentialGeometryTools:-Biform(var),Vessiot_form); 
	temp:=Lie_derivative(vectr,contact_form);
	temp:=coeff_set(convert(temp,Vessiot_biform,[1,0])      );
      if temp ={0} then 
		new_attributes[3]:=[contact,1];
	fi;
fi;

# test generalized and  evol

if 	last_component_index <= frameBaseDimension() + frameFiberDimension() 
and 	
	order_v>0 
then 
	new_attributes[3]:=[generalized,0];
	if first_component_index>frameBaseDimension()then 
		new_attributes[3]:=[evol,0];
      fi;
fi;

# test point and fiber preserving
 
if order_v=0 then 
	new_attributes[3]:=[point,0];
 	
#  test for fiber-preserving
	
	temp:={};
	indep_var_set:= convert(frameIndependentVariables(),set);
	for term in op(vectr)[2] do 
	if  term[1][1] >  frameBaseDimension() then 
		break
      fi;

	temp:= indet_helmlist(term[2]) minus indep_var_set;
	od;

	if temp ={} then 
		new_attributes[3]:=[projectable,0]; 
	fi;
fi;

makeVessiotObject(new_attributes, objectComponents(vectr))

end:

#--------------------------------------------------------

pr_vect := proc(vectr, k)
# CLASS I PROGRAM
# 08/26/91:CH
# 12/13/02:IA       

#This program contains pr for the coordinate frame.

local term, ans, TDA, i, pr_coeff, newcoeff, v, j,
      diffnum, index, minindex, prol_ord, vec,maxindex ,attributes,v0;

              
prol_ord:=vectorType(vectr)[2];
       
if    prol_ord>=k then
      RETURN(vectr)
fi; 


TDA := array(1..frameBaseDimension(), 1..frameBaseDimension(), sparse);

for term in objectComponents(vectr) do
	if term[1][1] <= frameBaseDimension()  then
      	for i from 1 by 1 to frameBaseDimension() do
                  TDA[term[1][1], i] := td(term[2], i)
            od
	fi
od;
        
minindex:=jet_space_dim(prol_ord):
maxindex := jet_space_dim(k):

pr_coeff := array(1..maxindex, sparse);

for term in objectComponents(vectr) do
	pr_coeff[term[1][1]] := term[2]
od;

#Actual Calculations.

ans:=op(vectr)[2]:

for j from  minindex+1 by 1 to maxindex do
        v0 := index_to_jet_variable(j);
        diffnum := 1;
        while op(diffnum,v0) = 0  
		do diffnum := diffnum+1  od;
        v := op(0,v0)[op(1..diffnum-1, v0), op(diffnum,v0)-1,
                        op(diffnum+1..frameBaseDimension(), v0)];
        index := tuple_to_index(v);

        newcoeff := td(pr_coeff[index], diffnum);

        for i from 1 by 1 to frameBaseDimension() do
                newcoeff := newcoeff - TDA[i,diffnum]*ldiff(v,i);
        od;

        pr_coeff[j] := newcoeff;

        ans := [op(ans), [[j],newcoeff]];;
od;

attributes:=[vect,objectFrame(vectr),[vectorType(vectr)[1],k]]; 

ans := _VESSIOT([attributes, ans]);

ans:=helmsimp(ans);

end:


#**********************************************
