# 
# Highel.jet
#
# JetCalc
#
# higher_EL0, higher_hook_EL
#

higher_EL0 := proc(expr::algebraic)
#CLASS II PROGRAM
#12/16/02:IA

local ans, ans2, helm_F, helm_f, helm_t, i, K1, K2, L_list,
              temp_eq, temp_var, temp_var2, term, tlist;

if nargs>1 then
   change_frame_to(args[2])
fi;

# Determine order of output:

K1 := functionOrder(expr);
tlist := 0$frameBaseDimension()-1, K1;
K2 := tuple_to_index(frameDependentVariables()
      [frameFiberDimension()][tlist]);

# Defining a dumby function:

helm_f := helm_F(op(frameIndependentVariables()), helm_t);

# Initilizing List of Euler Equations.

L_list := Euler_Lagrange(expr*helm_f);

if not(type(L_list,list))  then 
	L_list := [L_list] 
fi;

# Initializing answer array.

for i from 1 to K2 do
	ans[i] := 0
od;

for term in frameDependentVariables() do
	temp_eq := L_list[tuple_to_index(term[0$frameBaseDimension() ])-frameBaseDimension()];
	for i from frameBaseDimension()+1 to K2 do
            temp_var := index_to_jet_variable(i);
            if op(0, temp_var) = term then
       		tlist := [op(temp_var)];
        		temp_var2 := td(helm_f, tlist);
        		ans[i] := eval(subs(helm_f=0,subs(temp_var2=1, temp_eq)));
        		ans[i] := (-1)^convert(tlist, `+`) * ans[i]
          	fi;
      od;
od;

ans2 := [];

for i from 1 to K2 do
	ans2 := [op(ans2), ans[i]]
od;


ans2;
end:

#---------------------------------------------------------

higher_hook_EL := proc(bform0)
#CLASS I PROGRAM
#12/16/02:IA

local bform,ans, ans2, helm_F, helm_f, helm_t, i, j, K1, K2, K3,
              L_list, temp, temp_var, temp_var2, term, tlist,
              temp_attributes, temp_component;

bform:=evalV(bform0):

if type(bform,Vessiot_biform)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  higher_hook_EL requires arguement to be a biform:", 
		    "\n ",objectType(bfrom))); 
fi;

VessiotFrameCheck(bform);

if type(bform,Vessiot_biform)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  dH requires arguement to be a biform:", 
		    "\n ",objectType(bform))); 
fi;







# Determine order of output:

K1 := objectOrder(bform);
tlist := 0$frameBaseDimension()-1, K1;
K2 := tuple_to_index(frameDependentVariables()[frameFiberDimension()][tlist]);

# Defining a dumby function:

helm_f := helm_F(op(frameIndependentVariables()), helm_t);

# Initilizing List of Euler Equations.

L_list := JetCalcTools:-hook_EL(helm_f &mult bform);

# Initializing answer array.

for i from 1 to K2 do
	ans[i] := DifferentialGeometryTools:-zero_biform( biformDegree(bform) -[0,1]);
od;

# Actual calculations

for i from frameBaseDimension()+1 to K2 do
	temp_var := index_to_jet_variable(i);
      tlist := [op(temp_var)];
      K3 := convert(tlist, `+`);
      temp_var2 := td(helm_f, tlist);
      j := 1;
      while  frameDependentVariables()[j] <> op(0, temp_var) do
          j := j+ 1
      od;
      for term in objectComponents(L_list[j]) do
          	temp :=  eval(subs(helm_f=0,subs(temp_var2=1, term[2])));
          	if ans[i] <> 0 then
            temp_attributes:=objectAttributes(ans[i]);
            temp_component:=[term[1],(-1)^K3*temp]; 
            temp :=_VESSIOT([temp_attributes,[temp_component]]); 
            ans[i] := temp &plus ans[i];
          	fi;
      od;
od;

ans2 := [];

for i from 1 to K2 do
	ans2 := [op(ans2), ans[i]]
od;
ans2

end:

#************************************************
