#
# hook.jet
#
# JetCalc
#
# vert_hook, total_hook
#
#


vert_hook := proc(X0,forma0)
#CLASS I PROGRAM
#12/13/02:IA

#vert_hook:: `hooks` a vertical vector and a biform.

local X, omega, degree, newbiform, term1, term2,vectr,forma,biforma;

X:=evalV(X0);
forma:=evalV(forma0):

VessiotFrameCheck(X):

if type(X,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  vert_hook requires first arguement to be a vector field,", 
		    "\n ",objectType(X) )); 
fi;

if type(forma,Vessiot_biform)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  vert_hook requires second arguement to be a biform:",
		    "\n ",objectType(forma) )); 
fi;

if objectFrame(X) <> objectFrame(forma) then
	ERROR(cat("\n VESSIOT ERROR:", 
                "\n vector and form in different frames:",
		    "\n ", objectFrame(X), " , ",  objectFrame(forma) ))
fi;



vectr:=op(X);
biforma:=op(forma);

if biforma[1][3][2] <= 0 then
	ERROR(cat("\n VESSIOT ERROR:",  
                "\n input biform has zero vertical degree.") )
fi;

for term1 in vectr[2] do
	if term1[1][1] <= frameBaseDimension() then
      	ERROR(cat("\n VESSIOT ERROR:",
			"	\n vector is not vertical."))
      fi;
od;

newbiform := [];

for term1 in vectr[2] do
	for term2  in biforma[2] do
      	newbiform := [op(newbiform), mono_hook(term1, term2)]
      od;
od;

degree := [biforma[1][3][1], biforma[1][3][2] - 1];

newbiform := _VESSIOT([[op(1..2,biforma[1]),degree], newbiform]);
newbiform := helmsimp(newbiform);



newbiform
end:

#-------------------------------------------------

total_hook := proc(X0, omega0)
#CLASS I PROGRAM
#12/13/02:IA
        
#total_hook:: `hooks` a total vector and a biform.

local degree, newbiform, term1, term2,vectr,forma,biforma, X,omega;

X:=evalV(X0);
omega:=evalV(omega0);

VessiotFrameCheck(X):


if type(X,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  total_hook requires first arguement to be a vector field,", 
		    "\n ",objectType(X) )); 
fi;



if type(omega,Vessiot_biform)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  total_hook requires second arguement to a biform", 
		    "\n ",objectType(forma) )); 
fi;

if objectFrame(X) <> objectFrame(omega) then
	ERROR(cat("\n VESSIOT ERROR:", 
                "\n vector and form in different frames:\n ",
	           objectFrame(X), " , ",  objectFrame(forma) ))
fi;



vectr:=op(X);
biforma:=op(omega);
        
if  vectr[1][3]=[] or  vectr[1][3]<> [] and vectr[1][3][1]<>`tot` then
	ERROR(cat("\n VESSIOT ERROR:", 
		    "\n vector must be of type tot:", 
                "\n ",  convert(vectr[1][3],string) ) )
fi;           

if biforma[1][3][1] <= 0 then
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n Input biform has zero horizontal degree."))
fi;

newbiform := [];

for term1 in vectr[2] do 
	if term1[1][1] < frameBaseDimension()+1 then 
		for term2  in biforma[2] do
        	newbiform := [op(newbiform), mono_hook(term1, term2)]
          	od; 
	fi;
od;

degree := [biforma[1][3][1]-1, biforma[1][3][2]];

newbiform := _VESSIOT([[op(1..2,biforma[1]),degree], newbiform]);
newbiform := helmsimp(newbiform);



newbiform;
end:

#********************************************************