#  
#  JetCalcConvert
#
# JetCalc
#
# diff_to_jet; jet_to_diff; 
#



#-------------------------------


#----------------------------------------------------

`convert/Vessiot_transform`:=proc(de::Vessiot_diffeq) 
#CLASS I PROGRAM
#12/22/02:IA
#07/01/03:IA
#11/01/05: IA

local order, n,components0,components, fr,  Eq0, Eq1,f, i,phi,temp,Delta; 

Delta:=op(de);

order:=max(op(map(functionOrder,Delta[1][4])));  
n:=jet_space_dim(order);
DifferentialGeometryTools:-Form(n);

components0:=[seq(frameJetVariables()[i] = frameJetVariables()[i], i=1..n)];
Eq0:=coeff_set(de); 
fr:=Delta[1][5];

Eq1:=solve(Eq0,Delta[1][4]);
if Eq1=NULL  then ERROR(`Vessiot Error: System of DE inconsistent`)fi;


components:=[seq(lhs(a)=subs(Eq1,rhs(a)), a=components0)];
transform(fr,fr, components);
end:








#----------------------------------


`convert/Vessiot_biform`:= proc(forma0,bidegree::list)

# CLASS II PROGRAM
# 12/13/02:IA
# 12/28/03:IA      

local ans, bformlist, d1, d2, degree, i, j,n,r, frame, newform, M, term,
      term_bform, d, bform_attributes, bform_component,forma;

forma:=evalV(forma0);

if type(forma,Vessiot_form)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  form_to_biform  requires first arguement to be a form:", 
		    "\n ",objectType(forma))); 
fi;

VessiotFrameCheck(forma);

frame := frameProtocol();
degree := formDegree(forma);
newform := homomorphism[formBiform](frame[form_to_biform],forma,zero_form(degree));

n:=frameBaseDimension();
M:=min(degree,frameBaseDimension());

#sort out newform into various parts.

bformlist := array(0..degree,0..degree);

for i from 0 to M do
	bformlist[i,degree-i] := zero_biform([i,degree-i])
od;

for term in op(newform)[2] do
      r:=0;
      while r< degree and term[1][r+1] <= n do 
		r:=r+1  
      od;
      
      bform_attributes:=[biform, _Vessiot_current_frame_name,[r,degree -r] ];
      bform_component:=[term[1], term[2]];
	term_bform := _VESSIOT([bform_attributes,[bform_component]]);
      d:=op(biformDegree(term_bform));
      bformlist[d] := DiffGeomMain:-Plus( bformlist[d],  term_bform);
od;

if (nargs > 1) and (type(bidegree,list)) then
      if bidegree[1]<=frameBaseDimension() then
		ans := bformlist[op(bidegree)]
      else
            ans:=[]
     fi;

else
	ans := [];
	for i from 0 to M do
            j := degree-i;
            ans := [op(ans), bformlist[i,j]]
      od;
fi;

ans

end:




#--------------------------------

`convert/jet`:=proc(exp,order)
#CLASS II PROGRAM
#06/16/92:CH
#12/13/02:IA 

local n,m,p,jets, indep_vars, l,k,dep_var,diff_list, ans,diff_dep_var,fr;
 
if nargs=3 then 
	change_frame_to(args[3]) 
fi;

fr:=_Vessiot_current_frame_name;
n:=frameBaseDimension();
m:=frameFiberDimension();
p:=jet_space_dim(order);  

# The next command insures that the  list of jet variables is extend to order. 
DifferentialGeometryTools:-Form(p);

jets:=_Vessiot_frame_data[fr][1][4][4];
indep_vars:=_Vessiot_frame_data[fr][1][4][1];
 
ans:=exp;

for k from p to n+1  by -1 do
 	dep_var:=op(0,jets[k])(op(indep_vars));
 	diff_list:=[op(jets[k])];
 	diff_dep_var:=dep_var;
 	for l from 1 to n  do  
	if diff_list[l] <>0 then   
		diff_dep_var:=diff(diff_dep_var,seq(indep_vars[l], i=1..diff_list[l])); 
	fi;
 	od; 
	ans:=subs(diff_dep_var=jets[k],ans) 
od;

VessiotPrompt():
ans
end:

#----------------------------

`convert/deriv`:=proc(exp)
#CLASS II PROGRAM
#December 13,2002:IA  

local n, frame, indep_vars, var_list,var_list0, ans,  
term,dep_var, diff_list, diff_dep_var,l;

if nargs=3 then 
	change_frame_to(args[3]) 
fi;

n:=frameBaseDimension();
frame:=_Vessiot_current_frame_name;
indep_vars:=_Vessiot_frame_data[frame][1][4][1];

var_list0:=convert(indet_helmlist(exp),set);
var_list:=var_list0 minus convert(indep_vars,set);

ans:=exp;

for term in var_list do 
 	dep_var:=op(0,term)(op(indep_vars));
 	diff_list:=[op(term)];
 	diff_dep_var:=dep_var;
 	for l from 1 to n  do  
		if diff_list[l] <>0 then   
			diff_dep_var:=diff(diff_dep_var,seq(indep_vars[l], i=1..diff_list[l])); 
		fi;
 	od;
	ans:=subs(term=diff_dep_var,ans)
od; 

ans

end:

#--------------------------------------














#-------------------------------------
#  This should be in the diffgeom

diver:=proc(a_vector::Vessiot_vect)
#CLASS I PROGRAM
#06/16/92:CH
#12/13/02:IA 
	 
#    This routine takes the divergence of a Vessiot vector.
#
#    a_vector: a Vessiot vector.

local ans, term;

VessiotFrameCheck(a_vector);

ans:=0;

for term in op(a_vector)[2] do;
	ans:=ans+diff(term[2],index_to_jet_label(op(term[1])));
od;
	   
VessiotPrompt():

ans
end:


# Shouldn't need this either
#
