#
# pullback.jet
#
# JetCalc
#
# pullback_biform, projected_pullback, 
#
#



pullback_biform := proc(phi, forma0)

# CLASS II PROGRAM
# 12/17/02:IA 
# 12/25/03:IA   

local eqn_list, index, new_form, forma,dom_fr,pbtype;

forma:=evalV(forma0);

if type(phi,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pullback_biform requires first arguement to be a transformation: ", 
		    "\n ",objectType(phi))); 
fi;

if type(forma,Vessiot_biform)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pullback_biform requires second arguement to be a biform:", 
		    "\n ",objectType(forma))); 
fi;

if objectOrder(forma)>transformRange(phi)[2]  then
        ERROR(cat("\n VESSIOT ERROR:",
                  "\n differential order of the biform exceeds that of the map:", 
                  "\n ", objectOrder(forma),transformRange(phi)[2]))
fi;

if  transformRange(phi)[1] <> objectFrame(forma) then
        ERROR(cat("\n VESSIOT ERROR:",
			"\n  the domain of the map and form must be the same frame:",
                  "\n ",transformRange(phi)[1],objectFrame(forma) ))
fi;      
      
if transformType(phi)=[] then  
	ERROR(cat("\n VESSIOT ERROR:",
                "\n biforms may not be pullbacked ", 
                " under maps which are not fiber_preserving.", 
                "\n Use projected_pullback."))

elif transformType(phi)[1]<>`projectable` then
       ERROR(cat("\n VESSIOT ERROR:",
                "\n biforms may not be pullbacked ", 
                " under maps which are not fiber_preserving.",
                "\n Use projected_pullback."))

fi; 

dom_fr:=transformDomain(phi)[1]:

if dom_fr <> _Vessiot_current_frame_name then 
	change_frame_to(dom_fr):
fi;

# Apply homomorphism to forma, using pullback on each component.

pbtype := cat(`pullback_`, objectType(forma));

new_form := homomorphism[formBiform](frameProtocol()[pbtype],forma,
            DifferentialGeometryTools:-zero_biform(biformDegree(forma)),phi);


new_form
end:

#----------------------------------------------

projected_pullback:= proc(phi, forma0)

# CLASS II PROGRAM
# 12/17/02:IA     
# 12/25/03:IA 

local eqn_list, index, new_form,forma, alpha,beta;

forma:=evalV(forma0);
         
alpha:=convert(forma,Vessiot_form);



if type(phi,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  projected_pullback requires first arguement to be a transformation: ", 
		    "\n ",objectType(phi))); 
fi;

if type(forma,Vessiot_biform)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  projected_pullback requires second arguement to be a biform,", 
		    "\n ",objectType(forma))); 
fi;

if objectOrder(forma)>transformRange(phi)[2]  then
        ERROR(cat("\n VESSIOT ERROR:",
                  "\n differential order of the biform exceeds that of the map:",
                  "\n ", objectOrder(forma),transformRange(phi)[2]));
fi;

if  transformRange(phi)[1] <> objectFrame(forma) then
        ERROR(cat("\n VESSIOT ERROR:",
			"\n  the domain of the map and form must be the same frame:",
                  "\n ",transformRange(phi)[1],objectFrame(forma) ))
fi;      
             
if transformType(phi)=[] then
	ERROR(cat("\n VESSIOT ERROR:",
                " projected_pullback  may not be used on generic transformations.")) 
fi;

beta:= pullback(phi,alpha); 

new_form:= convert(beta, Vessiot_biform,biformDegree(forma));

new_form

end:

# **************************