#
# push_fwd.jet
#
# JetCalc
#
# pt_pushforward_total, pushforward_total,
#



pushforward_total:=proc()

local ans, pt_pushforward_total, pushforward_total0;


#-----------------------



pt_pushforward_total:=proc(a_map,a_vect0)

#CLASS II PROGRAM
#12/20/02:IA               

local ans, frame,a_vect, phi,domain_info;

a_vect:=evalV(a_vect0);

if type(a_map,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pt_pushforward_total requires first arguement to be a transformation: ", 
		    "\n ", objectType(a_map) )); 
fi;

if type(a_vect,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pt_pushforward_total requires second arguement to be a vector:", 
		    "\n ",objectType(a_vect))); 
fi;


domain_info:=transformDomain(a_map);


if objectFrame(a_vect)<> domain_info[1] then  
    ERROR(cat("\n Vessiot Error:", 
              "\ frame of vector must equal  domain frame of transformation:",
              "\n ", objectFrame(a_vect), domain_info[1]  ))
fi;


if   vectorType(a_vect) =[] then  
 	ERROR(cat("\n VESSIOT ERROR:",
                "\n The vector  field must be a total vector field:",
                "\n ", vectorType(a_vect) ))
fi;

if   vectorType(a_vect)[1] <> `tot` then 
	ERROR(cat("\n VESSIOT ERROR:",
                "\n The vector  field must be a total vector field:",
                "\n ", vectorType(a_vect) ))
fi;
 
phi:=assign_transform_type(a_map); 

if  transformType(phi)[1] = `generic` then 
      ERROR(cat("\n VESSIOT ERROR:", 
                "\n  The map cannot be of generic type:",
                "\n ", transformType(phi)[1]))
fi;

frame:=frameProtocol(objectFrame(a_vect));
 
ans:=frame[pt_pushforward_total](phi,a_vect);

ans;

end:

#--------------------------------------------------------

pushforward_total0:=proc(phi, inv_phi, total_vect0)  

#CLASS II PROGRAM
#12/20/02:IA               

local X,ans,p,total_vect;

total_vect:=evalV(total_vect0):

if type(phi,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pushforward_total requires first arguement to be a transformation: ", 
		    "\n ", objectType(phi))); 
fi;

if type(inv_phi,Vessiot_transformation)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pushforward_total requires second arguement to be a transformation: ", 
		    "\n ", objectType(inv_phi) )); 
fi;


if type(total_vect,Vessiot_vect)=false then 
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n  pushforward_total requires third arguement to be a vector:", 
		    "\n ",objectType(total_vect) )); 
fi;

p:=objectOrder(total_vect);

if transformDomain(inv_phi)[2] <p then  
	ERROR(cat("\n VESSIOT ERROR:",
	          "\n domain order of inverse map less that order of total vector:",
                "\n ",transformDomain(inv_phi)[2],p  )) 
fi;

X:=pt_pushforward_total(phi,total_vect);

ans:=DifferentialGeometryTools:-Vessiot_map(3,pullback,X,inv_phi);

ans;

end:

#-------------------------------------------------


# MAIN   ROUTINE

if nargs=2 then 
	ans:=pt_pushforward_total(args)
fi;


if nargs=3 then 
	ans:=pushforward_total0(args)
fi;

ans

end: