# 
# Td.ms
#
# Vessiot
#
# td; multi_td; form_td; multi_form_td;
#


td:=proc(A0,B)

local A, td0, fr, ans,multi_td, multi_form_td;

global form_td;


td0 := proc(expr::algebraic, var::algebraic)

# CLASS II PROGRAM
# 08/26/91:CH
# 12/13/02:IA
# 12/19/2003:IA 

local ans, index,varset,frame, w,v;

if nargs > 2 then
	change_frame_to(args[3])
fi;

if type(var,integer) and var <= frameBaseDimension() and var >0 then
	v:=index_to_jet_variable(var);
      index:=var;
elif member(var,frameIndependentVariables(),`index`)then
      v:=var;
else
      ERROR(cat("\n VESSIOT ERROR:",  
	          "\n variable not in independent variable list", frameIndependentVariables(), 
		    "\n ", var) )
fi;




varset := indet_helmlist(expr) minus {op(frameIndependentVariables())};
ans := diff(expr, v);

for w in varset do
	ans := ans + diff(expr, w)*ldiff(w, index)
od;



ans
end:

#---------------------------------------------

multi_td := proc(expr::algebraic, varset::list)

# CLASS II PROGRAM
# 08/26/91:CH
# 12/13/02:IA
# 12/19/2003:IA     

local ans, i, j;

if nargs > 2 then
	change_frame_to(args[3])
fi;



if nops(varset) <> frameBaseDimension() then
	ERROR(cat("\n VESSIOT ERROR:",  
	          "\n list of derivatives must have length", frameBaseDimension(), 
		    "\n ", varset ))
fi;

ans := expr;

for i from 1 to frameBaseDimension() do
	for j from 1 to varset[i] do
      	ans := td(ans,i)
      od;
od;


ans
end:

#--------------------------------------

form_td := proc(forma0, v::algebraic)

# CLASS II PROGRAM
#08/26/91:CH
#12/13/02:IA
         
local ans, index, forma, biform_td0, form_type,form_degree, frame, form_td0;


forma:=evalV(forma0);



form_td0:=proc(expr,flag, index)
local  ans, newvar,form_attributes, form_component;
        
if  flag= 'coeff'  then
	form_attributes:=[form, _Vessiot_current_frame_name, 0];
      form_component:=[[], td(expr,index)];
      ans := _VESSIOT([form_attributes,[form_component]]);

elif flag=cat(bftv) then
   	if expr <= frameBaseDimension() then
           ans := DifferentialGeometryTools:-zero_form(1)
      else
           newvar := tuple_to_index(ldiff(index_to_jet_variable(expr),index));
           form_attributes:=[form, _Vessiot_current_frame_name, 0];
           form_component:=[[newvar],1];
           ans := _VESSIOT([form_attributes,[form_component]])
      fi
else
      ERROR(`VESSIOT ERROR: insufficient input`);
fi;

ans

end:


biform_td0 := proc(expr,flag,index)
#CLASS I PROGRAM
#04/22/1992 CH
#12/27/2002:IA

local form_attributes, form_component, ans, newvar, biform_attributes,biform_component;

if  flag = 'coeff' then

	form_attributes:=[biform, _Vessiot_current_frame_name, [0,0]];
      form_component:=[[], td(expr,index)];
      ans := _VESSIOT([form_attributes,[form_component]]);

elif  flag='bftv' then
      if expr <= frameBaseDimension() then
      	ans := DifferentialGeometryTools:-zero_biform([1,0])
      else
            newvar:=tuple_to_index(ldiff(index_to_jet_variable(expr),index));
            biform_attributes:=[biform,_Vessiot_current_frame_name, [0,0]];
            biform_component:=[[newvar],1];  
            ans := _VESSIOT([biform_attributes,[biform_component]]);
      fi
else
      ERROR(`VESSIOT ERROR: insufficient input`)
fi;

ans;

end:





if type(forma, {Vessiot_form,Vessiot_biform}) = false then
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n form_td requires input object to be a form or biform,", 
		    "\n ",objectType(X))); 
fi;

if nargs > 2 then
	change_frame_to(args[3])
elif objectFrame(forma) <> _Vessiot_current_frame_name then 
	change_frame_to(objectFrame(forma))
fi;

if type(v,integer) and v <= frameBaseDimension() then
	index := v
elif member(v,frameIndependentVariables(),index) then
	index := index
else
      ERROR(cat("VESSIOT ERROR:",  
		    "\n variable not in independent list", 
		    "\n ", var, frameIndependentVariables() ))
fi;

frame := frameProtocol();

form_type:=objectType(forma);

if form_type= `form` then 
	form_degree:=formDegree(forma);
      ans:=derivation[formBiform](form_td0 ,deriv,
        forma,DifferentialGeometryTools:-zero_form(form_degree),index);   
else 
      form_degree:=biformDegree(forma);
	ans:=derivation[formBiform](biform_td0 ,deriv,
        forma,DifferentialGeometryTools:-zero_biform(form_degree),index);   


fi;



ans
end:

#---------------------------------



multi_form_td := proc(forma0, varlist::list)

# CLASS II PROGRAM
# December 13,2002:IA       
# 12/19/2003:IA

local ans, i, j, forma;

forma:=evalV(forma0);

if type(forma, {Vessiot_form,Vessiot_biform}) = false then
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n form_td requires input object to be a form or biform,", 
		    "\n ",objectType(X))); 
fi;


if nargs > 2 then
	change_frame_to(args[3])
elif  objectFrame(forma)<>  _Vessiot_current_frame_name then 
	change_frame_to(forma[1][2])
fi;


if nops(varlist) <> frameBaseDimension() then
	ERROR(cat("\n VESSIOT ERROR:",  
	          "\n list of derivatives must have length", frameBaseDimension(), 
		    "\n ", varlist ))
fi;

ans := forma;

for i to frameBaseDimension() do
	if varlist[i] > 0  then
      	for j to varlist[i] do
              	ans := form_td(ans,i)
            od;
       fi;
od;

ans
end:
#

#MAIN PROGRAM   

A:=evalV(A0);

if type(A,{Vessiot_form,Vessiot_biform} ) then
      fr:=objectFrame(A);
      if frameProtocol(fr) <> vst_euc then  
		ERROR( `td only works in vst_euc frame`)
	fi;
fi;


if type(A,Vessiot_scalar) and type  (B,algebraic) then 
	ans:=td0(A,B);
      RETURN(ans);
fi;


if type(A,{Vessiot_form,Vessiot_biform} ) and type  (B,algebraic) then  
	ans:=form_td(A,B);
      RETURN(ans);
fi;



if type(A,Vessiot_scalar) and type  (B,list) then 
	ans:=multi_td(A,B);
      RETURN(ans);
fi;



if type(A,{Vessiot_form,Vessiot_biform} ) and type  (B,list) then 
	ans:=multi_form_td(A,B);
      RETURN(ans);
fi;

ERROR( `invalid args`);

end:










#***********************************************