
#
# Ad.alg
#
# LieAlg
#
# ad, Ad, Killing
#



#~~~~~~~~~~~~~~~~~~~ ad ~~~~~~~~~~~~~~~~~~~~


ad:=proc(V0)


# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Computes various forms of the adjoint Matrix of vector in the Lie algebra`;

local  ad_type ,ans,acting_vector,subalg,subspace,list_of_ad_matrices,
	 the_list, n,i,j,k,c,alg_data,A,term,
	matrix_argument,p,B,coeffs,V;


if nargs >=1 then 
	V:=evalV(V0)
fi;

#
# LOCAL SUBROUTINE
#

list_of_ad_matrices:=proc(alg_data) local n,ans,i,A;

	n:=alg_data[1][3][1];

	for i from 1 to n do
		A[i]:=Matrix(n,n)
	od;

	for term in alg_data[2] do
		A[term[1][2]][ term[1][3], term[1][1] ]:=term[2];
		A[term[1][1]][ term[1][3], term[1][2] ]:=-term[2]
	od;
	
	ans:=[seq(eval(A[i]), i=1..n)];
	RETURN(ans);
end:


#...................


if nargs=0  then
	alg_data:=convert(_Vessiot_current_frame_name, Lie_algebra_data);
	ans:=list_of_ad_matrices(alg_data);
      RETURN(ans):
fi;





#.............ad on vectors ......

if nargs=1 and type(V,Vessiot_vect) then 
	
	n:=frameBaseDimension(); 
	A := Matrix(n,n);

	for i from 1 to n do
 		c:=op(coeff_set(hook(V, frameBaseForms()[i] )));
 		if c<>0  then 
			for j from 1 to n do
 				for k from 1 to n do 
					A[j,k]:=A[j,k]+c*structure_constant(i,k,j);
        
				od;
 			od;
		fi;
	od;

	RETURN(A);
fi;



if nargs=1 and type(V,name) then
	
	if member(V,listOfFrameNames())=false then 
		ERROR(cat("\n LieAlg Error:", 
			    "\n Argument for ad not a valid Lie algebra name.")) 	
	fi;

	alg_data:=convert(V, Lie_algebra_data);
	ans:=list_of_ad_matrices(alg_data);
      RETURN(ans):
fi;


if nargs=1 and type(V,Vessiot_Lie_alg) then 
 	ans:=list_of_ad_matrices(V);
      RETURN(ans):
fi;

                

#........... restricted ad  ..................


if nargs=2 then
	
	acting_vector:=evalV(args[1]);
	
	
	if  not type(acting_vector, Vessiot_vect)  then 
		ERROR(cat("\n LieAlg Error:",  
                      "\n First argument for ad(restricted) must be Vessiot vector:",
  			    "\n ", objectType(acting_vector)));
	fi:

	if  not type(args[2],list)  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Second argument for ad(restricted) must be", 
			    "\n a list of independent Vessiot vectors."));
	fi:

	subspace:=map(evalV,args[2]);
      
	if  not type(subspace,list(Vessiot_vect))  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Second argument for ad(restricted) must be", 
			    "\n a list of independent Vessiot vectors."));
	fi:
	
	if   nops(DiffGeom_basis(subspace)) <> nops(subspace)  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Second argument for ad(restricted) must be", 
			    "\n a list of independent Vessiot vectors."));
	fi:

      n:=nops(subspace);
      
	matrix_argument:=[];
	
      for i from 1 to n do 
      	coeffs:=linear_combo(Lie_bracket(acting_vector,subspace[i]),subspace);
 		if coeffs=[] then 
			ERROR(cat("\n LieAlg Error:",
				    "\n The  ad action of the given vector on the i-th vector",
                            "\n in the subspace does not lie in the subspace.",
                            "\n ", "i = ", i));
            else 
            matrix_argument:=[op(matrix_argument),coeffs];
            fi
      od;
   
	ans:=LinearAlgebra[Transpose](Matrix(matrix_argument));
 	RETURN(eval(ans));
fi;

#............quotient ad ....................

if nargs=3 then
      
	acting_vector:=evalV(args[1]);
	
	if  not type(acting_vector, Vessiot_vect)  then 
		ERROR(cat("\n LieAlg Error:",  
                      "\n First argument for ad(quotient) must be Vessiot vector:", 
  			    "\n ", objectType(acting_vector) ));
	fi:

	if  not type(args[2],list)  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Second argument for ad(quotient) must be", 
			    "\n a list of independent Vessiot vectors."));
	fi:

	subspace:=map(evalV,args[2]);

	if  not type(subspace,list(Vessiot_vect))  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Second argument for ad(quotient) must be", 
			    "\m a list of Vessiot vectors."));
	fi:

	if  not type(args[3],list)  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Third argument for ad(quotient) must be", 
			    "\n a list of independent Vessiot vectors."));
	fi:

      subalg:=map(evalV, args[3]);

	
	if  not type(subalg,list(Vessiot_vect))  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Third argument for ad(quotient) must be", 
			    "\n a list of independent Vessiot vectors."));
	fi:

	#if  not LieAlgCheck(subalg,ideal1)  then 
		#ERROR(cat("\n LieAlg Error:",  
                	   # "\n Third argument for ad(quotient) must an ideal"));
	#fi:

	B:=[op(subspace), op(subalg)];
	
      if nops(DiffGeom_basis(B)) <> frameBaseDimension() 
	or nops(B) <> frameBaseDimension() then
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Span of second and third arguments for ad(quotient) must be a", 
		 	    "\n for the Lie algebra."));
	fi:

	p:=nops(subspace);
 
	matrix_argument:=
	[seq(linear_combo(Lie_bracket(acting_vector,subspace[i]),B)[1..p], i=1..p)];
 
 
	ans:=LinearAlgebra[Transpose](Matrix(matrix_argument));
 
      RETURN(eval(ans))
fi; 

#.......................

ERROR(cat("\n LieAlg Error:",
	     "\n Invalid arguments for ad:",
           "\n 0 arguments.",
           "\n 1 argument:  \t Lie algebra name, Lie algebra data structure, vector.",
	     "\n 2 arguments: \t vector, list(independent vectors).",
	     "\n 3 arguments: \t vector, list(independent vectors), list(independent vectors)." ))		


end:



#~~~~~~~~~~~~~~~~~~~ Ad ~~~~~~~~~~~~~~~~~~~~



Ad := proc(vec0)

# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Computes the Adjoint Matrix of a vector  v -- exp(ad(v))`;

local ans,vec;


if nargs=0 then 
	ERROR(cat("\n LieAlg Error:", 
		    "\n Ad requires 1 argument, a vector")); 	
fi;

vec:=evalV(vec0);

if type(vec, Vessiot_vect) =false then 
	ERROR(cat("\n LieAlg Error:", 
		    "\n First argument for Ad must be a vector:",
		    "\n ", objectType(vec) )); 	
fi;



ans:= LinearAlgebra[MatrixExponential](ad(vec));

end:


#~~~~~~~~~~~~~~~~~~~ Killing ~~~~~~~~~~~~~~~~~~~~

Killing := proc()

# CLASS II PROGRAM
# 01/10/2004 IA


option `Copyright Ian M. Anderson 2004`; 

description  `1. Killing form (Matrix); 2. Killing form on a pair of vectors`;

local i,j,n,m,g,k, fr,ans,x,y;


#............Killing form (from initialized algebra)  ..........

if nargs =0 or (nargs =1  and type(args[1],name)) then 

      if nargs =1 then
	if member(args[1],listOfFrameNames())=false then 
		ERROR(cat("\n LieAlg Error:", 
			    "\n Argument for Killing not a valid Lie algebra name.")) 	
	else
		change_frame_to(args[1]);
	fi;
      fi;

      n:= frameBaseDimension();
	fr:=_Vessiot_current_frame_name;

      g := Matrix(n,n);
	for i from 1 to n do
		for j from i to n do
			g[i,j] := add(add( 		
			structure_constant(i,m,k)*structure_constant(j,k,m),m=1..n),k=1..n);
			g[j,i]:=g[i,j];
		od;
	od;
	RETURN(g);
fi;


#............ Killing form (from Lie Algebra data structure) ...........

if nargs=1 and type(args[1],Vessiot_Lie_alg) then
      n:=args[1][1][3][1];
	g := Matrix(n,n);
	for i from 1 to n do
		for j from i to n do
			g[i,j] := add(add(structure_constant(i,m,k,args[1])*
			structure_constant(j,k,m,args[1]),m=1..n),k=1..n);
			g[j,i]:=g[i,j];
		od;
	od;
	RETURN(g);
fi;


#............. Killing form evaluated on a pair of vectors ...........

if nargs=2 then
	
	x:=evalV(args[1]);
	y:=evalV(args[2]);
	
	if  not type(x, Vessiot_vect)  then 
		ERROR(cat("\n LieAlg Error:",  
                      "\n Killing with two arguments requires a pair of vector arguments.",
			    "\n First argument has type:",
                      "\n ", objectType(x) ))  	
	fi;
	
	if  not type(y, Vessiot_vect)  then 
		ERROR(cat("\n LieAlg Error:",  
                      "\n Killing with two arguments requires a pair of vector arguments.",
			    "\n Second argument has type:",
                      "\n ", objectType(y) ))  	
	fi;
	
	ans:=LinearAlgebra[Trace](LinearAlgebra[MatrixMatrixMultiply](ad(x),ad(y) ));

      RETURN(ans)
fi;
  

ERROR(cat("\n LieAlg ERROR:", 
          "\n Invalid arguments for Killing:",
          "\n 0 arguments.", 
          "\n 1 argument: \t a Lie algebra name or a data structure.",
          "\n 2 arguments:\t a pair of vectors."))
end:
#--------------------------------------------------------