#
# Automorphism.alg
#
# LieAlg
#
# infinitesimal_automorphisms
#



infinitesimal_automorphisms:=proc(auto_type::name)

# CLASS II PROGRAM
# 01/09/2004:IA

local  ans2, A,Q,q,listB,infinitesimal_outer_automorphisms,ans,ans1, i,j,h,k, kk,f,n,B;

description "Compute the inner, outer, or all automorphisms of a Lie algebra";

#
# LOCAL SUBROUTINES
#

#..........  infinitesimal_outer_automorphisms ..........

infinitesimal_outer_automorphisms:=proc()

local A, i,j,n,O,k,B, temp,ans, N,M,vars, eq,Eq;

n:=frameBaseDimension();


O:=Matrix(n,n,symbol=_X);
vars:=[seq(seq(O[i,j],i=1..n),j=1..n)];
eq:={};

for k from 1 to n do A[k]:=ad(frameBaseVectors()[k]);
	eq:= eq union {add(add(O[i,j]*A[k][i,j], i=1..n), j=1..n)};
od; 

for k from 1 to n do
	temp:=evalm( add(O[l,k]*A[l], l=1..n) - O&*A[k] + A[k]&*O) ;
	eq:=eq union convert(temp,set)
od; 

Eq:=LinearAlgebra[GenerateMatrix](expand(eq),vars);
N:=Vessiot_nullspace(Eq[1]);  
ans:=[]; 

for B in N do  
	listB:=[seq([seq(B[i+n*j], i=1..n)],j=0..n-1)];

	ans:= [op(ans), LinearAlgebra[Transpose](Matrix(listB))] 
od; 

ans;

end:

#...............................

#
# MAIN PROGRAM
#


if nargs=0 then 
	ERROR(cat("\n LieAlg ERROR:", 
	    "\n Input for infinitesimal_automorphisms must be one of {inner, outer, full}."));
fi;

f:=proc(i,j,h,k) 
if i=h and j=k then 
	RETURN(1) 
fi; 
0 
end:

n:=frameBaseDimension();

B:=[seq(seq(Matrix(n,n,(h,k)->f(i,j,h,k)) ,i=1..n), j=1..n)]:

	
if auto_type= inner  then 
	ans:=DiffGeom_basis(ad());
	ans1:=canonical_subspace_basis(ans,B);

      RETURN(ans1):
fi;

if auto_type=outer then
	ans:=infinitesimal_outer_automorphisms(); 
	ans1:=canonical_subspace_basis(ans,B);

      RETURN(ans1):
fi;

if auto_type=full  then
	ans:= [op( DiffGeom_basis(ad()) ),
	       op(infinitesimal_outer_automorphisms())];
	
	ans1:=canonical_subspace_basis(ans,B);

      ans2:=[];

      for A in ans1 do 
      	Q:=map(denom,convert(A,set));
      	q:=product(Q[kk], kk=1..nops(Q));
      	ans2:=[op(ans2),eval(q*A)];
      od;    


      RETURN(ans2)
fi;


ERROR(cat("\n LieAlg ERROR:", 
	    "\n Input for infinitesimal_automorphisms must be one of {inner, outer, full}:",
          "\n ", auto_type ));

end;


