#
# decompose_algebra
# 
#
#

Vessiot_query := proc () 
local ans, i, con_value, con; 

con := args; 
for i to infinity do ans := is(con); 
	if ans = true or ans = false then RETURN(ans) fi; 
	lprint(`VESSIOT NEEDS YOUR HELP.  IS: `); 
	print(args), lprint(`ENTER true , false,exit OR assume STATEMENT`); 
	con_value := readstat('Vessiot_query'); 
	if con_value = exit then ERROR(`Program Terminated`) fi; 
	if con_value = true then RETURN(true); break fi; 
	if con_value = false then RETURN(false); break fi; 
	con := eval(con) 
od; 
end:



central_decomposition:=proc()
local cent_alg,  der_alg, central_factor,v,test,i,n,fr, alg_basis,intersect_alg,alg,j,A,B,C,
complementary_factor, alg_name,ans1,ans2;

if nargs=1 then change_Lie_algebra_to(args[1]) fi;

n:=frameBaseDimension():
fr:=_Vessiot_current_frame_name;

A:=Matrix(n,n);

alg_basis:=[seq(Vect(i),i=1..n)];



if _Vessiot_show_intermediate_steps_flag then 
print(`Get Center`)
fi; 

cent_alg:=center();


if _Vessiot_show_intermediate_steps_flag then 
print(`Get Derived Algebra`)
fi; 


der_alg:=LieAlgebrasTools:-bracket_of_subspaces(alg_basis, alg_basis);


if _Vessiot_show_intermediate_steps_flag then 
print(`Intersect Center and Derived Algebra`)
fi; 


intersect_alg:=DifferentialGeometryTools:-IntersectSubspaces([cent_alg,der_alg]);


if _Vessiot_show_intermediate_steps_flag then 
print(`Find complement C of intesection algebra in center`)
fi; 

central_factor:=complementary_basis(intersect_alg,cent_alg); 

central_factor:=canonical_subspace_basis(central_factor,alg_basis);

for i from 1 to nops(central_factor) do
	for j from 1 to n do
		A[j,i] := coeff_list(central_factor[i],[[j]]);
	od;
od;

if _Vessiot_show_intermediate_steps_flag then 
print(`Find complement of C in algebra`)
fi; 

B:=[ op(central_factor) ,op(der_alg)];
C:=complementary_basis(B,alg_basis);

complementary_factor:=[op(der_alg),op(C)];
complementary_factor:=canonical_subspace_basis(complementary_factor,alg_basis);

for i from 1 to nops(complementary_factor)  do
	for j from 1 to n do
		A[j,i+nops(central_factor)] := 	coeff_list(complementary_factor[i],[[j]]);
	od;
od;

if central_factor<>[] then 
	ans1:=convert(central_factor,Lie_algebra_data, cat(fr,CentralFactor)):
else 
      ans1:=[]
fi;

ans2:=convert(complementary_factor,Lie_algebra_data, cat(fr,CompFactor)):

[ans1,ans2, eval(LinearAlgebra[MatrixInverse](A))];

end:

#-------------------------------------



decom_alg1:=proc(set_cent_mod_J,J) 
local ans, S,C, k,i,q;

S:=set_cent_mod_J;
if nops(S)>2 then ans:=false fi;




if nops(S) =2 then 
	C:=linear_combo(eval(S[2]^2),[S[1], op(J)]);
 
	if  nops(C)=0 then   
		ans:=false 
	fi;
      
	if  nops(C)>0  then  ans:=Vessiot_query(C[1]<0);
		
	fi;

fi;


if nops(S) =1 then ans:=true fi;


if ans = false then
	ans:=[seq( [ S[i], LinearAlgebra[MinimalPolynomial](S[i],_lambda)], i=2..nops(S))]
fi;

ans;
end:


decom_alg2:=proc (Spoly)
local i, m,n, f, f1, f2,p;
n = 1; 
for i to nops(Spoly) do 
      p:=numer(simplify(Spoly[i][2])); 
	f:=factors(p); 
	if 1 < nops(f[2])  then
		m := i; n=2; break 
	fi 
od;

if n = 1 then RETURN([]) fi; 
	
f1:=f[2][1][1]^(f[2][1][2]); 
f2:=expand(factor(Spoly[m][2]/f1)); 

[Spoly[m][1],f1, f2] 

end:
#-----------------------


decom_alg3:=proc(alg_data, A, f1,f2)
local r1,r2, G,H, N1,N2,M,r,d1,d2,s1,s2,struc_const, new_alg;
	
gcdex(f1,f2,_lambda,r1,r2);

M:=eval( subs(_lambda=A, expand(f1*r1)));
N1:=Vessiot_nullspace(M);
N2:=Vessiot_nullspace(eval(1-M));

G:=Matrix([op(N1), op(N2)]);
H:=LinearAlgebra[MatrixInverse](G);
d1:=nops(N1);
d2:= alg_data[1][3][1] - d1; 


new_alg:=change_Lie_algebra_basis(H,cat(alg_data[1][2],`Factor-`),alg_data);
s1:=[]; 
s2:=[];

for struc_const in new_alg[2] do
	if struc_const[1][1] <=d1 then 
		s1:=[op(s1),struc_const]  
 	else 
	s2:=[op(s2), [[struc_const[1][1]- d1, struc_const[1][2]-d1, 
	struc_const[1][3] -d1], struc_const[2]]]; 
	fi;

od;

	[   [[Lie_alg,cat(alg_data[1][2],1),[d1]],s1], 	[[Lie_alg,cat(alg_data[1][2],2),[d2]],s2], eval(H)] 

end:


#--------------------------------------------------------

decompose_algebra:=proc() 


local S, n,J,SmodJ,B,ans,alg,alg_name,fr,lie_alg_data,CBM;


if _Vessiot_show_intermediate_steps_flag then 
print(`Warning: Be sure to remove central factors first`)
fi; 
fr:=_Vessiot_current_frame_name;

if nargs=0  then  
	lie_alg_data:=convert(fr,Lie_algebra_data);
fi; 
	
if nargs=1 and type(args[1], name) then 
	change_Lie_algebra_to(args[1]);
      lie_alg_data:=convert(args[1],Lie_algebra_data);
fi;

if nargs=1 and type(args[1], Lie_alg) then 
	lie_alg_data:=lie_alg;
fi;

if nargs =4 then  
decom_alg3(lie_alg_data,args[2],args[3],args[4]);
RETURN(%)
fi;


if _Vessiot_show_intermediate_steps_flag then 
print(`Computing Set Centralizer and Jacobson radical for ad matrices`)
fi; 



S:=LieAlgebrasTools:-matrix_centralizer(ad(lie_alg_data));
J:=LieAlgebrasTools:-Jacobson_radical(S):
SmodJ:=complementary_basis(J,S);

ans:=decom_alg1(SmodJ,J);


if ans = true  then  
CBM:=LinearAlgebra[DiagonalMatrix]([seq(1,i=1..frameBaseDimension())] );
RETURN([lie_alg_data, eval(CBM)]) fi;



if _Vessiot_show_intermediate_steps_flag then 
print(`Factoring characteristic polynomials for  set centralizer mod Jacobson radical`)
fi; 

B:=decom_alg2(ans);

if  B=[] then
print(`LieAlg needs  you help.`);
print(`Compute prime factors of one  of the  following  polynomials.`);
print(`Rerun  decompose_algebra with Matrix and prime factors  of   polynomial  as arguements 2,3,4
`); 
RETURN(ans) 
fi; 

if _Vessiot_show_intermediate_steps_flag then 
print(`Computing change of basis to decompose algebra`)
fi; 

decom_alg3(lie_alg_data,B[1],B[2],B[3]);

end:

#---------------------------------------------------
DecomposeLieAlgebra:=proc()

local i,j,k,n1,n2,n3,original_alg_name,fr_name,
        stack1,stack2,CBM,D1,abelian_factor,B1,B2,B3,B4,
         reorder_matrix,reorder_info,flag_value;

 global _Vessiot_show_intermediate_steps_flag;

 if nargs = 1 then change_Lie_algebra_to(args[1]) fi;
 
 n1:=frameBaseDimension();
 original_alg_name:=_Vessiot_current_frame_name;

flag_value:=_Vessiot_show_intermediate_steps_flag;
 
stack1:=[];
 stack2:=[];
 CBM:=LinearAlgebra[DiagonalMatrix]([seq(1,i=1..n1)]);
 
if LieAlgCheck(abelian) then
    	RETURN( [ [[[`Lie_alg`,original_alg_name,[n1]],structure_constants_list()] ],eval(CBM)]);
 fi;

if flag_value= true then 
print(cat(`Checking indecomposability of: ` , original_alg_name));
fi;

alg_temp:=[[`Lie_alg`,original_alg_name,[n1]],structure_constants_list()] ;

if LieAlgCheck(alg_temp,indecomposable) then
   	RETURN( [ [[[`Lie_alg`,cat(original_alg_name,0),[n1]],structure_constants_list()]  ],eval(CBM)]);
fi;

if flag_value= true then 
print(cat(`The algebra `, original_alg_name, ` is decomposable.`));
fi;


 _Vessiot_show_intermediate_steps_flag:=false;




if flag_value= true then 
print(cat(`Performing  central  decomposition of: ` , original_alg_name));
fi;


 D1:=central_decomposition();
 abelian_factor:=D1[1];
 if abelian_factor=[] then 

	if flag_value= true then 
	print(cat(`The central  decomposition of ` , original_alg_name,   ` is trivial.`));
	fi;

 abelian_factor:=op([]) fi;
 CBM:=LinearAlgebra[MatrixMatrixMultiply](D1[3] , CBM);
 
 stack1:=[D1[2]];
	
while stack1<>[] do
 	n2:=nops(stack1);
	n3:=stack1[n2][1,3,1];

		
if flag_value= true then 
print(cat(`Decomposing the algebra: `, stack1[n2][1][2]));
fi; 
    
Lie_algebra_init(stack1[n2],[factor_vector],[factor_form]);
                  
fr_name:=_Vessiot_current_frame_name;
D1:=decompose_algebra();

if  nops(D1) =2 then	 
    			stack2:=[stack1[n2],op(stack2)];
		  	stack1:=[seq(stack1[j],j=1..n2-1)];
			 B1:=Matrix(n1-n3,n3,0);
			 B2:=LinearAlgebra[DiagonalMatrix]([seq(1,k=1..n1-n3)]);
			 B3:=LinearAlgebra[DiagonalMatrix]([seq(1,k=1..n3)]);
			 B4:=Matrix(n3,n1-n3,0);
			 reorder_matrix:=LinearAlgebra[Transpose](Matrix([[B1,B2],[B3,B4]]));
 		else
		      stack1:=[seq(stack1[j],j=1..n2-1),D1[1],D1[2]];
    			if n1<>n3 then 
				B1:=LinearAlgebra[DiagonalMatrix]([seq(1,k=1..n1-n3)]) 
			else 
				B1:=Matrix(0,0) fi;
    				B2:=D1[3];
    				reorder_matrix:=LinearAlgebra[DiagonalMatrix]([B1,B2]);
    				if  fr_name<> original_alg_name then 
 					remove_frame(fr_name);
				fi;
 			fi;
 			CBM:=LinearAlgebra[MatrixMatrixMultiply](reorder_matrix , CBM);
od;
 
if flag_value= true then 
print(`Sorting  factors`);
fi; 


reorder_info:=reorder_Lie_algebras(stack2);
stack2:=[op(reorder_info[1]),abelian_factor];
 B1:=reorder_info[2];
	 
if abelian_factor<>op([]) then
	 B2:=LinearAlgebra[DiagonalMatrix]([seq(1,j=1..abelian_factor[1,3,1])]) else B2:=Matrix(0,0) fi;
	 reorder_matrix:=LinearAlgebra[DiagonalMatrix]([B1,B2]);
	CBM:=LinearAlgebra[MatrixMatrixMultiply](reorder_matrix , CBM);

	 for k to nops(stack2) do
	  	stack2[k][1,2]:=cat(original_alg_name,`:Factor`,k);
	 od;
 

change_Lie_algebra_to(original_alg_name);
 _Vessiot_show_intermediate_steps_flag:=flag_value;
 

RETURN([stack2,eval(CBM)]); 

end:



reorder_Lie_algebras:=proc(full_factor_list::listlist)

local i,j,k,number_of_total_factors,colnum,final_list,
	factor_list,factor,number_of_subfactors,max_dim, 
	factor_list2,factor2,alg_dim,factor_dim,cononical_form_matrix,_ZM,matrix_blocks;

number_of_total_factors:=nops(full_factor_list);
 
colnum:=0;
factor_list:=[];
for factor in full_factor_list do
    factor_list:=[op(factor_list),[factor,colnum+1]];
    colnum:=colnum+factor[1,3,1];
od;


alg_dim:=colnum;
 
final_list:=[];

for i to number_of_total_factors do
    	number_of_subfactors:=nops(factor_list);
    	max_dim:=max(seq(factor_list[j][1,1,3,1],j=1..number_of_subfactors));
   	for factor in factor_list do 
		if factor[1,1,3]=[max_dim] then break 
		fi 
     	od;

	factor_list2:=[];

	for factor2 in factor_list do 
		if factor2[2]<>factor[2] then 
		factor_list2:=[op(factor_list2),factor2] 
		fi 
	od; 

	final_list:=[op(final_list),factor];
	factor_list:=factor_list2;
od;
 
colnum:=0;
matrix_blocks:=[];

for i to number_of_total_factors do
	factor_dim:=final_list[i][1,1,3,1];
    	_ZM[i]:=Matrix(factor_dim,alg_dim,0);
    	colnum:=final_list[i][2];
    	seq(assign('_ZM[i][j,colnum-1+j]'=1),j=1..factor_dim);
    	matrix_blocks:=[op(matrix_blocks),_ZM[i]];
 od;
 
cononical_form_matrix:=Matrix([seq([m], m=matrix_blocks)]);
 
final_list:=[seq(final_list[i,1],i=1..number_of_total_factors)];
 
RETURN([final_list,eval(cononical_form_matrix)]);
 
end:

#------------------------------------------------------------------------

#-----------------------------------------------------
