#
#  Initial.alg
#
#  LieAlg
#
#  change_Lie_algebra_to; Lie_algebra_init;
#
#


#~~~~~~~~~~~~~~~~~~ change_Lie_algebra_to ~~~~~~~~~~~~~~~~~~

change_Lie_algebra_to:=proc(alg_name) 

# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `same as change_frame_to`;

if nargs=0 then 
	ERROR(cat("\n LieAlg Error:",
		    "\n The argument for change_Lie_algebra_to must be an",
		    "\n initialized Lie algebra."))
fi;


if member(alg_name, listOfFrameNames())= false then 
	ERROR(cat("\n LieAlg Error:",
		    "\n The argument for change_Lie_algebra_to must be an",
		    "\n initialized Lie algebra."))
fi;

	 
		

change_frame_to(alg_name);

end:

#~~~~~~~~~~~~~~~~~ Lie_algebra_init ~~~~~~~~~~~~~~~~~

Lie_algebra_init := proc(vessiot_alg)

# CLASS I PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `initialize a Lie algebra`;

local check, frame, term, ind, i, j, f, n, struct_eq,k, 
	p, q, r, v, s,vector_basis, oneform_basis, alg_name,	
	LieAlg_vector_basis_labels,fr,LieAlg_bracket_array,
	LieAlg_ext_d_list, LieAlg_oneform_basis_labels;

global _Vessiot_frame_data, _VessiotWarningFlag;


if nargs=0 then  
	ERROR(cat("\n LieAlg ERROR:",
                "\n Lie_algebra_init requires a Lie algebra data structure." ))
fi;


if type(vessiot_alg, Vessiot_Lie_alg)=false then
	ERROR(cat("\n LieAlg ERROR:",
                "\n Lie_algebra_init requires a Lie algebra data structure." ))
fi;


struct_eq:=vessiot_alg[2];
n:=vessiot_alg[1][3][1];
alg_name:=vessiot_alg[1][2];

if member(alg_name,listOfFrameNames()) then 
	remove_frame(alg_name);
fi;

if n>1 then
	coord_init([seq(cat(z,i), i = 1 .. n)],[], alg_name,LieAlg_frame);
else
      coord_init([seq(cat(z,i), i = 1 .. n)],[u], alg_name,LieAlg_frame);
fi;

_Vessiot_current_frame_name;

if nargs >=2 then
      vector_basis := args[2]; 
	oneform_basis:= args[3];

 
	if type(vector_basis,list(name))=false then 
		ERROR(cat("\n LieAlg Error:",
		          "\n Third argument to Lie_algebra_init must a list of unassigned names."))
	fi;
	
	if type(oneform_basis,list(name))=false then 
		ERROR(cat("\n LieAlg Error:",
		          "\n Fourth argument to Lie_algebra_init must a list of unassigned names."))
	fi;
else
	 
	vector_basis := []; 
	oneform_basis:= [];
fi;
   
 	
 
LieAlg_vector_basis_labels :=constructFrameLabels(vector_basis, "e", n);

LieAlg_oneform_basis_labels:=constructFrameLabels(oneform_basis, "theta", n);


if  LieAlg_vector_basis_labels =[] or LieAlg_oneform_basis_labels=[] 
      then 
	print(`frame_init terminated`);
      RETURN()
fi;


for i to n do 	
	assign(reconstructVariableName(LieAlg_vector_basis_labels[i]),  frameBaseVectors()[i])
od;

for i to n do 
	assign(reconstructVariableName(LieAlg_oneform_basis_labels[i]), frameBaseForms()[i]);
od;


LieAlg_ext_d_list:= [seq(zero_form(2), i = 1 .. n)];
 
for term in vessiot_alg[2] do
      LieAlg_ext_d_list[term[1][3]] := 
      LieAlg_ext_d_list[term[1][3]] &minus (term[2] &mult (frameBaseForms()[term[1][1]]
        &wedge frameBaseForms()[term[1][2]]      ));    
od;
          
f:=(i,j)->zero_vect();
                      
LieAlg_bracket_array:=Matrix(n,n,f);

for term in vessiot_alg[2] do 
	LieAlg_bracket_array[term[1][1], term[1][2]]:= 
	LieAlg_bracket_array[term[1][1], term[1][2]] &plus
				(term[2] &mult frameBaseVectors()[term[1][3]] )
od;
 

for i from 1 to n  do
	for j from i to n  do
		LieAlg_bracket_array[j,i]:=  (-1) &mult LieAlg_bracket_array[i,j];
	od;
od;


fr:=_Vessiot_current_frame_name;

_Vessiot_frame_data[fr][1][2]:=LieAlg_frame;

_Vessiot_frame_data[fr][1][4]:=[op(_Vessiot_frame_data[fr][1][4][1..4]),
	LieAlg_vector_basis_labels, LieAlg_oneform_basis_labels,[],[],frameIndependentVariables()];

_Vessiot_frame_data[fr][2]:=[[]];
_Vessiot_frame_data[fr][3]:=[LieAlg_ext_d_list]:

_Vessiot_frame_data[fr][4]:=Matrix(1,1,0) ;
_Vessiot_frame_data[fr][5]:=eval(LieAlg_bracket_array):

cat(`Lie algebra: `, _Vessiot_frame_data[fr][1][3]);


end:


#***************************************************