#
# Input_output.alg
# 
# LieAlg 
#
# mult_table
#
#

#~~~~~~~~~~~~~~~~~~~ mult_table ~~~~~~~~~~~~~~~~~~~

mult_table:=proc(table_type)

# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Displays various Lie algebra multiplication tables`; 

local i, ans,Lie_bracket_mult_table,Lie_derivative_mult_table;



#
# LOCAL SUBROUTINES
#

#.......... Lie_bracket_mult_table ...........

Lie_bracket_mult_table := proc()

local i, j,n, fr, k, the_matrix, tab_one, 
	tab_two, tab_three,vec, vec_1, vec_2;

optionalFrameCheck([args],0);

fr:=_Vessiot_current_frame_name;
n:=frameBaseDimension();

the_matrix := Matrix(n,n,0);
	
for i from 1 to n do
	for j from i+1 to n do  
		vec:=Lie_bracket(Vect(i), Vect(j));
            if op(vec)[2][1][2]<> 0 
		then  		
            	the_matrix[i,j] := vec;
			the_matrix[j,i] := (-1) &mult vec;
		fi;
	od;
od;

tab_one := array(1..2, 1..n);
for i from 1 to n do
tab_one[1,i] := labelDataToLabel(frameLabels()[i]);
tab_one[2,i] := `----`;od;

tab_three:=array(1..n+2,1..2);
tab_three[1,1]:=``;
tab_three[1,2]:=`|`;
tab_three[2,1]:=``;
tab_three[2,2]:=`---`;
for i from 3 to  n +2 do
tab_three[i,1]:=labelDataToLabel(frameLabels()[i-2]);
tab_three[i,2]:=`|`;
od;


tab_two := Matrix([[tab_one],[the_matrix]]);
tab_two := Matrix([tab_three,tab_two]);
eval(tab_two);
end:

#........... Lie_derivative_mult_table ...........

Lie_derivative_mult_table := proc()

local i, j, k,n,fr, the_matrix, tab_one, 
	tab_two, tab_three, vec_1, onef ,vec_2;

optionalFrameCheck([args],1);

n:=frameBaseDimension():
fr:=_Vessiot_current_frame_name:

the_matrix := Matrix(n,n,0);

for i from 1 to n do
	for j from 1 to n  do 
		onef:=Lie_derivative(frameBaseVectors()[i],frameBaseVectors()[j]);
            if onef[2][1][2]<>0  then 
			the_matrix[i,j] := onef
		fi;
	od
od;

tab_one := array(1..2, 1..n);

for i from 1 to n do
tab_one[1,i] := reconstructVariableName(coframeLabels()[i]);
tab_one[2,i] := `----`;od;

tab_three:=array(1..n+2,1..2);
tab_three[1,1]:=``;
tab_three[1,2]:=`|`;
tab_three[2,1]:=``;
tab_three[2,2]:=`---`;
for i from 3 to n +2 do
tab_three[i,1]:=reconstructVariableName(frameLabels()[i-2]);
tab_three[i,2]:=`|`;
od;

tab_two := Matrix([[tab_one],[the_matrix]]);
tab_two := Matrix([tab_three,tab_two]);
eval(tab_two);
end:

#
# MAIN PROCEDURE
#

if nargs=0 then 
	ERROR(cat("\n LieAlg Error:",
                "\n The argument for mult_table must be one of {bracket, derivative,ext_d}."))
fi;


if table_type='bracket' then
	ans:=Lie_bracket_mult_table();
      RETURN(eval(ans));
fi;

if table_type='derivative' then
	ans:=Lie_derivative_mult_table();
      RETURN(eval(ans));
fi;


if table_type='ext_d' then
	for i from 1 to frameBaseDimension() do
	print(d(reconstructVariableName(coframeLabels()[i]))=ext_d(frameBaseForms()[i])  ) 
	od;
	RETURN()
fi;

 
ERROR(cat("\n LieAlg Error:",
          "\n The argument for mult_table must be one of {bracket, derivative,ext_d}."))



end:

#****************************************************