#
# Levi_decomposition.ms
#
# LieAlgClass
#
# Levi_decompostion


LeviDecomposition:=proc()


# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Find Levi decomposition.`;



local Rad, Rad0, DAR, L, DS, subalg, A ,SS, LD, Phi,masterAlgebra,LL
,phi,n,b, subalgData,R,k,DR,B,subalg_pair,alg_name1, alg_name2,alg_name3; 


masterAlgebra:=_Vessiot_current_frame_name;

n:=frameBaseDimension();

if _Vessiot_show_intermediate_steps_flag= true then 
	print(`Begin Step 1`); 	
      print(cat(`Computing Radical of `, masterAlgebra));
      fi;



L:=frameBaseVectors();


Rad:=canonical_subspace_basis(rad(),L);

if  nops(Rad) = 0 then 
	if _Vessiot_show_intermediate_steps_flag= true then 
	print(`Algebra is semi-simple`);
      print(`End of Step 1`); 
      fi;
RETURN([Rad, L]);
fi;

if nops(Rad) = frameBaseDimension() then
	if _Vessiot_show_intermediate_steps_flag= true then 
		print(`Algebra is solvable`);
            print(`End of Step 1`); 
      fi;
RETURN([Rad, []])
fi;




if _Vessiot_show_intermediate_steps_flag= true then 
       print(`Begin  Step 2 `);		
       print(`Computing Derived Series`);

      fi;


DS:=LieAlg_series(derived);

subalg:=canonical_subspace_basis(DS[-1],frameBaseVectors());



alg_name1:=cat(masterAlgebra, `_P`);


if _Vessiot_show_intermediate_steps_flag= true then 
       print(`Begin  Step 2 `);		
       print(`The basis for the terminal algebra in the derived series is:`);
       print(subalg);

      fi;


subalgData:=convert(subalg,Lie_algebra_data,alg_name1, inclusion);


A:=subalgData[2];

Lie_algebra_init(subalgData[1]);

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`The terminal algebra in the  derived series is initialized as Lie algebra `, 
	 alg_name1)); 	
	print(mult_table(bracket));
fi;


#
# Get radical  of P  as a subalgebra of master alg
#

if _Vessiot_show_intermediate_steps_flag= true then	
      print(cat(`Computing Radical of `, alg_name1));
      fi;


R:=rad();
Phi:=convert(A,Lie_algebra_transform,alg_name1,masterAlgebra);

Rad0:=map2(Lie_algebra_transform,Phi,R);


if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(`End  Step 2`);
fi;


for k from 0 to  n do

if _Vessiot_show_intermediate_steps_flag= true then 
	print(`Begin Step 3`)
fi;



DR:= LieAlgebrasTools:-bracket_of_subspaces(Rad0,Rad0);

if nops(DR) = 0 then break fi;



if _Vessiot_show_intermediate_steps_flag= true then 
	print(cat(`The  radical of the subalgebra L_`, k ,   ` is not Abelian`))
fi;

LL:=Levi_loop(subalg,Rad0,k);

subalg:=LL[1];
Rad0:=LL[2];

od;

#--------------------------------------------------------------------------

if _Vessiot_show_intermediate_steps_flag= true then 
	print(cat(`Radical of `, alg_name2,  ` is  now Abelian`));
      print(`Begin Step 4`):  
       fi;

alg_name3:=cat(_Vessiot_current_frame_name,`_S4`);
change_frame_to(masterAlgebra);

subalg_pair:=convert(subalg,Lie_algebra_data,[Rad0],alg_name3 ,inclusion);

R:=subalg_pair[2];
B:=subalg_pair[3];


if _Vessiot_show_intermediate_steps_flag= true then 
	print(`Computing Semi-Simple Part of Levi Decomposition`)
      fi;


phi:=convert(B,Lie_algebra_transform,alg_name3,masterAlgebra);

LL:=Levi_decomposition_for_abelian_radical(R);
SS:=map2(Lie_algebra_transform,phi,LL[2]);
SS:=canonical_subspace_basis(SS,L);
 
remove_frame(alg_name1,alg_name2,alg_name3);


if _Vessiot_show_intermediate_steps_flag= true then 
	print(`Done!`)
      fi;




[Rad, SS]

end;

#-----------------------------------------------------------------------


Levi_loop:=proc(subalg,Rad,k)
#
# This program  inplements the  step 3 on page 223.
# For a given   algebra it constructs the  sub_algebra 3.14 which has the 
# same  semi-simple part as the   current initialized algebra.  
#

local master_alg, L, DR,C1,C2,Q,Q_data, barS, S, A,barR,phi1,i,j,trans_eq1,subalg_pair,
new_rad, temp_alg, new_subalg,Q_alg, B,phi2,R;

master_alg:=_Vessiot_current_frame_name;

temp_alg:=cat(master_alg,`_S4_`,k):

if _Vessiot_show_intermediate_steps_flag= true then 
	print(cat(`Initializing subalgebra L_`, k,  ` as Lie algebra `, temp_alg))
fi;

subalg_pair:=convert(subalg,Lie_algebra_data,[Rad],temp_alg,inclusion);

R:=subalg_pair[2];
B:=subalg_pair[3];

phi2:=convert(B,Lie_algebra_transform,temp_alg,master_alg);

L:=frameBaseVectors(temp_alg);

DR:= LieAlgebrasTools:-bracket_of_subspaces(R,R);

if _Vessiot_show_intermediate_steps_flag= true then 
	print(cat(`The radical of `, temp_alg, ` is:`));
      print(R);
	print(cat(`The derived algebra of  radical of `, temp_alg, ` is:`));
      print(DR);

fi;

C1:=canonical_subspace_basis(complementary_basis(DR,R),L);
C2:=canonical_subspace_basis(complementary_basis(R,L),L);
Q:= canonical_subspace_basis([op(C1), op(C2)],L);


if _Vessiot_show_intermediate_steps_flag= true then 
	print(`The  complementary basis to the radical is:`);
      print(Q);
fi;

Q_alg:=cat(temp_alg,`_Q`);


Q_data:=quotient_algebra(DR,Q,Q_alg);

Lie_algebra_init(Q_data);


if _Vessiot_show_intermediate_steps_flag= true then 
	print(cat(`The Factor Algebra of `, temp_alg, ` by Radical is `, Q_alg));
      print(mult_table(bracket))      
fi;


A:=LinearAlgebra[Transpose](Matrix(linear_combo(Q,L)));

trans_eq1:= seq(cat(z,i) = add(A[i, j]*cat(z,j), j = 1 .. LinearAlgebra[ColumnDimension](A)),
      	i = 1 .. LinearAlgebra[RowDimension](A));

#
# chnage this to convert/Lie_algebra_transform !!
#
phi1:=transform(Q_alg,temp_alg,[trans_eq1],A);


barR:=rad();

if _Vessiot_show_intermediate_steps_flag= true then 
	print(`Compute Levi decomposition of Factor Algebra`)
fi;


barS:=Levi_decomposition_for_abelian_radical(barR)[2];

if _Vessiot_show_intermediate_steps_flag= true then 
	print(cat(`The  radical of `, Q_alg, ` is:`));
      print(barR);
      print(cat(`The semi-simple subalgebra of `, Q_alg, ` is:`));
      print(barS);
fi;


S:=map2(Lie_algebra_transform, phi1, barS);

remove_frame(Q_alg);

new_subalg:=map2(Lie_algebra_transform, phi2, [op(DR), op(S)]);

new_rad:=map2(Lie_algebra_transform, phi2, DR);

remove_frame(temp_alg);

if _Vessiot_show_intermediate_steps_flag= true then 
	print(cat(`The subalgebra L_`, k +1 , ` is`));
      print(new_subalg);
fi;

[new_subalg, new_rad] 

end:




#--------------------------------------------------------------------------


Levi_decomposition_for_abelian_radical := proc (Rad)
local parameters, np, p, basis, new_basis, A, temp, SS,
S, q,b, vars, i, j, w, general_S, eq, combo, c_dim, ans; 

if nargs = 2 then parameters := args[2] fi;


np := nops(parameters);
p := nops(Rad);


if p=0  then RETURN([[],frameBaseVectors()]) fi; 

fr:=objectFrame(Rad[1]);
basis := frameBaseVectors(fr);

S := complementary_basis(Rad,basis); 
q := nops(S); 

vars := [seq(seq(_r[i,j],i = 1 .. q),j = 1 .. p)]; 

 
general_S := []; 

for i to q do 
w := `&plus`(S[i],v_zip([seq(_r[i,j],j = 1 .. p)],Rad,plus)); 
general_S := [op(general_S), w] 
od; 

new_basis := [op(Rad), op(general_S)];

eq := []; 
for i to q do 
	for j from i+1 to q do 
	combo := linear_combo(Lie_bracket(general_S[i],general_S[j]),new_basis); 
	eq := [op(eq), op(combo[1 .. p])] ;
	od 
od; 

A := LinearAlgebra[GenerateMatrix](eq,vars); 
ans := Vessiot_linsolve(A[1],A[2],free=_k);

if ans = NULL then  
	ERROR(cat("\n LieAlg3 Error:", 
		"\n Linsolve failed to compute semi-simple subalgebra."));
 fi; 



c_dim:=LinearAlgebra[ColumnDimension](A[1]);
ans:=subs({seq(_k[i]=0,i=1..c_dim)},ans);

temp := map(helmsimp,subs({seq(vars[i]=ans[i],i = 1 .. p*q)},general_S)); 
SS:=map2(subs,{seq(_t[i] = parameters[i],i = 1 .. nops(np))},temp) ;

[Rad,SS]

end:

#*****************************


