#
# New_subalgebras_from_old.alg
#
# LieAlg
#
# minimal_subalgebra, minimal_ideal
#
#

#~~~~~~~~~~~~~~~~~~ minimal_subalgebra ~~~~~~~~~~~~~~~~~~~~

minimal_subalgebra := proc(span_set0)

# CLASS II PROGRAM
# 01/13/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Compute the minimal subalgebra containing a list of vectors`;

local i , n , n1,S1, S2, S3,S4,span_set,fr;

vars,A,N,C,i,j,eq,v,basis,sub_vars,span_set;
 
if nargs=0 then
	ERROR(cat("\n LieAlg Error:",
                "\n minimal_subalgebra requires 1 argument:",
		    "\n a list of vectors."))
fi;

if type(span_set0, list)=false then 
	ERROR(cat("\n LieAlg Error:",
                "\n The argument for minimal_subalgebra  must be a",
		    "\n a list of vectors."))
fi;

span_set:=map(evalV,span_set0); 

if type(span_set,list(Vessiot_vect))=false then 
	ERROR(cat("\n LieAlg Error:",
                "\n The argument for minimal_subalgebra  must be a",
		    "\n a list of  vectors."))
fi;


fr:=_Vessiot_current_frame_name;
n:= frameBaseDimension();

S1:=span_set;
n1:=nops(span_set);

for i from 1 to n do
	S2:=[op(LieAlgebrasTools:-bracket_of_subspaces(S1, S1)), zero_vect()] ;
	S3 := DiffGeom_basis([op(S2),op(S1)]);
	if nops(S3) > n1 then
	 	S1 := S3;
		n1 := nops(S3);
	elif nops(S3) = n1 then
		S4:=canonical_subspace_basis(S3,frameBaseVectors());
		RETURN(S4);
	fi;
od:

end:


#~~~~~~~~~~~~~~~~~ minimal_ideal ~~~~~~~~~~~~~~~~~~~

minimal_ideal := proc(span_set0)

# CLASS II PROGRAM
# 01/13/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Compute the minimal ideal containing a list of vectors`;


local  fr, n, n1,  span_set, S1,S2,  S3, S4, i,g0;

if nargs=0 then
	ERROR(cat("\n LieAlg Error:",
                "\n minimal_ideal requires 1 argument:",
		    "\n a list of vectors."))
fi;

if type(span_set0, list)=false then 
	ERROR(cat("\n LieAlg Error:",
                "\n The argument for minimal_ideal  must be a",
		    "\n a list of vectors."))
fi;

span_set:=map(evalV,span_set0); 

if type(span_set,list(Vessiot_vect))=false then 
	ERROR(cat("\n LieAlg Error:",
                "\n The argument for minimal_ideal  must be a",
		    "\n a list of  vectors."))
fi;

fr:=_Vessiot_current_frame_name;
n:= frameBaseDimension();

g0:=frameBaseVectors();

S1 := span_set;
n1 := nops(span_set);

for i from 1 to n do
	S2:=[op(LieAlgebrasTools:-bracket_of_subspaces(g0, S1)),zero_vect()];
	S3 := DiffGeom_basis([op(S2),op(S1)]);
	if nops(S3) > n1 then
	  	S1 := S3;
	 	n1 := nops(S3);
	elif nops(S3) = n1 then
		S4:=canonical_subspace_basis(S3,g0);
		RETURN(S4);
	fi;
od:

end:

#*******************************************************************
