Nilradical:=proc()

local 

poly_flag, masterAlgebra, listOfAlgNames, listOfAlgData, N, n, Lie_alg_dataX,

Rad, alg_name1,step1_flag, subalg1,  phi1,

L2, DL,D2L,alg_name2, step2_flag, C2, subalg2, phi2, 

CS, hypercenter,  alg_name3, step3_flag,L3,C3,subalg3,phi3,

L4,U,X,test, 

j, u,S, i, lc,  l, f,alg_name, step6_flag, step7_flag,step8_flag,phi6m,

B1, L6,C6,alg_name6q,subalg6q , phi6q, nilLB, M, alg_name6m, subalg6m, nilradM,ans,

g,adX,G, Umatrix,B2matrix,B2, comp, Y, L7,C7, alg_name7q, subalg7q, phi7q,  
alg_name7m, subalg7m, phi7m,  

alg_name8m, subalg8m, phi8m, test_square_free, square_free_factor;

global _Vessiot_current_frame_name, _Vessiot_show_intermediate_steps_flag;




if nargs=1 then  poly_flag:=args[1]  else poly_flag:=false fi;
#
#
#



test_square_free:=proc(poly, poly_flag) 
local F,ans,f;

if poly_flag=false then
	F:=factors(poly)[2];
	ans:=true;
	for  f in F do    
	if  f[2] >=2 then ans:= false 
	fi;  
	od;
	RETURN(ans);
fi;

if poly_flag=true then 
print(`The polynomial `, poly , `  is square_free`);
ans:=readstat(`(true or false)`);
RETURN(ans);
fi;

end:


square_free_factor:= proc(poly,poly_flag) 
local i, F,ans,f;
	

if poly_flag=false then
	F:=factors(poly)[2];
	ans:=product(F[i][1],i=1..nops(F));
      RETURN(ans)
fi;


if poly_flag=true then
	print(`Find a square_free_factor of`, poly);
	ans:=readstat(`g=`); 
      RETURN(ans);
fi;

end:




#
#
#
#-------------- Special Cases ---------------------- 


# Initialize

masterAlgebra:=_Vessiot_current_frame_name;

listOfAlgNames:=[];
listOfAlgData:=[];

#-----------  STEP  1 ------------------------------ 

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`Begin  calculation of nilradical for `, masterAlgebra)); 	
      print(`Step 1`);
      print(cat(`Computing radical of `, masterAlgebra)); 	
fi;

Rad:=rad();

#if1 

if nops(Rad)= 0  then 
	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
	print(`Algebra is semi-simple`); 	
	fi;
RETURN([]) 
fi;
 

if nops(LieAlgebrasTools:-bracket_of_subspaces(Rad,Rad))= 0  then 
	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
	print(`Radical  is abelian`); 	
	fi;
      ans:=canonical_subspace_basis(Rad,frameBaseVectors() );
	RETURN(ans); 
fi;



if nops(Rad)= 2  then 
	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
	print(`Radical  is 2 dimensional`); 	
	fi;
	N:= LieAlgebrasTools:-bracket_of_subspaces(Rad,Rad);
 	ans:=canonical_subspace_basis(N,frameBaseVectors() );
	RETURN(ans); 

fi;

n:=frameBaseDimension();

if nops(Rad) = n then
	if  _Vessiot_show_intermediate_steps_flag = true 
	then
		print(cat(masterAlgebra, ` is solvable`));
      fi;

	alg_name1:=cat(masterAlgebra, `_N`);
	step1_flag:=true;

      Lie_alg_dataX:=[[Lie_alg,alg_name1,[n]], structure_constants_list()];

	listOfAlgNames:=[op(listOfAlgNames),alg_name1];
	listOfAlgData:=[op(listOfAlgData), [Lie_alg_dataX] ];

	Lie_algebra_init(Lie_alg_dataX);

	phi1:=convert(LinearAlgebra[IdentityMatrix](n) ,Lie_algebra_transform, alg_name1, masterAlgebra);

	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
		print(cat(`The algebra `, masterAlgebra,  ` is re-initialized as `,  alg_name1)); 	
	      
	fi;

      change_frame_to(alg_name1);

else 

	alg_name1:=cat(masterAlgebra,`_N_S1`);
	step1_flag:=true;
	subalg1:=convert(Rad,Lie_algebra_data,alg_name1, inclusion);

	listOfAlgNames:=[op(listOfAlgNames),alg_name1];
	listOfAlgData:=[op(listOfAlgData), [subalg1] ];

	Lie_algebra_init(subalg1[1]);

	phi1:=convert(subalg1[2] ,Lie_algebra_transform,alg_name1,masterAlgebra);

	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
		print(cat(`The radical is initialized as Lie algebra `,  alg_name1)); 	
	      print(mult_table(bracket));
	fi;

       change_frame_to(alg_name1);


#fi1 

fi;

#
#  Another special case 
#

if  LieAlgCheck(nilpotent) then  
	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
		print(cat(`The radical is nilpotent`)); 	
	fi;
       
      change_Lie_algebra_to( alg_name1);
	ans:=map2(Lie_algebra_transform,phi1, frameBaseVectors()); 	
	ans:=canonical_subspace_basis(Rad,frameBaseVectors() );
	RETURN(ans); 
fi;


if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(`End of  Step  1`); 	
      print(`Begin Step 2`)
fi;

#------   STEP 2 ---------------------------------------------------------

L2:=frameBaseVectors();

DL:= LieAlgebrasTools:-bracket_of_subspaces(L2,L2);

D2L:=LieAlgebrasTools:-bracket_of_subspaces(DL, DL);

D2L:=canonical_subspace_basis(D2L,L2);

#if2 

if  nops(D2L)=0  
then
	if  _Vessiot_show_intermediate_steps_flag = true 
	then  
		print(cat(`Derived Algebra  of  `,  alg_name1,  ` is Abelian`)); fi;

	alg_name2:=alg_name1;
	step2_flag:=false;
      
else

	alg_name2:=cat(alg_name1, `_S2`);
	step2_flag:=true:
	C2:= complementary_basis(D2L,L2);

	subalg2:=quotient_algebra(D2L,C2,alg_name2,projection);


	listOfAlgNames:=[op(listOfAlgNames),alg_name2];
	listOfAlgData:=[op(listOfAlgData), [subalg2] ];

	Lie_algebra_init(subalg2[1]);

	phi2:=convert(subalg2[2] , Lie_algebra_transform, alg_name1, alg_name2);
       
      change_frame_to(alg_name2);

	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
		print(cat(`The  factor algebra of `, alg_name1, 
		` by   D2L is initialized as Lie algebra `,  alg_name2)); 	
		print(mult_table(bracket));
	fi;
#fi2

fi;

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(`End of  Step  2`); 	
      print(`Begin Step 3`)
fi;


#   -------------- STEP 3 --------------------------------------



if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`Computing Upper central series of `, alg_name2));
fi;

CS:= LieAlg_series(upper);

if CS = [[]] 
then
	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
		print(cat(`Center of `, alg_name2, ` is 0`));
      fi; 
	alg_name3:=alg_name2;
	step3_flag:=false;

else 
	L3:=frameBaseVectors();

      hypercenter:=CS[-1];
      hypercenter:=canonical_subspace_basis(hypercenter,L3);

	alg_name3:=cat(alg_name2,`_S3`);
      step3_flag:=true;
		C3:=complementary_basis(hypercenter,L3);

	subalg3:=quotient_algebra(hypercenter, C3,alg_name3,projection);

	listOfAlgNames:=[op(listOfAlgNames),alg_name3];
	listOfAlgData:=[op(listOFAlgData), [subalg3] ];

	Lie_algebra_init(subalg3[1]);
	
	phi3:=convert(subalg3[2], Lie_algebra_transform,alg_name2, alg_name3);
      
	change_frame_to(alg_name3);
        
	if  _Vessiot_show_intermediate_steps_flag = true 
	then 
		print(cat(`The  factor algebra  of  `, alg_name2, 
		` by the hypercenter is initialized as Lie algebra `,  alg_name3)); 	
	      print(mult_table(bracket));
	fi;

fi;

if  _Vessiot_show_intermediate_steps_flag = true 
	then 
	print(`End of  Step  3`); 	
      print(`Begin Step 4`)
fi;

#  ----Step 4 -------------------------------

L4:=frameBaseVectors();

U:=LieAlgebrasTools:-bracket_of_subspaces(L4,L4);
U:=canonical_subspace_basis(U,L4);  


X:= complementary_basis(U,L4);

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`Derived Algebra  U  of `, alg_name3));
      print(U); 
      print(`Complementary basis to U`);
      print(X);    
      print(`End of  Step  4`); 	
      print(`Begin Step 5`)
fi;

#----------------------STEP 5 ---------------------------------------
#
# STEP  5 to 7  are  all contained in this  j loop  
#

for  j from  1 to nops(X)   do


u:=U[1];
S:=[u];

for i from 1 to nops(U) do 
	u:= Lie_bracket(X[j],u);
	lc:=linear_combo(u,S);	
	if lc <>[] then break  fi;
	
	S:=[op(S),u]
od;

l:=nops(S);

f:= _q^(l) - add(_q^(i-1)*lc[i], i=1 ..l);

if  lc[1] = 0  
then 
	step6_flag:=true 
fi;

test:= test_square_free(f,poly_flag);

if  lc[1]<>0 and test=false 
then 
	step7_flag:=true 
fi ;

if  lc[1]<>0 and test=true 
then  
	step8_flag:=true;
fi;

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(`j=`,j);
      print(`The vector x_j is `, X[j] );
      print(`The polynomial f_j is `, f );
	print(`End of  Step  5`); 	
fi;


#  ---------- STEP  6 ----------------------------------

#if6

if   step6_flag =true  then  

if  _Vessiot_show_intermediate_steps_flag = true 
then  
       print(`Begin Step 6`)
fi;

L6:=frameBaseVectors();

B1:=LieAlgebrasTools:-bracket_of_subspaces([X[j]],U);
B1:=canonical_subspace_basis(B1,L6);

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(`The  algebra B1 is:`);
      print(B1);
fi;

C6:=complementary_basis(B1,L6);

alg_name:=_Vessiot_current_frame_name;
alg_name6q:=cat(_Vessiot_current_frame_name, `_S6Q`);

subalg6q:=quotient_algebra(B1,C6,alg_name6q,projection);

listOfAlgNames:=[op(listOfAlgNames),alg_name6q];
listOfAlgData:=[op(listOfAlgData), [subalg6q] ];

Lie_algebra_init(subalg6q[1]);

phi6q:=convert(subalg6q[2], Lie_algebra_transform,alg_name,alg_name6q);

change_frame_to(alg_name6q);

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`The  quotient of `, alg_name,  
 	` by B1 is initialized as Lie algebra `,  alg_name6q)); 	
	print(mult_table(bracket));
fi;

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(cat(`Find the nilradical of `, _Vessiot_current_frame_name))
fi;

nilLB:= Nilradical(args);
nilLB:= canonical_subspace_basis(nilLB,frameBaseVectors() );

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(nilLB);
      print(`We are back in Step 6, working with the algebra `, _Vessiot_current_frame_name); 
      print(`Find M`)
fi;

M:= transformation_subalgebra(phi6q,inverse_image,nilLB);
M:=canonical_subspace_basis(M,frameBaseVectors() );

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(M);
fi;

alg_name:=_Vessiot_current_frame_name;
alg_name6m:=cat(_Vessiot_current_frame_name, `_S6M`);

subalg6m:=convert(M,Lie_algebra_data,alg_name6m,inclusion);

listOfAlgNames:=[op(listOfAlgNames),alg_name6m];
listOfAlgData:=[op(listOfAlgData), [subalg6m] ];

Lie_algebra_init(subalg6m[1]);

phi6m:=convert(subalg6m[2], Lie_algebra_transform, alg_name6m,alg_name);

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`The subalgebra M is initialized as Lie algebra `,  alg_name6m)); 	
	print(mult_table(bracket));
      print(cat(`Compute the  nilradical  of `, alg_name6m));    
fi;

change_frame_to(alg_name6m);

nilradM:=Nilradical(args);


if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(`We are back in Step 6, working with the algebra`, _Vessiot_current_frame_name); 		
fi;

ans:= map2(Lie_algebra_transform, phi6m, nilradM);

if  _Vessiot_show_intermediate_steps_flag = true 
then  
        print(`End Step 6`)
fi;

#  break to step 9

break

#fi6

fi;

#---------- STEP 7  -----------------------------------


if   step7_flag =true  then  

if  _Vessiot_show_intermediate_steps_flag = true 
then  
       print(`Begin Step 7`)
fi;

g:=square_free_factor(f,poly_flag);


if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(`The  square_free factor is `, g);
fi;


adX:=ad(X[j]);

G:=eval(subs(_q=adX, expand(g)  ));


if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(`The  Matrix g(ad) is`, G);
fi;


Umatrix:=LinearAlgebra[Transpose](Matrix(linear_combo(U,L4)));

B2matrix:= LinearAlgebra[MatrixMatrixMultiply]
(G,Umatrix);

B2:=[];

for i from 1 to LinearAlgebra[ColumnDimension](B2matrix) 
do 
	comp:= convert(LinearAlgebra[Column](B2matrix,i),list);
	Y:=v_zip(comp,L4,plus);
	B2:=[op(B2),Y];
od;

L7:=frameBaseVectors();
B2:=  canonical_subspace_basis(DiffGeom_basis(B2),L7);

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(`The  algebra B2 is:`);
      print(B2);
fi;


C7:=complementary_basis(B2,L7);

alg_name:=_Vessiot_current_frame_name;
alg_name7q:=cat(_Vessiot_current_frame_name, `_S7Q`);

subalg7q:=quotient_algebra(B2,C7,alg_name7q,projection);


listOfAlgNames:=[op(listOfAlgNames),alg_name7q];
listOfAlgData:=[op(listOfAlgData), [subalg7q] ];

Lie_algebra_init(subalg7q[1]);

phi7q:=convert(subalg7q[2], Lie_algebra_transform, alg_name,alg_name7q);

change_frame_to(alg_name7q); 

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`The  quotient of `, alg_name, 
       ` by B2 is initialized as Lie algebra `,  alg_name7q)); 	
	print(mult_table(bracket));
fi;

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(cat(`Find the nilradical of `, _Vessiot_current_frame_name))
fi;
#
#nilLB:= Nilradical(args);
#

nilLB:= Nilradical(args);

nilLB:=canonical_subspace_basis(nilLB,frameBaseVectors());

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(nilLB);
      print(`Find M`)
fi;

M0:= transformation_subalgebra(phi7q,inverse_image,nilLB);

M:=canonical_subspace_basis(M0,L7);

if  _Vessiot_show_intermediate_steps_flag = true 
then
      print(`The algebra M is now:`); 
	print(M);
fi;

alg_name:=_Vessiot_current_frame_name;
alg_name7m:=cat(_Vessiot_current_frame_name, `_S7M`);

subalg7m:=convert(M,Lie_algebra_data,alg_name7m,inclusion);

listOfAlgNames:=[op(listOfAlgNames),alg_name7m];
listOfAlgData:=[op(listOfAlgData), [subalg7m] ];

Lie_algebra_init(subalg7m[1]);

phi7m:=convert(subalg7m[2],  Lie_algebra_transform,alg_name7m,alg_name);

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`The subalgebra M is initialized as Lie algebra `,  alg_name7m)); 	
	print(mult_table(bracket));
      print(cat(`Compute the  nilradical  of `, alg_name7m));    
fi;

# Line added here... to get back to M

#
change_frame_to(alg_name7m);

nilradM:=Nilradical(args);
nilradM:=canonical_subspace_basis(nilradM,frameBaseVectors() );


ans:= map2(Lie_algebra_transform, phi7m, nilradM);

#
#  break to step 9
#

if  _Vessiot_show_intermediate_steps_flag = true 
then
	print(`End of Step 7`);
      
fi;

break;

fi;



#---------STEP 8 ------------------------------------

# if1 
if   step8_flag =true  then  

if  _Vessiot_show_intermediate_steps_flag = true 
then  
       print(`Begin Step 8`)
fi;

#if2 
if  j= nops(X)   then

M:=centralizer([U[1]]);

M:=canonical_subspace_basis(M,frameBaseVectors() );


if  _Vessiot_show_intermediate_steps_flag = true 
then
      print(`The algebra M is now:`); 
	print(M);
fi;


#if3 

if nops(M) = nops(U) 
then
	ans:=U;
	if  _Vessiot_show_intermediate_steps_flag = true 
	then
      	print(`Since M=U, the  nilradical is U`);
	fi;

	break
fi;

alg_name:=_Vessiot_current_frame_name;
alg_name8m:=cat(_Vessiot_current_frame_name, `_S8M`);

subalg8m:=convert(M,Lie_algebra_data,alg_name8m,inclusion);

listOfAlgNames:=[op(listOfAlgNames),alg_name8m];
listOfAlgData:=[op(listOfAlgData), [subalg8m] ];

Lie_algebra_init(subalg8m[1]);


phi8m:=convert( subalg8m[2], Lie_algebra_transform, alg_name8m, alg_name);

change_frame_to(alg_name8m);

if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(cat(`The subalgebra M is initialized as Lie algebra `,  alg_name8m)); 	
	print(mult_table(bracket));
      print(cat(`Compute the  nilradical  of `, alg_name8m));    
fi;

nilradM:=Nilradical(args);

ans:= map2(Lie_algebra_transform, phi8m, nilradM);

if  _Vessiot_show_intermediate_steps_flag = true 
then  
        print(`End Step 8`)
fi;

break


#if2
fi;
#if1
fi;

#
# end of  big  do  loop  which  starts with  Step 5
#

if  _Vessiot_show_intermediate_steps_flag = true 
then  
        print(`End Step 8`);
        print( `Loop back to Step 5`); 

fi;


od;



#------   STEP 9 Reconstruct nilradical   by  4.33, 4.34. 4.35 -------------  




if  step3_flag = true 
then 
if  _Vessiot_show_intermediate_steps_flag = true 
then  
     print(`The  nilradical of`, alg_name3,` is`);
     print(ans);
fi;

ans:=transformation_subalgebra(phi3,inverse_image,ans);


if  _Vessiot_show_intermediate_steps_flag = true 
then  
     print(` Add in the hypercenter to get nilradical of`, alg_name2)  
fi;
 

fi;


if  step2_flag = true 
then

if  _Vessiot_show_intermediate_steps_flag = true 
then  
     print(`The  nilradical of`, alg_name2,` is`);
     print(ans);
fi;

ans:=transformation_subalgebra(phi2,inverse_image,ans);


if  _Vessiot_show_intermediate_steps_flag = true 
then  
     print(` Add in the hypercenter to get nilradical of`, alg_name1)  
fi;
 


fi;


if  step1_flag = true 
then

if  _Vessiot_show_intermediate_steps_flag = true 
then  
     print(`The  nilradical of`, alg_name1,` is`);
     print(ans);
fi;

ans:=map2(Lie_algebra_transform,phi1,ans);

fi;


ans:=canonical_subspace_basis(ans,frameBaseVectors() );


if  _Vessiot_show_intermediate_steps_flag = true 
then 
	print(`DONE!`);
      print(`The nilradical of`,  masterAlgebra,` is`);
      print(ans);  

fi;

map(remove_frame,listOfAlgNames);

_Vessiot_current_frame_name:=_XXXXXXXXXXXXXXX;

change_Lie_algebra_to(masterAlgebra);

ans;
#  

end:






#***************************