#
# Series.alg
#
# LieAlg
#
# LieAlg_series
#
#

#~~~~~~~~~~~~~~~~~~~~ LieAlg_series ~~~~~~~~~~~~~~~~~~~~~~



LieAlg_series:=proc(series_type)

# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Computes derived, lower_central, and  upper_central`;

local span, n1, g0, g1,g2, n0,fr,n, i, n2,C1,C2,ans;

optionalFrameChange([args],1);

if  nargs<1  then 
	ERROR(cat("\n LieAlg Error:",  
                "\n Argument for LieAlg_series must  be ", 
		    "`derived`; `lower`; or `upper`."));
fi:

fr:= _Vessiot_current_frame_name;
n:=frameBaseDimension(fr);

g0 := frameBaseVectors();

if series_type=derived then

	if _Vessiot_show_intermediate_steps_flag =   true then
		print(0, g0, n);
	fi;

      ans:=[g0];
	n0 := n;

	for i from 1 to (n + 2) do

		g1 := LieAlgebrasTools:-bracket_of_subspaces(g0, g0);
		ans:=[op(ans) ,g1];

		if nops(g1) = 0 then 
      		if _Vessiot_show_intermediate_steps_flag =   true then
			print(i, g1, 0) 
            	fi;
            RETURN(ans)
		fi;

		n1 := nops(g1);
	
		if n1 = n0 then
			if _Vessiot_show_intermediate_steps_flag =   true then
				print(infinity, g1, n0) 
            	fi;
            RETURN(ans)
		fi;

		g0 := g1;
		n0 :=n1;

		if _Vessiot_show_intermediate_steps_flag =   true then
			print(i, g1, n1);
      	fi;

	od;

	ans
fi;

if series_type='lower' then 
	
	g0 := frameBaseVectors();
	ans:=[g0];

	g1:=g0;

	if _Vessiot_show_intermediate_steps_flag =   true then
		print(0, g0, n);
	fi;

	n0 := n;

	for i from 1 to (n + 2) do
		g2 := LieAlgebrasTools:-bracket_of_subspaces(g1, g0);
		ans:=[op(ans) ,g2];

		if nops(g2) = 0 then 
      		if _Vessiot_show_intermediate_steps_flag =   true then
				print(i, g2, 0) 
            	fi;
            RETURN(ans)
		fi;
		n1 := nops(g2);
		if n1 = n0 then
			if _Vessiot_show_intermediate_steps_flag =   true then
				print(infinity, g1, n0) 
           		fi;
            	RETURN(ans)
		fi;
		
		g1 := g2;
		n0 :=n1;

		if _Vessiot_show_intermediate_steps_flag =   true then
			print(i, g1, n1);
      	fi;

	od;

      RETURN(ans)
fi;

#............................

if series_type= 'upper' then
    	C1 := center();

	if nops(C1) =0  then RETURN([[]]) fi;

	n1 := nops(C1);

	ans:=[C1];
   
	if _Vessiot_show_intermediate_steps_flag =   true then
		print(1, C1, n1);
	fi;

	for i from 2 to n + 2 do
		C2 := LieAlgebrasTools:-generalized_center(C1);
		n2 := nops(C2);
        	if n1 = n2 then 
			if _Vessiot_show_intermediate_steps_flag =   true then
            		print (infinity, C1, n2)
        		fi;
            	RETURN(ans)
        	fi;

	if _Vessiot_show_intermediate_steps_flag =   true then
		print(i,  C2, n2);
	fi;

	C1 := C2;
	n1 := n2;

	ans:=[op(ans),C2];
	od;

	RETURN(ans);
fi;

ERROR(cat("\n LieAlg Error:",
	    "\n Argument for LieAlg_series must be `derived`; `lower`; or `upper`:",
          "\n ", series_type));

end:


#********************************************************






