#
# Utilites_.alg 
#
# change_Lie_algebra_basis
#
# Check to see if this  program is  used or if we just need to keep  subalgebra_to_adapted_Lie_algebra_basis
#



change_Lie_algebra_basis:=
proc(A0)
 
local A,ans,change_Lie_algebra_basis_array,subalgebra_to_adapted_Lie_algebra_basis;


if nargs <1 then 
	ERROR(cat("\n LieAlg Error:", 
		    "\n change_Lie_algebra_basis requires:", 
                "\n First argument: array or list of vectors;",
                "\n Second argument(optional): new Lie algebra name;",
                "\n Third argument(optional): initialized Lie algebra name",
		    " or Lie algebra data structure.")); 
fi;

if not type(A0,Matrix) and not type(A0,list) then
	ERROR(cat("\n LieAlg Error:", 
		    "\n First argument for change_Lie_algebra_basis must be an: ",
                "\n Matrix or a list of vectors."))	
fi;

if nargs>=2 then
     if type(args[2],name)=false then 
     		ERROR(cat("\n LieAlg Error:", 
		   	    "\n Second argument for change_Lie_algebra_basis must be a",
		   	    " new Lie algebra name."))
	fi;
fi;

if nargs=3 then 
    	if type(args[3],{name, Vessiot_Lie_alg})=false then 
		ERROR(cat("\n LieAlg Error:", 
		    	    "\n Third argument for change_Lie_algebra_basis must be an",
		    	    "\n initialized Lie algebra name or Lie algebra data structure."))
   	fi;
fi;
#
# THis last ERROR  check is not compatible with subalgebra_to_adapted_Lie_algebra_basis;

#	 	
 
#
# LOCAL SUBROUTINES
#


change_Lie_algebra_basis_array:=proc(A,alg_nam,alg)

local B,n,i,j,k,r,s,t,C,struct_const,fr, term, alg_name,Lie_alg_data; 

if nargs>1 then 
	alg_name:=args[2] 
else 
	alg_name:= `Koszul` 
fi;


if nargs<3 then
	Lie_alg_data:=convert(_Vessiot_current_frame_name,Lie_algebra_data)
fi;

if nargs=3 and type(alg,name) then 
	Lie_alg_data:=convert(alg,Lie_algebra_data)
fi;

if nargs=3 and type(alg,Vessiot_Lie_alg)then
	Lie_alg_data:=alg
fi;


n:=frameBaseDimension();

if  LinearAlgebra[RowDimension](A) <> n or  LinearAlgebra[ColumnDimension](A) <> n then
 	ERROR( cat("\n LieAlg Error:", 
                 "\n The Matrix must be a n x n Matrix, where n=",n, 
		     " is the dimension of the Lie algebra."))
fi;

	

if  simplify(LinearAlgebra[Determinant](A)) = 0 then  
	ERROR(cat("\n LieAlg Error:",  
		    "\n Change of basis Matrix  not invertible.")) 
fi;

n:= frameBaseDimension();





B:=LinearAlgebra[MatrixInverse](A);

struct_const:=[];
for i from 1 to n do 
	for j from i+1 to n 
		do for k from 1 to n do 
            C:=0;
            for term in Lie_alg_data[2] do
	     		r:=term[1][1]; 
			s:=term[1][2];
			t:=term[1][3];  
            	C:=C + B[r,i]*B[s,j]*A[k,t]*term[2] 			 
			     -  B[s,i]*B[r,j]*A[k,t]*term[2]

	      od; C:= simplify(C);
		if C <> 0 
		then struct_const:=[op(struct_const),[[i,j,k],C]]
 		fi;
od;
od;
od;

[[Lie_alg,alg_name,[n]],struct_const];

end;

#.......................


subalgebra_to_adapted_Lie_algebra_basis:= proc (sub_alg) 
local A, M, alg_name, basis, data, i; 

if nargs = 3 then 
	M := args[3] 
else 
	M := complementary_basis(sub_alg,frameBaseVectors() ) 
fi; 

if 1 < nargs then 
	alg_name := args[2] 
else 
	alg_name := Koszul 
fi; 

basis := [op(sub_alg), op(M)]; 

data := convert(basis,Lie_algebra_data,alg_name); 

Lie_algebra_init(data); 

data, [seq(frameBaseVectors()[i],i = 1 .. nops(sub_alg))] 

end:

#
# MAIN ROUTINE
#


if type(A0,Matrix) then 
	ans:=change_Lie_algebra_basis_array(args);
      RETURN(ans) 

fi;

if type(A0,list) then 
	A:=map(evalV,A0);
	if nops(DiffGeom_basis(A)) <> nops(A) then 
		ERROR(cat("\n LieAlg Error:",
                      "\n Vectors in first argument for change_Lie_algebra_basis are",
                      "\n not independent."))
	fi	
fi;

if type(A,list(Vessiot_vect) ) and	nops(A)=frameBaseDimension() then
	ans:=convert(A,Lie_algebra_data,args[2..-1]);
	RETURN(ans)
fi;

if type(A,list(Vessiot_vect)) and	nops(list)<frameBaseDimension() then
	ans:=subalgebra_to_adapted_Lie_algebra_basis(A,args[2..-1]);
      RETURN(ans);
fi;

end:


#************************************************











