#
#  LieAlg2
#

AscendingIdealsBasis:=proc()

local ans, basis, C,S;

ans:=[frameBaseVectors(), []];

while  ans[1]<>[] do 
	basis:=[op(ans[1]), op(ans[2])];
	S:=LieAlgebrasTools:-bracket_of_subspaces(ans[1], ans[1]);
	C:=complementary_basis(S,ans[1]);
	ans[1]:=canonical_subspace_basis([op(S),op(C[1..-2])],basis);
      ans[2]:=canonical_subspace_basis([C[-1],op(ans[2])],basis)
od;

ans[2];
end:


CheckAscendingIdealsBasis:=proc(B0)

local B,n,i,C,TF;

B:=evalV(B):
n:=nops(B);

for i from 2 to n do
	C:=LieAlgebrasTools:-bracket_of_subspaces(B[1..i-1],B[1..i]);
	TF:=linear_combo(C, B[1..i-1],check);
	if TF = false then  
		RETURN(false) 
fi;
od; 

true: 
end:

CheckSolvableRepresentation:=proc(rho,B) 

local fr, C,A,sigma,test_upper_triangular,S;

if nargs =2 then 
	fr:=objectFrame(B[1]);
	C:=linear_combo(B,frameBaseVectors(fr));
	A:=LinearAlgebra[Transpose](convert(C,Matrix));
	sigma:=ChangeRepresentationRangeBasis(fr,A^(-1),rho);
else  
	sigma:=rho 
fi;

test_real_solvable_matrix:=proc(A) 
local n,i,j,flag; 

n:=LinearAlgebra[RowDimension](A);

for i from 1 to n-1 do  
	if A[i+1,i] <> 0 then 
		if  A[i,i] <> A[i+1,i+1] or A[i+1,i] <> -A[i,i+1] 
			then RETURN (false) 
		fi 
	fi;
	
	for j from i+2 to n do 
		if A[j,i]<> 0 then 
			RETURN(false) 
		fi
 	od 	
od;

true
 
end;




OLDtest_upper_triangular:=proc(A) 
local n,i,j,flag; 

n:=LinearAlgebra[RowDimension](A);

for i from 1 to n-1 do 
	for j from i+1 to n do 
		if A[j,i]<> 0 then 
			RETURN(false) 
		fi
 	od 	
od;
true 
end;

for S in sigma[2] do 
	if not test_real_solvable_matrix(S) then RETURN(false)
fi;

od;
true:
end:


#~~~~~~~~~~~~~~
#



RepresentationEigenvector:=proc(rho) 

local W, V, n,m,E,flag,lambda,M,Id,alg,Lambda,A,C,C0,newW,i,N,v,w,F;

alg:=transformDomain(rho)[1];
V:=transformRange(rho)[1];

n:=frameBaseDimension(alg);

m:=frameBaseDimension(V);

E:=Vector([1,0$(m-1)]);

flag:=false;
lambda:=[];

for v in frameBaseVectors(alg) do

	C:=linear_combo(LinearAlgebra[Column](ApplyRepresentation(rho,v),1),[E]);
	if C=[] then 
		flag:=false; 
		break; 
	else 
		flag:=true ; 
		lambda:=[op(lambda), C[1]]; 
	fi;
od;

if flag=true then RETURN(lambda,[frameBaseVectors(V)[1]]) fi;


F:=proc(a,b) 

if nops(indets(a)) <> 0 then RETURN(false) fi;
if nops(indets(b)) <> 0 then RETURN(false) fi;

if a= 0 and b<>0  then RETURN(true)fi; 
if evalc(Im(a)) = 0 and evalc(Im(b)) <>0 then RETURN(true) fi;
if evalc(Im(b)) = 0 and evalc(Im(a)) <>0 then RETURN(false) fi;

if evalc(Im(a))=0 and evalc(Im(b ))=0 and evalc(Re(a)) < evalc(Re(b)) 
then RETURN(true)fi;

if evalc(Im(a))=0 and evalc(Im(b ))=0 and evalc(Re(a)) >=evalc(Re(b))  
then RETURN(false) fi;

if evalc(Re(a))=0 and evalc(Re(b)) <>0 then RETURN(true) fi;if evalc(Re(b))=0 and evalc(Re(a)) <>0 
then RETURN(false) fi;

if evalc(Re(a))=0 and evalc(Re(b))=0 and evalc(Im(a)) <evalc(Im(b)) 
then RETURN(true) fi; 

if evalc(Re(a)) < evalc(Re(b)) then RETURN(true)fi;  
if evalc(Im(a)) < evalc(Im(b)) then RETURN(true) fi;
false 
end;


W:=frameBaseVectors(V):
Lambda:=[];

for i from 1 to frameBaseDimension(alg) do
      M:=ApplyRepresentation(rho,frameBaseVectors(alg)[i]); 
	A:=RestrictMatrix(M,W);
	C0:=LinearAlgebra[Eigenvalues](A);
      C:=sort(C0,F); 
	Id:=LinearAlgebra[IdentityMatrix](LinearAlgebra[RowDimension](A));

	N:=Vessiot_nullspace(A-C[1]*Id); 
	
	newW:=[];
	for v in N  do 
		w:=v_zip(convert(v,list),W,plus); 		
		newW:=[op(newW),w] 
	od; 

Lambda:=[op(Lambda),C[1]];
W:=canonical_subspace_basis(newW,frameBaseVectors(V));

od;

Lambda,W; 

end:

#~~~~~ SolvableRepresentation ~~~~~

SolvableRepresentation:=proc(rho)
#
# There is still uncertainity here as to if the initial basis for the algebra must be  chain of ideals.
# In may not be needed here directly but perhaps in finding the InvariantVector??
#
local  new_alg, Q,rho1,alg,V, i, H,B,C,Q0,Q1,Q2,F,S,A1,X1,X2,X,fr,phi,c,Xbar,X3,X4; 

alg:=transformDomain(rho)[1];
V:=transformRange(rho)[1];


#change_frame_to(alg);

#S:=SolvableBasis();

#new_alg:=cat(fr,`_0`);

#Q0:=convert(S,Lie_algebra_data,new_alg,m);
#A1:=Q0[2];
#Lie_algebra_init(Q0[1]);

#rho:=ChangeRepresentationDomainBasis(new_alg,A1,rho0);

#phi:=convert(A1,Lie_algebra_transform ,cat(fr,`_0`),alg);

X:=RepresentationEigenvector(rho)[2][1];

c:=coeff_list(X,all);

if evalc(map(conjugate,c))=c then 
	B:=[X]; 
      H:=[1]
else 
	Xbar:=Vessiot_map(evalc,Vessiot_map(conjugate,X)); 	X3:=evalV(1/2*(X +Xbar));
	X4:=evalV(I/2*(X -Xbar)); 
	B:=[X3,X4];
      H:=[2]
fi;

i:=0;

while nops(B) < frameBaseDimension(V) do 
	i:=i+1;
	C:=complementary_basis(B, frameBaseVectors(V));
        
        Q:=[[Lie_alg,temp,[nops(C)]], [ ] ];
    
        Lie_algebra_init(Q);

     
        rho1:=QuotientRepresentationBySubspace(rho,B,C,temp);

 	
	#F:=SolvableBasis();
	#Q2:=convert(F,Lie_algebra_data,cat(Q,fr,i,"_1"),m);
 	#Lie_algebra_init(Q2[1]);
 	
	X2:=RepresentationEigenvector(rho1)[2][1];
 	X1:=linear_combo(X2,frameBaseVectors(temp));
 	#C:=convert(LinearAlgebra[MatrixMatrixMultiply](LinearAlgebra[MatrixInverse](Q2[2]),X1),list);
	X:=v_zip(X1,C,plus);

	if evalc(map(conjugate,X1))=X1 then 
		B:=[op(B),X];  
	      H:=[op(H),1 +H[-1]];
	else 
		Xbar:=Vessiot_map(2,evalc,Vessiot_map(2,conjugate,X)); 
		X3:=evalV(1/2*(X +Xbar));
		X4:=evalV(I/2*(X -Xbar)); 
		B:=[op(B),X3,X4];
            H:=[op(H),2 +H[-1]];  
      remove_frame(cat(Q,fr,i,"_0"));
	remove_frame(cat(Q,fr,i,"_1"));


fi;

od; 

B,H;

end:



SolvableBasis:=proc() 
local alg,   alg1, B1,A1,L,A2, B2, C, ans,rho, A3; 
alg:=_Vessiot_current_frame_name; alg1:=cat(alg,`_temp`);

B1:=AscendingIdealsBasis();
A1:=Matrix(linear_combo(B1,frameBaseVectors(alg) ));
L:=convert(B1,Lie_algebra_data,alg1);
Lie_algebra_init(L,[f],[theta]);

rho:=MakeRepresentation(alg1,alg1,ad());
B2:=SolvableRepresentation(rho);
A2:=Matrix(linear_combo(B2[1],frameBaseVectors(alg1) ));

A3:=LinearAlgebra[MatrixMatrixMultiply](A2,A1); 
C:= convert((A3),listlist);
ans:=map(v_zip,C,frameBaseVectors(alg),plus);

ans,B2[2];

end:


