ClassifySemisimple:=proc(alg)
 local kdim,kvb,basis_vector,H,CH,eigen_info,eigen,RE,IM,
evect_list,eval_list,counter,X_1,Y_1,_beta,Hp,Xp,Yp,new_basis,i,cbm;

if nargs=1 then change_alg_to(args[1]) fi;
 

RE:=(z)->evalc(Re(z)):
IM:=(z)->evalc(Im(z)):

kdim:=frameBaseDimension();
kvb:=frameBaseVectors():
 
 for basis_vector in kvb do
    H:=basis_vector;
    CH:=complementary_basis([H],kvb);
    eigen_info:=LinearAlgebra[Eigenvectors](ad(H,[H,op(CH)]),output='list');
    eval_list:=remove(has,[seq(eigen_info[i,1],i=1..nops(eigen_info))],0);
    if eval_list <> [] then break fi;
 od;
 evect_list:=[];
 for eigen in eigen_info do
    if eigen[1]<>0 then evect_list:=[op(evect_list),eigen[3,1]] fi;
 od;
 
 if map(IM,eval_list)=[0,0] then
    X_1:=v_zip([seq(evect_list[1][j],j=1..kdim)],[H,CH[1],CH[2]],plus);
    Y_1:=v_zip([seq(evect_list[2][k],k=1..kdim)],[H,CH[1],CH[2]],plus);
    Hp:=(1/eval_list[1]) &mult H;
    _beta:=op(linear_combo(Lie_bracket(X_1,Y_1),[Hp]));
    Xp:=(1/_beta) &mult X_1;
    Yp:=Y_1;
    new_basis:=[Yp,Hp,(2 &mult Xp)];
    cbm:=LinearAlgebra[Transpose](Matrix(map(linear_combo,new_basis,kvb)));
    RETURN([eval(LinearAlgebra[MatrixInverse](cbm)),[USU,[3,5,0]]]);
 fi;
 
 for counter from 1 to nops(eval_list) do
    if is(IM(eval_list[counter]),positive) then break fi;
 od;
 
 Hp:=(1/IM(eval_list[counter])) &mult H;
 X_1:=v_zip(convert(map(RE,evect_list[counter]),list),[H,op(CH)],plus);
 Y_1:=v_zip(convert(map(IM,evect_list[counter]),list),[H,op(CH)],plus);
 _beta:=1/sqrt(abs(op(linear_combo(Lie_bracket(X_1,Y_1),[Hp]))));
 
 new_basis:=[(_beta) &mult X_1,(-_beta) &mult Y_1,Hp];
 
 if linear_combo(Lie_bracket(new_basis[1],new_basis[2]),[new_basis[3]])=[-1] then 
temp:=LinearAlgebra[Transpose](Matrix(map(linear_combo,new_basis,kvb)));
    cbm:=LinearAlgebra[MatrixMatrixMultiply](temp, Matrix([[0,1,0],[1,0,1],[1,0,-1]]));
    RETURN([eval(LinearAlgebra[MatrixInverse](cbm)),[USU,[3,5,0]] ]);
 fi;
 if linear_combo(Lie_bracket(new_basis[1],new_basis[2]),[new_basis[3]])=[1] then
    cbm:=LinearAlgebra[Transpose](Matrix(map(linear_combo,new_basis,kvb)));
    RETURN([eval(LinearAlgebra[MatrixInverse](cbm)),[USU,[3,6,0]] ]);
 fi;
  
 ERROR("If you get this message, there is a big problem with the code.");
 
 end:

