#
# Beginnings of Representation  Package
#
#  Add   dual Representation .  tensor product of Rep.



RestrictMatrix:=proc(A, subspace)
local n, fr, S,i,matrix_argument,coeffs,ans;

n:=nops(subspace);
fr:=objectFrame(subspace[1]);

S:=linear_combo(subspace,frameBaseVectors(fr));
      
matrix_argument:=[];

S:=map(Vector,S);
	
for i from 1 to n do 

coeffs:=linear_combo(LinearAlgebra[MatrixVectorMultiply](A,S[i]),S);
 		if coeffs=[] then 
			ERROR(cat("\n LieAlg2 Error:",
				    "\n The   action of the given Matrix on the i-th vector",
                            "\n in the subspace does not lie in the subspace - ie the given subspace is not invariant",
                            "\n ", "i = ", i));
            else 
            matrix_argument:=[op(matrix_argument),coeffs];
            fi
      od;
   
ans:=LinearAlgebra[Transpose](Matrix(matrix_argument));
RETURN(eval(ans));

end:


CheckRepresentation:=proc(rho)
local E,n,m,Z,i,j,A,B,C,F;
E:=frameBaseVectors(transformDomain(rho)[1]);
n:=nops(E);

m:=frameBaseDimension(transformRange(rho)[1]);
Z:=Matrix(m,m,0);

for i from 1 to n do for j from i+1 to n do

A:=ApplyRepresentation(rho,Lie_bracket(E[i],E[j]));
B:=ApplyRepresentation(rho,E[i]);
C:=ApplyRepresentation(rho,E[j]);
F:=simplify(A -(LinearAlgebra[MatrixMatrixMultiply](B,C)
               -LinearAlgebra[MatrixMatrixMultiply](C,B))  );
if not LinearAlgebra[Equal](F,Z) then  RETURN(false);fi; od; od;
true

end:


QuotientMatrix:=proc(M, subspace,complement)
local i,fr,S,C,B,p,matrix_argument,ans;

fr:=objectFrame(subspace[1]);

S:=linear_combo(subspace,frameBaseVectors(fr));
S:=map(Vector,S);

C:=linear_combo(complement,frameBaseVectors(fr));
C:=map(Vector,C);

B:=[op(C), op(S)];
p:=nops(C);
 
matrix_argument:=
[seq(linear_combo(LinearAlgebra[MatrixVectorMultiply](M,C[i]),B)[1..p], i=1..p)];
 
 
ans:=LinearAlgebra[Transpose](Matrix(matrix_argument));
 
eval(ans)

end: 


#
#
#



MakeRepresentation:=proc(alg,V,M);

[[Lie_rep,[[alg,0],[V,0]],[]],M] 
end:


#
#

ChangeRepresentationRangeBasis:=proc(new_V,A,rho) 
local newM,B, P;

B:=LinearAlgebra[MatrixInverse](A);
newM:=[seq(LinearAlgebra:-MatrixMatrixMultiply(LinearAlgebra:-MatrixMatrixMultiply(A,P), B), P=rho[2])];

[[Lie_rep,[ rho[1][2][1] , [new_V,0]], []],newM];

end:

#
#

ChangeRepresentationDomainBasis:=proc(new_alg,A,rho) 
local newM,n,i,j, P;

n:=frameBaseDimension(rho[1][2][1][1]);

 newM:=[seq(eval(add(A[j,i]*rho[2][j],j=1..n)),i=1..n)];

 [[Lie_rep,[[new_alg,0], rho[1][2][2] ],[]],newM];

 end:

#
#

ApplyRepresentation:=proc(rho,x0) 

local x, m, Y,RangeFrame,
 i,fr,C,E,y,A; 

x:=evalV(x0);
fr:=transformDomain(rho)[1]; 
RangeFrame:=transformRange(rho)[1]; 
m:=frameBaseDimension(fr);
C:=linear_combo(x,frameBaseVectors(fr));
A:=eval(add(C[i]*rho[2][i],i=1..m));

if nargs=2 then RETURN(eval(A)) fi;
 
y:=evalV(args[3]);
C:=linear_combo(y,frameBaseVectors(RangeFrame));
E:=LinearAlgebra:-MatrixVectorMultiply(A,Vector(C));
Y:=v_zip(convert(E,list),frameBaseVectors(RangeFrame),plus);

Y;

end:

#
#

RestrictRepresentationToInvariantSubspace:=proc(rho,subspace,new_V)

local newM, M;

# changing  rho[1][2][2] to rho[1][2][1]

newM:=[seq(RestrictMatrix(M,subspace),M=rho[2])];

[[Lie_rep,[ rho[1][2][1] , [new_V,0]], []],newM];

end:



#
#



QuotientRepresentationBySubspace:=proc(rho,subspace,complement,new_V)

local newM, M;

newM:=[seq(QuotientMatrix(M,subspace,complement),M=rho[2])];

# changing  rho[1][2][2] to rho[1][2][1]
#

[[Lie_rep,[ rho[1][2][1] , [new_V,0]], []],newM];

end:


#~~~~~ TensorProductRepresentation

TensorProductRepresentation:=proc(rho,tensorlist,repname) 
local fr,m,n,vars,B,Tspace,M,N,X,LieTensorList,C,P;

fr:=transformRange(rho)[1]; 
m:=nops(tensorlist); 
vars:=frameIndependentVariables(fr); 
n:=frameBaseDimension(fr):
B:=frameBaseVectors(fr):

if nargs=2 then 
	Tspace:=cat(fr,"_tens"); coord_init([seq(cat(x,i),i=1..m)],Tspace);
else 
	Tspace:=repname;
fi;

M:=rho[2];
N:=[];

for M in rho[2] do 
	X:=evalV(add(add(M[i,j]*vars[i]*B[j], i=1..n), j=1..n));
	LieTensorList:=map2(Lie_derivative,(-1) &mult X,tensorlist);
	C:=linear_combo(LieTensorList,tensorlist);
	P:=Matrix(C);
	N:=[op(N),P];
od;

[[Lie_rep,[rho[1][2][1], [Tspace,0]], []],N]

end:


