

bracket_of_subspaces := proc(v0, w0)

# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Computes the subspace spanned by brackets of two subspaces`;

local n1, n2, i, j, c, v,w, gener;


if  nargs<>2  then 
	ERROR(cat("\n LieAlg Error:",  
                "\n Arguments for bracket_of_subspaces must be a pair", 
	          "\n of lists of Vessiot vectors."));
fi:

if  not type(v0,list)  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n First argument for bracket_of_subspaces must be", 
			    "\n a list of Vessiot vectors."));
fi:

v:=map(evalV,v0);

if  not type(v,list(Vessiot_vect))  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n First argument for bracket_of_subspaces must be", 
			    "\n a list of Vessiot vectors."));
fi:


if  not type(w0,list)  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Second argument for bracket_of_subspaces must be", 
			    "\n a list of Vessiot vectors."));
fi:

w:=map(evalV,w0);

if  not type(w,list(Vessiot_vect))  then 
		ERROR(cat("\n LieAlg Error:",  
                	    "\n Second argument for bracket_of_subspaces must be", 
			    "\n a list of Vessiot vectors."));
fi:

n1 := nops(v);
n2 := nops(w);

if n1=0  or n2 =0 then 
	RETURN([]) 
fi;

gener :=[seq(  seq(Lie_bracket(v[i], w[j]), j = 1 .. n2),
         i = 1 .. n1)];

DiffGeom_basis(gener);

end:

