
#~~~~~~~~~~~~~~~~~ generalized_center ~~~~~~~~~~~~~~~~~

generalized_center := proc(ideal0)

# CLASS II PROGRAM
# 01/10/2004 IA

option `Copyright Ian M. Anderson 2004`; 

description `Computes generalized center of an ideal`;

local i, n, vars, vec, eq, alpha, a, ann,ideal, ans, A, N, v, X,g0,fr;

if nargs=0 then
	ERROR("\n LieAlg Error:",  
		"\n Argument to generalized_center must be a list of vectors");
fi;

ideal:=map(evalV,ideal0);

if not type(ideal,list(Vessiot_vect)) then
	ERROR("\n LieAlg Error:",  
		"\n Argument to generalized_center must be a list of vectors");
fi;
 
if nops(DiffGeom_basis(ideal)) <> nops(ideal) then 
	ERROR("\n LieAlg Error:",  
		"\n Argument to generalized_center must be a list of independent vectors");
fi;

	    
if not LieAlgCheck(ideal,ideal1)  then  
	ERROR("\n LieAlg Error:",  
		"\n Argument to generalized_center does not define an ideal");
fi;

fr:=_Vessiot_current_frame_name;
ann := annihilator(ideal);

n := frameBaseDimension();
vars := [seq(a[i], i = 1 .. n)];
  
g0 :=frameBaseVectors();

X := v_zip(vars,g0, plus);
eq := {};

for v in g0 do 
	for alpha in ann do 
		eq :=
            eq union coeff_set(hook(Lie_bracket(X, v), alpha))
   	od
od;
  
A := LinearAlgebra[GenerateMatrix](eq, vars);
N := Vessiot_nullspace(A[1]);

ans := [];
    
for v in N do 
	ans :=[op(ans), v_zip(convert(v, list), g0, plus)]
od;
    
ans;

end:

