#
# LieAlgExtensions.alg
#
#

Lie_algebra_extension:=proc(A) 


# CLASS II PROGRAM
# 02/08/2004 IA

option `Copyright Ian M. Anderson February 2004`; 

description `Computes right and central extensions of a Lie algebra`;

local alg_name, new_alg_name, n, formComponents, new_structure_eq, old_structure_eq, centralExtensionStructureEq,
i,j,a,rightExtensionStructureEq, ans:

if nargs=0 then 
	ERROR(cat("\n LieAlg Error:" ,
                                    "\n  First  argument for Lie_algebra_extension must be:",
                                    "\n {a Matrix, a two-form}." ))
fi;

if nargs=2 then
            if type(args[2],name)=false then
		ERROR(cat("\n LieAlg Error",
                                                    "\n Second argument for Lie_algebra_extension must be an",
		                      " unassigned name.")) 
            fi;

           new_alg_name:=args[2]
else
            new_alg_name := cat(_Vessiot_current_frame_name,"C"); 
fi;



n := frameBaseDimension(); 
old_structure_eq := convert(_Vessiot_current_frame_name,Lie_algebra_data)[2]; 

if  type(A,Vessiot_form) then 

	if formDegree(A) <> 2 then 
		ERROR(cat("\n LieAlg Error:",
                                                    "\n Lie_algebra_extension requires a two form:",
		                      "\n form degree:", formDegree(A) ));
               fi;
					
	formComponents := objectComponents(A);
               
	new_structure_eq := [seq([[op(a[1]), n+1], a[2]],a = formComponents)];
               
	centralExtensionStructureEq := [op(old_structure_eq), op(new_structure_eq)]; 
	ans:=[[Lie_alg, new_alg_name, [n+1]], centralExtensionStructureEq] ; 
               
	RETURN(ans);
fi;

if type(A, Matrix) then

	# 
	# add error message for LieAlgCheck(A, derivation)
	#

	new_structure_eq :=[];
	
	for i from 1 to n do 
		for j from 1 to n do  
		
		if A[i,j]<>0 then 
			new_structure_eq :=[op(new_structure_eq ),[[j,n+1,i],A[i,j]]]; 
		fi;
		od; 
	od; 

	rightExtensionStructureEq := [op(old_structure_eq), op(new_structure_eq)]; 
	
	ans:=[[Lie_alg, new_alg_name, [n+1]], rightExtensionStructureEq] ; 
               
	RETURN(ans);

fi;

ERROR(cat("\n LieAlg Error:", 
                    "\n  First  argument for Lie_algebra_extension must be:",
                    "\n {a Matrix, a two-form}." ))

end:

         