
matrix_centralizer:=proc(list_of_matrices::list(Matrix))
local n, EQ, A, X, ans, newX, vars,a, v,Id,C;


 	
n:=LinearAlgebra[RowDimension](list_of_matrices[1]);
X:=Matrix(n, n, (i,j)->cat(x,i,j));

Id:=LinearAlgebra[IdentityMatrix](n);

EQ:={};

for A in list_of_matrices 
	do
    	EQ:=EQ union convert(LinearAlgebra[MatrixMatrixMultiply]
(X,A) - LinearAlgebra[MatrixMatrixMultiply](A,X),set);
od;


 	
ans:=solve(EQ,convert(X,set));
newX:=map2(subs,ans, X);
vars:=convert(newX,set) intersect convert(X,set);
C:=[eval(Id)];
 	
for v in vars do 
	A:=map(diff,newX,v);
	a:=LinearAlgebra[Trace](A);
      if a <>0 then A:= n*A  -a*Id fi;
	if linear_combo(A,C)=[] then C:=[op(C), eval(A)]fi;
od;
 	
C
end;




new_matrix_centralizer:=proc(list_of_matrices::list(Matrix))
local n, i, EQ, A, X, ans, newX, vars,a, v,Id,C;


 	
n:=LinearAlgebra[RowDimension](list_of_matrices[1]);
X:=Matrix(n, n, (i,j)->x.i.j);
Id:=LinearAlgebra[IdentityMatrix](n);
EQ:={};

for A in list_of_matrices 
	do
    	EQ:=EQ union convert(LinearAlgebra[MatrixMatrixMultiply](X,A) - 
LinearAlgebra[MatrixMatrixMultiply](A,X),set);
od;

vars:=map(op,convert(X,listlist));

A:=LinearAlgebra[GenerateMatrix](EQ,convert(X,set));

N:=Vessiot_nullspace(A[1]);
 	
C:=[];

for soln in N do
	S:={seq(vars[i]=soln[i], i= 1..n^2)};
	M:=map2(subs,S,X);
	C:=[op(C),eval(M)]
od;
C;

end;


#~~~~~~~  Jacobson_radical ~~~~~~~~~~~~


Jacobson_radical:=proc(matrix_alg::list(Matrix))
local a,C,d,Y,i,EQ,A,ans,newY,vars,J,v;
  	
C:=matrix_alg;
d:=nops(C);
Y:=a[1]*C[1];
 
for i from 2 to d do
     	Y:= Y + a[i]*C[i];
od;
  	
EQ:={};

for A in C  do
     	EQ:=EQ union {LinearAlgebra[Trace](LinearAlgebra[MatrixMatrixMultiply]
(Y,A) )};
od;
  	
ans:=Vessiot_nullspace(LinearAlgebra[GenerateMatrix](EQ, [seq(a[i],i=1..d)])[1]);
  	
J:=[];
  	
for v in ans do
     	J:= [op(J), eval( add(v[i]*C[i],i=1..d))]
od;
  	
J
end:



