#
# contract_and_raise
#
# contract_indices, raise_lower_indices,
# inverse_metric
#


contract_indices:=proc()

local contract_indices1, contract_indices2,ans;

#=============================================

contract_indices1:=proc(a_tensor::Vessiot_tensor, init_index_list::list(list))
#Class I program
#06/01/97:CM
#01/04/03:IA      


#    This routine contracts indices pair by pair  on a Vessiot tensor.
#    an_index_list: a list of lists of index pairs to be contracted. 


local ans,  fr, indx,i,j, index_term, index_list, tensIndex, tensComponents,p,
      new_comps, comp, new_attributes,new_tensIndex2, new_tensIndex1,
      index_pair, term; 
      

tensIndex:=tensorIndexType(a_tensor);
tensComponents:=objectComponents(a_tensor);

fr:=objectFrame(a_tensor):
VessiotFrameCheck(a_tensor):

p:=nops(tensIndex);

for index_term in init_index_list do
	if nops(index_term) <> 2 then
         	ERROR(cat("\n VESSIOT ERROR:\n indices must be contracted in pairs."))
      fi;      
od; 

index_list := init_index_list; 

#
#  These  loops  shift the index list since after each contraction the absolute 
#  positions of the indices can change:
#  [[2,5], [3,6], [1,4], [7,10] ] ->[[2, 5], [2, 4], [1, 2], [1, 4]]
#
#  

for i to nops(init_index_list) do 
	for j from i+1 to nops(init_index_list) do 
		if init_index_list[j][1]  >   init_index_list[i][1] then 
			index_list[j][1] := index_list[j][1]-1 
		fi; 

		if init_index_list[j][1]  >   init_index_list[i][2] then 
			index_list[j][1] := index_list[j][1]-1 
		fi;


		if init_index_list[j][2] >   init_index_list[i][1]  then 
			index_list[j][2] := index_list[j][2]-1 
		fi; 


		if init_index_list[j][2] >   init_index_list[i][2]  then 
			index_list[j][2] := index_list[j][2]-1 
		fi; 


	od 
od; 

# determine the new index character:

new_tensIndex1:=tensIndex;

for  index_pair in init_index_list do
	i:=index_pair[1];
	j:=index_pair[2];
 
	if not ( (tensorIndexPart1(tensIndex[i])='cov' and tensorIndexPart1(tensIndex[j])='con') 
	   or  
               (tensorIndexPart1(tensIndex[j])='cov' and tensorIndexPart1(tensIndex[i])='con'))  
	then
         ERROR(cat("\n VESSIOT ERROR:", 
                   "\n contraction must be on indices of different contravalency: ", 
                    tensorIndexPart1(tensIndex[i]),",", tensorIndexPart1(tensIndex[j])) )
      fi;

      if tensorIndexPart2(tensIndex[i]) <> tensorIndexPart2(tensIndex[j])then
         ERROR(cat("\n VESSIOT ERROR:",
                   "\n contraction must be on  indices of the same spatial type. ",
 		         tensorIndexPart2(tensIndex[i]),",",tensorIndexPart2(tensIndex[j])) )
      fi;
      
      if j<=i then
	   ERROR(cat("\n VESSIOT ERROR:\n index pairs must be given in increasing order:", 
               index_pair) );
      fi; 	

      if i >p or j>p then 
  		ERROR(cat("\n VESSIOT ERROR:",
			    "\n Index pair ", index_pair, " exceeds rank of tensor " ,p)  );
      fi; 	
      
      new_tensIndex1[i]:='del';
      new_tensIndex1[j]:='del';

od;

new_tensIndex2:=[];

for indx in new_tensIndex1 do
	if  indx <> 'del' then 
		new_tensIndex2:=[op(new_tensIndex2), indx]
      fi;
od;

new_attributes:=[tensor, objectFrame(a_tensor), [new_tensIndex2, tensorDensityType(a_tensor)]];

#    construct the new tensor:


for  index_pair in index_list do
	new_comps:=[];
	i:=index_pair[1];
	j:=index_pair[2];
 
	for term in tensComponents do
	if term[1][i]=term[1][j] then
            comp:=[op(1..i-1,term[1]), op(i+1..j-1,term[1]),op(j+1..nops(term[1]),term[1])];
          	new_comps:=[op(new_comps),[comp,term[2]] ];
      fi;    
	od;
      tensComponents:=new_comps;
      
od;

ans:=helmsimp(_VESSIOT([new_attributes,new_comps]));


        
ans
        
end:

#=======================================================================

contract_indices2:= 
proc(tensor1::Vessiot_tensor, tensor2::Vessiot_tensor, index_pairs_list::list(list))

#Class I program
#01/04/03:IA

local tensComp1, tensComp2, tensIndex1, tensDensity1, p1, fr1, tensIndex2, tensDensity2, p2, 
      fr2, index1, index2,new_tensIndex, index_term, index_pair, i, j, new_tensIndex1, 
      new_tensIndex2, new_tensDensity, new_attributes, new_compts, term1, term2,
      l, ind_pair, new_tensor_compts1, new_tensor_compts2, ans, indx,tensorProductWeight; 


tensIndex1:=tensorIndexType(tensor1);
tensDensity1:=tensorDensityType(tensor1);
p1:=nops(tensIndex1);
fr1:=objectFrame(tensor1):
tensComp1:=objectComponents(tensor1);

tensIndex2:=tensorIndexType(tensor2);
tensDensity2:=tensorDensityType(tensor2);
p2:=nops(tensIndex2);
fr2:=objectFrame(tensor2):
tensComp2:=objectComponents(tensor2);

index1 := map2(op,1,index_pairs_list);
index2 := map2(op,2,index_pairs_list);


if fr1<>fr2 then 
	ERROR(cat("\n VESSIOT ERROR:\n tensors in different frame", fr1, ",", fr2));
fi;
 
VessiotFrameCheck(tensor1);

for index_term in index_pairs_list do
	if nops(index_term) <> 2 then
         	ERROR(cat("\n VESSIOT ERROR:\n indices must be contracted in pairs."))
      fi;      
od; 

new_tensIndex1:=tensIndex1;
new_tensIndex2:=tensIndex2:


for  index_pair in index_pairs_list do
	i:=index_pair[1];
	j:=index_pair[2];
 
	if not ( (tensorIndexPart1(tensIndex1[i])=cov and tensorIndexPart1(tensIndex2[j])=con) 
	   or  
               (tensorIndexPart1(tensIndex1[i])=con and tensorIndexPart1(tensIndex2[j])=cov))  
	then
         ERROR(cat("\n VESSIOT ERROR:", 
			 "\n contraction must be on indices of different contravalency.", 
                    tensorIndexPart1(tensIndex1[i]),",", tensorIndexPart1(tensIndex2[j])) )
      fi;

      if tensorIndexPart2(tensIndex1[i]) <> tensorIndexPart2(tensIndex2[j])then
         ERROR(cat("\n VESSIOT ERROR:", 
			 "\n contraction must be on same indices of the spatial type.",
 		         tensorIndexPart2(tensIndex1[i]),",", tensorIndexPart2(tensIndex2[j])) )
      fi;
      
      if i >p1 or j>p2 then 
  		ERROR(cat("\n VESSIOT ERROR: \n Index pair", index_pair, 
                      " exceeds rank of tensors" ,[p1,p2])   );
      fi; 	
      
      new_tensIndex1[i]:=`del`;
      new_tensIndex2[j]:=`del`;

od;

new_tensIndex:=[];

for indx in [op(new_tensIndex1),op(new_tensIndex2)] do
	if  indx <> `del` then 
		new_tensIndex:=[op(new_tensIndex), indx]
      fi;
od;

# determine the new density character:


tensorProductWeight:= proc (A1,A2) 
#Class II Program
#01/05/03:IA

local A,B,a, i, j;

if A1=[] then 
	RETURN(A2) 
fi;

if A2=[] then
	RETURN(A1);
fi;
 
A := [op(A1), op(A2)] ;

for i to nops(A) do 
	for j from i+1 to nops(A) do 
		if A[i][1] = A[j][1] then 
			A[i]:= [A[i][1], A[i][2]+A[j][2]];
                  A:=[op(1..j-1,A),op(j+1..-1,A)]; 
			break 
		fi 
	od 
od; 


B:=[];

for a in A do 
if a[2] <>0 then B:=[op(B), a] fi;
od;

B; 



end:


new_tensDensity:=tensorProductWeight(tensDensity1,tensDensity2); 

    
new_attributes:=[tensor, fr1, [new_tensIndex, new_tensDensity]];

new_compts := [];

for term1 in tensComp1 do 
	for term2 in tensComp2 do
            l := 0;
            for ind_pair in index_pairs_list do 
		    l := l + (term1[1][ind_pair[1]] - term2[1][ind_pair[2]])^2
            od;
            
            if l = 0 then
                new_tensor_compts1 := [];
                for i to p1 do
                    if member(i, index1) then
                    else 
				new_tensor_compts1 :=[op(new_tensor_compts1), term1[1][i]]
                    fi
                od;

                new_tensor_compts2 := [];
                for i to p2  do
                    if member(i, index2) then
                    else 
				new_tensor_compts2 :=[op(new_tensor_compts2), term2[1][i]]
                    fi
                od;

                new_compts := [op(new_compts), 
					[[op(new_tensor_compts1),op(new_tensor_compts2)],
                    		term1[2]*term2[2]]]
            fi
	od;

od;


if new_compts = [] then 
	ans := zero_tens([new_tensIndex, new_tensDensity])
else 
	ans := helmsimp(_VESSIOT([new_attributes, new_compts]))
fi;


ans;

end:


if nargs=2 then 
	ans:=contract_indices1(args);
      RETURN(ans);
fi;

if nargs=3 then
	ans:=contract_indices2(args);
      RETURN(ans)
fi;
	 

end:



#-----------------------------------------------

raise_lower_indices:=proc(a_metric::{Vessiot_metric,Vessiot_inv_metric}, 
a_tensor0,          index_list::list(nonnegint))
 
#Class I program
#01/04/03:IA
     

local ans,new_comps,term, term1, RL, a_tensor,
	metrFr, tensFr, metrComp, tensComp, metrIndexType, tensIndexType,
	new_tensIndexType, i ,tensC, metrC, new_attributes, t, C; 

#    This routine raises a list of indices of a Vessiot tensor
#    using a given metric.


a_tensor:=convert(evalV(a_tensor0),Vessiot_tensor);



metrFr:=objectFrame(a_metric);
tensFr:=objectFrame(a_tensor);

metrComp:=objectComponents(a_metric);
tensComp:=objectComponents(a_tensor);

metrIndexType:=tensorIndexType(a_metric):
tensIndexType:=tensorIndexType(a_tensor):


if tensorIndexPart1(metrIndexType[1])=cov then 
	RL:='down'
fi;

 
if tensorIndexPart1(metrIndexType[1])=con then 
	RL:='up'
fi;



if metrFr<> tensFr then
	ERROR(cat("\n VESSIOT ERROR:",
		    "\n metric and tensor in different frames: ", metrFr, "," ,tensFr) )
fi;

VessiotFrameCheck(a_metric);

if tensorIndexPart2(metrIndexType[1])= jet then 
	tensC:=objectGenerators(a_tensor);
	metrC:=objectGenerators(a_metric);

	if max(op(tensC))> max(metrC) then
	   	ERROR(cat("\n VESSIOT ERROR:",
			    "\n jet order of metric less than that of tensor.") )
	fi;

fi; 


new_tensIndexType:=tensIndexType;

if RL='up' then
	for i  in index_list do
    		if not tensorIndexPart1(tensIndexType[i])=cov then
        		ERROR(cat("\n VESSIOT ERROR:", 
				    "\n the index " , i , "is not a covariant index."))
      	fi;

            if  tensorIndexPart2(tensIndexType[i])<> 
   		    tensorIndexPart2(metrIndexType[1])
		then
        		ERROR(cat("\n VESSIOT ERROR:",
				    "\n tensor index and metric index  are of different spatial types.")) 

      	fi;
         
            new_tensIndexType[i]:= cat(con,"_",tensorIndexPart2(tensIndexType[i]))
	od;
fi;

if RL='down' then

	for i  in index_list do
    		if not tensorIndexPart1(tensIndexType[i])=con then
        		ERROR(cat("\n VESSIOT ERROR:",
                            "\n the index", i , "is not a contravariant index."))
      	fi;

            if  tensorIndexPart2(tensIndexType[i])<> 
   		    tensorIndexPart2(metrIndexType[1])
		then
        		ERROR(cat("\n VESSIOT ERROR:",
				    "\n tensor index and metric index ",
 				     "are of different spatial types.")) 

      	fi;
 		
		new_tensIndexType[i]:= cat(cov,"_",tensorIndexPart2(tensIndexType[i]))

	od;
fi;
new_attributes:=[tensor,tensFr,[new_tensIndexType,tensorDensityType(a_tensor)]];



for i in  index_list do
new_comps:=[];

	for term in metrComp do
		for term1 in tensComp do
      		if term1[1][i]=term[1][1] then
                        t:=term1[1]; 
                        C:=[op(t[1..i-1]), term[1][2], op(t[i+1..-1]) ];
            		new_comps:=[op(new_comps),[C,term[2]*term1[2]] ];
          		fi;
   		od;
	od;

tensComp:=new_comps;

od;


ans:=helmsimp(_VESSIOT([new_attributes ,new_comps]));



ans;


end:

#---------------------------------------



inverse_metric:=proc(a_metric::Vessiot_metric)

#Class II program
#01/04/03:IA          

local ans,A,B,C,temp,new_tensIndexType;

#    This routine constructs the LinearAlgebra[MatrixInverse] of the given metric.
#     

VessiotFrameCheck(a_metric);

temp:=tensorIndexPart2(tensorIndexType(a_metric)[1]);

new_tensIndexType:=[cat(con,"_",temp),cat(con,"_",temp)];

A:=convert(convert(a_metric,Vessiot_array),Matrix):

B:=LinearAlgebra[MatrixInverse](A);

C:=convert(B,array);

ans:=convert(C,Vessiot_tensor,[new_tensIndexType,[]]);


helmsimp(ans);

        
end: 


























# END FILE ten_2 ************************************************