#
#  Numerical Tensors
#  permutation_symbol,generalized_Kronecker_delta
#


permutation_symbol:=proc(index_type)
local n, T, S, ans; 

if index_type = cov_bas then 
	n := frameBaseDimension(); 
	T := v_zip(frameBaseForms(),tensor); 
	S := op( (n!) &mult  symm_skew_indices(T,[$1 .. n],skew) ); 
	S[1][3][2] := [[bas, 1]]; 
	ans := _VESSIOT(S) 
fi; 


if index_type = con_bas then 
	n := frameBaseDimension(); 
	T := v_zip(frameBaseVectors(),tensor); 
	S := op( (n!) &mult  symm_skew_indices(T,[$1 .. n],skew) ); 
	S[1][3][2] := [[bas, -1]]; 
	ans := _VESSIOT(S) 
fi;


ans 

end:


#-------------------------------------


generalized_Kronecker_delta := proc(spatial_type, r)
local n, T1, T2, K,i;
   
if spatial_type= bas then
      n:=frameBaseDimension(); 
	T1:=permutation_symbol(con_bas);
      T2:=permutation_symbol(cov_bas);
      K:= (1/(n-r)! ) &mult contract_indices(T1,T2, [seq([i,i],i=r+1..n)]);
fi;

K

end:
       

