#
#  Tensor Extensions
#


Lie_tens:=proc(vectr,geomObjField)
local indxType,ans, Z;

indxType:=tensorType(geomObjField);
Z:=DifferentialGeometryTools:-zero_tens(indxType);


	
ans:=derivation[tensor](Lie_tens0,geomObjField,Z,vectr);
    	
RETURN(ans)

end:




Lie_tens0:=proc(term,flag,X)

local ans,Y,Z, alpha,t,comp,termX,termN;

if flag = `coeff` 
	then 
      comp:=[ [ [], Lie_derivative(X,term)] ];
      ans:=_VESSIOT([[tensor,_Vessiot_current_frame_name,[[],[] ]],  comp ]);   
	RETURN(ans) 
fi;


if tensorIndexPart1(flag)= 'con'  
	then
#     code this from scratch for eff. 

      Y:=DifferentialGeometryTools:-Vect(term);
      ans:=Lie_bracket(X,Y);
      ans:=convert(ans,Vessiot_tensor);
	RETURN(ans);
fi;

if tensorIndexPart1(flag)= 'cov'  then
#     code this from scratch for eff.
	
      alpha:=DifferentialGeometryTools:-Form(term);
      ans:=Lie_derivative(X,alpha);
	ans:=convert(ans,Vessiot_tensor);
      RETURN(ans)

fi;

end:









 
#===================================================================

Lie_conn:=proc(a_vector,a_connection)

#08/26/1991:CH
#01/15/2003:IA         

#  currently works only on  base space
#  coordinate frame only.


local ans, ans0, V, frV, frC, indexType,n,C,indx1,  diff_order, indx, index1, new_args, 
new_comps, sum_start, sum_end, pr_vector, temp, term; 

V:=objectComponents(a_vector);
frV:=objectFrame(a_vector);
indexType:=tensorIndexType(a_connection);

frC:=objectFrame(a_connection);

if  frV <> frC then
	ERROR(cat("\n VESSIOT ERROR:",
            "\n vector and connection must be in the same frame",
            frV,frC))   
fi;

VessiotFrameCheck(a_vector);
n:=frameBaseDimension();

C:=convert(a_connection,Vessiot_tensor):
ans0:=Lie_derivative(a_vector,C):

new_comps:=[];

if  indexType[1]=cov_bas then
	for term in V do
		if term[1][1] <= frameBaseDimension() then
      		for indx from 1 to n do
            		for indx1 from 1 to n do
	          			new_comps:=[op(new_comps),
                                         [ [indx,term[1][1],indx1],
					diff(diff(term[2],frameIndependentVariables()[indx]),
                                                frameIndependentVariables()[indx1])]];  
		    		od;
		  	od;
		fi;
	od;
	
fi;

# this is junk for other kinds of connections

if ans[1][3][1]=cov_vrt then
	diff_order:=tens_diff_order(a_vector,coeff);
	sum_start:=frameBaseDimension() + 1;
	sum_end:=frameBaseDimension()+frameFiberDimension();
	pr_vector:=pr_vect(a_vector,diff_order);
	for term in pr_vector[2] do;
		if term[1][1] > frameBaseDimension() and
				    term[1][1]<= frameFiberDimension()+frameBaseDimension() 
		then
		for indx from sum_start to sum_end do;
            	for index1 from 1 to sum_start -1 do;
	          	new_comps:=[op(new_comps),[[indx,term[1][1],index1],
		      	      td(diff(term[2],index_to_jet_label(indx)),index1)]];  
		    	od;
		od;
		fi;
	 od;
fi; 
	  
#end of junk

temp:=_VESSIOT([objectAttributes(C),new_comps]);
	
ans:= helmsimp(ans0 &plus temp);

ans
        
end:

