#
# multi_vector,  metric_density, Hodge_star
#


#-------------------------------------------------------

multi_vector:=proc(list_of_vect::list(Vessiot_vect)) 
# CLASS II PROGRAM
# 01/04/03:IA
     
local n,coef,T;

n:=nops(list_of_vect);
coef:=[1$n];

T:=v_zip(coef, map(convert,list_of_vect,Vessiot_tensor),tensor);
T:=(n!) &mult symm_skew_indices(T,[$1..n],skew);

  
T

end:



#-----------------------------------------------------------

metric_density:=proc(a_metric::Vessiot_metric, a_weight::algebraic)
# CLASS I PROGRAM
# 05/01/99:CH
# 01/04/03:IA            

#    This routine creates a scalar density equal to the determinant of the metric
#    raised to the given weight.
#     
#    a_metric: a Vessiot type bicovariant metric tensor.
#    a weight: the weight of the scalar density.

local ans,  tensorIndex, densityIndex, fr, temp,A,tens_attributes;

tensorIndex:=tensorIndexType(a_metric);
densityIndex:=tensorDensityType(a_metric);

if densityIndex <>[]  then
	ERROR(\cat("\n VESSIOT ERROR:",  
                 "\n the given metric must have weight 0."))
fi;



VessiotFrameCheck(a_metric);

fr:=objectFrame(a_metric);

A:=convert(convert(a_metric,Vessiot_array),Matrix);

temp:=(LinearAlgebra[Determinant](A))^(a_weight/2);

if a_weight<> 0 then
	tens_attributes:=[tensor, fr,[[],[[tensorIndexPart2(tensorIndex[1]),a_weight/2]] ]];
	ans:=_VESSIOT([tens_attributes,[ [ [],temp] ] ]);
else
	ans:=_VESSIOT([[tensor, fr,[[],[]] ],[[[],temp]]]);
fi;



ans
        
end: 


#------------------------------------------

Hodge_star:=proc(a_metric::Vessiot_tensor, a_form::Vessiot_form)
       local ans, an_integer, form_order,
 n, p,e,       indx, new_comps, temp, tensor1; 


#
#

#    This routine returns a new form (as a tensor object) given a type [1,1]
#    metric and a form.
#     
#    a_metric: a type [1,1] Vessiot metric tensor.
#    a_form: a Vessiot form or Vessiot tensor which is equivalent to a form.
#    optional args: coordinate frame - a defined coordinate frame.

#    initial tests and default assignments:

      if nargs=3 then
        change_frame_to(args[3]);
        change_frame_to(args[3])
      fi;

#  include test for metric   type(g,Vessiot_metric);

#

 n:=frameBaseDimension();
 p:=formDegree(a_form);
 tensor1:=convert(a_form,Vessiot_tensor);


     if not objectFrame(a_metric)=objectFrame(a_form) then
       ERROR(`VESSIOT ERROR: The metric and form must be in the same frame`)
      fi;
# construct the new tensor:
     
e:=metric_density(a_metric,2) &tensor permutation_symbol(con_bas);
temp:=contract_indices(e,tensor1,[seq([i,i],i=1..p)]);

ans:=raise_lower_indices(a_metric,temp,[seq(i,i=1..n-p)]);
(1/((n-p)!*p!)) &mult convert(ans,Vessiot_form)        
end: 

#------------------------------


ParallelTransportEquations:=proc(curve,Y,C,parm)

local T, dY,S,temp, conn_term, conn_term_vect;

T:= v_zip(diff(curve,parm),frameBaseVectors(), plus);
dY:=DifferentialGeometryTools:-Vessiot_map(2,diff,Y,parm);

S:=convert(C,Vessiot_tensor);  
temp:=Y &tensor T; 

conn_term:= contract_indices(temp,S,[[1,1],[2,3]]);
conn_term_vect:=convert(conn_term, Vessiot_vect);  

dY &plus conn_term_vect;
end:

#-----------------------------


GeodesicEquations:=proc(curve,C,parm) local T;

T:= v_zip(diff(curve,parm),frameBaseVectors(), plus);
ParallelTransportEquations(curve,T,C,parm);

end:



#------------------------------



# END FILE ten_3 ************************************************