









canonical_flat_metric:=proc(p::nonnegint,q::nonnegint,tensor_space)
#Class II Program
#09/01/01:JJ
#01/07/03:IA


local  list1,M,G,n, indexType;

optionalFrameChange([args],3);


if tensor_space= bas then
	n:= frameBaseDimension()
elif  tensor_space= vrt then
      n:= frameFiberDimension()
elif  tensor_space= jet then
      n:= frameJetDimension()
else
     ERROR(cat("\n VESSIOT ERROR:",
               "\n tensor type  must be one of {bas, vrt, jet}.")) 
fi;


if p+q<>n then 
	ERROR(cat("\n VESSIOT ERROR:",
                "\n p+q must equal", n)) 
fi;

list1:=[1$p,(-1)$q];

M:=LinearAlgebra[DiagonalMatrix](list1);

indexType:=[cat(cov,"_",tensor_space),cat(cov,"_",tensor_space)];

G:=convert(M,Vessiot_tensor,[indexType, [] ]);

G;

end:

#-----------------------------------------------

canonical_symplectic_form:=proc(space)
#Class II Program
#09/01/01:JJ
#01/07/03:IA

local form1,i,n,m;


optionalFrameChange([args],2);


if  space= 'base' or space=bas then
      m:=1;
	n:= frameBaseDimension()
elif  space= vrt or  space='fiber' then
      m:= frameBaseDimension()+1;
      n:= frameFiberDimension()
else
     ERROR(cat("\n VESSIOT ERROR:", 
               "\n space must be one of {base, fiber}") ) 
fi;

if is(n,odd) then 
	ERROR(cat("\n VESSIOT ERROR:", 
                "\n space must be even dimensional."));
fi; 

form1:=DifferentialGeometryTools:-zero_form(2);

for i from m to n/2 +m-1 do
	form1:=form1 &plus DifferentialGeometryTools:-Form([i,i+n/2]);
od;

form1;

end:

#------------------------------------------------

canonical_complex_structure:=proc(tensor_space)
#Class II Program
#09/01/01:JJ
#01/07/03:IA

local ans, m, Id,zero_M,M1,M2,Mt,Mf1,Mf2,v,h,n, indexType;

optionalFrameChange([args],2);

if   tensor_space= bas then
	n:= frameBaseDimension()
elif  tensor_space= vrt then
      n:= frameFiberDimension()
else
     ERROR(cat("\n VESSIOT ERROR:", 
               "\n space must be one of {bas, vrt}.")) 
fi;

if is(n,odd) then 
	ERROR(cat("\n VESSIOT ERROR:", 
                "\n space must be even dimensional."));
fi; 

m:=n/2;

Id:=LinearAlgebra[DiagonalMatrix]([1$m]);
zero_M:=Matrix(m,m,0);

M1:=Matrix([eval(zero_M),eval(-1*eval(Id))] );
M2:=Matrix([eval(Id),eval(zero_M)]);

Mt:=Matrix([[M1],[M2]]);

v:=Matrix(2*m,n-2*m,0);
h:=Matrix(n-2*m,n,0);

Mf1:=Matrix([Mt,v]);
Mf2:=Matrix([[Mf1],[h]]);

indexType:=[cat(cov,"_",tensor_space), cat(con,"_",tensor_space)];

ans:=convert(Mf2,Vessiot_tensor,[indexType,[]]);


ans;
end:

#----------------------------------------------