USU1_1:=proc()

description `USU1_1 : Lie Algebras of dimension less than 6.`;

local L;
L:=table();

##.............decomposable 1 dimensional Lie algebras 


L[[1,0]][structure_constants]
:=[];

L[[1,0]][parameters]
:=[[],[[]]];

L[[1,0]][remarks]
:=[];

L[[1,0]][algebra_type]
:=abelian;

#.............indecomposable 2 dimensional Lie algebras 

L[[2,1]][structure_constants]
:=[[[1,2,1],1]];

L[[2,1]][parameters]
:=[[],[[]]];

L[[2,1]][remarks]
:=[];

L[[2,1]][algebra_type]
:=solvable;

L[[2,1]][nilradical]
:=[[1,0]];


L[[2,1]][reference][[Mubarakyzanov,1]]
:=[[2,1]]; 

L[[2,1]][reference][[Winternitz,1]]
:=[[2,1]];

L[[2,1]][reference][[Winternitz,5]]
:=[[2,1]];

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                                
#  3 DIMENSIONAL NILPOTENT LIE ALGEBRAS      
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

L[[3,1]][structure_constants]
:=[[[2,3,1],1]];

L[[3,1]][parameters]
:=[[],[[]]];

L[[3,1]][remarks]
:=[];

L[[3,1]][algebra_type]
:=nilpotent;

L[[3,1]][reference][[Mubarakyzanov,1]]
:=[[[3,X]]];

L[[3,1]][reference][[Winternitz,1]]
:=[[[3,1]]];

L[[3,1]][reference][[Winternitz,5]]
:=[[[3,1]]];

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                                
#  3 DIMENSIONAL SOLVABLE LIE ALGEBRAS      
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

L[[3,2]][structure_constants]
:=[[[1,3,1],1],[[2,3,2],a]];

L[[3,2]][parameters]
:=[[a],[[-1<= a, a<=1, a<>0]]];

L[[3,2]][remarks]
:=[];

L[[3,2]][algebra_type]
:=solvable;

L[[3,2]][nilradical]
:=[[2,0]];

L[[3,2]][Jordan_type]
:=[[1,1]];

L[[3,2]][reference][[Mubarakyzanov,1]]
:=[[[]]];

L[[3,2]][reference][[Winternitz,1]]
:=[  [ [3,5] ],  [ [3,3],{a=1}],  [[3,4],{a=-1}] ];

L[[3,2]][reference][[Winternitz,5]]
:=[[[3,2]]] ;


#......

L[[3,3]][structure_constants]
:=[[[1,3,1],1],[[2,3,1],1],[[2,3,2],1]];

L[[3,3]][parameters]
:=[[],[[]]];

L[[3,3]][remarks]
:=[];

L[[3,3]][algebra_type]
:=solvable;

L[[3,3]][nilradical]
:=[[2,0]];

L[[3,3]][Jordan_type]
:=[[2]];

L[[3,3]][reference][[Mubarakyzanov,1]]
:=[[[3,X]]];

L[[3,3]][reference][[Winternitz,1]]
:=[[[3,2]]]; 

L[[3,3]][reference][[Winternitz,5]]
:=[[[3,X]]];

#......

L[[3,4]][structure_constants]
:=[[[1,3,1],a],[[1,3,2],-1],[[2,3,1],1],[[2,3,2],a]];

L[[3,4]][parameters]
:=[[a],[[a>=0]]];

L[[3,4]][remarks]
:=[];

L[[3,4]][algebra_type]
:=solvable;

L[[3,4]][nilradical]
:=[[2,0]];

L[[3,4]][Jordan_type]
:=[[C]];

L[[3,4]][reference][[Mubarakyzanov,1]]
:=[[[3,X]]];

L[[3,4]][reference][[Winternitz,1]]
:=[ [[3,6], {a=0} ], [[3,7]] ];

L[[3,4]][reference][[Winternitz,5]]
:=[[[3,X]]];

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                                
#  3 DIMENSIONAL SEMISIMPLE LIE ALGEBRAS      
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

L[[3,5]][structure_constants]
:=[[[1,2,1],1],[[1,3,2],-2],[[2,3,3],1]];

L[[3,5]][parameters]
:=[[],[[]]];

L[[3,5]][remarks]
:=[];

L[[3,5]][algebra_type]
:=semisimple;

L[[3,5]][algebra_name]
:=sl(2);

L[[3,5]][reference][[Mubarakyzanov,1]]
:=[[[3,X]]];

L[[3,5]][reference][[Winternitz,1]]
:=[[[3,8]]];

L[[3,5]][reference][[Winternitz,5]]:=
[[[3,X]]];

#.................................................

L[[3,6]][structure_constants]
:=[[[1,2,3],1],[[1,3,2],-1],[[2,3,1],1]];

L[[3,6]][parameters]
:=[[],[[]]];

L[[3,6]][remarks]
:=[];

L[[3,6]][algebra_type]
:=semisimple;

L[[3,6]][algebra_name]
:=so(3);

L[[3,6]][reference][[Mubarakyzanov,1]]
:=[[[]]];

L[[3,6]][reference][[Winternitz,1]]:=
[[[3,9]]];

L[[3,6]][reference][[Winternitz,5]]:=
[[[3,5]]];

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                                
#  4 DIMENSIONAL NILPOTENT LIE ALGEBRAS      
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

L[[4,1]][structure_constants]:=[[[2,4,1],1],[[3,4,2],1]];

L[[4,1]][parameters]
:=[[],[[]] ];

L[[4,1]][remarks]
:=[];

L[[4,1]][algebra_type]
:=nilpotent;

L[[4,1]][reference][[Mubarakyzanov,1]]
:=[[[4,1]]];

L[[4,1]][reference][[Winternitz,1]]
:=[[[4,1]]];

L[[4,1]][reference][[Winternitz,5]]
:=[[[4,1]]];


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                                
#  4 DIMENSIONAL SOLVABLE LIE ALGEBRAS      
#     
#  NILRADICAL [3,0]
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#......  [4,2] ...........

L[[4,2]][structure_constants]
:=[[[1,4,1],1],[[2,4,2],a],[[3,4,3],b]];

L[[4,2]][parameters]
:=[[a,b],[[a<>0,b<>0, a<=1, b<=a, b>=-1]]];

L[[4,2]][remarks]
:=[];

L[[4,2]][algebra_type]
:=solvable;

L[[4,2]][nilradical]
:=[[3,0]];

L[[4,2]][Jordan_type]
:=[[1,1,1]];

L[[4,2]][reference][[Mubarakyzanov,1]]
:=[[[]]];

L[[4,2]][reference][[Winternitz,1]]
:=[[[4,5]]];

L[[4,2]][reference][[Winternitz,5]]
:=[[[4,2]]];

#......[4,3] ............

L[[4,3]][structure_constants]
:=[[[1,4,1],1],[[2,4,1],1],[[2,4,2],1],[[3,4,3],a]];

L[[4,3]][parameters]
:=[[a],[[a<>0]]];

L[[4,3]][remarks]
:=[];

L[[4,3]][algebra_type]
:=solvable;

L[[4,3]][nilradical]
:=[[3,0]];

L[[4,3]][Jordan_type]
:=[[2,1]];

L[[4,3]][reference][[Mubarakyzanov,1]]
:=[[[]]];

L[[4,3]][reference][[Winternitz,1]]
:=[[[4,2],{}, Matrix([[0, 0, 1, 0], [1, 0, 0, 0], [0, 1, 0, 0], [0, 0, 0, 1]])]];

L[[4,3]][reference][[Winternitz,5]]
:=[[[4,X]]];

#...........[4,4] .............

L[[4,4]][structure_constants]
:=[[[2,4,1],1],[[3,4,3],1]];

L[[4,4]][parameters]
:=[[],[[]]];

L[[4,4]][remarks]
:=[];

L[[4,4]][algebra_type]
:=solvable;

L[[4,4]][nilradical]
:=[[3,0]];

L[[4,4]][Jordan_type]
:=[2,1];

L[[4,4]][reference][[Mubarakyzanov,1]]
:=[[[4,X]]];

L[[4,4]][reference][[Winternitz,1]]
:=[[[4,3],{},Matrix([[0, 0, 1, 0], [1, 0, 0, 0], [0, 1, 0, 0], [0, 0, 0, 1]])]];

L[[4,4]][reference][[Winternitz,5]]
:=[[[4,X]]];

#......

L[[4,5]][structure_constants]
:=[[[1,4,1],1],[[2,4,1],1],[[2,4,2],1],[[3,4,2],1],[[3,4,3],1]];

L[[4,5]][parameters]
:=[[],[[]]];

L[[4,5]][remarks]
:=[];

L[[4,5]][algebra_type]
:=solvable;

L[[4,5]][nilradical]
:=[[3,0]];

L[[4,5]][Jordan_type]
:=[[3]];

L[[4,5]][reference][[Mubarakyzanov,1]]
:=[[[4,X]]];

L[[4,5]][reference][[Winternitz,1]]
:=[[[4,4]]];

L[[4,5]][reference][[Winternitz,5]]
:=[[[4,X]]];

#...............[4,6]

L[[4,6]][structure_constants]
:=[[[1,4,1],a],[[2,4,2],b],[[2,4,3],-1],[[3,4,2],1],[[3,4,3],b]];

L[[4,6]][parameters]
:=[[a,b],[[a<>0, b>=0]]];

L[[4,6]][remarks]
:=[];

L[[4,6]][algebra_type]
:=solvable;

L[[4,6]][nilradical]
:=[[3,0]];

L[[4,6]][Jordan_type]
:=[1,C];

L[[4,6]][reference][[Mubarakyzanov,1]]
:=[[[4,X]]];

L[[4,6]][reference][[Winternitz,1]]
:=[[[4,6]]];

L[[4,6]][reference][[Winternitz,5]]
:=[[[4,X]]];

#........................................................



#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                                
#  4 DIMENSIONAL SOLVABLE LIE ALGEBRAS      
#     
#  NILRADICAL [3,1]
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


L[[4,7]][structure_constants]
:=[[[1,4,1],a+1],[[2,3,1],1],[[2,4,2],1],[[3,4,3],a]];

L[[4,7]][parameters]
:=[[a],[[a<=1, a>=-1]]];

L[[4,7]][remarks]
:=[];

L[[4,7]][algebra_type]
:=solvable;

L[[4,7]][nilradical]
:=[[3,1]];


L[[4,7]][Jordan_type]
:=[1,1,1];

L[[4,7]][reference][[Mubarakyzanov,1],[]]
:=[[[4,X]]];

L[[4,7]][reference][[Winternitz,1]]
:=[ [[4,9], {a=b}],  [[4,8], {a=-1}] ];                      

L[[4,7]][reference][[Winternitz,5]]
:=[[[4,X]]];


#...........................................................

L[[4,8]][structure_constants]
:=[[[1,4,1],2],[[2,3,1],1],[[2,4,2],1],[[3,4,2],1],[[3,4,3],1]];

L[[4,8]][parameters]
:=[[],[[]]];

L[[4,8]][remarks]
:=[];

L[[4,8]][algebra_type]
:=solvable;

L[[4,8]][nilradical]
:=[[3,1]];


L[[4,8]][Jordan_type]
:=[[2,1]];

L[[4,8]][reference][[Mubarakyznov,A]]
:=[[[4,X]]];

L[[4,8]][reference][[Winternitz,1]]
:=[[[4,7]]];

L[[4,8]][reference][[Winternitz,5]]
:=[[[4,X]]];


#........................................................

L[[4,9]][structure_constants]
:=[[[1,4,1],2*a],[[2,3,1],1],[[2,4,2],a],[[2,4,3],-1],[[3,4,2],1],[[3,4,3],a]];

L[[4,9]][parameters]
:=[[a],[[a>=0]]];

L[[4,9]][remarks]
:=[];

L[[4,9]][algebra_type]
:=solvable;

L[[4,9]][nilradical]
:=[[3,1]];


L[[4,9]][Jordan_type]
:=[1,C];

L[[4,9]][reference][[Mubarakyzanov,1]]
:=[[[4,X]]];

L[[4,9]][reference][[Winternitz,1]]
:=[[[4,11]],  [[4,10], {a=0}]];

L[[4,9]][reference][[Winternitz,5]]
:=[[[4,11], {a=0}]];

#........................................................


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#                                                
#  4 DIMENSIONAL SOLVABLE LIE ALGEBRAS      
#     
#  NILRADICAL [2,0]
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

L[[4,10]][structure_constants]
:=[[[1,3,1],1],[[1,4,2],-1],[[2,3,2],1],[[2,4,1],1]];

L[[4,10]][parameters]
:=[[],[[]]];

L[[4,10]][remarks]
:=[];

L[[4,10]][algebra_type]
:=solvable;

L[[4,10]][nilradical]
:=[[2,0]];

L[[4,10]][Jordan_type]
:=[[1,1],[C]];

L[[4,10]][reference][[Mubarakyznov,A]]
:=[[[]]];

L[[4,10]][reference][[Winternitz,1]]
:=[[[4,12]]];

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#   5 DIMENSIONAL INDECOMPOSABLE NILPOTENT ALGEBRAS
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


L[[5,1]][structure_constants]
:=[[[3,5,1],1],[[4,5,2],1]];


L[[5,1]][parameters]
:=[[],[[]]];

L[[5,1]][algebra_type]
:=nilpotent;

L[[5,1]][reference][[Mubarakyzanov,2]]
:=[[[5,1]]];

L[[5,1]][reference][[Winternitz,1]]
:=[[[5,1]]];

L[[5,1]][reference][[Winternitz,5]]
:=[[5,1]];

#............  [5,2] ...........

L[[5,2]][structure_constants]
:=[[[2,5,1],1],[[3,5,2],1],[[4,5,3],1]];


L[[5,2]][parameters]
:=[[],[[]]];

L[[5,2]][algebra_type]
:=nilpotent;

L[[5,2]][reference][[Mubarakyzanov,2]]
:=[[[5,2]]];

L[[5,2]][reference][[Winternitz,1]]
:=[[[5,2]]];

L[[5,2]][reference][[Winternitz,5]]
:=[[[5,2]]];

#............ [5,3] ............    

L[[5,3]][structure_constants]
:=[[[2,4,3],1],[[2,5,1],1],[[4,5,2],1]];

L[[5,3]][parameters]
:=[[],[[]]];

L[[5,3]][algebra_type]
:=nilpotent;

L[[5,3]][reference][[Mubarakyzanov,2]]
:=[[[5,3]]];

L[[5,3]][reference][[Winternitz,1]]
:=[[[5,3],{}, Matrix([[1,0,0,0,0], [0,0,1,0,0],[0,1,0,0,0],[0,0,0,1,0],[0,0,0,0,1]])]];

L[[5,3]][reference][[Winternitz,5]]
:=[[[5,3],{}]];

L[[5,3]][remarks]
:=[`In Winternitz 5 e2 <-> e3`];

#............ [5,4] ...........

L[[5,4]][structure_constants]
:=[[[2,4,1],1],[[3,5,1],1]];


L[[5,4]][parameters]
:=[[],[[]]];

L[[5,4]][algebra_type]
:=nilpotent;

L[[5,4]][reference][[Mubarakyzanov,2]]
:=[[[5,4]]];

L[[5,4]][reference][[Winternitz,1]]
:=[[[5,4]]];

L[[5,4]][reference][[Winternitz,5]]
:=[[[5,4]]];


#............ [5,5] ...........

L[[5,5]][structure_constants]
:=[[[3,4,1],1],[[2,5,1],1],[[3,5,2],1]];


L[[5,5]][parameters]
:=[[],[[]]];

L[[5,5]][algebra_type]
:=nilpotent;

L[[5,5]][reference][[Mubarakyzanov,2]]
:=[[[5,5]]];

L[[5,5]][reference][[Winternitz,1]]
:=[[[5,5]]];

L[[5,5]][reference][[Winternitz,5]]
:=[[[5,5]]];

#............ [5,6] ..........

L[[5,6]][structure_constants]
:=[[[3,4,1],1],[[2,5,1],1],[[3,5,2],1],[[4,5,3],1]];

L[[5,6]][parameters]
:=[[],[[]]];

L[[5,6]][algebra_type]
:=nilpotent;

L[[5,6]][reference][[Mubarakyzanov,2]]
:=[[[5,6]]];

L[[5,6]][reference][[Winternitz,1]]
:=[[[5,6]]];

L[[5,6]][reference][[Winternitz,5]]
:=[[[5,6]]];


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#  5  DIMENSIONAL  SOLVABLE  NILRADICAL=[4,0]
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#............[5,7] ..........

L[[5,7]][structure_constants]
:=[[[1,5,1],1],[[2,5,2],a],[[3,5,3],b],[[4,5,4],c]];

L[[5,7]][parameters]
:=[[a,b,c], [[a<=1, b<=a, c<=b, c>=-1,a<>0,b<>0,c<>0]] ];

L[[5,7]][algebra_type]
:=solvable;

L[[5,7]][nilradical]
:=[[4,0]];

L[[5,7]][Jordan_type]
:=[1,1,1,1];

L[[5,7]][reference][[Mubarakyzanov,2]]
:=[[[5,7],{a=alpha,b=beta, c=gamma}]];

L[[5,7]][reference][[Winternitz,1]]
:=[[[5,7]]];

L[[5,7]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,7]][remarks]
:=[];



#............ [5,8] ..........


L[[5,8]][structure_constants]
:=[ [[2,5,1],1],[[3,5,3],1],[[4,5,4],a] ];

L[[5,8]][parameters]
:=[[a], [[a>=-1,a<=1, a<>0]]];

L[[5,8]][algebra_type]
:=solvable;

L[[5,8]][nilradical]
:=[[4,0]];

L[[5,8]][Jordan_type]
:=[2,1,1];

L[[5,8]][reference][[Mubarakyzanov,2]]
:=[[[5,8],{a=gamma}]];

L[[5,8]][reference][[Winternitz,1]]
:=[[[5,8],{a=c}]];

L[[5,8]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,8]][remarks]
:=[];


#............ [5,9] ...........

L[[5,9]][structure_constants]
:=[[[1,5,1],1],[[2,5,1],1],[[2,5,2],1],[[3,5,3],a],[[4,5,4],b]];

L[[5,9]][parameters]
:=[[a,b],[ [abs(b)<=a, abs(b) >=-a,  b<>0]] ];

L[[5,9]][algebra_type]
:=solvable;

L[[5,9]][nilradical]
:=[[4,0]];

L[[5,9]][Jordan_type]
:=[2,1,1];

L[[5,9]][reference][[Mubarakyzanov,2]]
:=[[[5,9],{a=beta, b=gamma}]];

L[[5,9]][reference][[Winternitz,1]]
:=[[[5,9],{a=b, b=c}]];

L[[5,9]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,9]][remarks]
:=[];


#............ [5,10] ...........


L[[5,10]][structure_constants]
:=[[[1,5,1],1],[[2,5,2],1],[[2,5,1],1],[[3,5,3],a],[[4,5,3],1],
   [[4,5,4],a]];

L[[5,10]][parameters]
:=[ [a],[[a<=1, a>=-1]] ];

L[[5,10]][algebra_type]
:=solvable;

L[[5,10]][nilradical]
:=[[4,0]];

L[[5,10]][Jordan_type]
:=[2,2];

L[[5,10]][reference][[Mubarakyzanov,2]]
:=[[[5,15],{a=gamma}]];

L[[5,10]][reference][[Winternitz,1]]
:=[[[5,15]]];

L[[5,10]][reference][[Winternitz,5]]
:=[[[5,12],{a=x}]];

L[[5,10]][remarks]
:=[];

#............ [5,11] ...........

L[[5,11]][structure_constants]
:=[ [[2,5,1],1],[[3,5,2],1],[[4,5,4],1]];

L[[5,11]][parameters]
:=[[],[ [] ]];

L[[5,11]][algebra_type]
:=solvable;

L[[5,11]][nilradical]
:=[[4,0]];

L[[5,11]][Jordan_type]
:=[3,1];

L[[5,11]][reference][[Mubarakyzanov,2]]
:=[[[5,10]]];

L[[5,11]][reference][[Winternitz,1]]
:=[[[5,10]]];

L[[5,11]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,11]][remarks]
:=[];

#............ [5,12] ............

L[[5,12]][structure_constants]
:=[[[1,5,1],1],[[2,5,1],1],[[2,5,2],1],[[3,5,2],1],[[3,5,3],1],[[4,5,4],a]];

L[[5,12]][parameters]
:=[[a],[[a<>0]]];

L[[5,12]][nilradical]
:=[[4,0]];

L[[5,12]][algebra_type]
:=solvable;

L[[5,12]][Jordan_type]
:=[3,1];

L[[5,12]][reference][[Mubarakyzanov,2]]
:=[[[5,11],{a=gamma}]];

L[[5,12]][reference][[Winternitz,1]]
:=[[[5,11],{a=c}]];

L[[5,12]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,12]][remarks]
:=[];

#............ [5,13] .............


L[[5,13]][structure_constants]
:=[[[1,5,1],1],[[2,5,1],1],[[2,5,2],1],[[3,5,2],1],
    [[3,5,3],1],[[4,5,3],1],[[4,5,4],1]];

L[[5,13]][parameters]
:=[[],[[]]];

L[[5,13]][algebra_type]
:=solvable;

L[[5,13]][nilradical]
:=[[4,0]];

L[[5,13]][Jordan_type]
:=[4];

L[[5,13]][reference][[Mubarakyzanov,2]]
:=[[[5,12]]];

L[[5,13]][reference][[Winternitz,1]]
:=[[[5,12]]];

L[[5,13]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,13]][remarks]
:=[];

#............ [5,14] ..............

L[[5,14]][structure_constants]
:=[[[1,5,1],1],[[2,5,2],a],[[3,5,3],b],[[3,5,4],-c],[[4,5,3],c],
   [[4,5,4],b]];

L[[5,14]][parameters]
:=[[a,b,c],[[a<>0,c>0, a<=1, a>=-1]] ];

L[[5,14]][algebra_type]
:=solvable;

L[[5,14]][nilradical]
:=[[4,0]];

L[[5,14]][Jordan_type]
:=[1,1,C];

L[[5,14]][reference][[Mubarakyzanov,2]]
:=[[[5,13],{a=gamma,b=p ,c=s}]];

L[[5,14]][reference][[Winternitz,1]]
:=[[[5,13],{b=p ,c=q}]];

L[[5,14]][reference][[Winternitz,1]]
:=[[5,10,{a=z, b=x, y=z}]];

L[[5,14]][remarks]
:=[];

#............ [5,15] ..........

L[[5,15]][structure_constants]
:=[[[2,5,1],1],[[3,5,3],a],[[3,5,4],-1],[[4,5,3],1],[[4,5,4],a] ];

L[[5,15]][parameters]
:=[[a],[[a<=1, a>=-1]]];

L[[5,15]][algebra_type]
:=solvable;

L[[5,15]][nilradical]
:=[[4,0]];

L[[5,15]][Jordan_type]
:=[2,C];

L[[5,15]][reference][[Mubarakyzanov,2]]
:=[[[5,14],{a=p}]];

L[[5,15]][reference][[Winternitz,1]]
:=[[[5,14], {a=p}]];

L[[5,15]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,15]][remarks]
:=[];

#............ [5,16] .............

L[[5,16]][structure_constants]
:=[[[1,5,1],1],[[2,5,1],1],[[2,5,2],1],[[3,5,3],a],[[3,5,4],-b],[[4,5,3],b],
   [[4,5,4],a]];

L[[5,16]][parameters]
:=[[a,b],[[b>0]]];

L[[5,16]][algebra_type]
:=solvable;

L[[5,16]][nilradical]
:=[[4,0]];

L[[5,16]][Jordan_type]
:=[2,C];

L[[5,16]][reference][[Mubarakyzanov,2]]
:=[[[5,16],{a=p,b=s}]];

L[[5,16]][reference][[Winternitz,1]]
:=[[[5,16], {a=p,b=q}]];

L[[5,16]][reference][[Winternitz,5]]
:=[[[5,14],[a=x,b=y]]];

L[[5,16]][remarks]
:=[];

#............ [5,17] ..........

L[[5,17]][structure_constants]
:=[[[1,5,1],a],[[1,5,2],-1],[[2,5,1],1],[[2,5,2],a],[[3,5,3],b],[[3,5,4],-c],
   [[4,5,3],c],[[4,5,4],b] ];

L[[5,17]][parameters]
:=[[a,b,c],[[a>0, 0<c ,c<=1], [a=0,b>=0, 0<c,c<=1]] ];

L[[5,17]][algebra_type]
:=solvable;

L[[5,17]][nilradical]
:=[[4,0]];

L[[5,17]][Jordan_type]
:=[C,C];

L[[5,17]][reference][[Mubarakyzanov,2]]
:=[[[5,17],{a=p, b=q,c=s}]];

L[[5,17]][reference][[Winternitz,1]]
:=[[[5,17],{a=p, b=q,c=s}]];

L[[5,17]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,17]][remarks]
:=[];

#............

L[[5,18]][structure_constants]
:=[[[1,5,1],a],[[1,5,2],-1],[[2,5,1],1],[[2,5,2],a],[[3,5,1],1],[[3,5,3],a],[[3,5,4],-1],
[[4,5,2],1],[[4,5,3],1],[[4,5,4],a]];

L[[5,18]][parameters]
:=[[a],[[a>=0]]];

L[[5,18]][algebra_type]
:=solvable;

L[[5,18]][nilradical]
:=[[4,0]];

L[[5,18]][Jordan_type]
:=[C2];

L[[5,18]][reference][[Mubarakyzanov,2]]
:=[[[5,18],{a=p}]];

L[[5,18]][reference][[Winternitz,1]]
:=[[[5,18],{a=p}]];

L[[5,18]][reference][[Winternitz,5]]
:=[[[5,7],{a=p}]];

L[[5,18]][remarks]
:=[`Error in Mubarakyzanov  [e4,e5] , compare with Matrix a_12` ];

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#  5 DIMENSIONAL  SOLVABLE, NILRADICAL = [[3,1],[1,0]]
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#.......... [5,19] ...........

L[[5,19]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],(a+1)],[[2,5,2],1],[[3,5,3],a],[[4,5,4],b]];

L[[5,19]][parameters]
:=[[a,b], [[a<>0, a<=1, a>-1,b<>0]]];

L[[5,19]][algebra_type]
:=solvable;

L[[5,19]][nilradical]
:=[[3,1],[1,0]];

L[[5,19]][Jordan_type]
:=[1,1,1];

L[[5,19]][reference][[Mubarakyzanov,2]]
:=[[[5,19],{a=alpha, b=beta}]];

L[[5,19]][reference][[Winternitz,1]]
:=[[[5,19], {a=a-1}]];

L[[5,19]][reference][[Winternitz,5]]
:=[[[5,22]]];

L[[5,19]][remarks]
:=[];

#............ [5,20] ............

L[[5,20]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],a+1],[[2,5,2],1],[[3,5,3],a],[[4,5,1],1],
   [[4,5,4],a+1]];

L[[5,20]][parameters]
:=[[a],[[a<>0, a>-1, a<=1]]];

L[[5,20]][algebra_type]
:=solvable;

L[[5,20]][nilradical]
:=[[3,1],[1,0]];

L[[5,20]][Jordan_type]
:=[1,1,1];

L[[5,20]][reference][[Mubarakyzanov,2]]
:=[[[5,20],{a=alpha}]];


L[[5,20]][reference][[Winternitz,1]]
:=[[[5,20],{a=a-1}]]; 

L[[5,20]][reference][[Winternitz,5]]
:=[[5,7]];

L[[5,20]][remarks]
:=[];

#............ [5,21] ...........

L[[5,21]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],2],[[2,5,2],1],[[2,5,3],1],
   [[3,5,3],1],[[3,5,4],1],[[4,5,4],1]];

L[[5,21]][parameters]
:=[[],[[]]];

L[[5,21]][algebra_type]
:=solvable;

L[[5,21]][nilradical]
:=[[3,1],[1,0]];

L[[5,21]][Jordan_type]
:=[3];

L[[5,21]][reference][[Mubarakyzanov,2]]
:=[[[5,21]]];

L[[5,21]][reference][[Winternitz,1]]
:=[[[5,21]]];

L[[5,21]][reference][[Winternitz,5]]
:=[[5,7]];

L[[5,21]][remarks]
:=[];

#............ [5,22] ...........

L[[5,22]][structure_constants]
:=[[[2,3,1],1],[[2,5,3],1],[[4,5,4],1]];

L[[5,22]][parameters]
:=[[],[[]]];

L[[5,22]][algebra_type]
:=solvable;

L[[5,22]][nilradical]
:=[[3,1],[1,0]];

L[[5,22]][Jordan_type]
:=[[2,1]];

L[[5,22]][reference][[Mubarakyzanov,2]]
:=[[[5,22]]];

L[[5,22]][reference][[Winternitz,1]]
:=[[[5,22]]];

L[[5,22]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,22]][remarks]
:=[];

#............

L[[5,23]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],2],[[2,5,2],1],[[2,5,3],1],[[3,5,3],1],[[4,5,4],a]];

L[[5,23]][parameters]
:=[[a],[[a<>0]]];

L[[5,23]][algebra_type]
:=solvable;

L[[5,23]][nilradical]
:=[[3,1],[1,0]];

L[[5,23]][Jordan_type]
:=[[2,1]];

L[[5,23]][reference][[Mubarakyzanov,2]]
:=[[[5,23],{a=beta}]];

L[[5,23]][reference][[Winternitz,1]]
:=[[[5,23],{a=b}]];

L[[5,23]][reference][[Winternitz,5]]
:=[[[5,31]]];

L[[5,23]][remarks]
:=[];

#............

L[[5,24]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],2],[[2,5,2],1],[[2,5,3],1],
   [[3,5,3],1],[[4,5,1],epsilon],[[4,5,4],2] ];

L[[5,24]][parameters]
:=[[epsilon], [[abs(epsilon) =1] ]];

L[[5,24]][algebra_type]
:=solvable;

L[[5,24]][nilradical]
:=[[3,1],[1,0]];

L[[5,24]][Jordan_type]
:=[[2,1]];

L[[5,24]][reference][[Mubarakyzanov,2]]
:=[[[5,24]]];

L[[5,24]][reference][[Winternitz,1]]
:=[[[5,24],{epsilon=e}]];

L[[5,24]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,24]][remarks]
:=[];

#............ [5,25] ...........

L[[5,25]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],2*a],[[2,5,2],a],[[2,5,3],1],[[3,5,2],-1],
   [[3,5,3],a],[[4,5,4],b]];

L[[5,25]][parameters]
:=[[a,b],[[b<>0]]];

L[[5,25]][algebra_type]
:=solvable;

L[[5,25]][nilradical]
:=[[3,1],[1,0]];

L[[5,25]][Jordan_type]
:=[C,1];

L[[5,25]][reference][[Mubarakyzanov,2]]
:=[[[5,25] ,{a=p,b=beta}]];

L[[5,25]][reference][[Winternitz,1]]
:=[[[5,25], {a=p}]];
    
L[[5,25]][reference][[Winternitz,5]]
:=[[[5,33],[a=x]]];

L[[5,25]][remarks]
:=[];

#............ [5,26] 

L[[5,26]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],2*a],[[2,5,2],a],[[2,5,3],1],
   [[3,5,2],-1],[[3,5,3],a],[[4,5,4],2*a],[[4,5,1],epsilon]];

L[[5,26]][parameters]
:=[[epsilon,a],[[abs(epsilon)=1]]];

L[[5,26]][algebra_type]
:=solvable;

L[[5,26]][nilradical]
:=[[3,1],[1,0]];

L[[5,26]][Jordan_type]
:=[2,1];

L[[5,26]][reference][[Mubarakyzanov,2]]
:=[[[5,26], {a=p}]];

L[[5,26]][reference][[Winternitz,1]]
:=[[[5,26],{a=p,epsilon=e}]];

L[[5,26]][reference][[Winternitz,5]]
:=[[5,7]];

L[[5,26]][remarks]
:=[];

#............ [5,27]..............

L[[5,27]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],1],[[3,5,3],1],[[3,5,4],1],[[4,5,1],1],[[4,5,4],1]];

L[[5,27]][parameters]
:=[[],[[]]];

L[[5,27]][algebra_type]
:=solvable;

L[[5,27]][nilradical]
:=[[3,1],[1,0]];

L[[5,27]][Jordan_type]
:=[2,1];

L[[5,27]][reference][[Mubarakyzanov,2]]
:=[[[5,27]]];

L[[5,27]][reference][[Winternitz,1]]
:=[[[5,27]]];

L[[5,27]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,27]][remarks]
:=[];

#............[5,28] ............

L[[5,28]][structure_constants]
:=[[[2,3,1],1],[[1,5,1], a+1],[[2,5,2],a],[[3,5,3],1],
   [[3,5,4],1],[[4,5,4],1]];

L[[5,28]][parameters]
:=[[a],[[a<>0, a<>-1]] ];

L[[5,28]][algebra_type]
:=solvable;

L[[5,28]][nilradical]
:=[[3,1],[1,0]];

L[[5,28]][remarks]
:=[];

L[[5,28]][Jordan_type]
:=[NA];

L[[5,28]][reference][[Mubarakyzanov,2]]
:=[[[5,28],{a=alpha}]];

L[[5,28]][reference][[Winternitz,1]]
:=[[[5,28],{a=a-1}]];

L[[5,28]][reference][[Winternitz,5]]
:=[[[5,7]]];

#............ [5,29] .........


L[[5,29]][structure_constants]
:=[[[2,3,1],1],[[1,5,1],1],[[2,5,2],1],[[3,5,4],1]];

L[[5,29]][parameters]
:=[[],[[]]];

L[[5,29]][algebra_type]
:=solvable;

L[[5,29]][nilradical]
:=[[3,1],[1,0]];

L[[5,29]][Jordan_type]
:=[NA];

L[[5,29]][reference][[Mubarakyzanov,2]]
:=[[[5,29]]];

L[[5,29]][reference][[Winternitz,1]]
:=[[[5,29],{a=a-1},Matrix([[1,0,0,0,0],[0,1,0,0,0],[0,0,0,1,0],[0,0,1,0,0],[0,0,0,0,1]])]];
   
L[[5,29]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,29]][remarks]
:=[];

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#  5 Dimensional Algebras Nilradical [4,1]
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#...........[5,30]............

L[[5,30]][structure_constants]
:=[[[2,4,1],1],[[3,4,2],1],[[1,5,1],a+2],[[2,5,2],a+1],
   [[3,5,3],a],[[4,5,4],1] ];

L[[5,30]][parameters]
:=[[a],[[]]];

L[[5,30]][algebra_type]
:=solvable;

L[[5,30]][nilradical]
:=[[4,1]];

L[[5,30]][reference][[Mubarakyzanov,2]]
:=[[[5,30],{a=h}]];

L[[5,30]][reference][[Winternitz,1]]
:=[[[5,30], {a=a-1}]];

L[[5,30]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,30]][remarks]
:=[];

#............ [5,31] ..........

L[[5,31]][structure_constants]
:=[[[2,4,1],1],[[3,4,2],1],[[1,5,1],3],
   [[2,5,2],2],[[3,5,3],1],[[4,5,3],1],[[4,5,4],1]];

L[[5,31]][parameters]
:=[[],[[]]];

L[[5,31]][algebra_type]
:=solvable;

L[[5,31]][nilradical]
:=[[4,1]];

L[[5,31]][reference][[Mubarakyzanov,2]]
:=[[[5,31],{a=h}]];

L[[5,31]][reference][[Winternitz,1]]
:=[[[5,31]]];

L[[5,31]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,31]][remarks]
:=[];

#............ [5,32] ..........

L[[5,32]][structure_constants]
:=[[[2,4,1],1],[[3,4,2],1],[[1,5,1],1],[[2,5,2],1],[[3,5,1],a],
   [[3,5,3],1]];

L[[5,32]][parameters]
:=[[a],[[]]];

L[[5,32]][algebra_type]
:=solvable;

L[[5,32]][nilradical]
:=[[4,1]];

L[[5,32]][reference][[Mubarakyzanov,2]]
:=[[[5,32],{epsilon=h}]];

L[[5,32]][reference][[Winternitz,1]]
:=[[[5,32]]];

L[[5,32]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,32]][remarks]
:=[];

#............ [5,33] ............

L[[5,33]][structure_constants]
:=[ [[1,4,1],1],[[3,4,3],a],[[2,5,2],1],[[3,5,3],b]];

L[[5,33]][parameters]
:=[[a,b],[[a^2 +b^2 <>0,a<>0, b<>0]]];

L[[5,33]][algebra_type]
:=solvable;

L[[5,33]][nilradical]
:=[[3,0]];

L[[5,33]][reference][[Mubarakyzanov,2]]
:=[[[5,33],{a=beta, b=gamma}]];

L[[5,33]][reference][[Winternitz,1]]
:=[[[5,33],{a=b,b=a}]];

L[[5,33]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,33]][remarks]
:=["When a=0 or b=0 the algebra is decomposable"];

#............ [5,34] .........

L[[5,34]][structure_constants]
:=[[[1,4,1],a],[[2,4,2],1],[[3,4,3],1],[[1,5,1],1],[[3,5,2],1]];

L[[5,34]][parameters]
:=[[a],[[]]];

L[[5,34]][nilradical]
:=[[3,0]];

L[[5,34]][algebra_type]
:=solvable;

L[[5,34]][reference][[Mubarakyzanov,2]]
:=[[[5,34],{a=alpha}]];

L[[5,34]][reference][[Winternitz,1]]
:=[[[5,34]]];

L[[5,34]][reference][[Winternitz,5]]
:=[[[5,47]]];

L[[5,34]][remarks]
:=[];

#............ [5,35] ...........

L[[5,35]][structure_constants]
:=[[[1,4,1],b],[[2,4,2],1],[[3,4,3],1],[[1,5,1],a],
   [[2,5,3],-1],[[3,5,2],1]];

L[[5,35]][parameters]
:=[[a,b],[[a^2 +b^2 <>0]]];

L[[5,35]][algebra_type]
:=solvable;

L[[5,35]][nilradical]
:=[[3,0]];

L[[5,35]][reference][[Mubarakyzanov,2]]
:=[[[5,35],{a=alpha, b=h}]];

L[[5,35]][reference][[Winternitz,1]]
:=[[[5,35]]];

L[[5,35]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,35]][remarks]
:=[];

#............ [5,36] ...........

L[[5,36]][structure_constants]
:=[[[1,4,1],1],[[2,5,2],1],[[4,5,3],1] ];

L[[5,36]][parameters]
:=[[],[[]] ];

L[[5,36]][algebra_type]
:=solvable;

L[[5,36]][nilradical]
:=[[3,0]];

L[[5,36]][reference][[Mubarakyzanov,2]]
:=[[[5,38]]];

L[[5,36]][reference][[Winternitz,1]]
:=[[[5,38]]];

L[[5,36]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,37]][remarks]
:=[];


#............ [5,37] ...........

L[[5,37]][structure_constants]
:=[[[1,4,1],1],[[2,5,1],1],[[1,5,2],-1],[[2,4,2],1],
   [[4,5,3],1]];

L[[5,37]][parameters]
:=[[],[[]]];

L[[5,37]][algebra_type]
:=solvable;

L[[5,37]][nilradical]
:=[[3,0]];

L[[5,37]][reference][[Mubarakyzanov,2]]
:=[[[5,39]]];

L[[5,37]][reference][[Winternitz,1]]
:=[[[5,39]]];

L[[5,37]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,37]][remarks]
:=[];



#............ [5,38] ..........

L[[5,38]][structure_constants]
:=[[[2,3,1],1],[[1,4,1],1],[[2,4,2],1],[[2,5,2],-1],
   [[3,5,3],1]];

L[[5,38]][parameters]
:=[[],[[]]];

L[[5,38]][algebra_type]
:=solvable;

L[[5,38]][nilradical]
:=[[3,1]];

L[[5,38]][reference][[Mubarakyzanov,2]]
:=[[[5,36]]];

L[[5,38]][reference][[Winternitz,1]]
:=[[[5,36]]];

L[[5,38]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,38]][remarks]
:=[];


#............ [5,39] ..........

L[[5,39]][structure_constants]
:=[[[2,3,1],1],[[1,4,1],2],[[2,4,2],1],[[3,4,3],1],[[2,5,3],-1],[[3,5,2],1]];

L[[5,39]][parameters]
:=[[],[[]]];

L[[5,39]][algebra_type]
:=solvable;

L[[5,39]][nilradical]
:=[[3,1]];

L[[5,39]][reference][[Mubarakyzanov,2]]
:=[[[5,37]]];

L[[5,39]][reference][[Winternitz,1]]
:=[[[5,37]]];

L[[5,39]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,39]][remarks]
:=[];

#............[5,40] ..........

L[[5,40]][structure_constants]
:=[[[1,2,1],2],[[1,3,2],-1],[[2,3,3],2],[[1,4,5],1],
   [[2,4,4],1],[[2,5,5],-1],[[3,5,4],1]];

L[[5,40]][parameters]
:=[[],[[]]];

L[[5,40]][algebra_type]
:=generic;

L[[5,40]][Levi_decomposition]
:=[[3,5],[2,0]];

L[[5,40]][reference][[Mubarakyzanov,2]]
:=[[[5,40]]];

L[[5,40]][reference][[Winternitz,1]]
:=[[[5,40]]];

L[[5,40]][reference][[Winternitz,5]]
:=[[[5,7]]];

L[[5,40]][remarks]
:=[];


##########################################################


eval(L);
end: