#
#   6 DIMENSIONAL  LIE ALGEBRAS
#

 



USU1_2:=proc()

local L,M;

L:=table();

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
# 6 DIMENSIONAL NILPOTENT ALGEBRAS 
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


L[[6,1,0]][structure_constants]
:=[[[3,6,1],1],[[4,6,2],1],[[5,6,3],1]];

L[[6,1,0]][algebra_type]
:=nilpotent;

L[[6,1,0]][mai]
:=[];


M:=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 0, 1, 0], [0, 0, 1, 0, 0, 0],
           [1, 0, 0, 0, 0, 0], [0, 0, 0, 1, 0, 0], [0, 1, 0, 0, 0, 0]]);

L[[6,1,0]][reference][[Morozov,1]]
:=[ [[6,1],{},eval(M)]];

L[[6,1,0]][reference][[Winternitz,1]]
:=[[[6,1],{},eval(M)]];

L[[6,1,0]][reference][[Winternitz,5]]
:=[[[6,1]]] ;


#............. [6,2,0].............

L[[6,2,0]][structure_constants]
:=[[[2,6,1],1],[[3,6,2],1],[[4,6,3],1],[[5,6,4],1]];

L[[6,2,0]][algebra_type]
:=nilpotent;

L[[6,2,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 0, 1, 0], [0, 0, 0, 1, 0, 0], 
[0, 0, 1, 0, 0, 0], [0, 1, 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);

L[[6,2,0]][reference][[Morozov,1]]
:=[[[6,2],{},eval(M)]];

L[[6,2,0]][reference][[Winternitz,1]]
:=[[[6,2],{},eval(M)]];

L[[6,2,0]][reference][[Winternitz,5]]
:=[[[6,2]]] ;


#........... [6,3,0] ............. 

L[[6,3,0]][structure_constants]
:=[[[4,5,3],1],[[4,6,1],1],[[5,6,2],1]];

L[[6,3,0]][algebra_type]
:=nilpotent;

L[[6,3,0]][mai]
:=[];

M :=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 1, 0, 0], [0, 0, 0, 0, 1, 0],
 [0, 1, 0, 0, 0, 0], [0, 0, 1, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);


L[[6,3,0]][reference][[Morozov,1]]
:=[[[6,3],{},eval(M)]];

L[[6,3,0]][reference][[Winternitz,1]]
:=[[[6,3],{}, eval(M)]];

M := Matrix([[0, 1, 0, 0, 0, 0], [0, 0, 1, 0, 0, 0], [1, 0, 0, 0, 0, 0],
 [0, 0, 0, 1, 0, 0], [0, 0, 0, 0, 1, 0], [0, 0, 0, 0, 0, 1]]); 

L[[6,3,0]][reference][[Winternitz,5]]
:=[[[6,3], {},eval(M)]] ;

#........... [6,4,0] ...........


L[[6,4,0]][structure_constants]
:=[[[3,6,1],1],[[4,5,1],1],[[4,6,2],1]];

L[[6,4,0]][algebra_type]
:=nilpotent;

L[[6,4,0]][mai]
:=[];

M := Matrix([[0,0,0,-1,0,0],[0,0,0,0,0,-1],[0,0,0,1,-1,0],
             [0,0,1,0,0,0],[0,1,0,0,0,0],[1,0,0,0,0,0]]);

L[[6,4,0]][reference][[Morozov,1]]
:=[[[6,4],{},eval(M)]];

L[[6,4,0]][reference][[Winternitz,1]]
:=[[[6,4],{},eval(M)]];

L[[6,4,0]][reference][[Winternitz,5]]
:=[[[6,4],{},LinearAlgebra[DiagonalMatrix](1,1,1,1,-1,1) ]] ;

#............[6,5,0]........

L[[6,5,0]][structure_constants]
:=[[[3,5,1],1],[[3,6,2],-1],[[4,5,2],1],[[4,6,1],1]];

L[[6,5,0]][algebra_type]
:=nilpotent;

L[[6,5,0]][mai]
:=[];

M:=Matrix([[0,0,0,0,0,1],[0,0,0,0,-1/(sqrt(-gamma)), 0], 
		[0, 0, 1/(sqrt(-gamma)), 0, 0, 0], [0, 0, 0, 1, 0, 0],
 		[0, 1/(sqrt(-gamma)), 0, 0, 0, 0], [-1, 0, 0, 0, 0, 0]]);

L[[6,5,0]][reference][[Morozov,1]]
:=[[[6,5],{},eval(M)]];

M:=Matrix([[0,0,0,0,0,1],[0,0,0,0,-1/(sqrt(-a)), 0], 
		[0, 0, 1/(sqrt(-a)), 0, 0, 0], [0, 0, 0, 1, 0, 0],
 		[0, 1/(sqrt(-a)), 0, 0, 0, 0], [-1, 0, 0, 0, 0, 0]]);

L[[6,5,0]][reference][[Winternitz,1]]
:=[[[6,5],{}, eval(M)]];

L[[6,5,0]][reference][[Winternitz,5]]
:=[[[6,5]]] ;


#........... [6,6,0] ...........

L[[6,6,0]][structure_constants]
:=[[[3,6,1],1],[[4,5,1],1],[[4,6,2],1],[[5,6,3],1]];

L[[6,6,0]][algebra_type]
:=nilpotent;

L[[6,6,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 1, 0, 0], 
          [0, 0, 0, 0, 1, 0], [0, 0, 1, 0, 0, 0], [1, 0, 0, 0, 0, 0], [0, 1, 0, 0, 0, 0]]);

L[[6,6,0]][reference][[Morozov,1]]
:=[[[6,6],{},eval(M)]];

L[[6,6,0]][reference][[Winternitz,1]]
:=[[[6,6],{},eval(M)]];

M := Matrix([[1, 0, 0, 0, 0, 0], [0, -1, 0, 0, 0, 0], [0, 0, 1, 0, 0, 0],
             [0, 0, 0, -1, 0, 0], [0, 0, 0, 0, 1, 0], [0, 0, 0, 0, 0, 1]]);

L[[6,6,0]][reference][[Winternitz,5]]
:=[[[6,6], {}, eval(M)]] ;

#.......... [6,7,0].........

L[[6,7,0]][structure_constants]
:=[[[3,6,1],1],[[4,5,2],1],[[4,6,3],1]];

L[[6,7,0]][algebra_type]
:=nilpotent;

L[[6,7,0]][mai]
:=[];

M:=Matrix([[0,0,0,0,0,1],[0,0,0,0,1,0],[0,0,0,1,0,0],
           [0,0,-1,0,0,0],[1,0,0,0,0,0],[0,-1,0,0,0,0]]);

L[[6,7,0]][reference][[Morozov,1]]
:=[[[6,7],{},eval(M)]];

L[[6,7,0]][reference][[Winternitz,1]]
:=[[[6,7],{},eval(M)]];

L[[6,7,0]][reference][[Winternitz,5]]
:=[[[6,7]]] ;


#...........[6,8,0]..........

L[[6,8,0]][structure_constants]
:=[[[3,5,2],1],[[3,6,1],1],[[4,5,2],1],[[5,6,3],1]];

L[[6,8,0]][algebra_type]
:=nilpotent;

L[[6,8,0]][mai]
:=[];

M:=Matrix([[0,0,0,0,1,0],[0,0,0,0,0,1], 
[0,0,1,1,0,0], [0,-1,0,0,0,0],[0,0,1,0,0,0],[-1,0,0,0,0,0]]);

L[[6,8,0]][reference][[Morozov,1]]
:=[[[6,8],{},eval(M)]];

L[[6,8,0]][reference][[Winternitz,1]]
:=[[[6,8],{},eval(M)]];

L[[6,8,0]][reference][[Winternitz,5]]
:=[[[6,8]]] ;

#........... [6,9,0] ...........

L[[6,9,0]][structure_constants]
:=[[[3,5,1],1],[[3,6,2],1],[[4,6,1],1],[[5,6,3],1]];

L[[6,9,0]][algebra_type]
:=nilpotent;

L[[6,9,0]][mai]
:=[];

M:=Matrix([[0,0,0,0,0,1],[0,0,0,0,1,0], [0,0,-1,0,0,0],
           [0,1,0,0,0,0],[0,0,0,-1,0,0],[1,0,0,0,0,0]]);

L[[6,9,0]][reference][[Morozov,1]]
:=[[[6,9],{},eval(M)]];

L[[6,9,0]][reference][[Winternitz,1]]
:=[[[6,9],{},eval(M)]];

L[[6,9,0]][reference][[Winternitz,5]]
:=[[[6,9]]] ;

#........... [6,10,0]..........

L[[6,10,0]][structure_constants]
:=[[[3,5,1],1],[[3,6,2],-1],[[4,5,2],1],[[4,6,1],1],[[5,6,3],1]];

L[[6,10,0]][algebra_type]
:=nilpotent;

L[[6,10,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, 1], [0, 0, 0, 0, -1/(sqrt(-gamma)), 0],
           [0, 0, 1/(sqrt(-gamma)), 0, 0, 0], [0, 0, 0, 1, 0, 0], 
           [0, 1/(sqrt(-gamma)), 0, 0, 0, 0], [-1, 0, 0, 0, 0, 0]]);

L[[6,10,0]][reference][[Morozov,1]]
:=[[[6,10],{},eval(M)]];

M:=Matrix([[0, 0, 0, 0, 0, 1], [0, 0, 0, 0, -1/(sqrt(-a)), 0],
           [0, 0, 1/(sqrt(-a)), 0, 0, 0], [0, 0, 0, 1, 0, 0], 
           [0, 1/(sqrt(-a)), 0, 0, 0, 0], [-1, 0, 0, 0, 0, 0]]);

L[[6,10,0]][reference][[Winternitz,1]]
:=[[[6,10],{},eval(M)]];

L[[6,10,0]][reference][[Winternitz,5]]
:=[[[6,10]]] ;

#............ [6,11,0] ..........

L[[6,11,0]][structure_constants]
:=[[[3,6,1],1],[[4,5,2],1],[[4,6,3],1],[[5,6,4],1]];

L[[6,11,0]][algebra_type]
:=nilpotent;

L[[6,11,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 0, 1, 0], [0, 0, 0, 1, 0, 0], 
[0, 0, 1, 0, 0, 0], [1, 0, 0, 0, 0, 0], [0, -1, 0, 0, 0, 0]]);

L[[6,11,0]][reference][[Morozov,1]]
:=[[[6,11],{},eval(M)]];

L[[6,11,0]][reference][[Winternitz,1]]
:=[[[6,11],{},eval(M)]];

L[[6,11,0]][reference][[Winternitz,5]]
:=[[[6,11]]] ;

#............ [6,12,0] ..........

L[[6,12,0]][structure_constants]
:=[[[2,6,1],1],[[3,5,1],1],[[4,5,3],1]];

L[[6,12,0]][algebra_type]
:=nilpotent;

L[[6,12,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, -1, 0], [0, 0, 0, 0, 0, -1], [0, 0, 0, 1, 0, 0],
 [0, 0, 1, 0, 0, 0], [0, 1, 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);


L[[6,12,0]][reference][[Morozov,1]]
:=[[[6,12],{},eval(M)]];

L[[6,12,0]][reference][[Winternitz,1]]
:=[[[6,12],{},eval(M)]];

L[[6,12,0]][reference][[Winternitz,5]]
:=[[[6,12]]] ;

#............[6,13,0] ...........

L[[6,13,0]][structure_constants]
:=[[[2,6,1],1],[[3,5,1],1],[[4,5,3],1],[[5,6,2],1]];

L[[6,13,0]][algebra_type]
:=nilpotent;

L[[6,13,0]][mai]
:=[];

M:= Matrix([[0, 0, 0, 0, 1, 0], [0, 0, 0, 0, 0, 1], [0, 0, 0, -1, 0, 0], 
     [0, 0, 1, 0, 0, 0], [0, 1, 0, 0, 0, 0], [-1, 0, 0, 0, 0, 0]]);

L[[6,13,0]][reference][[Morozov,1]]
:=[[[6,13],{},eval(M)]];

L[[6,13,0]][reference][[Winternitz,1]]
:=[[[6,13],{},eval(M)]];

L[[6,13,0]][reference][[Winternitz,5]]
:=[[[6,13]]] ;


#.............[6,14,0]............

L[[6,14,0]][structure_constants]
:=[[[2,6,1],epsilon],[[3,5,1],1],[[4,5,3],1],[[4,6,2],1]];

L[[6,14,0]][algebra_type]
:=nilpotent;

L[[6,14,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 1, 0], [0, 0, 0, 0, 0, sqrt(epsilon/gamma)], [0, 0, 0, 1, 0, 0], 
                 [0, 0, -1, 0, 0, 0],[0, -sqrt(epsilon/gamma), 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);

L[[6,14,0]][reference][[Morozov,1]]
:=[[[6,14],{},eval(M)]];


M:=Matrix([[0, 0, 0, 0, 1, 0], [0, 0, 0, 0, 0, sqrt(epsilon/a)], [0, 0, 0, 1, 0, 0], 
                 [0, 0, -1, 0, 0, 0],[0, -sqrt(epsilon/a), 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);


L[[6,14,0]][reference][[Winternitz,1]]
:=[[[6,14],{},eval(M)]];

L[[6,14,0]][reference][[Winternitz,5]]
:=[[[6,14],{epsilon=_x}]] ;

#............[6,15,0]............

L[[6,15,0]][structure_constants]
:=[[[2,6,1],1],[[3,5,1],1],[[4,5,3],1],[[4,6,1],1],[[5,6,4],1]];

L[[6,15,0]][algebra_type]
:=nilpotent;

L[[6,15,0]][mai]
:=[];

M := Matrix([[0, 0, 0, 0, -1, 0], [0, 0, 0, 0, 0, -1], [0, 0, 0, 1, 0, 0], 
            [0, 0, 1, 0, 0, 0], [0, 1, 0, 1, 0, 0], [1, 0, 0, 0, 0, 0]]);

L[[6,15,0]][reference][[Morozov,1]]
:=[[[6,15],{},eval(M)]];

L[[6,15,0]][reference][[Winternitz,1]]
:=[[[6,15],{},eval(M)]];

L[[6,15,0]][reference][[Winternitz,5]]
:=[[[6,15]]] ;


#...........[6,16,0]...........

L[[6,16,0]][structure_constants]
:=[[[2,6,1],1],[[3,5,1],1],[[3,6,2],1],[[4,5,2],1],[[4,6,3],1]];

L[[6,16,0]][algebra_type]
:=nilpotent;

L[[6,16,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 0, -1, 0], [0, 0, 0, 1, 0, 0],
          [0, 0, 1, 0, 0, 0], [0, 1, 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);

L[[6,16,0]][reference][[Morozov,1]]
:=[[[6,16],{},eval(M)]];

L[[6,16,0]][reference][[Winternitz,1]]
:=[[[6,16],{},eval(M)]];

L[[6,16,0]][reference][[Winternitz,5]]
:=[[[6,16]]] ;


#...........[6,17,0]...........

L[[6,17,0]][structure_constants]
:=[[[2,6,1],1],[[3,5,1],1],[[4,5,3],1],[[5,6,4],1]];

L[[6,17,0]][algebra_type]
:=nilpotent;

L[[6,17,0]][mai]
:=[];

M:= Matrix([[0, 0, 0, 0, 1, 0], [0, 0, 0, 0, 0, 1], [0, 0, 0, 1, 0, 0], 
[0, 0, -1, 0, 0, 0], [0, -1, 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);

L[[6,17,0]][reference][[Morozov,1]]
:=[[[6,17],{},eval(M)]];

L[[6,17,0]][reference][[Winternitz,1]]
:=[[[6,17],{},eval(M)]];

L[[6,17,0]][reference][[Winternitz,5]]
:=[[[6,17]]] ;

#...........[6,18,0]...........


L[[6,18,0]][structure_constants]
:=[[[2,6,1],epsilon],[[3,5,1],1],[[4,5,3],1],[[4,6,2],1],[[5,6,4],1]];

L[[6,18,0]][algebra_type]
:=nilpotent;

L[[6,18,0]][mai]
:=[];

M := Matrix([[0, 0, 0, 0, -1, 0], [0, 0, 0, 0, 0, -sqrt(epsilon*gamma)/gamma], [0, 0, 0, sqrt(epsilon*gamma)/gamma, 0, 0], [0, 0, sqrt(epsilon*gamma)/gamma, 0, 0, 0], [0, epsilon/gamma, 
0, 0, 0, 0], [sqrt(epsilon*gamma)/gamma, 0, 0, 0, 0, 0]]);

L[[6,18,0]][reference][[Morozov,1]]
:=[[[6,18],{},eval(M)]];


M := Matrix([[0, 0, 0, 0, -1, 0], [0, 0, 0, 0, 0, -sqrt(epsilon*a)/a], 
            [0, 0, 0, sqrt(epsilon*a)/a, 0, 0], [0, 0, sqrt(epsilon*a)/a, 0, 0, 0], 
		[0, epsilon/a, 0, 0, 0, 0], [sqrt(epsilon*a)/a, 0, 0, 0, 0, 0]]);


L[[6,18,0]][reference][[Winternitz,1]]
:=[[[6,18],{},eval(M)]];

L[[6,18,0]][reference][[Winternitz,5]]
:=[[[6,18],{epsilon=_x}]] ;


#.............[6,19,0]............

L[[6,19,0]][structure_constants]
:=[[[2,6,1],1],[[3,6,2],1],[[4,5,1],1],[[4,6,3],1],[[5,6,4],1]];

L[[6,19,0]][algebra_type]
:=nilpotent;

L[[6,19,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, 1], [0, 0, 0, 0, 1, 0], [0, 0, 0, -1, 0, 0], 
           [0, 0, 1, 0, 0, 0], [0, -1, 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);

L[[6,19,0]][reference][[Morozov,1]]
:=[[[6,19],{},eval(M)]];

L[[6,19,0]][reference][[Winternitz,1]]
:=[[[6,19],{},eval(M)]];

L[[6,19,0]][reference][[Winternitz,5]]
:=[[[6,19]]] ;

#...........[6,20,0]............

L[[6,20,0]][structure_constants]
:=[[[2,6,1],1],[[3,5,1],1],[[3,6,2],1],[[4,5,2],1],
   [[4,6,3],1],[[5,6,4],1]];

L[[6,20,0]][algebra_type]
:=nilpotent;

L[[6,20,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, 1], [0, 0, 0, 0, -1, 0], [0, 0, 0, 1, 0, 0],
 [0, 0, -1, 0, 0, 0], [0, 1, 0, 0, 0, 0], [-1, 0, 0, 0, 0, 0]]);

L[[6,20,0]][reference][[Morozov,1]]
:=[[[6,20],{},eval(M)]];

L[[6,20,0]][reference][[Winternitz,1]]
:=[[[6,20],{},eval(M)]];

L[[6,20,0]][reference][[Winternitz,5]]
:=[[[6,20]]] ;

#..........[6,21,0]............

L[[6,21,0]][structure_constants]
:=[[[2,6,1],1],[[3,4,1],1],
   [[3,5,2],1],[[4,5,3],1],[[5,6,4],1]];

L[[6,21,0]][algebra_type]
:=nilpotent;

L[[6,21,0]][mai]
:=[];

M:=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 0, 1, 0], [0, 0, 0, 1, 0, 0],
                [0, 0, -1, 0, 0, 0], [0, 1, 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);


L[[6,21,0]][reference][[Morozov,1]]
:=[[[6,21],{},eval(M)]];

L[[6,21,0]][reference][[Winternitz,1]]
:=[[[6,21],{},eval(M)]];

L[[6,21,0]][reference][[Winternitz,5]]
:=[[[6,21]]] ;


#............[6,22,0]............

L[[6,22,0]][structure_constants]
:=[[[2,6,1],1],[[3,4,1],1],[[3,5,2],1],[[4,5,3],1],[[4,6,2],1],
   [[5,6,4],1]];

L[[6,22,0]][algebra_type]
:=nilpotent;

L[[6,22,0]][mai]
:=[];

M :=Matrix([[0, 0, 0, 0, 0, -1], [0, 0, 0, 0, 1, 0], [0, 0, 0, 1, 0, 0], 
[0, 0, -1, 0, 0, 0], [0, 1, 0, 0, 0, 0], [1, 0, 0, 0, 0, 0]]);

L[[6,22,0]][reference][[Morozov,1]]
:=[[[6,22],{},eval(M)]];

L[[6,22,0]][reference][[Winternitz,1]]
:=[[[6,22],{},eval(M)]];

L[[6,22,0]][reference][[Winternitz,5]]
:=[[[6,22]]] ;


#

eval(L);
end: