#
# DiffGeomLibrary_Utilities.alg
#
# DiffGeomLibrary
#
# DiffGeom_library;library_references; 
# library_list
# 
#
#
#


USU_init:=proc(a,b) 
Lie_algebra_init(DiffGeom_library(USU,a,b));
end;


DiffGeomLibrary[USUinit]:=proc(b) 

if b[2]>0 then 
	Lie_algebra_init(DiffGeom_library(USU,2,b));
else
	Lie_algebra_init(DiffGeom_library(USU,`2D`,b));
fi;

end;




USU1:=proc(index)

if	index[1]>1 and index[2] <= 0  then 
	RETURN(USU1_0())
fi;

if index[1] <=5 then
	RETURN(USU1_1())
fi;

if index[1]  =6  then
      RETURN(USU1_6())
fi;

end:






DiffGeom_library:=proc(author,paper,index)

# CLASS II PROGRAM
# 01/25/2004 IA

description `Diff Geom Library reference lookup`;
option `Copyright Ian M. Anderson 2004`;



local ans,tbl, T, S, N,vars, i,m, w,L,A,W,DG_lib,n,r,alg_name;

 

DG_lib:=DifferentialGeometryLibrary[cat(author,paper)];

#......................................

if member(DG_lib,
{Mubarakyzanov1, Mubarakyzanov2,Mubarakyzanov3,Morozov1, Nielsen1, Turkowski1, Turkowski2, 
 USU1,USU1D,USU2,USU2D, USU3,USU6, Winternitz1, Winternitz5})
then
      T:=eval(DG_lib(index));
	S:=T[index][structure_constants];

	if nargs =4 then 
		N:=args[4] 
	else 
		N:=cat(substring(author,1..3),paper, ":",op(index));
	fi;

	ans:=[[Lie_alg,N,[index[1]]], S];

	if   DG_lib=Turkowski2 then 
      	unassign('x1','x2', 'n1', 'n2', 'n3', 'n4', 
               'theta1', 'theta2', 'theta3', 'theta4', 'theta5', 'theta6');
		ans:= ans,[x1,x2,n1,n2,n3,n4], [theta];
      	RETURN(ans) 
	fi;
	
	RETURN(ans);
fi;

#.......................................



if DG_lib=Petrov1 then 
      V0:=Petrov1()[index][vectors];
      V1:=subs({seq(cat(x,i)=frameIndependentVariables()[i],i=1..frameBaseDimension())}, V0);
      V2:=map(v_zip,V1,frameBaseVectors(),plus);
      RETURN(V2)
fi;
 


#........................................

if  DG_lib=Gonzalez_Lopez1 then 

	if nargs=4 then 
		vars:=Vars 
	else 
		vars := frameJetVariables();
	fi;

	n:=index[1];
      if nops(index)=2 then
      	r:=index[2];
	      alg_name:=cat(GonA,n,"_",r)
	else
		alg_name:=cat(GonA,n)
	fi;

     	if n=20 and r>5 then
		ans:=[q,seq(cat(xi,i)(x)*q, i=1..r)];
      	RETURN(map(evalV,ans),alg_name);
	fi;

	if n=21  and r>5 then 
		ans:=[y*q,q, seq(cat(xi,i)(x)*q, i=1..r)];
      	RETURN(map(evalV,ans),alg_name)
	fi;


      if  n=22  and r=XXX then 
      	L:=Lie_lib(winternitz,r):
      	Lie_alg_init(L):
      	m:=frameBaseDimension();
      	w:=frameBaseVectors()[m];
      	A:= Ad(x &mult w):
      	W:=convert( eval(A&*[seq(_C.i, i=1..m-1),0]),list);  
		change_frame_to(euclid):ans:=[seq(W[i]*q, i=1..m-1),p ];
      	RETURN(map(evalV,ans),cat(glko,r[2]))
	fi;


	if  n=23 and r=XXX then 
      	L:=Lie_lib(winternitz,r):
      	Lie_alg_init(L):
      	m:=frameBaseDimension();
      	w:=frameBaseVectors()[m];
      	A:= Ad(x &mult w):
      	W:=convert( eval(A&*[seq(_C.i, i=1..m-1),0]),list);  
		change_frame_to(euclid):ans:=[seq(W[i]*q, i=1..m-1),p, y*q];
      	RETURN(map(evalV,ans),cat(glko,r[2]))
	fi;

	if n=24  and r>5 then
		ans:=[p,x*p + alpha*y*q, seq(x^i*q,i=0..r)];
     		ans:=subs(x= vars[1], y = vars[2],p= vect(vars[1]),q = vect(vars[2]),ans);
		RETURN(map(evalV,ans),alg_name)
	fi;

	if n=25  and r>5 then 
     		ans:=[p,q,seq(x^i*q,i=1..r-1),x*p +(r*y +x^r)*q];
		ans:=subs(x= vars[1], y = vars[2],p= vect(vars[1]),q = vect(vars[2]),ans);
		RETURN(map(evalV,ans),alg_name)
	fi;

	if n=26 then 
		ans:=[p,y*q, seq(x^i*q,i=0..r)];
		ans:=subs(x= vars[1], y = vars[2],p= vect(vars[1]),q = vect(vars[2]),ans);
		RETURN(map(evalV,ans),alg_name)
	fi;

	if n=27 then
		ans:=[p,2*x*p +r*y*q,x^2*p +r*x*y*q, seq(x^i*q, i=0..r)];
		ans:=subs(x= vars[1], y = vars[2],p= vect(vars[1]),q = vect(vars[2]),ans);
		RETURN(map(evalV,ans),alg_name);
	fi;


	if n=28 then
		ans:=[p,x*p,x^2*p +r*x*y*q,y*q,  seq(x^i*q, i=0..r)];
		ans:=subs(x= vars[1], y = vars[2],p= vect(vars[1]),q = vect(vars[2]),ans);
                        RETURN(map(evalV,ans),alg_name);
	fi;
	
      T:=eval(DG_lib());
	
	S:=T[index][vectors];
      Fr:=frameBaseVectors();


      S:=subs(x= vars[1], y = vars[2],p= Fr[1],q = Fr[2],S);

      ans:=map(evalV,S);

	RETURN(ans,alg_name)

fi;


end:


library_print:=proc(author,paper,index_list,property_list)

# CLASS II PROGRAM
# 01/25/2004 IA

description `Diff Geom Library reference lookup`;
option `Copyright Ian M. Anderson 2004`;



local alg,data, ans,tbl, T, S, N,vars, i,m, w,L, A,W,DG_lib,n,r,alg_name;

 

DG_lib:=DifferentialGeometryLibrary[cat(author,paper)];

#......................................

if member(DG_lib,
{Morozov1,Mubarakyzanov1, Mubarakyzanov2,Mubarakyzanov3,Turkowski1, 
 Turkowski2, USU1,Winternitz1, Winternitz5})
then 
      for alg in index_list do

      
	data:=DiffGeom_library(author,paper,alg);
      Lie_algebra_init(data):
      print(_Vessiot_current_frame_name);
      print(mult_table(bracket));  

	T:=eval(DG_lib(alg));
  	
      if nargs =4 then  
     	print(seq(T[alg][p], p = property_list));
      fi;

      print(`~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`);
      remove_frame(_Vessiot_current_frame_name);
      
      od;
	
	RETURN();
fi;

#.......................................

if  DG_lib=Gonzalez_Lopez1 then 
fi;


end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


library_references:=proc()

# CLASS II PROGRAM
# 01/25/2004 IA

description `Diff Geom Library references`;
option `Copyright Ian M. Anderson 2004`;

writeline(default);
writeline(default, "Gonzalez-Lopez, 1");
writeline(default, "\t Lie algebras of vector fields in the real plane (with Kamran and Olver)"); 
writeline(default, "\t Proc. London Math Soc. Vol 64 (1992), 339--368");
writeline(default);
writeline(default);

#...........

writeline(default, "Mubarakzyanov, 1");
writeline(default, "\t Lie algebras of dimmensions 3,4");
writeline(default, "\t Izv. Vyssh. Uchebn. Zaved. Math 34(1963) 99.");
writeline(default);


#..........

writeline(default, "Mubarakzyanov, 2");
writeline(default, "\t Lie algebras of dimension 5");
writeline(default, "\t Izv. Vyssh. Uchebn. Zaved. Math 34(1963) 99.");
writeline(default);

#..........

writeline(default, "Mubarakzyanov, 3");
writeline(default, "\t Lie algebras of dimension 6");
writeline(default, "\t Izv. Vyssh. Uchebn. Zaved. Math 35(1963) 104.");
writeline(default);

#...........

writeline(default, "Olver, 1:");
writeline(default,  "\t Equivalence,Invariants and Symmetry, 472--473");
writeline(default);

#...........



writeline(default, "Petrov, 1:");
writeline(default,  "\t Einstein Spaces");
writeline(default);


writeline(default, "Turkowski, 1:"); 
writeline(default, "\t Low dimensional real Lie algebras");
writeline(default, "\t JMP(29),1990,2139--2144");
writeline(default);

#...........

writeline(default, "Turkowski, 2");
writeline(default, "\t Solvable Lie Algebras of dimension six"); 
writeline(default, "\t JMP(31),1990,1344--1350");
writeline(default);


#............

writeline(default, "Winternitz, 1:");
writeline(default, "\t Invariants of real low dimensional Lie algebras,(with Patera,Sharp and Zassenhaus)");              
writeline(default, "\t JMP vol 17, No 6, June 1976,  966--994");
writeline(default);

#...........

writeline(default, "Winternitz, 5:");
writeline(default,  "\t  Unpublished tables");  
writeline(default);


end:


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


library_index_sort:=proc(a,b)
# CLASS II PROGRAM
# 01/25/2004 IA

description `sorter`;
option `Copyright Ian M. Anderson 2004`;
local i,n;

n:=nops(a);

for i from 1 to n do
if abs(a[i]) <abs(b[i])then RETURN(true) fi;
if abs(a[i]) >abs(b[i])then RETURN(false) fi;
od; 

false

end:

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

library_list:=proc(author, paper)

# CLASS II PROGRAM
# 01/25/2004 IA

description `lists all the indices for a given table`;
option `Copyright Ian M. Anderson 2004`;

localT,L,ref,i;

ref:=DifferentialGeometryLibrary[cat(author,paper)];


if ref=USU1 then 
	L:=[];  
	for i from 0 to 4 do
 		T:=eval(cat(USU1_,i)());
		L:=[op(L),op(map(op,[indices(T)]))];
      od;
else
	T:=eval(ref());
	L:=map(op,[indices(T)]);
fi;

A:=sort(L, library_index_sort);

if nargs=2 then RETURN(A) fi;



ans:=[];


for ind in A do 
	if (library_index_sort(args[3],ind)or ind=args[3]) and 
         (library_index_sort(ind,args[4])or ind=args[4]) then  
	    
		ans:=[op(ans),ind] 
	fi;
od;

ans;

end:

#