


libname:= "C:\\Program Files\\Maple 10/lib","C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive";





with(DifferentialGeometryInternal):






DifferentialGeometry:=module()

description  "Differential Geometry Package";

option  package ,load=DifferentialGeometryStartup;

local DifferentialGeometryStartup,MakeJacobianMatrix,multi_Wronskian;


export 

#Action.ms
	vect_to_transform, transform_to_vect, vect_to_Lie_alg,

#Arit.ms
      `&plus`, `&minus`, `&mult`,  `&tensor`,

#CoordInit.ms
       coord_init,

#DiffGeomMain
        DiffGeomMain,

#DifferentialGeometryUtilities	
       v_zip,linear_combo,

#FrameInit.ms
	 frame_init,coframe_data, dual_basis,



#EvalV.ms
	evalV,

#Ext_d
      ext_d,

#FrameChangeRemove
	change_frame_to, remove_frame,


#Helmsimp
	helmsimp,

#Homotopy.ms
 	homotopy_ext_d,

#Hook
      hook,

#Lie.ms
	Lie_bracket, Lie_derivative,

#Pullback.ms
      pullback, 
 
#Push_fwd.ms
       pushforward, pullback_vect,

#Transformations
      transform,compose_transforms,inverse_transform ,

#Wedge.ms
      `&wedge` 

;

#-----------------------------------------------------------------

DifferentialGeometryStartup:=proc()

global
	
#EnvirnomentVariables
      _VessiotPromptLength,
	helm_show_frame_flag, _Vessiot_show_intermediate_steps_flag,
 	_Vessiot_current_frame_name, _Vessiot_frame_data, 
	_VessiotWarningFlag, _Vessiot_query_flag, _Vessiot_simplify,
	_Vessiot_linalg_flag,_Vessiot_xlinalg_conditions,_Vessiot_matrices_rref,
     _Vessiot_matrices_null,  

#Conversions
	`convert/Vessiot_tensor`,  `convert/Vessiot_vect`, `convert/Vessiot_form`,
       `convert/Vessiot_array`,`convert/Vessiot_connection`,
	
#print
 	`print/_VESSIOT` ,VessiotPrompt  
; 




with(DifferentialGeometryInternal):


$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\VessiotConvert.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\VessiotEnvironment.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\VessiotPrint.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\VessiotTypes.ms";

end:


#-----------------------------------------------------------

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Action.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Arith.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\CoordInit.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\DiffGeomMain.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\DifferentialGeometryUtilities.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\EvalV.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Ext_d.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\FrameChangeRemove.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\FrameInit.ms";


$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Helmsimp.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Homotopy.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Hook.ms";


$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\LieBracket.ms";


$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\LieDerivative.ms";


$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Pullback.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Push_fwd.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Transformations.ms";

$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\DifferentialGeometry\\Wedge.ms";


end module;


unwith(DifferentialGeometryInternal):

savelibname:="C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive\\DifferentialGeometry.mla";

savelib('DifferentialGeometry');
