
libname:= "C:\\Program Files\\Maple 10/lib","C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive";



with(DifferentialGeometry):
#with(DifferentialGeometryInternal):
with(DifferentialGeometryTools):


DifferentialGeometryLibrary:=module()

description  "Differential Geometry Library Package";

option  package; 

export 

#LieAlgebras

	Morozov1, Mubarakyzanov2, Mubarakyzanov3, Turkowski1,	Turkowski2,	Winternitz1,	Winternitz5,


#Petrov
	Petrov1,

#Utilities
	USU_init, USU1, DiffGeom_library,library_print,library_references,
	library_index_sort,library_list,



#USU Automorphisms
	USU2Auto1,USU2Auto2, USU2Auto3, USU2DAuto1, USU2DAuto3, 

#USU Generated Algebras
USU1D, USU2, USU2D, USU3,



#HomogenSpace
USU2HomogeneousSpaces,USU2DHomogeneousSpaces,


#LAP
	USU2LAP,USU2DLAP,

#LieGroups
	USU2DLieGroups,USU2LieGroups,

#PseudoRiemannianHomogeneousSpaces
	USUPseudoRiemannianHomogeneousSpaces,USU2DPseudoRiemannianHomogeneousSpaces,USU2PseudoRiemannianHomogeneousSpaces,

#Representations
	USU2_Representation, USU2D_Representation,

#RootAlgebras
	USU10, USU1_1, USU1_2, USU1_3,USU1_4, USU1_6,

#USU2SeriesClassification
	USU2SeriesClassification,

#Subalgebras
 	USU2Dsubalgebra1, USU2subalgebra1,

#USU2DClass
	USU2Dclass,




#VectorFields
	Gonzalez_Lopez1, GLKOproperties;



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\LieAlgebras\\Morozov1.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\LieAlgebras\\Mubarakyzanov2.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\LieAlgebras\\Mubarakyzanov3.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\LieAlgebras\\Turkowski1.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\LieAlgebras\\Turkowski2.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\LieAlgebras\\Winternitz1.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\LieAlgebras\\Winternitz5.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\Petrov\\PetrovVFS.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\Utilities\\DiffGeomLibrary_Utilities.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\VectorFields\\Gonzalez_Lopez1.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\VectorFields\\GLKOproperties.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Automorphisms\\USU2Auto1.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Automorphisms\\USU2Auto2.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Automorphisms\\USU2Auto3.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Automorphisms\\USU2DAuto1.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Automorphisms\\USU2DAuto3.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\GeneratedAlgebras\\USU1D.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\GeneratedAlgebras\\USU2.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\GeneratedAlgebras\\USU2D.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\GeneratedAlgebras\\USU3.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\HomogeneousSpaces\\USU2DHomogeneous_spaces.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\HomogeneousSpaces\\USU2Homogeneous_spaces.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\LAP\\USU2LAP.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\LAP\\USU2DLAP.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\LieGroups\\USU2LieGroups.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\LieGroups\\USU2DLieGroups.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\PseudoRiemannianHomogeneousSpaces\\USUPseudoRiemannianHomogeneousSpaces.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\PseudoRiemannianHomogeneousSpaces\\USU2PseudoRiemannianHomogeneousSpaces.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\PseudoRiemannianHomogeneousSpaces\\USU2DPseudoRiemannianHomogeneousSpaces.ms";



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Representations\\USU2DReps.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Representations\\USU2Reps.ms";



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\RootAlgebras\\USU1_0.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\RootAlgebras\\USU1_1.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\RootAlgebras\\USU1_2.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\RootAlgebras\\USU1_3.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\RootAlgebras\\USU1_4.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\RootAlgebras\\USU1_6.ms";



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\SeriesClassification\\USU2SeriesData.ms";



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Subalgebras\\USU2DsubalgebraB.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\Subalgebras\\USU2subalgebraB.ms";



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryLibrary\\USU\\USU2DClass\\USU2DClassification.ms";





end module;

unwith(DifferentialGeometry);

savelibname:="C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive\\DifferentialGeometryLibrary.mla";

savelib('DifferentialGeometryLibrary');
