
libname:=
 "C:\\Program Files\\Maple 10/lib",
 "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive";



with(DifferentialGeometry):
with(DifferentialGeometryInternal):
with(DifferentialGeometryTools):


JetCalc:=module()

description  "JetCalc Package";

option  package, load=JetCalcStartup; 


local pr_var_set,JetCalcStartup;   

export 

#HIhgerEL
	higher_EL0, higher_hook_EL, 

#Differential_eqn.ms
	Diffeq,pr_diffeq,   	
#Euler_Lagrange
       Euler_Lagrange,

#FormDiff
	ext_dH, ext_dV,

#Homotopy_dV
	homotopy_dV, homotopy_dH,

#Hook 
	vert_hook, total_hook,

#I_parts
	I_parts,

#Lie
      gen_Lie_bracket,

#PrTransform
	pr_transform,

#PrVect
      pr_vect, #  newtrypr_vect, #OTHER STUFF

#Project 



#Pullback_biform
 	pullback_biform, projected_pullback, 

#push_fwd
	pushforward_total,

#Td
	td,

#
      total, Evol;

#---------------------------------

JetCalcStartup:=proc()


global  `convert/Vessiot_biform`,   `convert/jet`, `convert/deriv`, 
       `convert/Vessiot_diffeq`, `convert/Vessiot_transform`;

local Lie_biform, Lie_biform_proj, Lie_vert0, Lie_tot0;


#---------------------------------


$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\JetCalcExtensions.ms";

DifferentialGeometry:-Lie_derivative:-addRule([Vessiot_biform],Lie_biform);

DifferentialGeometry:-Lie_derivative:-addProcedure([Vessiot_biform1,vst_euc],Lie_proj0 );

DifferentialGeometry:-Lie_derivative:-addProcedure([Vessiot_biform2,vst_euc],Lie_vert0);

DifferentialGeometry:-Lie_derivative:-addProcedure([Vessiot_biform3,vst_euc],Lie_tot0);


$include  "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\JetCalcConvert.ms";






end;


#----------------------------------

  
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\DifferentialEquations.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\EulerLagrange.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\FormDiff.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\HighEl.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\Homotopy.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\Hook.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\IParts.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\Lie.ms";



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\PrTransform.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\PrVect.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\Pullback.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\PushFwd.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\Td.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\JetCalc\\TotEvol.ms";





end module;

unwith(DifferentialGeometry);

savelibname:="C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive\\DifferentialGeometry.mla";

savelib('JetCalc');
