
libname:= "C:\\Program Files\\Maple 10/lib","C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive";



with(DifferentialGeometry):
#with(DifferentialGeometryInternal):
with(DifferentialGeometryTools):


LieAlgebras:=module()

description  "Lie Algebra (Root) Package";

option  package, load=LieAlgebrasStartup; 


local LieAlgebrasStartup,Vessiot_query, decom_alg1, decom_alg2,decom_alg3,
decompose_algebra, Levi_decomposition_for_abelian_radical, Levi_loop,reorder_Lie_algebra, Lie_form, Lie0,
ext_d_form;

export 

#Ad.ms
	ad, Ad, Killing,

#Automorphisms.ms
	infinitesimal_automorphisms,

#Checks.ms
	LieAlgCheck,

#DecomposeLieAlgebra
	DecomposeLieAlgebra,

#Initial.ms
	change_Lie_algebra_to, Lie_algebra_init,

#InputOutput
	mult_table,

#LieAlgebraTransform
 	Lie_algebra_transform, transformation_subalgebra,

#LeviDecompositon
      LeviDecomposition,

#MatrixAlgebras
	matrix_algebras,


#NewAlgebrasFromOld
	quotient_algebra, complexify_Lie_algebra, direct_sum_of_algebras,

#NewSubAlgebrasFromOld
 	minimal_subalgebra, minimal_ideal,

#Nilradical
	Nilradical,

#Series
	LieAlg_series,
 
#algebras_and_ideals.ms
	center,rad, derived_algebra, normalizer, stablizer, centralizer,

#Utilities
	change_Lie_algebra_basis;




LieAlgebrasStartup:=proc()

global
	`convert/Lie_algebra_data`, `convert/vector_field_system`,`convert/Lie_algebra_transform`;


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\LieAlgebraExtensions.ms";



DifferentialGeometry:-ext_d:-addProcedure([LieAlg_frame],ext_d_form);

DifferentialGeometry:-Lie_derivative:-addProcedure([Vessiot_form,LieAlg_frame],LieDerForm);

DifferentialGeometry:-Lie_derivative:-addProcedure([Vessiot_scalar,LieAlg_frame],Lie0);


DifferentialGeometry:-Lie_bracket:-addRule([LieAlg_frame],Lie_bckt);



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\LieAlgebraConvert.ms";

end:

   


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\Ad.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\Automorphisms.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\Checks.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\DecomposeAlgebra.ms";



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\Initial.ms";

   
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\InputOutput.ms";

   
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\LieAlgebraTransform.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\LeviDecomposition.ms";


   
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\MatrixAlgebras.ms";


   
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\NewAlgebrasFromOld.ms";

   
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\NewSubalgebrasFromOld.ms";

   
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\Nilradical.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\Series.ms";
   

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\SubalgebrasAndIdeals.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\LieAlgebras\\Utilities.ms";

      
end module;

unwith(DifferentialGeometry);

savelibname:="C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive\\DifferentialGeometry.mla";

savelib('LieAlgebras');
