
libname:= "C:\\Program Files\\Maple 10/lib","C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive";



with(DifferentialGeometry):
#with(DifferentialGeometryInternal):
with(DifferentialGeometryTools):


tensors:=module()

description  "Differential Geometry Tensor Package";

option  package,  load=TensorStartup; 
 


local TensorStartup;


export 

#connection.ms
	offel1,offel2,torsion_tensor,


#contract_and_raise
 	contract_indices, raise_lower_indices, inverse_metric,

#cov_der.ms
	directional_covariant_derivative, covariant_derivative,

#Curvature.ms 
	curvature_tensor,Ricci_tensor, Ricci_scalar, Einstein_tensor, Weyl_tensor, Cotton_tensor,

#Numerical Tensors
	permutation_symbol,generalized_Kronecker_delta,


#push_pull
 	push_pull_tensor,

#rearrange
	rearrange_indices, symm_skew_indices,

#tensor_utilities
	multi_vector,  metric_density, Hodge_star,  ParallelTransportEquations, GeodesicEquations; 


TensorStartup:=proc()


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\TensorExtensions.ms";

DifferentialGeometry:-Lie_derivative:-addRule([Vessiot_tensor], proc()  [Vessiot_tensor] end );

DifferentialGeometry:-Lie_derivative:-addRule([Vessiot_connection], proc()  [Vessiot_connection] end );

DifferentialGeometry:-Lie_derivative:-addProcedure([Vessiot_tensor],Lie_tens);

DifferentialGeometry:-Lie_derivative:-addProcedure([Vessiot_connection],Lie_conn);

end:



$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\Connections.ms";

   
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\ContractAndRaise.ms";

  
$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\CovariantDerivatives.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\Curvature.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\NumericalTensors.ms";

$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\PushPullTensor.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\Rearrange.ms";


$include "C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DiffGeomSourceCode\\Tensors\\tensorUtilities.ms";


end module;

unwith(DifferentialGeometry);

savelibname:="C:\\Ian'sWork\\MapleSoft\\DiffGeom2.0\\DifferentialGeometryArchive\\DifferentialGeometry.mla";

savelib('tensors');
