USU2LieGroups:=proc()

local LG;
LG:=table();
LG[[3, 1, 0]][representation]:=
[[1, -x1, x2], [0, 1, x3], [0, 0, 1]];

LG[[3, 1, 0]][identity]:=
[0, 0, 0];

LG[[3, 1, 0]][G_dot]:=
proc(X,Y) [Y[1]+X[1], Y[2]-X[1]*Y[3]+X[2], Y[3]+X[3]] end;


LG[[3, 2, 0]][representation]:=
[[exp(-x2), 0, -exp(-x2)*x1], [0, exp(-x2*a), x3], [0, 0, 1]];

LG[[3, 2, 0]][identity]:=
[0, 0, 0];

LG[[3, 2, 0]][G_dot]:=
proc(X,Y) [exp(X[2]+Y[2])*(Y[1]*exp(-X[2]-Y[2])*exp(X[2])+X[1])/exp(X[2]), X[2]+Y[2], exp(-X[2]*a)*Y[3]+X[3]] end;


LG[[3, 3, 0]][representation]:=
[[exp(-x1), -x1*exp(-x1), x2], [0, exp(-x1), x3], [0, 0, 1]];

LG[[3, 3, 0]][identity]:=
[0, 0, 0];

LG[[3, 3, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], -(-Y[2]+X[1]*Y[3]-X[2]*exp(X[1]))/exp(X[1]), (Y[3]+X[3]*exp(X[1]))/exp(X[1])] end;


LG[[3, 4, 0]][representation]:=
[[exp(-x1*a)*cos(x1), -exp(-x1*a)*sin(x1), x2], [exp(-x1*a)*sin(x1), exp(-x1*a)*cos(x1), x3], [0, 0, 1]];

LG[[3, 4, 0]][identity]:=
[0, 0, 0];

LG[[3, 4, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], exp(-X[1]*a)*cos(X[1])*Y[2]-exp(-X[1]*a)*sin(X[1])*Y[3]+X[2], exp(-X[1]*a)*sin(X[1])*Y[2]+exp(-X[1]*a)*cos(X[1])*Y[3]+X[3]] end;


LG[[3, 5, 0]][representation]:=
[[exp(-1/2*x2)+x3*x1*exp(-x2), x3], [x1*exp(-1/2*x2), exp(1/2*x2)]];

LG[[3, 5, 0]][identity]:=
[0, 0, 0];

LG[[3, 5, 0]][G_dot]:=
proc(X,Y) [(X[1]^2*Y[3]*exp(-2*X[2]-1/2*Y[2])+X[1]^2*Y[3]^2*Y[1]*exp(-Y[2]-2*X[2])+2*X[1]*Y[3]*Y[1]*exp(-1/2*Y[2]-X[2])+X[1]*exp(-1/2*X[2])^2+Y[1])/exp(-1/2*X[2])^2, 2*ln(X[1]*Y[3]*exp(-1/2*Y[2]-X[2])+1)+X[2]+Y[2], (Y[3]*exp(-1/2*X[2])*exp(X[2])+Y[3]*X[3]*X[1]+X[3]*exp(1/2*Y[2])*exp(X[2]))/exp(X[2])] end;



LG[[3, 6, 0]][representation]:=[[cos(x3)*cos(x1)-sin(x3)*sin(x2)*sin(x1), cos(x2)*sin(x1), -sin(x3)*cos(x1)-cos(x3)*sin(x2)*sin(x1)], [-cos(x3)*sin(x1)-sin(x3)*sin(x2)*cos(x1), 
cos(x2)*cos(x1), sin(x3)*sin(x1)-cos(x3)*sin(x2)*cos(x1)], [sin(x3)*cos(x2), sin(x2), cos(x3)*cos(x2)]];

LG[[3, 6, 0]][identity]:=
[0, 0, 0];


LG[[4, 1, 0]][representation]:=
[[1, -x4, 1/2*x4^2, -x1+x4*x2-1/2*x4^2*x3], [0, 1, -x4, -x2+x4*x3], [0, 0, 1, -x3], [0, 0, 0, 1]];

LG[[4, 1, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 1, 0]][G_dot]:=
proc(X,Y) [1/2*X[3]*Y[4]^2+Y[4]*X[2]+Y[1]+X[1], X[3]*Y[4]+Y[2]+X[2], Y[3]+X[3], Y[4]+X[4]] end;


LG[[4, 2, 0]][representation]:=
[[exp(-x3), 0, 0, -exp(-x3)*x1], [0, exp(-x3*a), 0, x4], [0, 0, exp(-x3*b), -exp(-x3*b)*x2], [0, 0, 0, 1]];

LG[[4, 2, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 2, 0]][G_dot]:=
proc(X,Y) [exp(Y[3]+X[3])*(Y[1]*exp(-X[3]-Y[3])*exp(X[3])+X[1])/exp(X[3]), (Y[2]*exp(-X[3]*b-Y[3]*b)+exp(-X[3]*b)*X[2])/exp(-(Y[3]+X[3])*b), Y[3]+X[3], exp(-X[3]*a)*Y[4]+X[4]] end;


LG[[4, 3, 0]][representation]:=
[[exp(-x2*a), 0, 0, -exp(-x2*a)*x1], [0, exp(-x2), -x2*exp(-x2), x3], [0, 0, exp(-x2), x4], [0, 0, 0, 1]];

LG[[4, 3, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 3, 0]][G_dot]:=
proc(X,Y) [(Y[1]*exp(-X[2]*a-Y[2]*a)+exp(-X[2]*a)*X[1])/exp(-(X[2]+Y[2])*a), X[2]+Y[2], -(-Y[3]+X[2]*Y[4]-X[3]*exp(X[2]))/exp(X[2]), (Y[4]+X[4]*exp(X[2]))/exp(X[2])] end;


LG[[4, 4, 0]][representation]:=
[[exp(-x3), 0, 0, x4], [0, 1, -x3, -x1+x3*x2], [0, 0, 1, -x2], [0, 0, 0, 1]];

LG[[4, 4, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 4, 0]][G_dot]:=
proc(X,Y) [X[2]*Y[3]+Y[1]+X[1], X[2]+Y[2], Y[3]+X[3], (Y[4]+X[4]*exp(X[3]))/exp(X[3])] end;


LG[[4, 5, 0]][representation]:=
[[exp(-x1), -x1*exp(-x1), 1/2*x1^2*exp(-x1), x2], [0, exp(-x1), -x1*exp(-x1), x3], [0, 0, exp(-x1), x4], [0, 0, 0, 1]];

LG[[4, 5, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 5, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], 1/2*(2*Y[2]-2*X[1]*Y[3]+X[1]^2*Y[4]+2*X[2]*exp(X[1]))/exp(X[1]), -(-Y[3]+X[1]*Y[4]-X[3]*exp(X[1]))/exp(X[1]), (Y[4]+X[4]*exp(X[1]))/exp(X[1])] end;


LG[[4, 6, 0]][representation]:=
[[exp(-x2*a), 0, 0, -exp(-x2*a)*x1], [0, exp(-x2*b)*cos(x2), -exp(-x2*b)*sin(x2), x3], [0, exp(-x2*b)*sin(x2), exp(-x2*b)*cos(x2), x4], [0, 0, 0, 1]];

LG[[4, 6, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 6, 0]][G_dot]:=
proc(X,Y) [(Y[1]*exp(-X[2]*a-Y[2]*a)+exp(-X[2]*a)*X[1])/exp(-(X[2]+Y[2])*a), X[2]+Y[2], exp(-X[2]*b)*cos(X[2])*Y[3]-exp(-X[2]*b)*sin(X[2])*Y[4]+X[3], exp(-X[2]*b)*sin(X[2])*Y[3]+exp(-X[2]*b)*cos(X[2])*Y[4]+X[4]] end;


LG[[4, 7, 0]][representation]:=
[[exp(-x4-x4*a), exp(-x4-x4*a)*x3, exp(-x4-x4*a)*x2, exp(-x4-x4*a)*(-x1-x1*a+x3*x2)], [0, exp(-x4), 0, exp(-x4)*x2], [0, 0, exp(-x4*a), -exp(-x4*a)*x3*a], [0, 0, 0, 1]];

LG[[4, 7, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 7, 0]][G_dot]:=
proc(X,Y) [(X[2]*exp(-X[4]-X[4]*a-Y[4]*a)*Y[3]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)+X[2]*exp(-X[4]-X[4]*a-Y[4]*a)*X[3]*exp(-X[4]-X[4]*a-Y[4])+exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)^2*Y[1]+exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)^2*Y[1]*a+X[2]*Y[3]*a*exp(-X[4]-X[4]*a-Y[4]*a)*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)+exp(-X[4]-X[4]*a)*X[1]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)+exp(-X[4]-X[4]*a)*X[1]*a*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)-exp(-X[4]-X[4]*a)*X[3]*X[2]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a))/exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)^2/(a+1), (Y[2]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)+X[2]*exp(-X[4]-X[4]*a-Y[4]*a))/exp(-X[4]-X[4]*a-Y[4]-Y[4]*a), (Y[3]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)+X[3]*exp(-X[4]-X[4]*a-Y[4]))/exp(-X[4]-X[4]*a-Y[4]-Y[4]*a), X[4]+Y[4]] end;


LG[[4, 8, 0]][representation]:=
[[exp(-2*x4), exp(-2*x4)*x3, -exp(-2*x4)*x2, exp(-2*x4)*(2*x1-x3*x2)], [0, exp(-x4), -x4*exp(-x4), -exp(-x4)*x2+x4*exp(-x4)*x3], [0, 0, exp(-x4), -exp(-x4)*x3], [0, 0, 0, 1]];

LG[[4, 8, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 8, 0]][G_dot]:=
proc(X,Y) [1/2*(Y[3]*exp(-2*X[4]-2*Y[4])*exp(-X[4]-Y[4])*X[4]*exp(X[4])*exp(Y[4])*X[3]*exp(-2*X[4]-Y[4])+Y[3]^2*exp(-2*X[4]-2*Y[4])^2*exp(-X[4]-Y[4])*Y[4]*exp(X[4])*exp(Y[4])+2*Y[3]*exp(-2*X[4]-2*Y[4])*exp(-X[4]-Y[4])*Y[4]*exp(X[4])*exp(Y[4])*X[3]*exp(-2*X[4]-Y[4])+Y[3]*exp(-2*X[4]-2*Y[4])^2*Y[2]-Y[3]^2*exp(-2*X[4]-2*Y[4])^2*Y[4]+Y[3]*exp(-2*X[4]-2*Y[4])^2*X[2]*exp(Y[4])-Y[3]*exp(-2*X[4]-2*Y[4])^2*X[4]*X[3]*exp(Y[4])+X[3]^2*exp(-2*X[4]-Y[4])^2*exp(-X[4]-Y[4])*X[4]*exp(X[4])*exp(Y[4])+X[3]^2*exp(-2*X[4]-Y[4])^2*exp(-X[4]-Y[4])*Y[4]*exp(X[4])*exp(Y[4])+X[3]*exp(-2*X[4]-Y[4])*Y[2]*exp(-2*X[4]-2*Y[4])-X[3]*exp(-2*X[4]-Y[4])*Y[4]*Y[3]*exp(-2*X[4]-2*Y[4])+X[3]*exp(-2*X[4]-Y[4])*X[2]*exp(Y[4])*exp(-2*X[4]-2*Y[4])-X[3]^2*exp(-2*X[4]-Y[4])*X[4]*exp(Y[4])*exp(-2*X[4]-2*Y[4])+2*exp(-2*X[4]-2*Y[4])^2*Y[1]*exp(Y[4])*exp(-X[4]-Y[4])*exp(X[4])-exp(-2*X[4]-2*Y[4])^2*Y[3]*Y[2]*exp(Y[4])*exp(-X[4]-Y[4])*exp(X[4])-exp(-2*X[4])*X[3]*Y[2]*exp(-X[4]-Y[4])*exp(X[4])*exp(-2*X[4]-2*Y[4])+exp(-2*X[4])*X[3]*Y[4]*Y[3]*exp(-X[4]-Y[4])*exp(X[4])*exp(-2*X[4]-2*Y[4])+X[2]*Y[3]*exp(-2*X[4]-Y[4])*exp(Y[4])*exp(-X[4]-Y[4])*exp(X[4])*exp(-2*X[4]-2*Y[4])+2*exp(-2*X[4])*X[1]*exp(Y[4])*exp(-X[4]-Y[4])*exp(X[4])*exp(-2*X[4]-2*Y[4])-exp(-2*X[4])*X[3]*X[2]*exp(Y[4])*exp(-X[4]-Y[4])*exp(X[4])*exp(-2*X[4]-2*Y[4]))/exp(-2*X[4]-2*Y[4])^2/exp(Y[4])/exp(-X[4]-Y[4])/exp(X[4]), (exp(-X[4]-Y[4])*X[4]*exp(X[4])*exp(Y[4])*X[3]*exp(-2*X[4]-Y[4])+exp(-X[4]-Y[4])*Y[4]*exp(X[4])*exp(Y[4])*Y[3]*exp(-2*X[4]-2*Y[4])+exp(-X[4]-Y[4])*Y[4]*exp(X[4])*exp(Y[4])*X[3]*exp(-2*X[4]-Y[4])+Y[2]*exp(-2*X[4]-2*Y[4])-Y[4]*Y[3]*exp(-2*X[4]-2*Y[4])+X[2]*exp(Y[4])*exp(-2*X[4]-2*Y[4])-X[4]*X[3]*exp(Y[4])*exp(-2*X[4]-2*Y[4]))/exp(-X[4]-Y[4])/exp(X[4])/exp(Y[4])/exp(-2*X[4]-2*Y[4]), (Y[3]*exp(-2*X[4]-2*Y[4])+X[3]*exp(-2*X[4]-Y[4]))/exp(-2*X[4]-2*Y[4]), X[4]+Y[4]] end;


LG[[4, 9, 0]][representation]:=
[[exp(-2*x4*a), -exp(-2*x4*a)*x3, exp(-2*x4*a)*x2, exp(-2*x4*a)*(2*x1*a-1/2*x2^2-x3*x2*a-1/2*x3^2)], [0, -(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))*a^2/(a^2+1)^2-(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))/(a^2+1)^2, -a^2*exp(-x4*a)*sin(x4)/(a^2+1)-exp(-x4*a)*sin(x4)/(a^2+1), (-(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))*a^2/(a^2+1)^2-(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))/(a^2+1)^2)*(x2*a+x3)+(-a^2*exp(-x4*a)*sin(x4)/(a^2+1)-exp(-x4*a)*sin(x4)/(a^2+1))*(-x2+x3*a)], [0, a^2*exp(-x4*a)*sin(x4)/(a^2+1)+exp(-x4*a)*sin(x4)/(a^2+1), -(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))*a^2/(a^2+1)^2-(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))/(a^2+1)^2, (a^2*exp(-x4*a)*sin(x4)/(a^2+1)+exp(-x4*a)*sin(x4)/(a^2+1))*(x2*a+x3)+(-(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))*a^2/(a^2+1)^2-(-exp(-x4*a)*cos(x4)-a^2*exp(-x4*a)*cos(x4))/(a^2+1)^2)*(-x2+x3*a)], [0, 0, 0, -(-a^2-1)*a^2/(a^2+1)^2-(-a^2-1)/(a^2+1)^2]];

LG[[4, 9, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 9, 0]][G_dot]:=
proc(X,Y) [-1/4*(-X[2]^2*exp(-Y[4]*a)^2*exp(-2*X[4]*a)^2-2*a*X[3]*exp(-Y[4]*a)^2*exp(-2*X[4]*a)^2*X[2]-Y[3]^2*exp(-2*X[4]*a-2*Y[4]*a)^2+2*exp(-2*X[4]*a-2*Y[4]*a)*Y[3]*Y[2]*a*exp(-2*(X[4]+Y[4])*a)+2*exp(-2*X[4]*a)*X[3]*X[2]*a*exp(-2*(X[4]+Y[4])*a)-4*exp(-2*X[4]*a-2*Y[4]*a)*Y[1]*a*exp(-2*(X[4]+Y[4])*a)-4*exp(-2*X[4]*a)*X[1]*a*exp(-2*(X[4]+Y[4])*a)+exp(-2*X[4]*a-2*Y[4]*a)*Y[2]^2*exp(-2*(X[4]+Y[4])*a)+exp(-2*X[4]*a)*X[3]^2*exp(-2*(X[4]+Y[4])*a)+exp(-2*X[4]*a-2*Y[4]*a)*Y[3]^2*exp(-2*(X[4]+Y[4])*a)+exp(-2*X[4]*a)*X[2]^2*exp(-2*(X[4]+Y[4])*a)+2*X[3]*exp(-Y[4]*a)*exp(-2*X[4]*a)*cos(Y[4])*Y[2]*a*exp(-2*(X[4]+Y[4])*a)-X[3]^2*exp(-Y[4]*a)^2*exp(-2*X[4]*a)^2+2*X[3]*exp(-Y[4]*a)*exp(-2*X[4]*a)*sin(Y[4])*Y[2]*exp(-2*(X[4]+Y[4])*a)+4*a*X[2]*exp(-Y[4]*a)^2*sin(Y[4])^2*exp(-2*X[4]*a)^2*X[3]-2*X[3]*exp(-Y[4]*a)*exp(-2*X[4]*a)*sin(Y[4])*Y[3]*a*exp(-2*(X[4]+Y[4])*a)+2*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)*X[2]*exp(-Y[4]*a)*sin(Y[4])*exp(-2*X[4]*a)-2*X[2]*exp(-Y[4]*a)*exp(-2*X[4]*a)*sin(Y[4])*Y[2]*a*exp(-2*(X[4]+Y[4])*a)-2*X[2]*exp(-Y[4]*a)*exp(-2*X[4]*a)*sin(Y[4])*Y[3]*exp(-2*(X[4]+Y[4])*a)+2*a*X[2]^2*exp(-Y[4]*a)^2*sin(Y[4])*exp(-2*X[4]*a)^2*cos(Y[4])-2*a*X[3]^2*exp(-Y[4]*a)^2*cos(Y[4])*exp(-2*X[4]*a)^2*sin(Y[4])-2*a*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)*X[3]*exp(-Y[4]*a)*sin(Y[4])*exp(-2*X[4]*a)-2*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)*X[3]*exp(-Y[4]*a)*sin(Y[4])*exp(-2*X[4]*a)+2*a*X[2]*exp(-Y[4]*a)*sin(Y[4])*exp(-2*X[4]*a)*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)+2*X[2]*exp(-Y[4]*a)*exp(-2*X[4]*a)*cos(Y[4])*Y[2]*exp(-2*(X[4]+Y[4])*a)-2*a*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)*X[2]*exp(-Y[4]*a)*cos(Y[4])*exp(-2*X[4]*a)-2*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)*X[2]*exp(-Y[4]*a)*cos(Y[4])*exp(-2*X[4]*a)-2*a*X[3]*exp(-Y[4]*a)*cos(Y[4])*exp(-2*X[4]*a)*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)-2*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)*X[3]*exp(-Y[4]*a)*cos(Y[4])*exp(-2*X[4]*a)-2*X[2]*exp(-Y[4]*a)*exp(-2*X[4]*a)*cos(Y[4])*Y[3]*a*exp(-2*(X[4]+Y[4])*a)+2*X[3]*exp(-Y[4]*a)*exp(-2*X[4]*a)*cos(Y[4])*Y[3]*exp(-2*(X[4]+Y[4])*a)-Y[2]^2*exp(-2*X[4]*a-2*Y[4]*a)^2-2*a*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)^2*Y[2])/exp(-2*(X[4]+Y[4])*a)^2/a, (Y[2]*exp(-2*X[4]*a-2*Y[4]*a)+X[3]*exp(-Y[4]*a)*sin(Y[4])*exp(-2*X[4]*a)+X[2]*exp(-Y[4]*a)*cos(Y[4])*exp(-2*X[4]*a))/exp(-2*(X[4]+Y[4])*a), -(-Y[3]*exp(-2*X[4]*a-2*Y[4]*a)-X[3]*exp(-Y[4]*a)*cos(Y[4])*exp(-2*X[4]*a)+X[2]*exp(-Y[4]*a)*sin(Y[4])*exp(-2*X[4]*a))/exp(-2*(X[4]+Y[4])*a), X[4]+Y[4]] end;


LG[[4, 10, 0]][representation]:=
[[cos(x3)*exp(-x4), -sin(x3)*exp(-x4), cos(x3)*x1-sin(x3)*x2, cos(x3)*x2+sin(x3)*x1], [sin(x3)*exp(-x4), cos(x3)*exp(-x4), cos(x3)*x2+sin(x3)*x1, sin(x3)*x2-cos(x3)*x1], [0, 0, 1, 0], [0, 0, 0, 1]];

LG[[4, 10, 0]][identity]:=
[0, 0, 0, 0];

LG[[4, 10, 0]][G_dot]:=
proc(X,Y) [(cos(X[3])*X[2]*exp(X[4])*sin(Y[3]+X[3])+sin(X[3])*X[1]*exp(X[4])*sin(Y[3]+X[3])+cos(Y[3]+X[3])*cos(X[3])*X[1]*exp(X[4])-cos(Y[3]+X[3])*sin(X[3])*X[2]*exp(X[4])+Y[1])/exp(X[4]), (Y[2]+cos(Y[3]+X[3])*cos(X[3])*X[2]*exp(X[4])+cos(Y[3]+X[3])*sin(X[3])*X[1]*exp(X[4])-cos(X[3])*X[1]*exp(X[4])*sin(Y[3]+X[3])+sin(X[3])*X[2]*exp(X[4])*sin(Y[3]+X[3]))/exp(X[4]), Y[3]+X[3], X[4]+Y[4]] end;


LG[[5, 1, 0]][representation]:=
[[1, 0, -x3, 0, -x1+x3*x2], [0, 1, 0, -x3, x4], [0, 0, 1, 0, -x2], [0, 0, 0, 1, x5], [0, 0, 0, 0, 1]];

LG[[5, 1, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 1, 0]][G_dot]:=
proc(X,Y) [Y[3]*X[2]+Y[1]+X[1], X[2]+Y[2], Y[3]+X[3], Y[4]-X[3]*Y[5]+X[4], Y[5]+X[5]] end;


LG[[5, 2, 0]][representation]:=
[[1, -x1, 1/2*x1^2, -1/6*x1^3, x2], [0, 1, -x1, 1/2*x1^2, x3], [0, 0, 1, -x1, x4], [0, 0, 0, 1, x5], [0, 0, 0, 0, 1]];

LG[[5, 2, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 2, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], Y[2]-X[1]*Y[3]+1/2*X[1]^2*Y[4]-1/6*X[1]^3*Y[5]+X[2], Y[3]-X[1]*Y[4]+1/2*X[1]^2*Y[5]+X[3], Y[4]-X[1]*Y[5]+X[4], Y[5]+X[5]] end;


LG[[5, 3, 0]][representation]:=
[[1, 0, -x3, x1, 2*x2-x3*x1], [0, 1, -x4, 1/2*x4^2, x5], [0, 0, 1, -x4, x1-x4*x3], [0, 0, 0, 1, x3], [0, 0, 0, 0, 1]];

LG[[5, 3, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 3, 0]][G_dot]:=
proc(X,Y) [Y[1]+X[3]*Y[4]+X[1], X[3]*Y[4]*Y[3]+1/2*X[3]^2*Y[4]+X[1]*Y[3]+Y[2]+X[2], Y[3]+X[3], X[4]+Y[4], Y[5]-X[4]*Y[1]+X[4]*Y[4]*Y[3]+1/2*X[4]^2*Y[3]+X[5]] end;


LG[[5, 4, 0]][representation]:=
[[1, x1, x2, x3], [0, 1, 0, x4], [0, 0, 1, x5], [0, 0, 0, 1]];

LG[[5, 4, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 4, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], X[2]+Y[2], Y[3]+X[1]*Y[4]+X[2]*Y[5]+X[3], X[4]+Y[4], Y[5]+X[5]] end;


LG[[5, 5, 0]][representation]:=
[[1, -2*x4, -2*x3+x4^2, x2+2*x4*x3-1/3*x4^3, 2*x1-2*x3*x2+x4^2*x2], [0, 1, -x4, -x3+1/2*x4^2, x5], [0, 0, 1, -x4, x2], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1]];

LG[[5, 5, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 5, 0]][G_dot]:=
proc(X,Y) [Y[3]*X[2]-X[4]*Y[4]*X[2]-X[4]*Y[4]*Y[2]-1/2*Y[4]^2*X[2]+Y[1]-X[4]*Y[5]+X[1], X[2]+Y[2], Y[3]+X[3], X[4]+Y[4], Y[5]-X[4]*Y[2]+X[5]] end;


LG[[5, 6, 0]][representation]:=
[[1, -2*x4, -x3+x4^2, x2-1/3*x4^3, 2*x1-x3*x2+x4^2*x2-1/3*x4^3*x3], [0, 1, -x4, 1/2*x4^2, x5], [0, 0, 1, -x4, x2-x4*x3], [0, 0, 0, 1, x3], [0, 0, 0, 0, 1]];

LG[[5, 6, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 6, 0]][G_dot]:=
proc(X,Y) [-1/2*Y[4]^2*X[2]-X[4]*Y[4]*X[2]-X[4]*Y[4]*Y[2]+X[1]+Y[1]-X[4]*Y[5]+1/2*X[4]*Y[4]^2*Y[3]+1/2*Y[4]*X[3]^2+Y[3]*X[2]+X[3]*Y[4]*Y[3]-1/2*X[4]*Y[4]^2*X[3]-1/3*Y[4]^3*X[3], Y[2]+Y[4]*X[3]+X[2], Y[3]+X[3], X[4]+Y[4], Y[5]-X[4]*Y[2]+X[4]*Y[4]*Y[3]+1/2*X[4]^2*Y[3]+X[5]] end;


LG[[5, 7, 0]][representation]:=
[[exp(-x4), 0, 0, 0, x5], [0, exp(-x4*a), 0, 0, exp(-x4*a)*x1*a], [0, 0, exp(-x4*b), 0, exp(-x4*b)*x2*b], [0, 0, 0, exp(-x4*c), exp(-x4*c)*x3*c], [0, 0, 0, 0, 1]];

LG[[5, 7, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 7, 0]][G_dot]:=
proc(X,Y) [(Y[1]*exp(-X[4]*a-Y[4]*a)+exp(-X[4]*a)*X[1])/exp(-(X[4]+Y[4])*a), (Y[2]*exp(-X[4]*b-Y[4]*b)+exp(-X[4]*b)*X[2])/exp(-(X[4]+Y[4])*b), (Y[3]*exp(-X[4]*c-Y[4]*c)+exp(-X[4]*c)*X[3])/exp(-(X[4]+Y[4])*c), X[4]+Y[4], (Y[5]+X[5]*exp(X[4]))/exp(X[4])] end;


LG[[5, 8, 0]][representation]:=
[[exp(-x2*a), 0, 0, 0, x3], [0, exp(-x2), 0, 0, x4], [0, 0, 1, -x1, x5], [0, 0, 0, 1, -x2], [0, 0, 0, 0, 1]];

LG[[5, 8, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 8, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], X[2]+Y[2], exp(-X[2]*a)*Y[3]+X[3], (Y[4]+X[4]*exp(X[2]))/exp(X[2]), Y[5]+X[1]*Y[2]+X[5]] end;


LG[[5, 9, 0]][representation]:=
[[exp(-x1*b), 0, 0, 0, x2], [0, exp(-x1*a), 0, 0, x3], [0, 0, exp(-x1), -x1*exp(-x1), x4], [0, 0, 0, exp(-x1), x5], [0, 0, 0, 0, 1]];

LG[[5, 9, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 9, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], exp(-X[1]*b)*Y[2]+X[2], exp(-X[1]*a)*Y[3]+X[3], (Y[4]-X[1]*Y[5]+X[4]*exp(X[1]))/exp(X[1]), (Y[5]+X[5]*exp(X[1]))/exp(X[1])] end;


LG[[5, 10, 0]][representation]:=
[[exp(-x1), -x1*exp(-x1), 0, 0, x2], [0, exp(-x1), 0, 0, x3], [0, 0, exp(-x1*a), -x1*exp(-x1*a), x4], [0, 0, 0, exp(-x1*a), x5], [0, 0, 0, 0, 1]];

LG[[5, 10, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 10, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], -(-Y[2]+X[1]*Y[3]-X[2]*exp(X[1]))/exp(X[1]), (Y[3]+X[3]*exp(X[1]))/exp(X[1]), exp(-X[1]*a)*Y[4]-X[1]*exp(-X[1]*a)*Y[5]+X[4], exp(-X[1]*a)*Y[5]+X[5]] end;


LG[[5, 11, 0]][representation]:=
[[exp(-x1), 0, 0, 0, x2], [0, 1, -x1, 1/2*x1^2, x3], [0, 0, 1, -x1, x4], [0, 0, 0, 1, x5], [0, 0, 0, 0, 1]];

LG[[5, 11, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 11, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], (Y[2]+X[2]*exp(X[1]))/exp(X[1]), Y[3]-X[1]*Y[4]+1/2*X[1]^2*Y[5]+X[3], Y[4]-X[1]*Y[5]+X[4], Y[5]+X[5]] end;


LG[[5, 12, 0]][representation]:=
[[exp(-x1*a), 0, 0, 0, x2], [0, exp(-x1), -x1*exp(-x1), 1/2*x1^2*exp(-x1), x3], [0, 0, exp(-x1), -x1*exp(-x1), x4], [0, 0, 0, exp(-x1), x5], [0, 0, 0, 0, 1]];

LG[[5, 12, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 12, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], exp(-X[1]*a)*Y[2]+X[2], 1/2*(2*Y[3]-2*X[1]*Y[4]+X[1]^2*Y[5]+2*X[3]*exp(X[1]))/exp(X[1]), -(-Y[4]+X[1]*Y[5]-X[4]*exp(X[1]))/exp(X[1]), (Y[5]+X[5]*exp(X[1]))/exp(X[1])] end;


LG[[5, 13, 0]][representation]:=
[[exp(-x1), -x1*exp(-x1), 1/2*x1^2*exp(-x1), -1/6*x1^3*exp(-x1), x2], [0, exp(-x1), -x1*exp(-x1), 1/2*x1^2*exp(-x1), x3], [0, 0, exp(-x1), -x1*exp(-x1), x4], [0, 0, 0, exp(-x1), x5], [0, 0, 0, 0, 1]];

LG[[5, 13, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 13, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], -1/6*(-6*Y[2]+6*X[1]*Y[3]-3*X[1]^2*Y[4]+X[1]^3*Y[5]-6*X[2]*exp(X[1]))/exp(X[1]), 1/2*(2*Y[3]-2*X[1]*Y[4]+X[1]^2*Y[5]+2*X[3]*exp(X[1]))/exp(X[1]), -(-Y[4]+X[1]*Y[5]-X[4]*exp(X[1]))/exp(X[1]), (Y[5]+X[5]*exp(X[1]))/exp(X[1])] end;


LG[[5, 14, 0]][representation]:=
[[exp(-x1), 0, 0, 0, x2], [0, exp(-x1*a), 0, 0, x3], [0, 0, exp(-x1*b)*cos(x1*c), -exp(-x1*b)*sin(x1*c), x4], [0, 0, exp(-x1*b)*sin(x1*c), exp(-x1*b)*cos(x1*c), x5], [0, 0, 0, 0, 1]];

LG[[5, 14, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 14, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], (Y[2]+X[2]*exp(X[1]))/exp(X[1]), exp(-X[1]*a)*Y[3]+X[3], exp(-X[1]*b)*cos(X[1]*c)*Y[4]-exp(-X[1]*b)*sin(X[1]*c)*Y[5]+X[4], exp(-X[1]*b)*sin(X[1]*c)*Y[4]+exp(-X[1]*b)*cos(X[1]*c)*Y[5]+X[5]] end;


LG[[5, 15, 0]][representation]:=
[[1, x3, 0, 0, -x3*x2-x1], [0, 1, 0, 0, -x2], [0, 0, exp(-x2*a)*cos(x2), -exp(-x2*a)*sin(x2), x4], [0, 0, exp(-x2*a)*sin(x2), exp(-x2*a)*cos(x2), x5], [0, 0, 0, 0, 1]];

LG[[5, 15, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 15, 0]][G_dot]:=
proc(X,Y) [-Y[3]*X[2]+Y[1]+X[1], X[2]+Y[2], Y[3]+X[3], exp(-X[2]*a)*cos(X[2])*Y[4]-exp(-X[2]*a)*sin(X[2])*Y[5]+X[4], exp(-X[2]*a)*sin(X[2])*Y[4]+exp(-X[2]*a)*cos(X[2])*Y[5]+X[5]] end;


LG[[5, 16, 0]][representation]:=
[[exp(-x1), -x1*exp(-x1), 0, 0, x2], [0, exp(-x1), 0, 0, x3], [0, 0, exp(-x1*a)*cos(x1*b), -exp(-x1*a)*sin(x1*b), x4], [0, 0, exp(-x1*a)*sin(x1*b), exp(-x1*a)*cos(x1*b), x5], [0, 0, 0, 0, 1]];

LG[[5, 16, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 16, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], -(-Y[2]+X[1]*Y[3]-X[2]*exp(X[1]))/exp(X[1]), (Y[3]+X[3]*exp(X[1]))/exp(X[1]), exp(-X[1]*a)*cos(X[1]*b)*Y[4]-exp(-X[1]*a)*sin(X[1]*b)*Y[5]+X[4], exp(-X[1]*a)*sin(X[1]*b)*Y[4]+exp(-X[1]*a)*cos(X[1]*b)*Y[5]+X[5]] end;


LG[[5, 17, 0]][representation]:=
[[exp(-x1*a)*cos(x1), -exp(-x1*a)*sin(x1), 0, 0, x2], [exp(-x1*a)*sin(x1), exp(-x1*a)*cos(x1), 0, 0, x3], [0, 0, exp(-x1*b)*cos(x1*c), -exp(-x1*b)*sin(x1*c), x4], [0, 0, exp(-x1*b)*sin(x1*c), exp(-x1*b)*cos(x1*c), x5], [0, 0, 0, 0, 1]];

LG[[5, 17, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 17, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], exp(-X[1]*a)*cos(X[1])*Y[2]-exp(-X[1]*a)*sin(X[1])*Y[3]+X[2], exp(-X[1]*a)*sin(X[1])*Y[2]+exp(-X[1]*a)*cos(X[1])*Y[3]+X[3], exp(-X[1]*b)*cos(X[1]*c)*Y[4]-exp(-X[1]*b)*sin(X[1]*c)*Y[5]+X[4], exp(-X[1]*b)*sin(X[1]*c)*Y[4]+exp(-X[1]*b)*cos(X[1]*c)*Y[5]+X[5]] end;


LG[[5, 18, 0]][representation]:=
[[exp(-x1*a)*cos(x1), -exp(-x1*a)*sin(x1), -x1*exp(-x1*a)*cos(x1), x1*exp(-x1*a)*sin(x1), x2], [exp(-x1*a)*sin(x1), exp(-x1*a)*cos(x1), -x1*exp(-x1*a)*sin(x1), -x1*exp(-x1*a)*cos(x1), x3], [0, 0, exp(-x1*a)*cos(x1), -exp(-x1*a)*sin(x1), x4], [0, 0, exp(-x1*a)*sin(x1), exp(-x1*a)*cos(x1), x5], [0, 0, 0, 0, 1]];

LG[[5, 18, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 18, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], exp(-X[1]*a)*cos(X[1])*Y[2]-exp(-X[1]*a)*sin(X[1])*Y[3]-X[1]*exp(-X[1]*a)*cos(X[1])*Y[4]+X[1]*exp(-X[1]*a)*sin(X[1])*Y[5]+X[2], exp(-X[1]*a)*sin(X[1])*Y[2]+exp(-X[1]*a)*cos(X[1])*Y[3]-X[1]*exp(-X[1]*a)*sin(X[1])*Y[4]-X[1]*exp(-X[1]*a)*cos(X[1])*Y[5]+X[3], exp(-X[1]*a)*cos(X[1])*Y[4]-exp(-X[1]*a)*sin(X[1])*Y[5]+X[4], exp(-X[1]*a)*sin(X[1])*Y[4]+exp(-X[1]*a)*cos(X[1])*Y[5]+X[5]] end;


LG[[5, 19, 0]][representation]:=
[[exp(-x4*b), 0, 0, 0, x5], [0, exp(-x4*(a+1)), -exp(-x4*(a+1))*x3, exp(-x4*(a+1))*x2, exp(-x4*(a+1))*(x1*a+x1-x3*x2)], [0, 0, exp(-x4), 0, exp(-x4)*x2], [0, 0, 0, exp(-x4*a), exp(-x4*a)*x3*a], [0, 0, 0, 0, 1]];

LG[[5, 19, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 19, 0]][G_dot]:=
proc(X,Y) [(exp(X[4]+Y[4])*Y[3]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)*Y[2]*exp(-X[4]-Y[4])*exp(X[4])+exp(X[4]+Y[4])*Y[3]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)*X[2]+exp(X[4]+Y[4])*X[3]*exp(-X[4]-X[4]*a-Y[4])*Y[2]*exp(-X[4]-Y[4])*exp(X[4])+exp(X[4]+Y[4])*X[3]*exp(-X[4]-X[4]*a-Y[4])*X[2]+exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)*Y[1]*exp(X[4])+exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)*Y[1]*a*exp(X[4])-exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)*Y[3]*Y[2]*exp(X[4])-X[3]*Y[2]*exp(-X[4]-X[4]*a-Y[4])*exp(X[4])+X[2]*Y[3]*a*exp(-X[4]-X[4]*a-Y[4]*a)*exp(X[4])+exp(-X[4]*(a+1))*X[1]*exp(X[4])+exp(-X[4]*(a+1))*X[1]*a*exp(X[4])-exp(-X[4]*(a+1))*X[3]*X[2]*exp(X[4]))/exp(-(a+1)*(X[4]+Y[4]))/exp(X[4])/(a+1), exp(X[4]+Y[4])*(Y[2]*exp(-X[4]-Y[4])*exp(X[4])+X[2])/exp(X[4]), (Y[3]*exp(-X[4]-X[4]*a-Y[4]-Y[4]*a)+X[3]*exp(-X[4]-X[4]*a-Y[4]))/exp(-(a+1)*(X[4]+Y[4])), X[4]+Y[4], exp(-X[4]*b)*Y[5]+X[5]] end;


LG[[5, 20, 0]][representation]:=
[[exp(-x5-x5*a), exp(-x5-x5*a)*x3, exp(-x5-x5*a)*x2, -x5*exp(-x5-x5*a), exp(-x5-x5*a)*(-x1-x1*a+x3*x2)-x5*exp(-x5-x5*a)*(-x4-x4*a)], [0, exp(-x5), 0, 0, exp(-x5)*x2], [0, 0, exp(-x5*a), 0, -exp(-x5*a)*x3*a], [0, 0, 0, exp(-x5-x5*a), exp(-x5-x5*a)*(-x4-x4*a)], [0, 0, 0, 0, 1]];

LG[[5, 20, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 20, 0]][G_dot]:=
proc(X,Y) [(exp(-X[5]-X[5]*a)*exp(-Y[5]-Y[5]*a)*Y[1]*a*exp(-(X[5]+Y[5])*a)+Y[5]*exp(-(X[5]+Y[5])*a)*exp(-X[5]-X[5]*a)*X[4]*a-exp(-X[5]-X[5]*a)*Y[5]*exp(-Y[5]-Y[5]*a)*Y[4]*a*exp(-(X[5]+Y[5])*a)+exp(-X[5]-X[5]*a)*X[1]*a*exp(-(X[5]+Y[5])*a)+Y[5]*exp(-(X[5]+Y[5])*a)*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)*Y[4]*a+X[2]*Y[3]*a*exp(-X[5]-X[5]*a-Y[5]*a)*exp(-(X[5]+Y[5])*a)-exp(-X[5]-X[5]*a)*exp(-Y[5]-Y[5]*a)*Y[3]*Y[2]*exp(-(X[5]+Y[5])*a)-exp(-X[5]-X[5]*a)*Y[5]*exp(-Y[5]-Y[5]*a)*Y[4]*exp(-(X[5]+Y[5])*a)+Y[3]*exp(-X[5]*a-Y[5]*a)*Y[2]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+Y[3]*exp(-X[5]*a-Y[5]*a)*X[2]*exp(-X[5]-X[5]*a-Y[5]*a)+Y[5]*exp(-(X[5]+Y[5])*a)*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)*Y[4]+exp(-X[5]-X[5]*a)*X[1]*exp(-(X[5]+Y[5])*a)+exp(-X[5]-X[5]*a)*exp(-Y[5]-Y[5]*a)*Y[1]*exp(-(X[5]+Y[5])*a)-exp(-X[5]-X[5]*a)*X[3]*X[2]*exp(-(X[5]+Y[5])*a)+exp(-X[5]*a)*X[3]*Y[2]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+exp(-X[5]*a)*X[3]*X[2]*exp(-X[5]-X[5]*a-Y[5]*a)+Y[5]*exp(-(X[5]+Y[5])*a)*exp(-X[5]-X[5]*a)*X[4]-X[3]*Y[2]*exp(-X[5]-X[5]*a-Y[5])*exp(-(X[5]+Y[5])*a))/exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)/exp(-(X[5]+Y[5])*a)/(a+1), (Y[2]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+X[2]*exp(-X[5]-X[5]*a-Y[5]*a))/exp(-X[5]-X[5]*a-Y[5]-Y[5]*a), (Y[3]*exp(-X[5]*a-Y[5]*a)+exp(-X[5]*a)*X[3])/exp(-(X[5]+Y[5])*a), (exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)*Y[4]+exp(-X[5]-X[5]*a)*X[4])/exp(-X[5]-X[5]*a-Y[5]-Y[5]*a), X[5]+Y[5]] end;


LG[[5, 21, 0]][representation]:=
[[exp(-2*x4), 0, exp(-2*x4)*x2, -exp(-2*x4)*x3, 1/2*exp(-2*x4)*(4*x1+x2^2-2*x3*x2)], [0, exp(-x4), -x4*exp(-x4), 1/2*x4^2*exp(-x4), x5], [0, 0, exp(-x4), -x4*exp(-x4), exp(-x4)*x2+exp(-x4)*x3-x4*exp(-x4)*x2], [0, 0, 0, exp(-x4), exp(-x4)*x2], [0, 0, 0, 0, 1]];

LG[[5, 21, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 21, 0]][G_dot]:=
proc(X,Y) [1/4*(-2*exp(Y[4])*Y[2]*exp(-2*X[4]-2*Y[4])*X[2]*exp(-2*X[4]-Y[4])-exp(Y[4])*X[2]^2*exp(-2*X[4]-Y[4])^2+2*exp(-2*X[4]-2*Y[4])*exp(Y[4])*Y[2]*X[2]*Y[4]*exp(-2*X[4]-Y[4])+2*exp(Y[4])*X[2]*exp(-2*X[4]-Y[4])*Y[3]*exp(-2*X[4]-2*Y[4])+2*exp(Y[4])*X[2]^2*exp(-2*X[4]-Y[4])^2*Y[4]+2*exp(Y[4])*X[2]*exp(-2*X[4]-Y[4])^2*X[3]+4*exp(-2*X[4]-2*Y[4])^2*Y[1]*exp(Y[4])+2*exp(-2*X[4])*X[2]*Y[2]*exp(-2*X[4]-2*Y[4])+2*exp(-2*X[4])*X[2]*Y[3]*exp(-2*X[4]-2*Y[4])-2*exp(-2*X[4])*X[2]*Y[4]*Y[2]*exp(-2*X[4]-2*Y[4])+4*exp(-2*X[4])*X[1]*exp(Y[4])*exp(-2*X[4]-2*Y[4])+exp(-2*X[4])*X[2]^2*exp(Y[4])*exp(-2*X[4]-2*Y[4])-2*exp(-2*X[4])*X[3]*X[2]*exp(Y[4])*exp(-2*X[4]-2*Y[4]))/exp(-2*X[4]-2*Y[4])^2/exp(Y[4]), (Y[2]*exp(-2*X[4]-2*Y[4])+X[2]*exp(-2*X[4]-Y[4]))/exp(-2*X[4]-2*Y[4]), (Y[3]*exp(-2*X[4]-2*Y[4])+X[2]*Y[4]*exp(-2*X[4]-Y[4])+X[3]*exp(-2*X[4]-Y[4]))/exp(-2*X[4]-2*Y[4]), X[4]+Y[4], 1/2*(2*Y[5]*exp(Y[4])-2*X[4]*Y[2]-2*X[4]*Y[3]+2*X[4]*Y[4]*Y[2]+X[4]^2*Y[2]*exp(-X[4]-Y[4])*exp(X[4])*exp(Y[4])+2*X[5]*exp(X[4])*exp(Y[4]))/exp(X[4])/exp(Y[4])] end;


LG[[5, 22, 0]][representation]:=
[[exp(-x4), 0, 0, 0, 2*exp(-x4)*x3], [0, 1, -x2, 1/2*x2^2, -x1], [0, 0, 1, -x2, x5], [0, 0, 0, 1, -x4], [0, 0, 0, 0, 1]];

LG[[5, 22, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 22, 0]][G_dot]:=
proc(X,Y) [Y[1]+X[2]*Y[5]+1/2*X[2]^2*Y[4]+X[1], X[2]+Y[2], exp(X[4]+Y[4])*(Y[3]*exp(-X[4]-Y[4])*exp(X[4])+X[3])/exp(X[4]), X[4]+Y[4], Y[5]+X[2]*Y[4]+X[5]] end;


LG[[5, 23, 0]][representation]:=
[[exp(-x5*a), 0, 0, 0, 2*exp(-x5*a)*x4], [0, exp(-2*x5), exp(-2*x5)*x2, -exp(-2*x5)*x3, exp(-2*x5)*(-2*x1+x3*x2)], [0, 0, exp(-x5), -x5*exp(-x5), -exp(-x5)*x3+x5*exp(-x5)*x2], [0, 0, 0, exp(-x5), -exp(-x5)*x2], [0, 0, 0, 0, 1]];

LG[[5, 23, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 23, 0]][G_dot]:=
proc(X,Y) [1/2*(exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])*X[2]*exp(-2*X[5]-Y[5])+exp(Y[5])*X[2]*Y[5]*exp(-2*X[5]-Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])+exp(Y[5])*X[2]^2*Y[5]*exp(-2*X[5]-Y[5])^2+exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])^2*X[2]+2*exp(-2*X[5]-2*Y[5])^2*Y[1]*exp(Y[5])+exp(-2*X[5])*X[2]*Y[3]*exp(-2*X[5]-2*Y[5])-exp(-2*X[5])*X[2]*Y[5]*Y[2]*exp(-2*X[5]-2*Y[5])+2*exp(-2*X[5])*X[1]*exp(Y[5])*exp(-2*X[5]-2*Y[5])-exp(-2*X[5])*X[3]*X[2]*exp(Y[5])*exp(-2*X[5]-2*Y[5]))/exp(-2*X[5]-2*Y[5])^2/exp(Y[5]), (Y[2]*exp(-2*X[5]-2*Y[5])+X[2]*exp(-2*X[5]-Y[5]))/exp(-2*X[5]-2*Y[5]), (Y[3]*exp(-2*X[5]-2*Y[5])+X[2]*Y[5]*exp(-2*X[5]-Y[5])+X[3]*exp(-2*X[5]-Y[5]))/exp(-2*X[5]-2*Y[5]), (Y[4]*exp(-X[5]*a-Y[5]*a)+exp(-X[5]*a)*X[4])/exp(-(X[5]+Y[5])*a), X[5]+Y[5]] end;


LG[[5, 24, 0]][representation]:=
[[exp(-2*x5), -exp(-2*x5)*x2, exp(-2*x5)*x3, -x5*epsilon*exp(-2*x5), exp(-2*x5)*(2*x1-x3*x2)-2*x5*epsilon*exp(-2*x5)*x4], [0, exp(-x5), -x5*exp(-x5), 0, -exp(-x5)*x3+x5*exp(-x5)*x2], [0, 0, exp(-x5), 0, -exp(-x5)*x2], [0, 0, 0, exp(-2*x5), 2*exp(-2*x5)*x4], [0, 0, 0, 0, 1]];

LG[[5, 24, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 24, 0]][G_dot]:=
proc(X,Y) [1/2*(exp(Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2*Y[3]+exp(Y[5])*X[2]*Y[5]*exp(-2*X[5]-Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])+exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])*X[2]*exp(-2*X[5]-Y[5])+exp(Y[5])*X[2]^2*Y[5]*exp(-2*X[5]-Y[5])^2+exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])^2*X[2]+2*epsilon*Y[5]*exp(Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2+2*epsilon*Y[5]*exp(Y[5])*exp(-2*X[5])*X[4]*exp(-2*X[5]-2*Y[5])+2*exp(-2*X[5])*exp(-2*Y[5])*Y[1]*exp(Y[5])*exp(-2*X[5]-2*Y[5])-exp(-2*X[5])*exp(-2*Y[5])*Y[3]*Y[2]*exp(Y[5])*exp(-2*X[5]-2*Y[5])-2*exp(-2*X[5])*Y[5]*epsilon*exp(-2*Y[5])*Y[4]*exp(Y[5])*exp(-2*X[5]-2*Y[5])+exp(-2*X[5])*X[2]*Y[3]*exp(-2*X[5]-2*Y[5])-exp(-2*X[5])*X[2]*Y[5]*Y[2]*exp(-2*X[5]-2*Y[5])+2*exp(-2*X[5])*X[1]*exp(Y[5])*exp(-2*X[5]-2*Y[5])-exp(-2*X[5])*X[3]*X[2]*exp(Y[5])*exp(-2*X[5]-2*Y[5]))/exp(-2*X[5]-2*Y[5])^2/exp(Y[5]), (Y[2]*exp(-2*X[5]-2*Y[5])+X[2]*exp(-2*X[5]-Y[5]))/exp(-2*X[5]-2*Y[5]), (Y[3]*exp(-2*X[5]-2*Y[5])+X[2]*Y[5]*exp(-2*X[5]-Y[5])+X[3]*exp(-2*X[5]-Y[5]))/exp(-2*X[5]-2*Y[5]), (Y[4]*exp(-2*X[5]-2*Y[5])+exp(-2*X[5])*X[4])/exp(-2*X[5]-2*Y[5]), X[5]+Y[5]] end;


LG[[5, 25, 0]][representation]:=
[[exp(-x4*b), 0, 0, 0, x5], [0, exp(-2*x4*a), -exp(-2*x4*a)*x3, -exp(-2*x4*a)*x2, -1/2*exp(-2*x4*a)*(4*x1*a+x2^2-2*x3*x2*a+x3^2)], [0, 0, exp(-x4*a)*cos(x4), -exp(-x4*a)*sin(x4), -exp(-x4*a)*cos(x4)*x2*a+exp(-x4*a)*cos(x4)*x3-exp(-x4*a)*sin(x4)*x2-exp(-x4*a)*sin(x4)*x3*a], [0, 0, exp(-x4*a)*sin(x4), exp(-x4*a)*cos(x4), -exp(-x4*a)*sin(x4)*x2*a+exp(-x4*a)*sin(x4)*x3+exp(-x4*a)*cos(x4)*x2+exp(-x4*a)*cos(x4)*x3*a], [0, 0, 0, 0, 1]];

LG[[5, 25, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 25, 0]][G_dot]:=
proc(X,Y) [1/4*(-Y[2]^2*exp(-2*X[4]*a-2*Y[4]*a)^2+exp(-2*X[4]*a-2*Y[4]*a)*Y[2]^2*exp(-2*(X[4]+Y[4])*a)-2*exp(-2*X[4]*a-2*Y[4]*a)*Y[3]*Y[2]*a*exp(-2*(X[4]+Y[4])*a)+4*exp(-2*X[4]*a)*X[1]*a*exp(-2*(X[4]+Y[4])*a)-2*exp(-2*X[4]*a)*X[3]*X[2]*a*exp(-2*(X[4]+Y[4])*a)+exp(-2*X[4]*a-2*Y[4]*a)*Y[3]^2*exp(-2*(X[4]+Y[4])*a)+exp(-2*X[4]*a)*X[3]^2*exp(-2*(X[4]+Y[4])*a)+4*exp(-2*X[4]*a-2*Y[4]*a)*Y[1]*a*exp(-2*(X[4]+Y[4])*a)+exp(-2*X[4]*a)*X[2]^2*exp(-2*(X[4]+Y[4])*a)-X[2]^2*exp(-Y[4]*a-2*X[4]*a)^2-Y[3]^2*exp(-2*X[4]*a-2*Y[4]*a)^2+2*a*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)^2*Y[3]-X[3]^2*exp(-Y[4]*a-2*X[4]*a)^2+2*a*X[2]*exp(-Y[4]*a-2*X[4]*a)^2*X[3]-2*exp(-2*X[4]*a)*X[3]*exp(-Y[4]*a)*sin(Y[4])*Y[2]*exp(-2*(X[4]+Y[4])*a)-2*exp(-2*X[4]*a)*X[3]*exp(-Y[4]*a)*sin(Y[4])*Y[3]*a*exp(-2*(X[4]+Y[4])*a)-2*exp(-2*X[4]*a)*X[2]*exp(-Y[4]*a)*sin(Y[4])*Y[2]*a*exp(-2*(X[4]+Y[4])*a)+2*exp(-2*X[4]*a)*X[2]*exp(-Y[4]*a)*sin(Y[4])*Y[3]*exp(-2*(X[4]+Y[4])*a)+2*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)*X[3]*sin(Y[4])*exp(-Y[4]*a-2*X[4]*a)-4*a*X[3]*sin(Y[4])^2*exp(-Y[4]*a-2*X[4]*a)^2*X[2]-2*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)*X[2]*sin(Y[4])*exp(-Y[4]*a-2*X[4]*a)+2*a*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)*X[2]*sin(Y[4])*exp(-Y[4]*a-2*X[4]*a)-2*a*X[3]*sin(Y[4])*exp(-Y[4]*a-2*X[4]*a)*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)-2*a*X[3]^2*sin(Y[4])*exp(-Y[4]*a-2*X[4]*a)^2*cos(Y[4])+2*a*X[2]^2*cos(Y[4])*exp(-Y[4]*a-2*X[4]*a)^2*sin(Y[4])+2*exp(-2*X[4]*a)*X[2]*exp(-Y[4]*a)*cos(Y[4])*Y[2]*exp(-2*(X[4]+Y[4])*a)+2*exp(-2*X[4]*a)*X[2]*exp(-Y[4]*a)*cos(Y[4])*Y[3]*a*exp(-2*(X[4]+Y[4])*a)-2*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)*X[2]*cos(Y[4])*exp(-Y[4]*a-2*X[4]*a)+2*a*X[2]*cos(Y[4])*exp(-Y[4]*a-2*X[4]*a)*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)-2*Y[3]*exp(-2*X[4]*a-2*Y[4]*a)*X[3]*cos(Y[4])*exp(-Y[4]*a-2*X[4]*a)+2*a*Y[2]*exp(-2*X[4]*a-2*Y[4]*a)*X[3]*cos(Y[4])*exp(-Y[4]*a-2*X[4]*a)+2*exp(-2*X[4]*a)*X[3]*exp(-Y[4]*a)*cos(Y[4])*Y[3]*exp(-2*(X[4]+Y[4])*a)-2*exp(-2*X[4]*a)*X[3]*exp(-Y[4]*a)*cos(Y[4])*Y[2]*a*exp(-2*(X[4]+Y[4])*a))/exp(-2*(X[4]+Y[4])*a)^2/a, (Y[2]*exp(-2*X[4]*a-2*Y[4]*a)-X[3]*sin(Y[4])*exp(-Y[4]*a-2*X[4]*a)+X[2]*cos(Y[4])*exp(-Y[4]*a-2*X[4]*a))/exp(-2*(X[4]+Y[4])*a), (Y[3]*exp(-2*X[4]*a-2*Y[4]*a)+X[3]*cos(Y[4])*exp(-Y[4]*a-2*X[4]*a)+X[2]*sin(Y[4])*exp(-Y[4]*a-2*X[4]*a))/exp(-2*(X[4]+Y[4])*a), X[4]+Y[4], exp(-X[4]*b)*Y[5]+X[5]] end;


LG[[5, 26, 0]][representation]:=
[[exp(-2*x5*a), exp(-2*x5*a)*x3, -exp(-2*x5*a)*x2, 1/2*x5*epsilon*exp(-2*x5*a), exp(-2*x5*a)*(2*x1*a+1/2*x2^2-x3*x2*a+1/2*x3^2)-2*x5*epsilon*exp(-2*x5*a)*x4*a], [0, (2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*a^2/((a^2-1)^2+4*a^2)^2, (2*exp(-x5*a)*sin(x5)*a^2+exp(-x5*a)*sin(x5)+a^4*exp(-x5*a)*sin(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(2*exp(-x5*a)*sin(x5)*a^2+exp(-x5*a)*sin(x5)+a^4*exp(-x5*a)*sin(x5))*a^2/((a^2-1)^2+4*a^2)^2, 0, ((2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*a^2/((a^2-1)^2+4*a^2)^2)*(-x2*a+x3)+((2*exp(-x5*a)*sin(x5)*a^2+exp(-x5*a)*sin(x5)+a^4*exp(-x5*a)*sin(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(2*exp(-x5*a)*sin(x5)*a^2+exp(-x5*a)*sin(x5)+a^4*exp(-x5*a)*sin(x5))*a^2/((a^2-1)^2+4*a^2)^2)*(-x2-x3*a)], [0, (-2*exp(-x5*a)*sin(x5)*a^2-exp(-x5*a)*sin(x5)-a^4*exp(-x5*a)*sin(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(-2*exp(-x5*a)*sin(x5)*a^2-exp(-x5*a)*sin(x5)-a^4*exp(-x5*a)*sin(x5))*a^2/((a^2-1)^2+4*a^2)^2, (2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*a^2/((a^2-1)^2+4*a^2)^2, 0, ((-2*exp(-x5*a)*sin(x5)*a^2-exp(-x5*a)*sin(x5)-a^4*exp(-x5*a)*sin(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(-2*exp(-x5*a)*sin(x5)*a^2-exp(-x5*a)*sin(x5)-a^4*exp(-x5*a)*sin(x5))*a^2/((a^2-1)^2+4*a^2)^2)*(-x2*a+x3)+((2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(2*exp(-x5*a)*cos(x5)*a^2+a^4*exp(-x5*a)*cos(x5)+exp(-x5*a)*cos(x5))*a^2/((a^2-1)^2+4*a^2)^2)*(-x2-x3*a)], [0, 0, 0, exp(-2*x5*a), -4*exp(-2*x5*a)*x4*a], [0, 0, 0, 0, (2*a^2+a^4+1)*(a^2-1)^2/((a^2-1)^2+4*a^2)^2+4*(2*a^2+a^4+1)*a^2/((a^2-1)^2+4*a^2)^2]];

LG[[5, 26, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 26, 0]][G_dot]:=
proc(X,Y) [1/2*(-8*epsilon*a*Y[5]*X[4]*sin(X[5])*sin(Y[5])^2*cos(X[5])*exp(Y[5]*a)^2+2*Y[1]*sin(Y[5])^2+4*a^2*X[2]*sin(Y[5])^3*sin(X[5])*X[3]*cos(X[5])*cos(Y[5])*exp(Y[5]*a)^2-X[3]^2*sin(Y[5])^3*cos(Y[5])*exp(Y[5]*a)^2+4*epsilon*Y[5]*X[4]*cos(X[5])*cos(Y[5])*sin(X[5])*sin(Y[5])*exp(Y[5]*a)^2-4*Y[1]*sin(Y[5])^2*sin(X[5])^2-8*a*sin(X[5])*cos(Y[5])*Y[3]*cos(X[5])*sin(Y[5])^2*X[2]*exp(Y[5]*a)-8*epsilon*a*Y[5]*X[4]*sin(X[5])^2*cos(Y[5])*sin(Y[5])*exp(Y[5]*a)^2-4*epsilon*a^2*Y[5]*X[4]*cos(X[5])*cos(Y[5])*sin(X[5])*sin(Y[5])*exp(Y[5]*a)^2+4*a^2*X[3]*cos(Y[5])*cos(X[5])*sin(Y[5])^2*Y[3]*sin(X[5])*exp(Y[5]*a)-2*Y[1]*a^2*sin(Y[5])^2+2*a*sin(Y[5])^4*X[3]^2*exp(Y[5]*a)^2-2*X[3]*sin(Y[5])^3*Y[3]*exp(Y[5]*a)-2*X[3]*sin(Y[5])^4*X[2]*exp(Y[5]*a)^2+2*X[2]^2*a*sin(Y[5])^2*exp(Y[5]*a)^2-2*a*X[2]^2*sin(Y[5])^4*exp(Y[5]*a)^2-2*X[3]^2*a*sin(Y[5])^2*exp(Y[5]*a)^2-2*X[1]*a^2*sin(Y[5])^2*exp(Y[5]*a)^2-4*X[1]*sin(Y[5])^2*sin(X[5])^2*exp(Y[5]*a)^2+4*Y[1]*a^2*sin(X[5])^2*sin(Y[5])^2+4*Y[1]*a*cos(Y[5])*sin(Y[5])+cos(Y[5])*X[2]^2*sin(Y[5])^3*exp(Y[5]*a)^2+2*X[1]*sin(Y[5])^2*exp(Y[5]*a)^2+4*epsilon*a*Y[5]*X[4]*sin(X[5])*cos(X[5])*exp(Y[5]*a)^2-2*Y[1]*a^2*sin(X[5])^2+4*X[1]*a*sin(X[5])*cos(X[5])*exp(Y[5]*a)^2+4*Y[1]*a*sin(X[5])*cos(X[5])+2*X[1]*sin(X[5])^2*exp(Y[5]*a)^2+2*epsilon*Y[5]*X[4]*sin(X[5])^2*exp(Y[5]*a)^2-2*epsilon*a^2*Y[5]*X[4]*sin(X[5])^2*exp(Y[5]*a)^2-2*X[1]*a^2*sin(X[5])^2*exp(Y[5]*a)^2+4*cos(X[5])*X[2]*a*sin(X[5])*cos(Y[5])*Y[3]*exp(Y[5]*a)+2*Y[1]*sin(X[5])^2+2*Y[3]*sin(X[5])^2*cos(Y[5])*X[2]*exp(Y[5]*a)+2*a^2*Y[3]*X[2]*cos(Y[5])*exp(Y[5]*a)+2*cos(X[5])*X[2]^2*sin(X[5])*sin(Y[5])^2*exp(Y[5]*a)^2-2*cos(X[5])*X[3]^2*sin(Y[5])^2*sin(X[5])*exp(Y[5]*a)^2-2*sin(X[5])*sin(Y[5])^4*X[2]^2*cos(X[5])*exp(Y[5]*a)^2-8*Y[1]*a*sin(X[5])*sin(Y[5])^2*cos(X[5])+8*a*sin(X[5])*X[3]*sin(Y[5])^4*cos(X[5])*X[2]*exp(Y[5]*a)^2-4*a*sin(X[5])^2*X[3]^2*sin(Y[5])^4*exp(Y[5]*a)^2+4*a*sin(X[5])^2*X[3]^2*sin(Y[5])^2*exp(Y[5]*a)^2-2*sin(X[5])^2*X[3]*sin(Y[5])*Y[3]*exp(Y[5]*a)+4*a*X[2]^2*sin(Y[5])^4*sin(X[5])^2*exp(Y[5]*a)^2+4*sin(X[5])^2*X[3]*sin(Y[5])^3*Y[3]*exp(Y[5]*a)-2*sin(X[5])^2*X[3]*sin(Y[5])^2*X[2]*exp(Y[5]*a)^2-4*X[2]^2*a*sin(X[5])^2*sin(Y[5])^2*exp(Y[5]*a)^2+4*X[2]*a*Y[3]*sin(Y[5])*exp(Y[5]*a)-a^2*X[2]^2*sin(Y[5])^3*cos(Y[5])*exp(Y[5]*a)^2+2*cos(Y[5])*Y[3]*sin(Y[5])^2*X[2]*exp(Y[5]*a)+a^2*X[2]^2*sin(Y[5])*cos(Y[5])*exp(Y[5]*a)^2+4*X[1]*a*cos(Y[5])*sin(Y[5])*exp(Y[5]*a)^2+8*a*sin(X[5])*X[3]*sin(Y[5])^3*cos(X[5])*Y[3]*exp(Y[5]*a)+a^2*X[3]^2*cos(Y[5])*sin(Y[5])^3*exp(Y[5]*a)^2+4*epsilon*a^2*Y[5]*X[4]*sin(X[5])^2*sin(Y[5])^2*exp(Y[5]*a)^2-a^2*X[3]^2*cos(Y[5])*sin(Y[5])*exp(Y[5]*a)^2-8*Y[1]*a*sin(X[5])^2*cos(Y[5])*sin(Y[5])+sin(X[5])^2*cos(Y[5])*X[2]^2*sin(Y[5])*exp(Y[5]*a)^2-2*sin(X[5])^2*sin(Y[5])^3*X[2]^2*cos(Y[5])*exp(Y[5]*a)^2-4*a*sin(X[5])*X[3]*sin(Y[5])^2*cos(X[5])*X[2]*exp(Y[5]*a)^2+2*sin(X[5])^2*X[3]^2*sin(Y[5])^3*cos(Y[5])*exp(Y[5]*a)^2-4*a^2*Y[3]*cos(X[5])*X[2]*sin(X[5])*sin(Y[5])*exp(Y[5]*a)-sin(X[5])^2*X[3]^2*sin(Y[5])*cos(Y[5])*exp(Y[5]*a)^2+4*a^2*X[2]*sin(Y[5])^3*cos(X[5])*Y[3]*sin(X[5])*exp(Y[5]*a)+4*Y[1]*cos(X[5])*cos(Y[5])*sin(X[5])*sin(Y[5])-4*a*sin(X[5])*X[3]*cos(X[5])*sin(Y[5])*Y[3]*exp(Y[5]*a)+2*cos(X[5])*X[3]^2*sin(Y[5])^4*sin(X[5])*exp(Y[5]*a)^2+4*sin(X[5])^2*X[3]*sin(Y[5])^4*X[2]*exp(Y[5]*a)^2+4*X[1]*a^2*sin(X[5])^2*sin(Y[5])^2*exp(Y[5]*a)^2-4*cos(X[5])*X[3]*sin(Y[5])^2*sin(X[5])*cos(Y[5])*Y[3]*exp(Y[5]*a)-4*a*sin(X[5])*cos(Y[5])*X[2]^2*sin(Y[5])^3*cos(X[5])*exp(Y[5]*a)^2+8*a*sin(X[5])^2*X[3]*sin(Y[5])^2*cos(Y[5])*Y[3]*exp(Y[5]*a)+2*a^2*X[2]*sin(Y[5])^4*X[3]*exp(Y[5]*a)^2-2*a^2*X[2]*sin(Y[5])^2*X[3]*exp(Y[5]*a)^2+8*a*sin(X[5])^2*X[3]*sin(Y[5])^3*cos(Y[5])*X[2]*exp(Y[5]*a)^2+4*a*sin(X[5])*X[3]^2*sin(Y[5])^3*cos(X[5])*cos(Y[5])*exp(Y[5]*a)^2-2*sin(X[5])*X[3]^2*a*cos(X[5])*sin(Y[5])*cos(Y[5])*exp(Y[5]*a)^2-4*X[1]*a^2*cos(X[5])*cos(Y[5])*sin(X[5])*sin(Y[5])*exp(Y[5]*a)^2-2*a^2*Y[3]*X[2]*cos(Y[5])*sin(X[5])^2*exp(Y[5]*a)+2*cos(X[5])*X[2]^2*a*sin(X[5])*cos(Y[5])*sin(Y[5])*exp(Y[5]*a)^2+2*a^2*X[3]*sin(Y[5])^3*Y[3]*exp(Y[5]*a)-2*a^2*X[3]*sin(Y[5])*Y[3]*exp(Y[5]*a)+2*epsilon*Y[5]*X[4]*sin(Y[5])^2*exp(Y[5]*a)^2-4*cos(X[5])*X[3]*sin(Y[5])^3*sin(X[5])*cos(Y[5])*X[2]*exp(Y[5]*a)^2-4*a*X[2]*sin(Y[5])^3*Y[3]*exp(Y[5]*a)+4*epsilon*a*Y[5]*X[4]*cos(Y[5])*sin(Y[5])*exp(Y[5]*a)^2+4*a^2*X[2]*sin(Y[5])^2*sin(X[5])^2*cos(Y[5])*Y[3]*exp(Y[5]*a)-8*X[1]*a*sin(X[5])*sin(Y[5])^2*cos(X[5])*exp(Y[5]*a)^2+2*a^2*X[2]^2*sin(Y[5])^4*cos(X[5])*sin(X[5])*exp(Y[5]*a)^2-4*sin(X[5])*sin(Y[5])^3*Y[3]*cos(X[5])*X[2]*exp(Y[5]*a)+2*a^2*X[3]^2*sin(X[5])*cos(X[5])*sin(Y[5])^2*exp(Y[5]*a)^2+4*cos(X[5])*X[2]*sin(X[5])*sin(Y[5])*Y[3]*exp(Y[5]*a)-2*a^2*X[3]^2*sin(X[5])*cos(X[5])*sin(Y[5])^4*exp(Y[5]*a)^2-4*a^2*X[2]*sin(Y[5])^4*sin(X[5])^2*X[3]*exp(Y[5]*a)^2+2*X[3]*X[2]*a^2*sin(X[5])^2*sin(Y[5])^2*exp(Y[5]*a)^2-8*a*Y[3]*sin(X[5])^2*X[2]*sin(Y[5])*exp(Y[5]*a)+2*a^2*Y[3]*sin(X[5])^2*X[3]*sin(Y[5])*exp(Y[5]*a)-4*a^2*Y[3]*sin(X[5])^2*X[3]*sin(Y[5])^3*exp(Y[5]*a)-4*epsilon*Y[5]*X[4]*sin(Y[5])^2*sin(X[5])^2*exp(Y[5]*a)^2+8*a*X[2]*sin(Y[5])^3*sin(X[5])^2*Y[3]*exp(Y[5]*a)-2*a^2*X[2]^2*sin(Y[5])^2*cos(X[5])*sin(X[5])*exp(Y[5]*a)^2+a^2*X[3]^2*cos(Y[5])*sin(X[5])^2*sin(Y[5])*exp(Y[5]*a)^2-2*a^2*X[3]^2*cos(Y[5])*sin(X[5])^2*sin(Y[5])^3*exp(Y[5]*a)^2+2*a^2*X[2]^2*sin(Y[5])^3*sin(X[5])^2*cos(Y[5])*exp(Y[5]*a)^2-a^2*X[2]^2*sin(Y[5])*cos(Y[5])*sin(X[5])^2*exp(Y[5]*a)^2-4*Y[1]*a^2*cos(X[5])*cos(Y[5])*sin(X[5])*sin(Y[5])-2*epsilon*a^2*Y[5]*X[4]*sin(Y[5])^2*exp(Y[5]*a)^2-2*a^2*X[2]*sin(Y[5])^2*Y[3]*cos(Y[5])*exp(Y[5]*a)-4*a*sin(Y[5])^3*X[3]*cos(Y[5])*X[2]*exp(Y[5]*a)^2-4*a*sin(Y[5])^2*Y[3]*X[3]*cos(Y[5])*exp(Y[5]*a)+4*X[1]*cos(X[5])*cos(Y[5])*sin(X[5])*sin(Y[5])*exp(Y[5]*a)^2-4*sin(X[5])^2*sin(Y[5])^2*Y[3]*cos(Y[5])*X[2]*exp(Y[5]*a)-8*X[1]*a*sin(X[5])^2*cos(Y[5])*sin(Y[5])*exp(Y[5]*a)^2+2*Y[1]*a^2+2*X[1]*a^2*exp(Y[5]*a)^2+2*epsilon*a^2*Y[5]*X[4]*exp(Y[5]*a)^2)/(-4*sin(X[5])^2*cos(Y[5])*a*sin(Y[5])+2*sin(X[5])*cos(Y[5])*cos(X[5])*sin(Y[5])-2*a^2*cos(X[5])*cos(Y[5])*sin(X[5])*sin(Y[5])+2*a^2*sin(X[5])^2*sin(Y[5])^2-4*a*sin(X[5])*sin(Y[5])^2*cos(X[5])+2*cos(Y[5])*a*sin(Y[5])+sin(Y[5])^2-2*sin(X[5])^2*sin(Y[5])^2+sin(X[5])^2+2*a*sin(X[5])*cos(X[5])+a^2-a^2*sin(X[5])^2-sin(Y[5])^2*a^2), (-exp(Y[5]*a)*a*sin(X[5])*X[3]*sin(Y[5])^2+exp(Y[5]*a)*a*sin(X[5])*cos(Y[5])*X[2]*sin(Y[5])+Y[2]*a*sin(X[5])*sin(Y[5])+exp(Y[5]*a)*sin(X[5])*sin(Y[5])^2*X[2]+exp(Y[5]*a)*a*cos(X[5])*sin(Y[5])^2*X[2]-Y[2]*a*cos(X[5])*cos(Y[5])-exp(Y[5]*a)*cos(X[5])*cos(Y[5])*X[2]*sin(Y[5])+exp(Y[5]*a)*a*cos(X[5])*sin(Y[5])*X[3]*cos(Y[5])+exp(Y[5]*a)*cos(X[5])*X[3]*sin(Y[5])^2-Y[2]*cos(X[5])*sin(Y[5])-Y[2]*sin(X[5])*cos(Y[5])+exp(Y[5]*a)*sin(X[5])*sin(Y[5])*X[3]*cos(Y[5])-exp(Y[5]*a)*cos(X[5])*X[2]*a-exp(Y[5]*a)*sin(X[5])*X[2])/(-sin(X[5])*cos(Y[5])-a*cos(X[5])*cos(Y[5])+a*sin(X[5])*sin(Y[5])-cos(X[5])*sin(Y[5])), (Y[3]*exp(-2*X[5]*a-2*Y[5]*a)+X[3]*exp(-Y[5]*a)*cos(Y[5])*exp(-2*X[5]*a)+X[2]*exp(-Y[5]*a)*sin(Y[5])*exp(-2*X[5]*a))/exp(-2*(X[5]+Y[5])*a), (Y[4]*exp(-2*X[5]*a-2*Y[5]*a)+exp(-2*X[5]*a)*X[4])/exp(-2*(X[5]+Y[5])*a), X[5]+Y[5]] end;


LG[[5, 27, 0]][representation]:=
[[exp(-x4), -x4*exp(-x4), x5, exp(-x4)*x2, -exp(-x4)*x1+x4*exp(-x4)*x3-x2*x5], [0, exp(-x4), -x4*exp(-x4), 0, -exp(-x4)*x3+x4*exp(-x4)*x2], [0, 0, exp(-x4), 0, -exp(-x4)*x2], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1]];

LG[[5, 27, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 27, 0]][G_dot]:=
proc(X,Y) [Y[4]^2*X[2]*exp(Y[4])+Y[4]*X[3]*exp(Y[4])-Y[5]*exp(Y[4])^2*X[2]+Y[1]+X[1]*exp(Y[4]), Y[2]+X[2]*exp(Y[4]), Y[4]*X[2]*exp(Y[4])+Y[3]+X[3]*exp(Y[4]), X[4]+Y[4], (Y[5]*exp(Y[4])+X[4]*Y[4]*exp(-X[4]-Y[4])*exp(X[4])*exp(Y[4])+X[5]*exp(X[4]))/exp(X[4])/exp(Y[4])] end;


LG[[5, 28, 0]][representation]:=
[[exp(-x5-x5*a), exp(-x5-x5*a)*x3, 0, exp(-x5-x5*a)*x2, exp(-x5-x5*a)*(-x1-x1*a+x3*x2*a)], [0, exp(-x5*a), 0, 0, exp(-x5*a)*x2*a], [0, 0, exp(-x5), -x5*exp(-x5), -exp(-x5)*x4+x5*exp(-x5)*x3], [0, 0, 0, exp(-x5), -exp(-x5)*x3], [0, 0, 0, 0, 1]];

LG[[5, 28, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 28, 0]][G_dot]:=
proc(X,Y) [(Y[2]*a*exp(-X[5]*a-Y[5]*a)*Y[3]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+Y[2]*a*exp(-X[5]*a-Y[5]*a)*X[3]*exp(-X[5]-X[5]*a-Y[5]*a)+exp(-X[5]*a)*X[2]*a*Y[3]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+exp(-X[5]*a)*X[2]*a*X[3]*exp(-X[5]-X[5]*a-Y[5]*a)+exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)*Y[1]*exp(-(X[5]+Y[5])*a)+exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)*Y[1]*a*exp(-(X[5]+Y[5])*a)-exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)*Y[3]*Y[2]*a*exp(-(X[5]+Y[5])*a)-X[3]*Y[2]*a*exp(-X[5]-X[5]*a-Y[5]*a)*exp(-(X[5]+Y[5])*a)+X[2]*Y[3]*exp(-X[5]-X[5]*a-Y[5])*exp(-(X[5]+Y[5])*a)+exp(-X[5]-X[5]*a)*X[1]*exp(-(X[5]+Y[5])*a)+exp(-X[5]-X[5]*a)*X[1]*a*exp(-(X[5]+Y[5])*a)-exp(-X[5]-X[5]*a)*X[3]*X[2]*a*exp(-(X[5]+Y[5])*a))/exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)/exp(-(X[5]+Y[5])*a)/(a+1), (Y[2]*exp(-X[5]*a-Y[5]*a)+exp(-X[5]*a)*X[2])/exp(-(X[5]+Y[5])*a), (Y[3]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+X[3]*exp(-X[5]-X[5]*a-Y[5]*a))/exp(-X[5]-X[5]*a-Y[5]-Y[5]*a), (exp(-X[5]-Y[5])*X[5]*exp(X[5])*exp(Y[5])*X[3]*exp(-X[5]-X[5]*a-Y[5]*a)+exp(-X[5]-Y[5])*Y[5]*exp(X[5])*exp(Y[5])*Y[3]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+exp(-X[5]-Y[5])*Y[5]*exp(X[5])*exp(Y[5])*X[3]*exp(-X[5]-X[5]*a-Y[5]*a)+Y[4]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)-Y[5]*Y[3]*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)+X[4]*exp(Y[5])*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a)-X[5]*X[3]*exp(Y[5])*exp(-X[5]-X[5]*a-Y[5]-Y[5]*a))/exp(-X[5]-Y[5])/exp(X[5])/exp(Y[5])/exp(-X[5]-X[5]*a-Y[5]-Y[5]*a), X[5]+Y[5]] end;


LG[[5, 29, 0]][representation]:=
[[exp(-x5), 0, 0, exp(-x5)*x2, -exp(-x5)*x1], [0, exp(-x5), 0, 0, exp(-x5)*x2], [0, 0, 1, -x5, -x4+x5*x3], [0, 0, 0, 1, -x3], [0, 0, 0, 0, 1]];

LG[[5, 29, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 29, 0]][G_dot]:=
proc(X,Y) [exp(X[5]+Y[5])*(Y[1]*exp(-X[5]-Y[5])*exp(X[5])+X[2]*Y[3]+X[1])/exp(X[5]), exp(X[5]+Y[5])*(Y[2]*exp(-X[5]-Y[5])*exp(X[5])+X[2])/exp(X[5]), Y[3]+X[3], X[3]*Y[5]+Y[4]+X[4], X[5]+Y[5]] end;


LG[[5, 30, 0]][representation]:=
[[exp(-x5*a-2*x5), -exp(-x5*a-2*x5)*x4, 1/2*exp(-x5*a-2*x5)*x4^2, exp(-x5*a-2*x5)*(x2-x4*x3), exp(-x5*a-2*x5)*(x1*a+2*x1-x4*(x2*a+x2)+1/2*x4^2*x3*a)], [0, exp(-x5-x5*a), -exp(-x5-x5*a)*x4, exp(-x5-x5*a)*x3, exp(-x5-x5*a)*(x2*a+x2-x4*x3*a)], [0, 0, exp(-x5*a), 0, exp(-x5*a)*x3*a], [0, 0, 0, exp(-x5), exp(-x5)*x4], [0, 0, 0, 0, 1]];

LG[[5, 30, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 30, 0]][G_dot]:=
proc(X,Y) [1/2*(a*exp(-X[5]*a)*X[3]*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)^2-exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2*Y[4]^2*Y[3]*a*exp(-(X[5]+Y[5])*a)-2*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*Y[4]*Y[3]*a*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+4*Y[4]*exp(-X[5]*a-2*X[5]-Y[5])*X[2]*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+2*exp(-X[5]*a-2*X[5])*X[1]*a*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])-2*exp(-X[5]*a-2*X[5])*X[4]*X[2]*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+a*Y[3]*exp(-X[5]*a-Y[5]*a)*Y[4]^2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2+2*a*Y[3]*exp(-X[5]*a-Y[5]*a)*Y[4]*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)+a*Y[3]*exp(-X[5]*a-Y[5]*a)*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)^2+a*exp(-X[5]*a)*X[3]*Y[4]^2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2+2*a*exp(-X[5]*a)*X[3]*Y[4]*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)+X[4]^2*Y[3]*a*exp(-X[5]*a-2*X[5]-Y[5]*a)*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])-4*Y[4]*exp(-X[5]*a-2*X[5]-Y[5])*X[4]*X[3]*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])-2*exp(-X[5]*a-2*X[5])*X[4]*X[2]*a*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+exp(-X[5]*a-2*X[5])*X[4]^2*X[3]*a*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+4*exp(-X[5]*a-2*X[5])*X[1]*exp(-(X[5]+Y[5])*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2*Y[1]*a*exp(-(X[5]+Y[5])*a)+4*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2*Y[1]*exp(-(X[5]+Y[5])*a)+4*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*Y[3]*exp(-X[5]*a-Y[5]*a)*Y[4]*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])-2*a*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*exp(-X[5]*a-2*X[5]-Y[5])*X[3]*exp(-(X[5]+Y[5])*a)+2*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)^2*Y[3]*exp(-X[5]*a-Y[5]*a)-2*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)^2*Y[3]*exp(-(X[5]+Y[5])*a)+2*Y[4]^2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2*Y[3]*exp(-X[5]*a-Y[5]*a)+2*Y[4]^2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2*exp(-X[5]*a)*X[3]+2*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)^2*exp(-X[5]*a)*X[3]-2*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*exp(-X[5]*a-2*X[5]-Y[5])*X[3]*exp(-(X[5]+Y[5])*a)+2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])*a*Y[4]*exp(-X[5]*a-2*X[5]-Y[5])*X[2]*exp(-(X[5]+Y[5])*a)-2*a*X[4]^2*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)^2*Y[3]*exp(-(X[5]+Y[5])*a)-4*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])*Y[4]*Y[3]*exp(-(X[5]+Y[5])*a)+2*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*exp(-X[5]*a-2*X[5]-Y[5])*X[2]*exp(-(X[5]+Y[5])*a)+4*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*exp(-X[5]*a)*X[3]*Y[4]*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])-2*Y[4]^2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2*Y[3]*exp(-(X[5]+Y[5])*a)-2*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])*a*Y[4]*exp(-X[5]*a-2*X[5]-Y[5])*X[4]*X[3]*exp(-(X[5]+Y[5])*a)+2*a*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*exp(-X[5]*a-2*X[5]-Y[5])*X[2]*exp(-(X[5]+Y[5])*a))/exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])^2/exp(-(X[5]+Y[5])*a)/(a+2), (Y[3]*exp(-X[5]*a-Y[5]*a)*Y[4]*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+Y[3]*exp(-X[5]*a-Y[5]*a)*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)+exp(-X[5]*a)*X[3]*Y[4]*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+exp(-X[5]*a)*X[3]*X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)+exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])*Y[2]*exp(-(X[5]+Y[5])*a)-exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])*Y[4]*Y[3]*exp(-(X[5]+Y[5])*a)-X[4]*Y[3]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a)*exp(-(X[5]+Y[5])*a)+exp(-X[5]*a-2*X[5]-Y[5])*X[2]*exp(-(X[5]+Y[5])*a)-exp(-X[5]*a-2*X[5]-Y[5])*X[4]*X[3]*exp(-(X[5]+Y[5])*a))/exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])/exp(-(X[5]+Y[5])*a), (Y[3]*exp(-X[5]*a-Y[5]*a)+exp(-X[5]*a)*X[3])/exp(-(X[5]+Y[5])*a), (Y[4]*exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5])+X[4]*exp(-X[5]*a-2*X[5]-Y[5]-Y[5]*a))/exp(-X[5]*a-2*X[5]-Y[5]*a-2*Y[5]), X[5]+Y[5]] end;


LG[[5, 31, 0]][representation]:=
[[exp(-3*x5), exp(-3*x5)*x4, 1/2*exp(-3*x5)*x4^2, exp(-3*x5)*(x2-x4*x3), exp(-3*x5)*(-3*x1+2*x4*x2-1/2*x4^2*x3-1/6*x4^3)], [0, exp(-2*x5), exp(-2*x5)*x4, -exp(-2*x5)*x3, exp(-2*x5)*(2*x2-x4*x3-1/2*x4^2)], [0, 0, exp(-x5), -x5*exp(-x5), exp(-x5)*(-x3-x4)+x5*exp(-x5)*x4], [0, 0, 0, exp(-x5), -exp(-x5)*x4], [0, 0, 0, 0, 1]];

LG[[5, 31, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 31, 0]][G_dot]:=
proc(X,Y) [1/18*(-exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-3*exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-6*exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]+3*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+9*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+9*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-18*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]-9*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2-6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[4]^2*exp(Y[5])^2*X[5]+3*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3+9*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]+9*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-3*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-36*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]-36*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-36*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-12*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+42*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-108*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]+60*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]-42*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]-30*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2+6*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+30*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+54*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-54*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+18*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3-30*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]-18*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-6*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+18*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2-18*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3-3*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]^4-60*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]-3*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]*X[5]^3-9*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]^2*X[5]^2-9*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]^3*X[5]+9*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]+12*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]+3*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]^3+18*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]+42*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]+30*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-18*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+18*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3+6*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3-6*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-42*Y[4]*exp(-3*X[5]-Y[5])*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2+9*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]*Y[5]^2-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]^2*Y[5]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]*exp(-2*X[5]-2*Y[5])^2*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2-18*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]*Y[5]-9*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]^2+3*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]^3-9*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]^2+9*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]^2*Y[5]+9*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]+9*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[4]^2*Y[5]-10*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2*Y[5]+18*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]^2*Y[5]-9*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]^2-27*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]*Y[5]-18*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]^2+27*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*X[5]*Y[5]^2+12*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]^3-3*exp(-3*X[5])*X[4]^2*Y[4]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2+3*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2*Y[5]^3+3*exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-9*exp(-3*X[5])*X[4]^2*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-12*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3-36*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]+72*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]+36*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+36*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2+12*exp(-3*X[5])*X[4]*X[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+18*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+54*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+54*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]+54*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]-9*exp(-3*X[5]-3*Y[5])*Y[4]^2*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2-3*exp(-3*X[5]-3*Y[5])*Y[4]^2*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2+9*exp(-3*X[5]-3*Y[5])*Y[4]^2*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]+6*exp(-3*X[5]-3*Y[5])*Y[4]^2*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]-36*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-24*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]-24*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-12*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*exp(-2*X[5]-2*Y[5])+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^4*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-2*X[5]-2*Y[5])+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[3]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[4]*exp(-2*X[5]-2*Y[5])+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*X[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-2*Y[5])+12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]*Y[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*exp(-2*X[5]-2*Y[5])*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-2*X[5]-2*Y[5])*X[5]-9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]^2*exp(-2*X[5]-2*Y[5])^2*X[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[4]*exp(-2*X[5]-2*Y[5])*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*exp(-2*X[5]-2*Y[5])+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[3]*exp(-2*X[5]-2*Y[5])+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[4]*exp(-2*X[5]-2*Y[5])*X[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[3]*exp(-2*X[5]-2*Y[5])*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+3*exp(-3*X[5]-3*Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[4]*exp(Y[5])+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*X[4]*exp(-2*X[5]-2*Y[5])-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]^2*X[4]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]^2+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2*X[5]*X[4]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]*X[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^3*Y[4]^2*exp(-2*X[5]-2*Y[5])^2-42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[5]^2*X[4]^2*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]^2*X[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[5]^2*Y[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]^2*Y[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-2*X[5]-2*Y[5])*X[5]+33*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*Y[5]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2*Y[5]-39*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-2*X[5]-2*Y[5])+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*exp(-2*X[5]-2*Y[5])+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])-39*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]*exp(-2*X[5]-2*Y[5])+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]*X[4]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[5]*Y[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[5]^3*X[4]^2*exp(-2*X[5]-2*Y[5])^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*Y[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]^2*X[5]*exp(-2*X[5]-2*Y[5])+3*exp(-3*X[5]-3*Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2*X[5]^2*X[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]^2*X[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-2*X[5]-2*Y[5])*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(-2*X[5]-2*Y[5])*Y[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])*Y[5]-42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*Y[5]*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(-2*X[5]-2*Y[5])*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^3*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[5]*Y[4]*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]*X[5]-21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(-2*X[5]-2*Y[5])+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*X[3]*Y[5]-63*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]*Y[4]+6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*Y[4]*X[5]*X[4]*exp(Y[5])-3*exp(-3*X[5]-3*Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*X[4]*exp(Y[5])+6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[4]*X[3]*exp(Y[5])-18*exp(-3*X[5]-3*Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*Y[4]+exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(-2*X[5]-2*Y[5])^3-36*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-3*exp(-3*X[5]-3*Y[5])*Y[4]^2*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]-12*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]+12*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2+48*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]+36*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+54*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+54*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]+exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+3*exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3+3*exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]-3*exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+3*exp(-3*X[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-6*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]+3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2+exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]-3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-6*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]-3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2-exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+3*exp(-3*X[5]-3*Y[5])*Y[4]^2*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3-3*exp(-3*X[5]-3*Y[5])*Y[4]^2*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+18*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+12*exp(-3*X[5]-3*Y[5])*Y[4]*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-54*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+18*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3-54*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-18*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-108*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]+54*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]+54*exp(-3*X[5]-3*Y[5])*Y[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-6*exp(-3*X[5]-3*Y[5])*X[5]*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[3]*X[4]-3*exp(-3*X[5]-3*Y[5])*X[5]^3*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]^2-3*exp(-3*X[5]-3*Y[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[5]+3*exp(-3*X[5]-3*Y[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[5]^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[5]^2*exp(-2*X[5]-2*Y[5])^2+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[3]*exp(-2*X[5]-2*Y[5])+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[4]*exp(-2*X[5]-2*Y[5])-39*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*exp(-2*X[5]-2*Y[5])-21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])-78*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[4]*exp(-2*X[5]-2*Y[5])-42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*X[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*X[5]+3*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*X[5]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-2*Y[5])-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[5]^3*exp(-2*X[5]-2*Y[5])^2+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[3]-10*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^3*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]*Y[5]+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*Y[5]+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*Y[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]*X[4]*Y[5]+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])^2*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]*X[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^3*Y[4]*X[4]+30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*X[4]*Y[5]-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]*X[4]*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[4]^2*X[5]*Y[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]-3*exp(-3*X[5]-3*Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*Y[5]*Y[4]+33*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]^2*exp(-2*X[5]-2*Y[5])^2+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(-2*X[5]-2*Y[5])-60*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[3]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]^2*exp(-2*X[5]-2*Y[5])^2-42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])^2-39*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-2*X[5]-2*Y[5])+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-2*X[5]-2*Y[5])+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^3*Y[4]*exp(-2*X[5]-2*Y[5])^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]^2-42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[3]*X[5]-9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]*exp(-2*X[5]-2*Y[5])^2*X[5]^2+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])+3*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*Y[4]^2+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]^2*Y[4]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*Y[5]^2*Y[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]*X[3]+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]^2*Y[4]-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]^2*X[5]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*X[5]^2*X[4]-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]*X[3]+12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*X[3]*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]*X[5]^2*X[4]-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]+15*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*X[5]+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*X[5]+54*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*X[3]*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[4]*Y[5]+3*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[3]^2*exp(Y[5])^2-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*X[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*Y[5]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*Y[4]*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*X[3]*X[5]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*Y[4]*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[5]*X[4]*Y[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]^2*X[5]+12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]*Y[4]*Y[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]*X[5]+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^3*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[3]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]*exp(-2*X[5]-2*Y[5])^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2-6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[4]^2*Y[5]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*Y[4]-78*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*Y[5]*Y[4]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]*X[5]*X[4]-3*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*X[5]^2+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])^2-10*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-78*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*X[5]*X[4]-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]*X[4]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*X[4]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*X[3]+3*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]^2+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*Y[4]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])-78*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*Y[4]+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]*Y[4]^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]*Y[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^3*Y[4]^2-78*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*X[5]-exp(-3*X[5]-3*Y[5])*X[5]^3*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[5]^2*X[4]^2*Y[5]+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]^2*Y[5]-exp(-3*X[5]-3*Y[5])*Y[5]^3*Y[4]^3*exp(-2*X[5]-2*Y[5])^3-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]*X[5]*X[4]*Y[5]-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*Y[4]+54*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])^2*X[3]+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]*Y[4]^2*X[5]^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[5]^2*X[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[5]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]*X[5]*X[4]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*X[5]^2*X[4]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*X[5]*X[4]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*X[5]^2+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*X[4]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[5]^2*X[4]^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*X[5]^2*X[4]+30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*Y[4]+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*X[3]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]^2-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[5]^2*exp(-2*X[5]-2*Y[5])^2+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^3*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(-2*X[5]-2*Y[5])+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*exp(-2*X[5]-2*Y[5])+27*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]^2*Y[4]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^4*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]+36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]^2*exp(-2*X[5]-2*Y[5])-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]^2+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[3]-15*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]*exp(-2*X[5]-2*Y[5])^2+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2+33*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2*X[5]-42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]^4*exp(-2*X[5]-Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(-2*X[5]-2*Y[5])^3*Y[5]^2+3*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]^2*X[4]^2*exp(Y[5])^2-6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[4]*X[5]*X[4]*exp(Y[5])-3*exp(-3*X[5])*X[4]^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*exp(Y[5])^2+3*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+9*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+9*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]+9*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]+9*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-18*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]+3*exp(-3*X[5]-3*Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[5]^2*X[4]^2*exp(Y[5])^2+3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(-2*X[5]-2*Y[5])^3*X[5]^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2-6*exp(-3*X[5]-3*Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])^2*X[5]*X[4]-6*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*Y[5]*X[3]*exp(Y[5])-6*exp(-3*X[5]-3*Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[4]^2*exp(Y[5])^2*X[5]-3*exp(-3*X[5]-3*Y[5])*Y[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*X[4]*exp(Y[5])+3*exp(-3*X[5]-3*Y[5])*Y[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])+6*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])^2*X[5]*X[4]-6*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])^2*X[4]-6*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^2*X[4]-3*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]^3*exp(-2*X[5]-2*Y[5])^3*X[5]^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2+3*exp(-3*X[5]-3*Y[5])*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[5]^2*X[4]^2+3*exp(-3*X[5]-3*Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[4]^2*exp(Y[5])^2+3*exp(-3*X[5]-3*Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[3]^2*exp(Y[5])^2+6*exp(-3*X[5]-3*Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])^2*X[4]+3*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3-9*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-3*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-18*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3+18*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]-6*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]+6*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2-6*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3+6*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+6*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]+6*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(-2*X[5]-2*Y[5])^3*Y[5]*X[5]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])-6*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^2*X[3]+6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])^2*X[4]-9*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+6*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-12*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]-18*X[4]*exp(-3*X[5]-2*Y[5])*Y[4]*Y[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2-36*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]-54*exp(-3*X[5])*X[1]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2-36*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[5]-36*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]^2+36*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2+72*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[5]+36*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^2+12*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3-12*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3-12*X[4]*exp(-3*X[5]-2*Y[5])*Y[2]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[5]^3+3*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[4]*exp(Y[5])-6*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^2*X[4]+6*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^2*X[4]-3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+6*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*Y[5]*X[5]*X[4]*exp(Y[5])-6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*Y[4]*X[3]*exp(Y[5])-3*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*X[4]*exp(Y[5])-6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])^2*X[5]*X[4]-6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*Y[4]*X[4]*exp(Y[5])+3*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[4]^2*exp(Y[5])^2+3*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[3]*exp(Y[5])+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[5]^3*X[4]^2+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2+33*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]-39*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]^2-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]*Y[4]+33*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[4]^2*X[5]+3*exp(-3*X[5]-3*Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*Y[4]+3*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[4]^2+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*X[4]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*exp(-2*X[5]-Y[5])+6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]-36*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*Y[5]*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*Y[4]*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-2*X[5]-Y[5])*Y[5]*Y[4]*X[5]-6*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[3]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[3]-78*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]*exp(-2*X[5]-2*Y[5])+21*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])*X[5]+18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[5]-15*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]^2*exp(-2*X[5]-2*Y[5])+33*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]+9*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])*Y[5]+6*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[4]*X[4]*exp(Y[5])+6*exp(-3*X[5]-3*Y[5])*X[5]^2*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[3]*X[4]-3*exp(-3*X[5]-3*Y[5])*X[5]*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]^2+6*exp(-3*X[5]-3*Y[5])*X[5]^2*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]^2-3*exp(-3*X[5]-3*Y[5])*X[5]*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[3]^2+3*exp(-3*X[5]-3*Y[5])*X[5]^2*Y[4]^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[3]-3*exp(-3*X[5]-3*Y[5])*X[3]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[5]*X[4]-6*exp(-3*X[5]-3*Y[5])*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]^2*X[5]+3*exp(-3*X[5]-3*Y[5])*X[3]^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]+6*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^2*X[4]-3*exp(-3*X[5]-3*Y[5])*Y[5]^2*Y[4]^3*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+6*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[4]^2*exp(Y[5])^2*X[5]+3*exp(-3*X[5]-3*Y[5])*X[5]^2*Y[4]^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]-3*exp(-3*X[5]-3*Y[5])*X[5]^3*Y[4]^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]-3*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[5]^2*X[4]^2*exp(Y[5])^2+6*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])^2*X[3]+3*exp(-3*X[5]-3*Y[5])*Y[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*X[4]*exp(Y[5])-3*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[3]^2*exp(Y[5])^2-3*exp(-3*X[5]-3*Y[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])^3*X[4]^2*exp(Y[5])^2+3*exp(-3*X[5]-3*Y[5])*X[3]*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*X[4]^2-6*exp(-3*X[5]-3*Y[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^3*Y[5]*X[4]*exp(Y[5])-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])-60*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]*X[5]*X[4]+33*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*Y[5]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[5]*Y[4]+42*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[5]*X[4]-30*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2-60*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*X[3]+3*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]+exp(-3*X[5]-3*Y[5])*Y[3]^3*exp(-2*X[5]-2*Y[5])^3-3*exp(-3*X[5]-3*Y[5])*Y[4]^3*exp(-2*X[5]-2*Y[5])^3*Y[5]+exp(-3*X[5]-3*Y[5])*X[3]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3+exp(-3*X[5]-3*Y[5])*X[4]^3*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*X[3]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[4]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[4]^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*X[4]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*X[3]*X[4]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^3*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[3]*exp(-2*X[5]-2*Y[5])^2*X[5]+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[3]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*exp(-2*X[5]-2*Y[5])-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[4]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*exp(-2*X[5]-2*Y[5])^2+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2*X[5]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[4]^2*exp(-2*X[5]-2*Y[5])^2-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[4]-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*X[4]^2*exp(-2*X[5]-2*Y[5])^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]^2*exp(-2*X[5]-2*Y[5])^2+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2*X[4]+24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*exp(-2*X[5]-2*Y[5])^2-12*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^3*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(-2*X[5]-2*Y[5])^2*X[4]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])*exp(-X[5]-Y[5])*exp(X[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]-24*exp(-3*X[5]-3*Y[5])*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])*exp(X[5])*Y[4]*X[4]+12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*X[4]*exp(-3*X[5]-2*Y[5])-24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*exp(-3*X[5]-Y[5])*X[4]*X[3]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*exp(-3*X[5]-Y[5])*X[2]-24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*exp(-3*X[5]-Y[5])*X[2]*X[5]+24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*exp(-3*X[5]-3*Y[5])*Y[2]+24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*exp(-3*X[5]-Y[5])*X[2]+12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*exp(-3*X[5]-Y[5])*X[4]*X[3]-24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*exp(-3*X[5]-3*Y[5])*Y[2]*X[5]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*X[4]^2*exp(-3*X[5]-Y[5])+24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*Y[5]*X[4]*exp(-3*X[5]-2*Y[5])*X[5]-24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*Y[5]*X[4]*exp(-3*X[5]-2*Y[5])+24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]*exp(-3*X[5]-Y[5])*X[4]*X[3]*X[5]+6*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]^3*X[4]^2*exp(-3*X[5]-Y[5])+12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*X[4]^2*exp(-3*X[5]-Y[5])*X[5]-24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-3*X[5]-Y[5])*X[4]*X[3]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]^2*exp(-3*X[5]-Y[5])*X[2]+24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-3*X[5]-3*Y[5])*Y[2]+24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-3*X[5]-Y[5])*X[2]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])+12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[5]^2*X[4]*exp(-3*X[5]-2*Y[5])-24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*X[4]*exp(-3*X[5]-2*Y[5])+12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]^2*exp(-3*X[5]-Y[5])*X[4]*X[3]+24*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[5]*exp(-3*X[5]-3*Y[5])*Y[4]*Y[5]+6*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[5]^2*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*Y[5]^2*X[4]*exp(-3*X[5]-2*Y[5])+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]*exp(-3*X[5]-Y[5])*X[4]*X[3]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]^2*exp(-3*X[5]-Y[5])*X[2]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]*exp(-3*X[5]-Y[5])*X[2]*X[5]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]*exp(-3*X[5]-3*Y[5])*Y[2]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]*exp(-3*X[5]-Y[5])*X[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]^2*exp(-3*X[5]-Y[5])*X[4]*X[3]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]*exp(-3*X[5]-3*Y[5])*Y[2]*X[5]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]^2*X[4]^2*exp(-3*X[5]-Y[5])-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*Y[5]*X[4]*exp(-3*X[5]-2*Y[5])*X[5]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*Y[5]*X[4]*exp(-3*X[5]-2*Y[5])+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*Y[5]*exp(-3*X[5]-3*Y[5])*Y[4]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]*exp(-3*X[5]-Y[5])*X[4]*X[3]*X[5]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[4]-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]^3*X[4]^2*exp(-3*X[5]-Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*Y[5]^2*X[4]^2*exp(-3*X[5]-Y[5])*X[5]-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2+36*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*X[3]*exp(-2*X[5]-2*Y[5])^2+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]^2*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2-36*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*X[3]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*X[5]^2*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*X[5]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2-18*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*X[5]^2*exp(-3*X[5]-Y[5])*X[3]*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^3*Y[5]^3*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2-6*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])*X[5]^2*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*X[4]^2*Y[5]^2*exp(-3*X[5]-Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2*Y[5]-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[4]*exp(-2*X[5]-2*Y[5])^2-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2*Y[5]-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2*Y[5]-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2*X[5]+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[4]*exp(-2*X[5]-2*Y[5])^2*Y[5]-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2*X[5]-18*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2*X[5]-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[4]*exp(-2*X[5]-2*Y[5])^2*X[5]+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[5]+36*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[4]^2*Y[5]^2*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2+48*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]^2*Y[3]*exp(-3*X[5]-2*Y[5])*Y[5]-36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]^2*exp(-3*X[5]-Y[5])*X[3]-48*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]*exp(-3*X[5]-3*Y[5])*Y[2]*Y[5]-48*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]*exp(-3*X[5]-Y[5])*X[2]*Y[5]-36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*X[4]*exp(-3*X[5]-Y[5])*X[2]+36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]*exp(-3*X[5]-3*Y[5])*Y[2]+36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]*exp(-3*X[5]-Y[5])*X[2]+36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]^2*exp(-3*X[5]-Y[5])*X[3]*Y[5]-36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*X[4]*exp(-3*X[5]-3*Y[5])*Y[2]-18*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]^3*Y[5]*exp(-3*X[5]-Y[5])+36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*X[4]^2*Y[3]*exp(-3*X[5]-2*Y[5])-36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]^2*Y[3]*exp(-3*X[5]-2*Y[5])+36*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*X[4]^2*exp(-3*X[5]-Y[5])*X[3]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*X[4]^3*Y[5]^2*exp(-3*X[5]-Y[5])+18*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]^2*X[4]^3*Y[5]*exp(-3*X[5]-Y[5])+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2-6*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^3*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^3*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2-36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*Y[5]+12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]+36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-3*Y[5])*Y[2]*Y[5]+36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-Y[5])*X[2]*Y[5]+24*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-Y[5])*X[2]*X[5]-12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-Y[5])*X[2]-36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*Y[5]+24*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-3*Y[5])*Y[2]*X[5]+6*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])-24*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*X[5]+12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])+12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-3*X[5]-3*Y[5])*Y[3]-24*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]*X[5]-36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]^2*exp(-3*X[5]-3*Y[5])*Y[3]*Y[5]-18*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*X[4]^2*Y[5]^2*exp(-3*X[5]-Y[5])-12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[4]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])*X[5]+12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[4]*X[3]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[2]+6*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]*exp(-2*X[5]-2*Y[5])^3*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])+12*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*Y[3]^2*exp(-2*X[5]-2*Y[5])^3*X[4]*exp(-3*X[5]-2*Y[5])-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2*Y[5]+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2*Y[5]+24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2*Y[5]+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]^2*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2-24*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*X[5]*exp(-3*X[5]-Y[5])*X[4]*exp(-2*X[5]-2*Y[5])^2*Y[5]+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*X[5]^2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*X[5]^2*exp(-3*X[5]-Y[5])*X[4]*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2-18*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^2*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*X[3]*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]*Y[5]^3*exp(-2*X[5]-Y[5])*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2-6*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[4]^3*Y[5]^4*exp(-2*X[5]-Y[5])*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]^2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*Y[5]*exp(-3*X[5]-Y[5])*X[4]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]^2*exp(-3*X[5]-Y[5])*X[2]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]*exp(-3*X[5]-Y[5])*X[2]*X[5]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]*exp(-3*X[5]-3*Y[5])*Y[2]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]*exp(-3*X[5]-Y[5])*X[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*Y[5]^2*exp(-3*X[5]-Y[5])*X[4]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]*exp(-3*X[5]-3*Y[5])*Y[2]*X[5]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*X[5]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*Y[5]*exp(-3*X[5]-Y[5])*X[4]*X[5]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]+6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*Y[5]^3*X[4]^2*exp(-3*X[5]-Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]^2*Y[3]*exp(-3*X[5]-2*Y[5])-18*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])*X[3]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-3*X[5]-Y[5])*X[2]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]*exp(-3*X[5]-3*Y[5])*Y[2]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]*exp(-3*X[5]-Y[5])*X[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^3*Y[5]^2*exp(-3*X[5]-Y[5])-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]*Y[3]*exp(-3*X[5]-2*Y[5])-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]+6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^3*Y[5]^3*exp(-3*X[5]-Y[5])-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]^2*exp(-2*X[5]-Y[5])*Y[5]^2*exp(-3*X[5]-Y[5])*X[4]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2+12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*Y[5]^2*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*Y[5]^2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[3]*exp(-2*X[5]-Y[5])*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^2*Y[4]*X[4]^2*Y[5]^2*exp(-3*X[5]-Y[5])-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]^3*Y[4]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])-12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^3*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]+12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^3*Y[4]*exp(-3*X[5]-3*Y[5])*Y[2]+12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^3*Y[4]*exp(-3*X[5]-Y[5])*X[2]-6*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^4*Y[4]*X[4]^2*exp(-3*X[5]-Y[5])-12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^3*Y[4]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])-12*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^3*Y[4]^2*exp(-3*X[5]-3*Y[5])*Y[3]-12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*Y[5]+12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[4]*X[3]+12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-3*Y[5])*Y[2]*Y[5]+12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[2]*Y[5]-12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-3*Y[5])*Y[2]-12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[2]-12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[4]*X[3]*Y[5]+6*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])+12*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])-6*X[5]^2*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*X[4]^2*Y[5]^2*exp(-3*X[5]-Y[5])+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]*exp(-3*X[5]-Y[5])*X[4]*X[3]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]^2*exp(-3*X[5]-Y[5])*X[2]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]*exp(-3*X[5]-3*Y[5])*Y[2]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]*exp(-3*X[5]-Y[5])*X[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*X[5]^2*X[4]*exp(-3*X[5]-2*Y[5])+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*X[5]*X[4]*exp(-3*X[5]-2*Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]^2*exp(-3*X[5]-Y[5])*X[4]*X[3]-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[5]^2*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*X[5]*Y[4]*Y[5]^3*X[4]^2*exp(-3*X[5]-Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[5]*Y[4]*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[3]*X[4]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*X[5]*exp(-3*X[5]-Y[5])*X[4]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]^2*exp(-3*X[5]-Y[5])*X[2]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]*exp(-3*X[5]-3*Y[5])*Y[2]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]*exp(-3*X[5]-Y[5])*X[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]^2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*X[5]^2*exp(-3*X[5]-Y[5])*X[4]-18*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[5]^2*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-3*X[5]-Y[5])*X[2]*X[5]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]*X[5]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[5]^2*Y[3]*exp(-3*X[5]-2*Y[5])*X[5]-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^3*Y[5]^3*exp(-3*X[5]-Y[5])*X[5]-24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*X[5]^2*Y[3]*exp(-3*X[5]-2*Y[5])*Y[5]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*X[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]*Y[5]+24*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*X[5]^2*exp(-3*X[5]-Y[5])*X[2]*Y[5]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*X[5]^3*exp(-3*X[5]-Y[5])*X[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*X[5]^3*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*X[5]^3*Y[3]*exp(-3*X[5]-2*Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*X[5]^3*exp(-3*X[5]-Y[5])*X[3]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^3*X[5]^2*Y[5]^2*exp(-3*X[5]-Y[5])-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^3*X[5]^3*Y[5]*exp(-3*X[5]-Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*exp(-3*X[5]-Y[5])*X[4]*X[3]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*exp(-3*X[5]-3*Y[5])*Y[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*exp(-3*X[5]-Y[5])*X[2]-6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]*X[4]^2*Y[5]*exp(-3*X[5]-Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*X[4]*exp(-3*X[5]-2*Y[5])-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^3*exp(X[5])^3*Y[3]^2*exp(-3*X[5]-3*Y[5])*Y[4]+48*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*Y[5]-48*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-3*Y[5])*Y[2]*Y[5]-48*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[2]*Y[5]+48*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-3*X[5]-Y[5])*X[4]*X[3]*Y[5]+24*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*X[4]^2*Y[5]^2*exp(-3*X[5]-Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]^2*exp(-3*X[5]-Y[5])*X[4]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-3*X[5]-Y[5])*X[2]+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[3]*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]+36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])-36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]*exp(-3*X[5]-3*Y[5])*Y[2]-36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]*exp(-3*X[5]-Y[5])*X[2]+36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]*exp(-3*X[5]-Y[5])*X[4]*X[3]+36*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^2*Y[4]^2*exp(-3*X[5]-3*Y[5])*Y[3]+18*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*Y[5]^3*Y[4]*X[4]^2*exp(-3*X[5]-Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*exp(-3*X[5]-Y[5])*X[3]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*exp(-3*X[5]-3*Y[5])*Y[2]-12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*exp(-3*X[5]-Y[5])*X[2]+6*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^3*Y[5]*exp(-3*X[5]-Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]^2*Y[3]*exp(-3*X[5]-2*Y[5])+12*exp(Y[5])^3*exp(-2*X[5]-2*Y[5])^3*exp(-X[5]-Y[5])^2*exp(X[5])^2*X[4]*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]-24*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*exp(-3*X[5]-Y[5])*X[4]*X[3]+24*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*exp(-3*X[5]-3*Y[5])*Y[2]+24*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*exp(-3*X[5]-Y[5])*X[2]-12*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*Y[5]^3*X[4]^2*exp(-3*X[5]-Y[5])-24*X[5]*Y[4]*exp(-X[5]-Y[5])^2*exp(X[5])^2*exp(Y[5])^2*exp(-2*X[5]-2*Y[5])^3*Y[5]^2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5]))/exp(-3*X[5]-3*Y[5])/exp(Y[5])^3/exp(-2*X[5]-2*Y[5])^3/exp(-X[5]-Y[5])^3/exp(X[5])^3/(-1+3*X[5]+3*Y[5]-3*X[5]^2-6*X[5]*Y[5]-3*Y[5]^2+X[5]^3+3*X[5]^2*Y[5]+3*X[5]*Y[5]^2+Y[5]^3), 1/2*(-2*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[4]+2*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+2*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*Y[5]+2*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*Y[5]-X[4]^2*Y[5]^2*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+2*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[5]+2*exp(-3*X[5]-3*Y[5])*X[3]*exp(-2*X[5]-Y[5])*X[5]*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*exp(-2*X[5]-2*Y[5])+4*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])-2*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+2*exp(-3*X[5]-3*Y[5])*X[3]*exp(-2*X[5]-Y[5])*X[5]*X[4]*exp(Y[5])*exp(-2*X[5]-2*Y[5])-2*exp(-3*X[5]-Y[5])*X[2]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])-2*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*Y[5]-2*exp(-3*X[5]-3*Y[5])*X[3]*exp(-2*X[5]-Y[5])*X[4]*exp(Y[5])*exp(-2*X[5]-2*Y[5])+2*exp(-3*X[5]-3*Y[5])*Y[2]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[5]-2*exp(-3*X[5]-3*Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])-2*exp(-3*X[5]-3*Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])-2*exp(-3*X[5]-3*Y[5])*X[3]^2*exp(-2*X[5]-Y[5])*exp(Y[5])*exp(-2*X[5]-2*Y[5])+2*exp(-3*X[5]-3*Y[5])*X[3]*exp(-2*X[5]-Y[5])*Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])+2*exp(-3*X[5]-3*Y[5])*X[4]^2*Y[5]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+2*exp(-3*X[5]-3*Y[5])*X[3]^2*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+2*exp(-3*X[5]-3*Y[5])*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*X[5]*exp(Y[5])*exp(-2*X[5]-2*Y[5])-2*exp(-3*X[5]-3*Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[3]*exp(Y[5])*exp(-2*X[5]-2*Y[5])+2*exp(-3*X[5]-3*Y[5])*X[4]*Y[5]^2*exp(-2*X[5]-Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])+X[4]^2*Y[5]*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])-X[4]^2*Y[5]*exp(-3*X[5]-Y[5])*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[5]-2*exp(-3*X[5]-3*Y[5])*X[4]^2*Y[5]*exp(-2*X[5]-Y[5])*exp(Y[5])*exp(-2*X[5]-2*Y[5])-2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[5]-2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*Y[5]+2*exp(-3*X[5]-3*Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])-2*exp(-3*X[5]-3*Y[5])*X[3]*exp(-2*X[5]-Y[5])*Y[4]*exp(-2*X[5]-2*Y[5])+4*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])+2*X[4]*Y[3]*exp(-3*X[5]-2*Y[5])*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+2*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])+2*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[5]*X[4]*exp(Y[5])-2*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[4]*exp(Y[5])+2*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*Y[5]*Y[4]-2*exp(-3*X[5]-3*Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])^2*X[3]*exp(Y[5])-2*exp(-3*X[5]-3*Y[5])*X[3]*exp(-2*X[5]-Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])-2*exp(-3*X[5]-Y[5])*X[4]*X[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[5]-2*exp(-3*X[5]-3*Y[5])*Y[4]*Y[3]*exp(-2*X[5]-2*Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*Y[5]+4*exp(-3*X[5]-3*Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])^2*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[3]+2*exp(-3*X[5]-3*Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])*X[5]*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*exp(-2*X[5]-2*Y[5])-2*exp(-3*X[5]-3*Y[5])*Y[3]^2*exp(-2*X[5]-2*Y[5])^2)/exp(-3*X[5]-3*Y[5])/exp(-2*X[5]-2*Y[5])^2/exp(-X[5]-Y[5])/exp(X[5])/exp(Y[5])/(-1+X[5]+Y[5]), (Y[3]*exp(-2*X[5]-2*Y[5])+X[4]*Y[5]*exp(-2*X[5]-Y[5])+X[3]*exp(-2*X[5]-Y[5]))/exp(-2*X[5]-2*Y[5]), (exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*Y[3]*exp(-2*X[5]-2*Y[5])+exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[4]*Y[5]*exp(-2*X[5]-Y[5])+exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*X[3]*exp(-2*X[5]-Y[5])-Y[3]*exp(-2*X[5]-2*Y[5])-Y[4]*exp(-2*X[5]-2*Y[5])+Y[5]*Y[4]*exp(-2*X[5]-2*Y[5])+X[5]*Y[4]*exp(-X[5]-Y[5])*exp(X[5])*exp(Y[5])*exp(-2*X[5]-2*Y[5])-X[3]*exp(Y[5])*exp(-2*X[5]-2*Y[5])-X[4]*exp(Y[5])*exp(-2*X[5]-2*Y[5])+X[5]*X[4]*exp(Y[5])*exp(-2*X[5]-2*Y[5]))/exp(-X[5]-Y[5])/exp(X[5])/exp(Y[5])/exp(-2*X[5]-2*Y[5])/(-1+X[5]+Y[5]), X[5]+Y[5]] end;


LG[[5, 32, 0]][representation]:=
[[exp(-x5), -exp(-x5)*x4, 1/2*exp(-x5)*x4^2-x5*a*exp(-x5), exp(-x5)*(-x2+x4*x3), 
exp(-x5)*(-x1-x3*a+x4*x2-1/2*x4^2*x3)+x5*a*exp(-x5)*x3], 
[0, exp(-x5), -exp(-x5)*x4, -exp(-x5)*x3, exp(-x5)*(-x2+x4*x3)], 
[0, 0, exp(-x5), 0, -exp(-x5)*x3], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1]];

LG[[5, 32, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 32, 0]][G_dot]:=
proc(X,Y) [1/2*(2*Y[1]-2*Y[5]*a*Y[3]+2*X[1]*exp(Y[5])-2*Y[3]*X[5]*a-2*Y[4]*Y[2]+Y[4]^2*Y[3]+Y[3]*X[4]^2
+2*a*Y[5]*exp(Y[5])*Y[3]*exp(-X[5]-Y[5])*exp(X[5])+2*a*Y[5]*exp(Y[5])*X[3]
-exp(Y[5])*Y[4]^2*Y[3]*exp(-X[5]-Y[5])*exp(X[5])+
exp(Y[5])*Y[4]^2*X[3]-2*a*exp(Y[5])*Y[3]*exp(-X[5]-Y[5])*exp(X[5])-
exp(Y[5])*X[4]^2*Y[3]*exp(-X[5]-Y[5])*exp(X[5])+2*a*X[5]*exp(Y[5])*Y[3]*
exp(-X[5]-Y[5])*exp(X[5])+2*exp(Y[5])*Y[4]*exp(-X[5]-Y[5])*Y[2]*exp(X[5])+
2*exp(Y[5])*Y[4]*X[2]+2*Y[3]*a)/exp(-X[5]-Y[5])/exp(X[5])/exp(Y[5]), 
(Y[4]*X[3]+exp(-X[5]-Y[5])*Y[2]*exp(X[5])+X[2])/exp(-X[5]-Y[5])/exp(X[5]), 
(Y[3]*exp(-X[5]-Y[5])*exp(X[5])+X[3])/exp(-X[5]-Y[5])/exp(X[5]), X[4]+Y[4], X[5]+Y[5]] end;


LG[[5, 33, 0]][representation]:=
[[exp(-x5), 0, 0, -exp(-x5)*x2, 0], [0, exp(-x4), 0, 0, -exp(-x4)*x1], [0, 0, exp(-x5*b)*exp(-x4*a), -exp(-x5*b)*exp(-x4*a)*x3*b, -exp(-x5*b)*exp(-x4*a)*x3*a], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1]];

LG[[5, 33, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 33, 0]][G_dot]:=
proc(X,Y) [exp(X[4]+Y[4])*(Y[1]*exp(-X[4]-Y[4])*exp(X[4])+X[1])/exp(X[4]), (exp(-X[5]-Y[5])*Y[2]*exp(X[5])+X[2])/exp(-X[5]-Y[5])/exp(X[5]), (Y[3]*exp(-X[5]*b-X[4]*a-Y[5]*b-Y[4]*a)+X[3]*exp(-X[5]*b-X[4]*a))/exp(-X[5]*b-X[4]*a-Y[5]*b-Y[4]*a), X[4]+Y[4], X[5]+Y[5]] end;


LG[[5, 34, 0]][representation]:=
[[exp(-x5)*exp(-x4*a), 0, 0, -exp(-x5)*exp(-x4*a)*x1*a, -exp(-x5)*exp(-x4*a)*x1], [0, exp(-x4), -x5*exp(-x4), -exp(-x4)*x2+x5*exp(-x4)*x3, -exp(-x4)*x3], [0, 0, exp(-x4), -exp(-x4)*x3, 0], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1]];

LG[[5, 34, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 34, 0]][G_dot]:=
proc(X,Y) [(Y[1]*exp(-X[5]-X[4]*a-Y[5]-Y[4]*a)+X[1]*exp(-X[5]-X[4]*a))/exp(-X[5]-X[4]*a-Y[5]-Y[4]*a), (exp(Y[4])*Y[5]*Y[3]*exp(-X[4]-Y[4])*exp(X[4])+exp(Y[4])*Y[5]*X[3]+Y[2]-Y[5]*Y[3]+X[2]*exp(Y[4]))/exp(-X[4]-Y[4])/exp(X[4])/exp(Y[4]), (Y[3]*exp(-X[4]-Y[4])*exp(X[4])+X[3])/exp(-X[4]-Y[4])/exp(X[4]), X[4]+Y[4], X[5]+Y[5]] end;


LG[[5, 35, 0]][representation]:=
[[exp(-x5*a)*exp(-x4*b), 0, 0, -exp(-x5*a)*exp(-x4*b)*x1*b, -exp(-x5*a)*exp(-x4*b)*x1*a], [0, (-(-a^2*cos(x5)-cos(x5))*a^2/(a^2+1)^2-(-a^2*cos(x5)-cos(x5))/(a^2+1)^2)*exp(-x4), (-a^2*sin(x5)/(a^2+1)-sin(x5)/(a^2+1))*exp(-x4), -(-(-a^2*cos(x5)-cos(x5))*a^2/(a^2+1)^2-(-a^2*cos(x5)-cos(x5))/(a^2+1)^2)*exp(-x4)*x2-(-a^2*sin(x5)/(a^2+1)-sin(x5)/(a^2+1))*exp(-x4)*x3, -(-(-a^2*cos(x5)-cos(x5))*a^2/(a^2+1)^2-(-a^2*cos(x5)-cos(x5))/(a^2+1)^2)*exp(-x4)*x3+(-a^2*sin(x5)/(a^2+1)-sin(x5)/(a^2+1))*exp(-x4)*x2], [0, (a^2*sin(x5)/(a^2+1)+sin(x5)/(a^2+1))*exp(-x4), (-(-a^2*cos(x5)-cos(x5))*a^2/(a^2+1)^2-(-a^2*cos(x5)-cos(x5))/(a^2+1)^2)*exp(-x4), -(a^2*sin(x5)/(a^2+1)+sin(x5)/(a^2+1))*exp(-x4)*x2-(-(-a^2*cos(x5)-cos(x5))*a^2/(a^2+1)^2-(-a^2*cos(x5)-cos(x5))/(a^2+1)^2)*exp(-x4)*x3, -(a^2*sin(x5)/(a^2+1)+sin(x5)/(a^2+1))*exp(-x4)*x3+(-(-a^2*cos(x5)-cos(x5))*a^2/(a^2+1)^2-(-a^2*cos(x5)-cos(x5))/(a^2+1)^2)*exp(-x4)*x2], [0, 0, 0, -(-a^2-1)*a^2/(a^2+1)^2-(-a^2-1)/(a^2+1)^2, 0], [0, 0, 0, 0, -(-a^2-1)*a^2/(a^2+1)^2-(-a^2-1)/(a^2+1)^2]];

LG[[5, 35, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 35, 0]][G_dot]:=
proc(X,Y) [X[1]*exp(Y[5]*a+Y[4]*b)+Y[1], X[2]*sin(X[5])*exp(Y[4])*sin(X[5]+Y[5])+X[3]*cos(X[5])*exp(Y[4])*sin(X[5]+Y[5])+cos(X[5]+Y[5])*X[2]*cos(X[5])*exp(Y[4])-cos(X[5]+Y[5])*X[3]*sin(X[5])*exp(Y[4])+Y[2], Y[3]+cos(X[5]+Y[5])*X[2]*sin(X[5])*exp(Y[4])+cos(X[5]+Y[5])*X[3]*cos(X[5])*exp(Y[4])-X[2]*cos(X[5])*exp(Y[4])*sin(X[5]+Y[5])+X[3]*sin(X[5])*exp(Y[4])*sin(X[5]+Y[5]), X[4]+Y[4], X[5]+Y[5]] end;


LG[[5, 36, 0]][representation]:=
[[exp(-x2), 0, 0, 0, x4], [0, exp(-x3), 0, 0, x5], [0, 0, 1, -x3, -x1+x3*x2], [0, 0, 0, 1, -x2], [0, 0, 0, 0, 1]];

LG[[5, 36, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 36, 0]][G_dot]:=
proc(X,Y) [Y[3]*X[2]+Y[1]+X[1], X[2]+Y[2], Y[3]+X[3], (Y[4]+X[4]*exp(X[2]))/exp(X[2]), (Y[5]+X[5]*exp(X[3]))/exp(X[3])] end;


LG[[5, 37, 0]][representation]:=
[[1, (x3+sin(x2)*x4*cos(x2))/cos(x2)^2, x4, -x1, x5], [0, cos(x2)*exp(x1), -sin(x2)*exp(x1), 0, 0], [0, sin(x2)*exp(x1), cos(x2)*exp(x1), 0, 0], [0, 0, 0, 1, -x2], [0, 0, 0, 0, 1]];

LG[[5, 37, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 37, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], X[2]+Y[2], 1/4*(6*exp(Y[1])*X[3]*cos(Y[2]+2*X[2])+exp(Y[1])*X[4]*sin(3*Y[2])+8*Y[3]-2*Y[4]*sin(4*X[2])+8*Y[3]*cos(2*Y[2]+2*X[2])-2*sin(4*X[2]+2*Y[2])*Y[4]+8*Y[3]*cos(2*X[2])^2+12*cos(Y[2])*exp(Y[1])*X[3]+exp(Y[1])*X[4]*sin(-Y[2]+2*X[2])+3*exp(Y[1])*X[4]*sin(Y[2]+2*X[2])-2*Y[4]*sin(-2*Y[2]+2*X[2])*cos(2*X[2])-2*sin(4*X[2]+2*Y[2])*Y[4]*cos(2*X[2])-2*sin(2*Y[2]+2*X[2])*Y[4]*cos(2*X[2])-4*sin(2*X[2])*Y[4]*cos(2*X[2])-2*sin(4*X[2])*Y[4]*cos(2*X[2])+2*sin(2*Y[2])*Y[4]*cos(2*X[2])+4*Y[3]*cos(4*X[2]+2*Y[2])*cos(2*X[2])+4*Y[3]*cos(4*X[2]+2*Y[2])+4*Y[3]*cos(2*Y[2])-4*Y[4]*sin(2*X[2])+X[4]*sin(Y[2])*exp(Y[1])+16*Y[3]*cos(2*X[2])+8*sin(2*Y[2]+2*X[2])*sin(Y[2])*exp(Y[1])*X[3]-4*sin(2*Y[2]+2*X[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])-4*sin(2*Y[2]+2*X[2])*X[4]*cos(Y[2])*exp(Y[1])+4*sin(4*X[2]+2*Y[2])*sin(Y[2])*exp(Y[1])*X[3]-2*sin(4*X[2]+2*Y[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])-2*sin(4*X[2]+2*Y[2])*X[4]*cos(Y[2])*exp(Y[1])+2*sin(4*Y[2])*sin(Y[2])*exp(Y[1])*X[3]-sin(4*Y[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])-sin(4*Y[2])*X[4]*cos(Y[2])*exp(Y[1])+2*sin(4*X[2])*sin(Y[2])*exp(Y[1])*X[3]-2*sin(2*X[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])-2*sin(2*X[2])*X[4]*cos(Y[2])*exp(Y[1])+4*sin(4*Y[2]+2*X[2])*sin(Y[2])*exp(Y[1])*X[3]+4*sin(2*X[2])*sin(Y[2])*exp(Y[1])*X[3]-2*sin(2*Y[2])*X[4]*cos(Y[2])*exp(Y[1])+exp(Y[1])*X[4]*sin(-Y[2]+2*X[2])*cos(2*X[2])+12*cos(Y[2])*exp(Y[1])*X[3]*cos(2*X[2])+exp(Y[1])*X[4]*sin(3*Y[2])*cos(2*X[2])-2*sin(4*Y[2]+2*X[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])-2*sin(4*Y[2]+2*X[2])*X[4]*cos(Y[2])*exp(Y[1])+2*sin(4*X[2]+4*Y[2])*sin(Y[2])*exp(Y[1])*X[3]-sin(4*X[2]+4*Y[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])-sin(4*X[2]+4*Y[2])*X[4]*cos(Y[2])*exp(Y[1])+2*exp(Y[1])*X[3]*cos(5*Y[2]+2*X[2])*cos(2*X[2])+exp(Y[1])*X[4]*sin(5*Y[2]+4*X[2])*cos(2*X[2])+X[4]*sin(Y[2])*exp(Y[1])*cos(2*X[2])+3*exp(Y[1])*X[4]*sin(Y[2]+2*X[2])*cos(2*X[2])+3*exp(Y[1])*X[4]*sin(3*Y[2]+2*X[2])*cos(2*X[2])+4*exp(Y[1])*X[3]*cos(3*Y[2])*cos(2*X[2])+exp(Y[1])*X[4]*sin(5*Y[2]+2*X[2])*cos(2*X[2])+6*exp(Y[1])*X[3]*cos(3*Y[2]+2*X[2])*cos(2*X[2])+exp(Y[1])*X[4]*sin(Y[2]+4*X[2])*cos(2*X[2])+2*exp(Y[1])*X[3]*cos(-Y[2]+2*X[2])*cos(2*X[2])-sin(4*X[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])-sin(4*X[2])*X[4]*cos(Y[2])*exp(Y[1])+4*sin(2*Y[2])*sin(Y[2])*exp(Y[1])*X[3]-2*sin(2*Y[2])*exp(Y[1])*X[4]*cos(Y[2]+2*X[2])+6*exp(Y[1])*X[3]*cos(Y[2]+2*X[2])*cos(2*X[2])+2*exp(Y[1])*X[4]*sin(3*Y[2]+4*X[2])*cos(2*X[2])+2*exp(Y[1])*X[4]*sin(3*Y[2]+4*X[2])+exp(Y[1])*X[4]*sin(5*Y[2]+4*X[2])+2*exp(Y[1])*X[3]*cos(5*Y[2]+2*X[2])+exp(Y[1])*X[4]*sin(5*Y[2]+2*X[2])+4*exp(Y[1])*X[3]*cos(3*Y[2])+2*exp(Y[1])*X[3]*cos(-Y[2]+2*X[2])+exp(Y[1])*X[4]*sin(Y[2]+4*X[2])+8*Y[3]*cos(2*Y[2]+2*X[2])*cos(2*X[2])+4*Y[3]*cos(2*Y[2])*cos(2*X[2])+6*exp(Y[1])*X[3]*cos(3*Y[2]+2*X[2])+3*exp(Y[1])*X[4]*sin(3*Y[2]+2*X[2])-2*Y[4]*sin(2*Y[2]+2*X[2])-2*Y[4]*sin(-2*Y[2]+2*X[2])+2*Y[4]*sin(2*Y[2]))/(2+cos(-2*Y[2]+2*X[2])+cos(2*Y[2]+2*X[2])+2*cos(2*X[2])^2+cos(2*Y[2]+2*X[2])*cos(2*X[2])+2*cos(2*Y[2])*cos(2*X[2])+2*cos(2*Y[2])+4*cos(2*X[2])+cos(-2*Y[2]+2*X[2])*cos(2*X[2])), (Y[4]*cos(2*X[2])+Y[4]-2*sin(Y[2])*exp(Y[1])*X[3]+exp(Y[1])*X[4]*cos(Y[2]+2*X[2])+X[4]*cos(Y[2])*exp(Y[1]))/(cos(2*X[2])+1), Y[5]+X[1]*Y[2]+X[5]] end;


LG[[5, 38, 0]][representation]:=
[[exp(-2/3*x1+1/3*x2), x3, x4], [0, exp(1/3*x1-2/3*x2), x5], [0, 0, exp(1/3*x1+1/3*x2)]];

LG[[5, 38, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 38, 0]][G_dot]:=
proc(X,Y) [X[1]+Y[1], X[2]+Y[2], exp(-2/3*X[1]+1/3*X[2])*Y[3]+X[3]*exp(1/3*Y[1]-2/3*Y[2]), exp(-2/3*X[1]+1/3*X[2])*Y[4]+X[3]*Y[5]+X[4]*exp(1/3*Y[1]+1/3*Y[2]), exp(1/3*X[1]-2/3*X[2])*Y[5]+X[5]*exp(1/3*Y[1]+1/3*Y[2])] end;


LG[[5, 39, 0]][representation]:=
[[exp(-2*x5), -exp(-x5)*x3, exp(-x5)*x2, -1/2*x2^2-1/2*x3^2, 2*x1-x3*x2], [0, cos(x4)*exp(-x5), -sin(x4)*exp(-x5), cos(x4)*x3+sin(x4)*x2, cos(x4)*x2-sin(x4)*x3], [0, sin(x4)*exp(-x5), cos(x4)*exp(-x5), sin(x4)*x3-cos(x4)*x2, cos(x4)*x3+sin(x4)*x2], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1]];

LG[[5, 39, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 39, 0]][G_dot]:=
proc(X,Y) [1/2*(Y[3]*exp(-2*X[5]-Y[5])^2*exp(X[5]+Y[5])^2*Y[2]*exp(X[5])+Y[3]*exp(-2*X[5]-Y[5])*exp(X[5]+Y[5])^2*X[3]*sin(Y[4])*exp(-X[5]-Y[5])*exp(X[5])+Y[3]*exp(-2*X[5]-Y[5])*exp(X[5]+Y[5])^2*X[2]*cos(Y[4])*exp(-X[5]-Y[5])*exp(X[5])+X[3]*cos(Y[4])*exp(-X[5]-Y[5])*exp(X[5]+Y[5])^2*Y[2]*exp(-2*X[5]-Y[5])*exp(X[5])+X[3]^2*cos(Y[4])*exp(-X[5]-Y[5])^2*exp(X[5]+Y[5])^2*sin(Y[4])*exp(X[5])+X[3]*cos(Y[4])^2*exp(-X[5]-Y[5])^2*exp(X[5]+Y[5])^2*X[2]*exp(X[5])-X[2]*sin(Y[4])*exp(-X[5]-Y[5])*exp(X[5]+Y[5])^2*Y[2]*exp(-2*X[5]-Y[5])*exp(X[5])-X[2]*sin(Y[4])^2*exp(-X[5]-Y[5])^2*exp(X[5]+Y[5])^2*X[3]*exp(X[5])-X[2]^2*sin(Y[4])*exp(-X[5]-Y[5])^2*exp(X[5]+Y[5])^2*cos(Y[4])*exp(X[5])+2*exp(-2*X[5])*Y[1]*exp(X[5])-exp(-2*X[5])*Y[3]*Y[2]*exp(X[5])+X[3]*sin(Y[4])*Y[3]-X[3]*cos(Y[4])*Y[2]+X[2]*cos(Y[4])*Y[3]+X[2]*sin(Y[4])*Y[2]+2*X[1]*exp(X[5])-X[3]*X[2]*exp(X[5]))/exp(X[5]), Y[2]*exp(-2*X[5]-Y[5])*exp(X[5]+Y[5])+X[3]*sin(Y[4])*exp(-X[5]-Y[5])*exp(X[5]+Y[5])+X[2]*cos(Y[4])*exp(-X[5]-Y[5])*exp(X[5]+Y[5]), Y[3]*exp(-2*X[5]-Y[5])*exp(X[5]+Y[5])+X[3]*cos(Y[4])*exp(-X[5]-Y[5])*exp(X[5]+Y[5])-X[2]*sin(Y[4])*exp(-X[5]-Y[5])*exp(X[5]+Y[5]), arctan(exp(-X[5]-Y[5])*sin(X[4]+Y[4])*exp(X[5]+Y[5]),exp(-X[5]-Y[5])*cos(X[4]+Y[4])*exp(X[5]+Y[5])), X[5]+Y[5]] end;


LG[[5, 40, 0]][representation]:=
[[exp(x4)+x5*x3*exp(2*x4), x5, -x1-x5*exp(x4)*x2], [x3*exp(x4), exp(-x4), -x2], [0, 0, 1]];

LG[[5, 40, 0]][identity]:=
[0, 0, 0, 0, 0];

LG[[5, 40, 0]][G_dot]:=
proc(X,Y) 

[(exp(X[4])*Y[1]+X[1]*X[3]*Y[5]*exp(2*X[4]+Y[4])-Y[5]*X[2]*exp(2*X[4]+Y[4])+X[1])/(X[3]*Y[5]*exp(2*X[4]+Y[4])+1), 
(X[3]*exp(X[4])^2*Y[1]+X[3]*exp(X[4])^2*Y[5]*exp(Y[4])*Y[2]+Y[2]+X[2]*exp(X[4]))/exp(X[4]),
 (X[3]^2*Y[5]*exp(4*X[4]+Y[4])+X[3]*exp(X[4])^2+X[3]^2*Y[5]^2*Y[3]*exp(4*X[4]+2*Y[4])+2*X[3]*Y[5]*Y[3]*exp(2*X[4]+Y[4])+Y[3])/(exp(X[4])^2), 
-ln(X[3]*Y[5]*exp(2*X[4]+Y[4])+1)+Y[4]+X[4], 
(exp(X[4])*Y[5]*exp(Y[4])+Y[5]*X[5]*X[3]*exp(2*X[4])*exp(Y[4])+X[5])/exp(Y[4])];

end:


eval(LG);
end;
